// cog

/*
-------------------------------------------------------------------------------
Copyright 2014 Parallax Inc.

This file is part of the hardware description for the Propeller 1 Design.

The Propeller 1 Design is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by the
Free Software Foundation, either version 3 of the License, or (at your option)
any later version.

The Propeller 1 Design is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
more details.

You should have received a copy of the GNU General Public License along with
the Propeller 1 Design.  If not, see <http://www.gnu.org/licenses/>.
-------------------------------------------------------------------------------


																  ADD
instruction								mnem	oper	R  C  Z   +- C  D  S
----------------------------------------------------------------------------
000000 ZC0ICCCC DDDDDDDDD SSSSSSSSS		WRBYTE	D,S		_______   __________
000000 ZC1ICCCC DDDDDDDDD SSSSSSSSS		RDBYTE	D,S		B______   __________
000001 ZC0ICCCC DDDDDDDDD SSSSSSSSS		WRWORD	D,S		_______   __________
000001 ZC1ICCCC DDDDDDDDD SSSSSSSSS		RDWORD	D,S		B______   __________
000010 ZC0ICCCC DDDDDDDDD SSSSSSSSS		WRLONG	D,S		_______   __________
000010 ZC1ICCCC DDDDDDDDD SSSSSSSSS		RDLONG	D,S		B______   __________
000011 ZCRICCCC DDDDDDDDD SSSSSSSSS		SYSOP	D,S		B__B___   __________

000100 ZCRICCCC DDDDDDDDD SSSSSSSSS	*	<MUL>	D,S		M__M__Z   __________
000101 ZCRICCCC DDDDDDDDD SSSSSSSSS	*	<MULS>	D,S		M__M__Z   __________
000110 ZCRICCCC DDDDDDDDD SSSSSSSSS	*	<ENC>	D,S		E_____Z   __________
000111 ZCRICCCC DDDDDDDDD SSSSSSSSS	*	<ONES>	D,S		E_____Z   __________

001000 ZCRICCCC DDDDDDDDD SSSSSSSSS		ROR		D,S		R__R__Z   __________
001001 ZCRICCCC DDDDDDDDD SSSSSSSSS		ROL		D,S		R__R__Z   __________
001010 ZCRICCCC DDDDDDDDD SSSSSSSSS		SHR		D,S		R__R__Z   __________
001011 ZCRICCCC DDDDDDDDD SSSSSSSSS		SHL		D,S		R__R__Z   __________
001100 ZCRICCCC DDDDDDDDD SSSSSSSSS		RCR		D,S		R__R__Z   __________
001101 ZCRICCCC DDDDDDDDD SSSSSSSSS		RCL		D,S		R__R__Z   __________
001110 ZCRICCCC DDDDDDDDD SSSSSSSSS		SAR		D,S		R__R__Z   __________
001111 ZCRICCCC DDDDDDDDD SSSSSSSSS		REV		D,S		R__R__Z   __________

010000 ZCRICCCC DDDDDDDDD SSSSSSSSS		MINS	D,S		L__As_Z   1__0__1__1
010001 ZCRICCCC DDDDDDDDD SSSSSSSSS		MAXS	D,S		L__As_Z   1__0__1__1
010010 ZCRICCCC DDDDDDDDD SSSSSSSSS		MIN		D,S		L__Au_Z   1__0__1__1
010011 ZCRICCCC DDDDDDDDD SSSSSSSSS		MAX		D,S		L__Au_Z   1__0__1__1
010100 ZCRICCCC DDDDDDDDD SSSSSSSSS		MOVS	D,S		L______   __________
010101 ZCRICCCC DDDDDDDDD SSSSSSSSS		MOVD	D,S		L______   __________
010110 ZCRICCCC DDDDDDDDD SSSSSSSSS		MOVI	D,S		L______   __________
010111 ZCRICCCC DDDDDDDDD SSSSSSSSS		JMPRET	D,S		L______   __________

011000 ZCRICCCC DDDDDDDDD SSSSSSSSS		AND		D,S		L__L__Z   __________
011001 ZCRICCCC DDDDDDDDD SSSSSSSSS		ANDN	D,S		L__L__Z   __________
011010 ZCRICCCC DDDDDDDDD SSSSSSSSS		OR		D,S		L__L__Z   __________
011011 ZCRICCCC DDDDDDDDD SSSSSSSSS		XOR		D,S		L__L__Z   __________
011100 ZCRICCCC DDDDDDDDD SSSSSSSSS		MUXC	D,S		L__L__Z   __________
011101 ZCRICCCC DDDDDDDDD SSSSSSSSS		MUXNC	D,S		L__L__Z   __________
011110 ZCRICCCC DDDDDDDDD SSSSSSSSS		MUXZ	D,S		L__L__Z   __________
011111 ZCRICCCC DDDDDDDDD SSSSSSSSS		MUXNZ	D,S		L__L__Z   __________

100000 ZCRICCCC DDDDDDDDD SSSSSSSSS		ADD		D,S		A__Au_Z   0__0__1__1
100001 ZCRICCCC DDDDDDDDD SSSSSSSSS		SUB		D,S		A__Au_Z   1__0__1__1
100010 ZCRICCCC DDDDDDDDD SSSSSSSSS		ADDABS	D,S		A__Au_Z   M__0__1__1
100011 ZCRICCCC DDDDDDDDD SSSSSSSSS		SUBABS	D,S		A__Au_Z   Mn_0__1__1
100100 ZCRICCCC DDDDDDDDD SSSSSSSSS		SUMC	D,S		A__Ao_Z   C__0__1__1
100101 ZCRICCCC DDDDDDDDD SSSSSSSSS		SUMNC	D,S		A__Ao_Z   Cn_0__1__1
100110 ZCRICCCC DDDDDDDDD SSSSSSSSS		SUMZ	D,S		A__Ao_Z   Z__0__1__1
100111 ZCRICCCC DDDDDDDDD SSSSSSSSS		SUMNZ	D,S		A__Ao_Z   Zn_0__1__1

101000 ZCRICCCC DDDDDDDDD SSSSSSSSS		MOV		D,S		A__Am_Z   0__0__0__1
101001 ZCRICCCC DDDDDDDDD SSSSSSSSS		NEG		D,S		A__Am_Z   1__0__0__1
101010 ZCRICCCC DDDDDDDDD SSSSSSSSS		ABS		D,S		A__Am_Z   M__0__0__1
101011 ZCRICCCC DDDDDDDDD SSSSSSSSS		ABSNEG	D,S		A__Am_Z   Mn_0__0__1
101100 ZCRICCCC DDDDDDDDD SSSSSSSSS		NEGC	D,S		A__Am_Z   C__0__0__1
101101 ZCRICCCC DDDDDDDDD SSSSSSSSS		NEGNC	D,S		A__Am_Z   Cn_0__0__1
101110 ZCRICCCC DDDDDDDDD SSSSSSSSS		NEGZ	D,S		A__Am_Z   Z__0__0__1
101111 ZCRICCCC DDDDDDDDD SSSSSSSSS		NEGNZ	D,S		A__Am_Z   Zn_0__0__1

110000 ZCRICCCC DDDDDDDDD SSSSSSSSS		CMPS	D,S		A__As_Z   1__0__1__1
110001 ZCRICCCC DDDDDDDDD SSSSSSSSS		CMPSX	D,S		A__As_Z&  1__C__1__1
110010 ZCRICCCC DDDDDDDDD SSSSSSSSS		ADDX	D,S		A__Au_Z&  0__C__1__1
110011 ZCRICCCC DDDDDDDDD SSSSSSSSS		SUBX	D,S		A__Au_Z&  1__C__1__1
110100 ZCRICCCC DDDDDDDDD SSSSSSSSS		ADDS	D,S		A__Ao_Z   0__0__1__1
110101 ZCRICCCC DDDDDDDDD SSSSSSSSS		SUBS	D,S		A__Ao_Z   1__0__1__1
110110 ZCRICCCC DDDDDDDDD SSSSSSSSS		ADDSX	D,S		A__Ao_Z&  0__C__1__1
110111 ZCRICCCC DDDDDDDDD SSSSSSSSS		SUBSX	D,S		A__Ao_Z&  1__C__1__1

111000 ZCRICCCC DDDDDDDDD SSSSSSSSS		CMPSUB	D,S		A__Ac_Z   1__0__1__1
111001 ZCRICCCC DDDDDDDDD SSSSSSSSS		DJNZ	D,S		A__Au_Z   1__1__1__0
111010 ZCRICCCC DDDDDDDDD SSSSSSSSS		TJNZ	D,S		A__Au_Z   1__0__1__0
111011 ZCRICCCC DDDDDDDDD SSSSSSSSS		TJZ		D,S		A__Au_Z   1__0__1__0
111100 ZCRICCCC DDDDDDDDD SSSSSSSSS		WAITPEQ	D,S		_______   __________
111101 ZCRICCCC DDDDDDDDD SSSSSSSSS		WAITPNE	D,S		_______   __________
111110 ZCRICCCC DDDDDDDDD SSSSSSSSS		WAITCNT	D,S		A__Au_Z   0__0__1__1
111111 ZCRICCCC DDDDDDDDD SSSSSSSSS		WAITVID	D,S		_______   __________
----------------------------------------------------------------------------
* future instructions


ZCR		effects
----------------------------------------------------------------------------
000		nz, nc, nr
001		nz, nc, r
010		nz, c,  nr
011		nz, c,  r
100		z,  nc, nr
101		z,  nc, r
110		z,  c,  nr
111		z,  c,  r


CCCC	condition			(easier-to-read list)
----------------------------------------------------------------------------
0000	never				1111	always			(default)
0001	nc  &  nz			1100	if_c							if_b
0010	nc  &  z			0011	if_nc							if_ae
0011	nc					1010	if_z							if_e
0100	 c  &  nz			0101	if_nz							if_ne
0101	nz					1000	if_c_and_z		if_z_and_c
0110	 c  <> z			0100	if_c_and_nz		if_nz_and_c
0111	nc  |  nz			0010	if_nc_and_z		if_z_and_nc
1000	 c  &  z			0001	if_nc_and_nz	if_nz_and_nc	if_a
1001	 c  =  z			1110	if_c_or_z		if_z_or_c		if_be
1010	 z					1101	if_c_or_nz		if_nz_or_c
1011	nc  |  z			1011	if_nc_or_z		if_z_or_nc
1100	 c					0111	if_nc_or_nz		if_nz_or_nc
1101	 c  |  nz			1001	if_c_eq_z		if_z_eq_c
1110	 c  |  z			0110	if_c_ne_z		if_z_ne_c
1111	always				0000	never


I	SSSSSSSSS	source operand
----------------------------------------------------------------------------
0	SSSSSSSSS	register
1	#SSSSSSSSS	immediate, zero-extended


	DDDDDDDDD	destination operand
----------------------------------------------------------------------------
	DDDDDDDDD	register

*/
/*@cexp:settings:2*/
module cloned_cog
(
//Eingabe- und Ausgabewerte
/*@cexp:port-ignore*/ input clk_pll, // clocks
/*@cexp:port-ignore*/ input clk_cog,
/*@cexp:port:1*/ input nres, // reset
/*@cexp:port:1*/ input ena_bus,
/*@cexp:port:1*/ input ptr_w, // pointers
/*@cexp:port:1*/ input [31:0]	ptr_d,
/*@cexp:port:1*/ input ena, // control
/*@cexp:port:1*/ input bus_sel, // bus
/*@cexp:port:1*/ output reg bus_r,
/*@cexp:port:1*/ output reg bus_e,
/*@cexp:port:1*/ output reg bus_w,
/*@cexp:port:1*/ output reg [31:0] bus_s,            
/*@cexp:port:1*/ output reg [31:0] bus_a,
/*@cexp:port:1*/ output reg [31:0] bus_d,
/*@cexp:port:1*/ input [31:0] bus_q,
/*@cexp:port:1*/ input bus_c,
/*@cexp:port:1*/ input bus_ack,
/*@cexp:port:1*/ input [31:0] cnt, // counter
/*@cexp:port:1*/ input [31:0] pll_in, // pll's
/*@cexp:port:1*/ input [31:0] pin_in, // pins
/*@cexp:port:0*/ output reg pll_out,
/*@cexp:port:1*/ output reg [31:0] pin_out,
/*@cexp:port:1*/ output reg [31:0] pin_dir,

//Sub Modul cog_alu
/*@cexp:submodule:cog_alu:cog_alu*/
/*@cexp:port-submodule:1:cog_alu:0*/ output reg [31:0] submod_cog_alu_i_in,
/*@cexp:port-submodule:1:cog_alu:0*/ output reg [31:0] submod_cog_alu_s_in,
/*@cexp:port-submodule:1:cog_alu:0*/ output reg [31:0] submod_cog_alu_d_in,
/*@cexp:port-submodule:1:cog_alu:0*/ output reg [31:0] submod_cog_alu_p_in,
/*@cexp:port-submodule:1:cog_alu:0*/ output reg submod_cog_alu_run_in,
/*@cexp:port-submodule:1:cog_alu:0*/ output reg submod_cog_alu_ci_in,
/*@cexp:port-submodule:1:cog_alu:0*/ output reg submod_cog_alu_zi_in,
/*@cexp:port-submodule:1:cog_alu:0*/ output reg [31:0] submod_cog_alu_bus_q_in,
/*@cexp:port-submodule:1:cog_alu:0*/ output reg submod_cog_alu_bus_c_in,
/*@cexp:port-submodule:1:cog_alu:0*/ input submod_cog_alu_wr_out,
/*@cexp:port-submodule:1:cog_alu:0*/ input [31:0] submod_cog_alu_r_out,
/*@cexp:port-submodule:1:cog_alu:0*/ input submod_cog_alu_co_out,
/*@cexp:port-submodule:1:cog_alu:0*/ input submod_cog_alu_zo_out,

//Sub Modul cog_vid
/*@cexp:submodule:cog_vid:cog_vid*/
/*@cexp:port-submodule-dummy*/ output reg submod_cog_vid_clk_cog_in,
/*@cexp:port-submodule-dummy*/ output reg submod_cog_vid_clk_vid_in,
/*@cexp:port-submodule:1:cog_vid:0*/ output reg submod_cog_vid_ena_in,
/*@cexp:port-submodule:1:cog_vid:0*/ output reg submod_cog_vid_setvid_in,
/*@cexp:port-submodule:1:cog_vid:0*/ output reg submod_cog_vid_setscl_in,
/*@cexp:port-submodule:1:cog_vid:0*/ output reg [31:0] submod_cog_vid_data_in,
/*@cexp:port-submodule:1:cog_vid:0*/ output reg [31:0] submod_cog_vid_pixel_in,
/*@cexp:port-submodule:1:cog_vid:0*/ output reg [31:0] submod_cog_vid_color_in,
/*@cexp:port-submodule:1:cog_vid:0*/ output reg [31:0] submod_cog_vid_aural_in,
/*@cexp:port-submodule:1:cog_vid:0*/ output reg submod_cog_vid_carrier_in,
/*@cexp:port-submodule:1:cog_vid:0*/ input submod_cog_vid_ack_out,
/*@cexp:port-submodule:1:cog_vid:0*/ input [31:0] submod_cog_vid_pin_out_out,

//Sub Modul cog_ctra
/*@cexp:submodule:cog_ctr:cog_ctra*/
/*@cexp:port-submodule-dummy*/ output reg submod_cog_ctra_clk_cog_in,
/*@cexp:port-submodule-dummy*/ output reg submod_cog_ctra_clk_pll_in,
/*@cexp:port-submodule:1:cog_ctra:1*/ output reg submod_cog_ctra_ena_in,
/*@cexp:port-submodule:1:cog_ctra:1*/ output reg submod_cog_ctra_setctr_in,
/*@cexp:port-submodule:1:cog_ctra:1*/ output reg submod_cog_ctra_setfrq_in,
/*@cexp:port-submodule:1:cog_ctra:1*/ output reg submod_cog_ctra_setphs_in,
/*@cexp:port-submodule:1:cog_ctra:1*/ output reg [31:0] submod_cog_ctra_data_in,
/*@cexp:port-submodule:1:cog_ctra:1*/ output reg [31:0] submod_cog_ctra_pin_in_in,
/*@cexp:port-submodule:1:cog_ctra:1*/ input [63:0] submod_cog_ctra_phs_out,
/*@cexp:port-submodule:1:cog_ctra:1*/ input [31:0] submod_cog_ctra_pin_out_out,
/*@cexp:port-submodule:0:cog_ctra:0*/ input submod_cog_ctra_pll_out,

//Sub Modul cog_ctrb
/*@cexp:submodule:cog_ctr:cog_ctrb*/
/*@cexp:port-submodule-dummy*/ output reg submod_cog_ctrb_clk_cog_in,
/*@cexp:port-submodule-dummy*/ output reg submod_cog_ctrb_clk_pll_in,
/*@cexp:port-submodule:1:cog_ctrb:1*/ output reg submod_cog_ctrb_ena_in,
/*@cexp:port-submodule:1:cog_ctrb:1*/ output reg submod_cog_ctrb_setctr_in,
/*@cexp:port-submodule:1:cog_ctrb:1*/ output reg submod_cog_ctrb_setfrq_in,
/*@cexp:port-submodule:1:cog_ctrb:1*/ output reg submod_cog_ctrb_setphs_in,
/*@cexp:port-submodule:1:cog_ctrb:1*/ output reg [31:0] submod_cog_ctrb_data_in,
/*@cexp:port-submodule:1:cog_ctrb:1*/ output reg [31:0] submod_cog_ctrb_pin_in_in,
/*@cexp:port-submodule:1:cog_ctrb:1*/ input [63:0] submod_cog_ctrb_phs_out,
/*@cexp:port-submodule:1:cog_ctrb:1*/ input [31:0] submod_cog_ctrb_pin_out_out,
/*@cexp:port-submodule:0:cog_ctrb:0*/ input submod_cog_ctrb_pll_out,

//Sub Modul cog_ram
/*@cexp:submodule:cog_ram:cog_ram*/
/*@cexp:port-submodule-dummy*/ output reg submod_cog_ram_clk_in,
/*@cexp:port-submodule:1:cog_ram:0*/ output reg submod_cog_ram_ena_in,
/*@cexp:port-submodule:1:cog_ram:0*/ output reg submod_cog_ram_w_in,
/*@cexp:port-submodule:1:cog_ram:0*/ output reg [31:0] submod_cog_ram_a_in,
/*@cexp:port-submodule:1:cog_ram:0*/ output reg [31:0] submod_cog_ram_d_in,
/*@cexp:port-submodule:1:cog_ram:0*/ input [31:0] submod_cog_ram_q_out,

//Register nach außen, nur zur Verifikation
/*@cexp:port-state*/ output reg [31:0] reg_ptr_d,
/*@cexp:port-state*/ output reg [31:0] reg_m_d,
/*@cexp:port-state*/ output reg reg_run_d,
/*@cexp:port-state*/ output reg [31:0] reg_p_d,
/*@cexp:port-state*/ output reg reg_c_d,
/*@cexp:port-state*/ output reg reg_z_d,
/*@cexp:port-state*/ output reg reg_cancel_d,
/*@cexp:port-state*/ output reg reg_match_d,
/*@cexp:port-state*/ output reg [31:0] reg_outa_d,
/*@cexp:port-state*/ output reg [31:0] reg_dira_d,
/*@cexp:port-state*/ output reg [31:0] reg_ix_d,
/*@cexp:port-state*/ output reg [31:0] reg_sy_d,
/*@cexp:port-state*/ output reg [31:0] reg_s_d,
/*@cexp:port-state*/ output reg [31:0] reg_d_d,
/*@cexp:port-state*/ input [27:0] reg_ptr_q,
/*@cexp:port-state*/ input [4:0] reg_m_q,
/*@cexp:port-state*/ input reg_run_q,
/*@cexp:port-state*/ input [8:0] reg_p_q,
/*@cexp:port-state*/ input reg_c_q,
/*@cexp:port-state*/ input reg_z_q,
/*@cexp:port-state*/ input reg_cancel_q,
/*@cexp:port-state*/ input reg_match_q,
/*@cexp:port-state*/ input [31:0] reg_outa_q,
/*@cexp:port-state*/ input [31:0] reg_dira_q,
/*@cexp:port-state*/ input [31:0] reg_ix_q,
/*@cexp:port-state*/ input [31:0] reg_sy_q,
/*@cexp:port-state*/ input [31:0] reg_s_q,
/*@cexp:port-state*/ input [31:0] reg_d_q,

//Taktflanken Signale
/*@cexp:port-clock:1*/ input posedge_clk_cog,
/*@cexp:port-clock:1*/ input negedge_nres,
/*@cexp:port-clock:1*/ input negedge_ena
);

//Fwd Clock Ports
/*@cexp:port-input:1*/ reg posedge_clk_pll;
/*@cexp:port-input:1*/ reg posedge_vclk;
/*@cexp:port-input:1*/ reg posedge_snc1;

//Interne Register
/*@cexp:reg-state:1:1*/ reg [31:0] flags; //1: carry, 0:zero
/*@cexp:reg-state:1:1*/ reg [31:0] dira;
/*@cexp:reg-state:1:1*/ reg [31:0] outa;
/*@cexp:reg-state:1:1*/ reg [31:0] instruction_reg;
/*@cexp:reg-state:1:1*/ reg [31:0] sy_reg;
/*@cexp:reg-state:1:1*/ reg [31:0] source;
/*@cexp:reg-state:1:1*/ reg [31:0] dest;
/*@cexp:reg-state:1:1*/ reg [31:0] p_reg;
/*@cexp:reg-state:1:1*/ reg [31:0] progctr;
/*@cexp:reg-state:1:1*/ reg [31:0] state;
/*@cexp:reg-state:1:1*/ reg match;
/*@cexp:reg-state:1:1*/ reg cancel;
/*@cexp:reg-state:1:1*/ reg running;
/*@cexp:reg-state:0,1:0*/ reg plla_saved;
/*@cexp:reg-state:0,1:0*/ reg pllb_saved;


//Lokale Variablen
/*@cexp:reg-local:1*/ reg [31:0] sx;
/*@cexp:reg-local:1*/ reg [31:0] px;
/*@cexp:reg-local:1*/ reg [31:0] i;
/*@cexp:reg-local:1*/ reg [31:0] instr_src;
/*@cexp:reg-local:1*/ reg [31:0] instr_dst;
/*@cexp:reg-local:1*/ reg [31:0] instr_opcode;
/*@cexp:reg-local:1*/ reg jump;
/*@cexp:reg-local:1*/ reg cond;
/*@cexp:reg-local:1*/ reg jump_cancel;
/*@cexp:reg-local:1*/ reg wio;
/*@cexp:reg-local:1*/ reg match_prev;


localparam [31:0] StateNoN     = 0;
localparam [31:0] StateRdS     = 1;
localparam [31:0] StateRdD     = 2;
localparam [31:0] StateRdI     = 3;
localparam [31:0] StateWrD     = 4;
localparam [31:0] StateWai     = 5;

always @(*) begin
    /*@cexp:dummyinit-start*/
    bus_r = 0;
    bus_e = 0;
    bus_w = 0;
    bus_s = 0;
    bus_a = 0;
    bus_d = 0;
    pll_out = 0;
    pin_out = 0;
    pin_dir = 0;
    reg_ptr_d = 0;
    reg_m_d = 0;
    reg_run_d = 0;
    reg_p_d = 0;
    reg_c_d = 0;
    reg_z_d = 0;
    reg_cancel_d = 0;
    reg_match_d = 0;
    reg_outa_d = 0;
    reg_dira_d = 0;
    reg_ix_d = 0;
    reg_sy_d = 0;
    reg_s_d = 0;
    reg_d_d = 0;
    sx=0;
    jump=0;
    px=0;
    i=0;
    cond=0;
    jump_cancel=0;
    wio=0;
    state = 0;
    dira = 0;
    outa = 0;
    instruction_reg = 0;
    sy_reg = 0;
    source = 0;
    dest = 0;
    match = 0;
    cancel = 0;
    running = 0;
    p_reg = 0;
    progctr = 0;
    instr_src  = 0;
    instr_dst = 0;
    instr_opcode = 0;
    flags = 0;
    match_prev = 0;
    submod_cog_alu_i_in   = 0;
    submod_cog_alu_s_in   = 0;
    submod_cog_alu_d_in   = 0;
    submod_cog_alu_p_in   = 0;
    submod_cog_alu_run_in = 0;
    submod_cog_alu_ci_in  = 0;
    submod_cog_alu_zi_in  = 0;
    submod_cog_alu_bus_q_in = 0;
    submod_cog_alu_bus_c_in = 0;
    submod_cog_ram_clk_in = 0;
    submod_cog_ram_ena_in = 0;
    submod_cog_ram_w_in = 0;
    submod_cog_ram_a_in = 0;
    submod_cog_ram_d_in = 0;
    submod_cog_ctra_clk_cog_in = 0;
    submod_cog_ctra_clk_pll_in = 0;
    submod_cog_ctra_ena_in     = 0;
    submod_cog_ctra_setctr_in  = 0;
    submod_cog_ctra_setfrq_in  = 0;
    submod_cog_ctra_setphs_in  = 0;
    submod_cog_ctra_data_in    = 0;
    submod_cog_ctra_pin_in_in  = 0;
    submod_cog_ctrb_clk_cog_in = 0;
    submod_cog_ctrb_clk_pll_in = 0;
    submod_cog_ctrb_ena_in     = 0;
    submod_cog_ctrb_setctr_in  = 0;
    submod_cog_ctrb_setfrq_in  = 0;
    submod_cog_ctrb_setphs_in  = 0;
    submod_cog_ctrb_data_in    = 0;
    submod_cog_ctrb_pin_in_in  = 0;
    submod_cog_vid_clk_cog_in =  0;
    submod_cog_vid_clk_vid_in =  0;
    submod_cog_vid_ena_in     =  0;
    submod_cog_vid_setvid_in  =  0;
    submod_cog_vid_setscl_in  =  0;
    submod_cog_vid_data_in    =  0;
    submod_cog_vid_pixel_in   =  0;
    submod_cog_vid_color_in   =  0;
    submod_cog_vid_aural_in   =  0;
    submod_cog_vid_carrier_in =  0;
    plla_saved = 0;
    pllb_saved = 0;
    /*@cexp:dummyinit-stop*/

    
    if (reg_m_q == 1)
        state = StateRdS;
    else if (reg_m_q == 2)
        state = StateRdD;
    else if (reg_m_q == 4)
        state = StateRdI;
    else if (reg_m_q == 8)
        state = StateWrD;
    else if (reg_m_q == 16)
        state = StateWai;
    else
        state = StateNoN;
    flags[1] = reg_c_q;
    flags[0] = reg_z_q;
    dira = reg_dira_q;
    outa = reg_outa_q;
    instruction_reg = reg_ix_q;
    sy_reg = reg_sy_q;
    source = reg_s_q;
    dest = reg_d_q;
    match = reg_match_q;
    cancel = reg_cancel_q;
    running = reg_run_q;
    p_reg = reg_p_q;
    progctr = reg_ptr_q;
    
    
    //TODO wie clock machen?
    submod_cog_ctra_clk_cog_in = clk_cog;
    submod_cog_ctra_clk_pll_in = clk_pll;
    submod_cog_ctrb_clk_cog_in = clk_cog;
    submod_cog_ctrb_clk_pll_in = clk_pll;
    submod_cog_vid_clk_cog_in = clk_cog;
    submod_cog_ram_clk_in      = clk_cog;
    submod_cog_vid_clk_vid_in = submod_cog_ctra_pll_out;
    
    
    //Hier geht es los
    /*@cexp:code-start:clocks_cog*/
    /*@cexp:declare-module-input:cog_ctr:cog_ctra:0*/
    /*@cexp:call-module:cog_ctr:cog_ctra:0:noclock*/
    /*@cexp:declare-module-input:cog_ctr:cog_ctrb:0*/
    /*@cexp:call-module:cog_ctr:cog_ctrb:0:noclock*/
    plla_saved = submod_cog_ctra_pll_out;
    pllb_saved = submod_cog_ctrb_pll_out;
    pll_out     = plla_saved;//submod_cog_ctra_pll_out;
    /*@cexp:code-stop*/
    /*@cexp:code-start:clocks_cog*/
    i = mux32(running,instruction_reg,or32(32'b000010_001_0_0001_000000000_000000000,shl32(p_reg,9)));
    instr_opcode = and32(shr32(i,26),32'h3F);
    
    bus_r = 0;
    bus_e = 0;
    bus_w = 0;
    bus_s = 0;
    bus_a = 0;
    bus_d = 0;
    if (bus_sel) begin
        bus_r = running;
        bus_e = andB(eq32(state,StateWai),eq32(and32(instr_opcode,32'h3C),0));
        bus_w = notB(testBit32(i,23));
        bus_s = and32(instr_opcode,3);
        bus_a = mux32(running,and32(source,32'hFFFF),or32(and32(shl32(add32(and32(progctr,32'hFFFFF),p_reg),2),32'hFFFF),and32(source,3)));
        bus_d = dest;
    end
    
    instr_dst  = and32(shr32(i,9),32'h1FF);
    instr_src  = and32(i,32'h1FF);
    
    /*@cexp:declare-module-input:cog_alu:cog_alu:0*/
    submod_cog_alu_i_in     = instr_opcode;
    submod_cog_alu_s_in     = source;
    submod_cog_alu_d_in     = dest;
    submod_cog_alu_p_in     = p_reg;
    submod_cog_alu_run_in   = running;
    submod_cog_alu_ci_in    = testBit32(flags,1);
    submod_cog_alu_zi_in    = testBit32(flags,0);
    submod_cog_alu_bus_q_in = bus_q;
    submod_cog_alu_bus_c_in = bus_c;
    /*@cexp:call-module:cog_alu:cog_alu:0:noclock*/
    
    cond = andB(notB(cancel),eq32(and32(shr32(and32(shr32(i,18),15),flags),1),1));
    if (orB(eq32(state,StateRdI),eq32(state,StateWrD))) begin
        jump = 1'b1;
        if (eq32(instr_opcode,6'b010111)) begin
            jump_cancel = 1'b0;
        end else if (eq32(instr_opcode,6'b111001)) begin
            jump_cancel = eq32(dest,1);
        end else if (eq32(instr_opcode,6'b111010)) begin
            jump_cancel = eq32(dest,0);
        end else if (eq32(instr_opcode,6'b111011)) begin
            jump_cancel = neq32(dest,0);
        end else begin
            jump = 1'b0;
        end
        wio = andB(andB(eq32(state,StateWrD),cond),testBit32(i,23));
    end
    
    /*@cexp:declare-module-input:cog_ctr:cog_ctra:1*/
    submod_cog_ctra_ena_in     = ena;
    submod_cog_ctra_setctr_in  = andB(wio,eq32(instr_dst,32'h1F8));
    submod_cog_ctra_setfrq_in  = andB(wio,eq32(instr_dst,32'h1FA));
    submod_cog_ctra_setphs_in  = andB(wio,eq32(instr_dst,32'h1FC));
    submod_cog_ctra_data_in    = submod_cog_alu_r_out;
    submod_cog_ctra_pin_in_in  = pin_in;
    /*@cexp:call-module:cog_ctr:cog_ctra:1:clockfwd*/
    
    /*@cexp:declare-module-input:cog_ctr:cog_ctrb:1*/
    submod_cog_ctrb_ena_in     = ena;
    submod_cog_ctrb_setctr_in  = andB(wio,eq32(instr_dst,32'h1F9));
    submod_cog_ctrb_setfrq_in  = andB(wio,eq32(instr_dst,32'h1FB));
    submod_cog_ctrb_setphs_in  = andB(wio,eq32(instr_dst,32'h1FD));
    submod_cog_ctrb_data_in    = submod_cog_alu_r_out;
    submod_cog_ctrb_pin_in_in  = pin_in;
    /*@cexp:call-module:cog_ctr:cog_ctrb:1:clockfwd*/
    
    if (orB(eq32(state,StateRdI),eq32(state,StateWrD))) begin
        sx = mux32(testBit32(i,22),instr_src,
                    mux32(le32(instr_src,32'h1F0),sy_reg,
                    mux32(eq32(instr_src,32'h1F0),and32(shr32(progctr,12),32'hFFFC),
                    mux32(eq32(instr_src,32'h1F1),cnt,
                    mux32(eq32(instr_src,32'h1F2),pin_in,
                    mux32(eq32(instr_src,32'h1FC),lower32(submod_cog_ctra_phs_out),
                    mux32(eq32(instr_src,32'h1FD),lower32(submod_cog_ctrb_phs_out),
                    sy_reg)))))));
        px = and32(mux32(andB(cond,jump),sx,p_reg),32'h1FF);
        
    end
    
    
    /*@cexp:declare-module-input:cog_vid:cog_vid:0*/
    submod_cog_vid_ena_in     = ena;
    submod_cog_vid_setvid_in  = andB(wio,eq32(instr_dst,32'h1FE));
    submod_cog_vid_setscl_in  = andB(wio,eq32(instr_dst,32'h1FF));
    submod_cog_vid_data_in    = submod_cog_alu_r_out;
    submod_cog_vid_pixel_in   = source;
    submod_cog_vid_color_in   = dest;
    submod_cog_vid_aural_in   = pll_in;
    submod_cog_vid_carrier_in = pllb_saved;//submod_cog_ctrb_pll_out;
    /*@cexp:call-module:cog_vid:cog_vid:0:clockfwd*/
    
    pin_out     = and32(or32(or32(or32(outa,submod_cog_ctra_pin_out_out),submod_cog_ctrb_pin_out_out),submod_cog_vid_pin_out_out),dira);
    pin_dir     = dira;
    
    /*@cexp:declare-module-input:cog_ram:cog_ram:0*/
    submod_cog_ram_ena_in      = orB(inRange32(state,StateRdS,StateRdI),andB(andB(eq32(state,StateWrD),cond),testBit32(i,23)));
    submod_cog_ram_w_in        = andB(eq32(state,StateWrD),submod_cog_alu_wr_out);
    submod_cog_ram_a_in        = mux32(eq32(state,StateRdI),px,mux32(eq32(state,StateRdS),instr_src,instr_dst));
    submod_cog_ram_d_in        = submod_cog_alu_r_out;
    /*@cexp:call-module:cog_ram:cog_ram:0:clockfwd*/
    
    if (orB(posedge_clk_cog,negedge_nres)) begin
        if (notB(nres)) begin
            progctr = 28'b00000000000000_11111000000000;
        end else if (andB(ena_bus,ptr_w)) begin
            progctr = ptr_d;
        end
    end
    match_prev = match;
    if (orB(posedge_clk_cog,negedge_ena)) begin
        
        if (notB(ena)) begin
            running = 1'b0;
            p_reg = 1'b0;
            flags = 0;
            dira = 32'b0;
            cancel = 1'b0;
        end else begin
            if (eq32(state,StateWrD)) begin
                if (eq32(px,32'h1FF)) begin
                    running = 1'b1;
                end
                if (notB(andB(cond,jump_cancel))) begin
                    p_reg = and32(add32(px,1),32'h1FF);
                end
                if (andB(cond,testBit32(i,24))) begin
                    flags = mux32(submod_cog_alu_co_out,or32(flags,2),and32(flags,1));
                end
                if (andB(cond,testBit32(i,25))) begin
                    flags = mux32(submod_cog_alu_zo_out,or32(flags,1),and32(flags,2));
                end
                cancel = orB(andB(cond,jump_cancel),eq32(px,32'h1FF));
            end
                
            if (andB(wio,eq32(instr_dst,32'h1F6))) begin //setdira
                dira = submod_cog_alu_r_out;
            end
        end
            
        if (posedge_clk_cog) begin
            if (andB(wio,eq32(instr_dst,32'h1F4))) begin //setouta
                outa = submod_cog_alu_r_out;
            end
            if (eq32(state,StateWrD)) begin
                instruction_reg = submod_cog_ram_q_out;
            end
            if (eq32(state,StateRdD)) begin
                sy_reg = submod_cog_ram_q_out;
            end
            match = andB(eq32(state,StateWai),neqB(eq32(and32(instr_opcode,3),2'b01),eq32(mux32(testBit32(i,27),cnt,and32(pin_in,source)),dest)));
            if (eq32(state,StateRdI)) begin
                source = sx;
                dest = submod_cog_ram_q_out;
            end
        end
            
        if (notB(ena)) begin
            state = StateNoN;
        end
        else begin
            case (state)
                StateNoN: begin
                    state = StateRdS;
                end
                StateRdS: begin
                    state = StateRdD;
                end
                StateRdD: begin
                    state = StateRdI;
                end
                StateRdI,StateWai: begin
                    state = mux32(andB(cond,muxB(
                        eq32(and32(instr_opcode,32'h3c),6'b000000),notB(bus_ack),
                    muxB(orB(eq32(and32(instr_opcode,32'h3e),6'b111100),eq32(instr_opcode,6'b111110)),
                        notB(match_prev),
                        andB(eq32(instr_opcode,6'b111111),notB(submod_cog_vid_ack_out)))
                        )),StateWai,StateWrD);
                end
                StateWrD: begin
                    state = StateRdS;
                end
            endcase
        end
    end
    /*@cexp:code-stop*/
    
    
    
    //Register upate
    if (state == StateRdS)
        reg_m_d = 1;
    else if (state == StateRdD)
        reg_m_d = 2;
    else if (state == StateRdI)
        reg_m_d = 4;
    else if (state == StateWrD)
        reg_m_d = 8;
    else if (state == StateWai)
        reg_m_d = 16;
    else
        reg_m_d = 0;
    
    reg_c_d = flags[1];
    reg_z_d = flags[0];
    reg_dira_d = dira;
    reg_outa_d = outa;
    reg_ix_d = instruction_reg;
    reg_sy_d = sy_reg;
    reg_d_d = dest;
    reg_s_d = source;
    reg_match_d = match;
    reg_cancel_d = cancel;
    reg_run_d = running;
    reg_p_d = p_reg;
    reg_ptr_d = progctr;
    
    /*@cexp:always-block-end*/
end

endmodule
