// cog_ram

/*
-------------------------------------------------------------------------------
Copyright 2014 Parallax Inc.

This file is part of the hardware description for the Propeller 1 Design.

The Propeller 1 Design is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by the
Free Software Foundation, either version 3 of the License, or (at your option)
any later version.

The Propeller 1 Design is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
more details.

You should have received a copy of the GNU General Public License along with
the Propeller 1 Design.  If not, see <http://www.gnu.org/licenses/>.
-------------------------------------------------------------------------------
*/

module cloned_cog_ram
(
input clk,
input ena,
input w,
input [8:0] a,
input [31:0] d,

output [31:0] q,


input [31:0] reg_q_q,
output reg [31:0] reg_q_d,
input [32*512-1:0] reg_r_q,
output reg [32*512-1:0] reg_r_d,

input posedge_clk
);


// 512 x 32 ram

always @(*)
begin
    reg_q_d = reg_q_q;
    reg_r_d = reg_r_q;
    if (posedge_clk && ena) begin
        if (w)
            reg_r_d[a*32+31:a*32] = d;
        q = reg_r_q[a*32+31:a*32];
    end
end

endmodule
