// cog_vid

/*
-------------------------------------------------------------------------------
Copyright 2014 Parallax Inc.

This file is part of the hardware description for the Propeller 1 Design.

The Propeller 1 Design is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by the
Free Software Foundation, either version 3 of the License, or (at your option)
any later version.

The Propeller 1 Design is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
more details.

You should have received a copy of the GNU General Public License along with
the Propeller 1 Design.  If not, see <http://www.gnu.org/licenses/>.
-------------------------------------------------------------------------------
*/
/*@cexp:settings:1*/
module cloned_cog_vid
(
//Eingabe- und Ausgabewerte
/*@cexp:port-ignore*/ input clk_cog,
/*@cexp:port-ignore*/ input clk_vid,
/*@cexp:port:0*/ input ena,
/*@cexp:port:0*/ input setvid,
/*@cexp:port:0*/ input setscl,
/*@cexp:port:0*/ input [31:0] data,
/*@cexp:port:0*/ input [31:0] pixel,
/*@cexp:port:0*/ input [31:0] color,
/*@cexp:port:0*/ input [31:0] aural,
/*@cexp:port:0*/ input carrier,
/*@cexp:port:0*/ output reg ack,
/*@cexp:port:0*/ output reg [31:0] pin_out,

//Register nach außen, nur zur Verifikation
/*@cexp:port-state*/ output reg [31:0] reg_vid_d,
/*@cexp:port-state*/ output reg [31:0] reg_scl_d,
/*@cexp:port-state*/ output reg [31:0] reg_cnts_d,
/*@cexp:port-state*/ output reg [31:0] reg_cnt_d,
/*@cexp:port-state*/ output reg [31:0] reg_set_d,
/*@cexp:port-state*/ output reg [31:0] reg_pixels_d,
/*@cexp:port-state*/ output reg [31:0] reg_colors_d,
/*@cexp:port-state*/ output reg [31:0] reg_discrete_d,
/*@cexp:port-state*/ output reg [31:0] reg_snc_d,
/*@cexp:port-state*/ output reg [31:0] reg_phase_d,
/*@cexp:port-state*/ output reg [31:0] reg_baseband_d,
/*@cexp:port-state*/ output reg [31:0] reg_composite_d,
/*@cexp:port-state*/ output reg reg_cap_d,

/*@cexp:port-state*/ input [31:0] reg_vid_q,
/*@cexp:port-state*/ input [31:0] reg_scl_q,
/*@cexp:port-state*/ input  [7:0] reg_cnts_q,
/*@cexp:port-state*/ input  [7:0] reg_cnt_q,
/*@cexp:port-state*/ input [11:0] reg_set_q,
/*@cexp:port-state*/ input [31:0] reg_pixels_q,
/*@cexp:port-state*/ input [31:0] reg_colors_q,
/*@cexp:port-state*/ input [7:0] reg_discrete_q,
/*@cexp:port-state*/ input reg_cap_q,
/*@cexp:port-state*/ input [1:0] reg_snc_q,
/*@cexp:port-state*/ input [3:0] reg_phase_q,
/*@cexp:port-state*/ input [3:0] reg_baseband_q,
/*@cexp:port-state*/ input [2:0] reg_composite_q,

//Taktflanken Signale
/*@cexp:port-clock:0*/ input posedge_clk_cog,
/*@cexp:port-clock:0*/ input negedge_ena,
/*@cexp:port-clock:0*/ input posedge_vclk,
/*@cexp:port-clock:0*/ input posedge_snc1,

//Taktflanken Ausgangs Signale //TODO cexp richtig?
/*@cexp:port-ignore*/ output reg vclk_trgout,
/*@cexp:port-ignore*/ output reg snc1_trgout
);

//Diese Register werden später nicht gebraucht
/*@cexp:reg-dummy*/ reg vcfg_dummy1;
/*@cexp:reg-dummy*/ reg [31:0] vcfg_dummy2;
/*@cexp:reg-dummy*/ reg vcfg_dummy3;
/*@cexp:reg-dummy*/ reg [31:0] vscl_dummy;


//Interne Register
/*@cexp:reg-state:0:0*/ reg [31:0] vcfg_vmode;
/*@cexp:reg-state:0:0*/ reg [31:0] vcfg_auralsub;
/*@cexp:reg-state:0:0*/ reg [31:0] vcfg_vgroup;
/*@cexp:reg-state:0:0*/ reg [31:0] vcfg_vpins;
/*@cexp:reg-state:0:0*/ reg [31:0] vscl_pixelclocks;
/*@cexp:reg-state:0:0*/ reg [31:0] vscl_frameclocks;
/*@cexp:reg-state:0:0*/ reg [31:0] composite;
/*@cexp:reg-state:0:0*/ reg [31:0] baseband;
/*@cexp:reg-state:0:0*/ reg [31:0] phase;
/*@cexp:reg-state:0:0*/ reg [31:0] discrete;
/*@cexp:reg-state:0:0*/ reg [31:0] saved_pixels;
/*@cexp:reg-state:0:0*/ reg [31:0] saved_colors;
/*@cexp:reg-state:0:0*/ reg [31:0] cnts;
/*@cexp:reg-state:0:0*/ reg [31:0] cnt0;
/*@cexp:reg-state:0:0*/ reg [31:0] setr;
/*@cexp:reg-state:0:0*/ reg vcfg_cmode;
/*@cexp:reg-state:0:0*/ reg vcfg_chroma1;
/*@cexp:reg-state:0:0*/ reg vcfg_chroma0;
/*@cexp:reg-state:0:0*/ reg capr;
/*@cexp:reg-state:0:0*/ reg snc0;
/*@cexp:reg-state:0:0*/ reg snc1;

//Lokale Variablen
/*@cexp:reg-local:0*/ reg [31:0] local_colormod;
/*@cexp:reg-local:0*/ reg local_enable;
/*@cexp:reg-local:0*/ reg local_new_set;
/*@cexp:reg-local:0*/ reg local_new_cnt;
/*@cexp:reg-local:0*/ reg local_capr_next;
/*@cexp:reg-local:0*/ reg local_colorphs;

always @(*) begin
    /*@cexp:dummyinit-start*/
    ack = 0;
    pin_out = 0;
    reg_vid_d = 0;
    reg_scl_d = 0;
    reg_cnts_d = 0;
    reg_cnt_d = 0;
    reg_set_d = 0;
    reg_pixels_d = 0;
    reg_colors_d = 0;
    reg_discrete_d = 0;
    reg_snc_d = 0;
    reg_phase_d = 0;
    reg_baseband_d = 0;
    reg_composite_d = 0;
    reg_cap_d = 0;
    vcfg_vmode = 0;
    vcfg_auralsub = 0;
    vcfg_vgroup = 0;
    vcfg_vpins = 0;
    vscl_pixelclocks = 0;
    vscl_frameclocks = 0;
    composite = 0;
    baseband = 0;
    phase = 0;
    discrete = 0;
    saved_pixels = 0;
    saved_colors = 0;
    cnts = 0;
    cnt0 = 0;
    setr = 0;
    vcfg_cmode = 0;
    vcfg_chroma1 = 0;
    vcfg_chroma0 = 0;
    capr = 0;
    snc0 = 0;
    snc1 = 0;
    local_enable = 0;
    local_new_set = 0;
    local_new_cnt = 0;
    local_capr_next = 0;
    local_colorphs = 0;
    local_colormod = 0;
    vcfg_dummy1 = 0;
    vcfg_dummy2 = 0;
    vcfg_dummy3 = 0;
    vscl_dummy = 0;
    /*@cexp:dummyinit-stop*/
    vclk_trgout = 0; //TODO
    snc1_trgout = 0; //TODO
    
    vcfg_dummy1 = reg_vid_q[31];
    vcfg_dummy2 = reg_vid_q[22:11];
    vcfg_dummy3 = reg_vid_q[8];
    vcfg_vmode = reg_vid_q[30:29];
    vcfg_cmode = reg_vid_q[28];
    vcfg_chroma1 = reg_vid_q[27];
    vcfg_chroma0 = reg_vid_q[26];
    vcfg_auralsub = reg_vid_q[25:23];
    vcfg_vgroup = reg_vid_q[10:9]<<3; //im manual sind 11:9; wird um 3 Bits geshifted gespeichert
    vcfg_vpins = reg_vid_q[7:0];
    
    vscl_dummy = reg_scl_q[31:20];
    vscl_pixelclocks = reg_scl_q[19:12];
    vscl_frameclocks = reg_scl_q[11:0];
    
    composite = reg_composite_q;
    baseband = reg_baseband_q;
    phase = reg_phase_q;
    discrete = reg_discrete_q;
    saved_pixels = reg_pixels_q;
    saved_colors = reg_colors_q;
    cnts = reg_cnts_q;
    cnt0 = reg_cnt_q;
    setr = reg_set_q;
    capr = reg_cap_q;
    snc0 = reg_snc_q[0];
    snc1 = reg_snc_q[1];
    
    
    
    //Hier geht es los
    //TODO wie clock edge signale implementieren
    snc1_trgout = snc1;
    vclk_trgout = clk_vid && neq32(vcfg_vmode,0);
    /*@cexp:code-start:clocks_cog*/
    local_enable = neq32(vcfg_vmode,0);
    local_capr_next = capr;
    ack = snc0;
    
    
    pin_out = 0;
    case (vcfg_vmode)
        3: begin
            pin_out = shl32(and32(add32(add32(shl32(baseband,4),mux32(neqB(carrier,testBit32(aural,vcfg_auralsub)),32'h08,0)),mux32(carrier,sub32(7,shr32(add32(composite,1),1)),and32(shr32(composite,1),3))),vcfg_vpins),vcfg_vgroup);
        end
        2: begin
            pin_out = shl32(and32(add32(add32(baseband,mux32(neqB(carrier,testBit32(aural,vcfg_auralsub)),32'h80,0)),shl32(mux32(carrier,sub32(7,shr32(add32(composite,1),1)),and32(shr32(composite,1),3)),4)),vcfg_vpins),vcfg_vgroup);
        end
        1: begin
            pin_out = shl32(and32(discrete,vcfg_vpins),vcfg_vgroup);
        end
        0: begin
            pin_out = 0;
        end
    endcase
    
    if (orB(posedge_vclk,posedge_snc1)) begin
        local_new_set = eq32(setr,1'b1);
        local_new_cnt = eq32(cnt0,1'b1);
        if (snc1) begin
            local_capr_next = 1'b0;
        end else if (local_new_set) begin
            local_capr_next = 1'b1;
        end
        if (posedge_vclk) begin
            local_colorphs = 1'b0;
            local_colormod = discrete;
            if (neq32(and32(discrete,8),0)) begin
                local_colorphs = neq32(and32(add32(and32(shr32(discrete,4),32'hF),phase),8),0);
                local_colormod = add32(local_colormod,mux32(local_colorphs,7,1));
            end
        
            cnt0 = and32(mux32(local_new_set,vscl_pixelclocks,mux32(local_new_cnt,cnts,sub32(cnt0,1'b1))),32'hFF);
            setr = and32(mux32(local_new_set,vscl_frameclocks,sub32(setr,1'b1)),32'hFFF);
            
            if (local_new_set) begin
                cnts = and32(vscl_pixelclocks,32'hFF);
            end
                
            phase = and32(add32(phase,1'b1),32'hF);
            baseband = add32(mux32(local_colorphs,8,0), and32(mux32(vcfg_chroma0,local_colormod,discrete),7));
            composite = and32(mux32(vcfg_chroma1,local_colormod,discrete),7);
            if (andB(vcfg_cmode,eq32(and32(saved_pixels,3),3))) begin
                discrete = and32(shr32(saved_colors,24),32'hFF);
            end else if (andB(vcfg_cmode,eq32(and32(saved_pixels,3),2))) begin
                discrete = and32(shr32(saved_colors,16),32'hFF);
            end else if (eq32(and32(saved_pixels,1),1)) begin
                discrete = and32(shr32(saved_colors,8),32'hFF);
            end else begin
                discrete = and32(saved_colors,32'hFF);
            end
            
            if (local_new_set) begin
                saved_pixels = pixel;
                saved_colors = color;
            end else if (local_new_cnt) begin
                saved_pixels = mux32(vcfg_cmode,or32(and32(saved_pixels,32'hC0000000),shr32(saved_pixels,2)),or32(and32(saved_pixels,32'h80000000),shr32(saved_pixels,1)));
            end
        end
    end
    
    
    
    
    if (orB(posedge_clk_cog,negedge_ena)) begin
        if (notB(ena)) begin
            //vcfg_dummy1 = 0;
            //vcfg_dummy2 = 0;
            //vcfg_dummy3 = 0;

            vcfg_vmode = 0;
            vcfg_cmode = 0;
            vcfg_chroma1 = 0;
            vcfg_chroma0 = 0;
            vcfg_auralsub = 0;
            vcfg_vgroup = 0;
            vcfg_vpins = 0;
            
        end else if (setvid) begin
            //vcfg_dummy1 = eq32(and32(shr32(data,31),1),1);
            //vcfg_dummy2 = and32(shr32(data,11),32'hFFF);
            //vcfg_dummy3 = eq32(and32(shr32(data,8),1),1);

            vcfg_vmode = and32(shr32(data,29),3);
            vcfg_cmode = eq32(and32(shr32(data,28),1),1);
            vcfg_chroma1 = eq32(and32(shr32(data,27),1),1);
            vcfg_chroma0 = eq32(and32(shr32(data,26),1),1);
            vcfg_auralsub = and32(shr32(data,23),7);
            vcfg_vgroup = shl32(and32(shr32(data,9),3),3);
            vcfg_vpins = and32(data,32'hFF);
        end
    end
    if (posedge_clk_cog) begin
        if (setscl) begin
            //vscl_dummy = and32(shr32(data,20),32'hFFF);
            vscl_pixelclocks = and32(shr32(data,12),32'hFF);
            vscl_frameclocks = and32(data,32'hFFF);
        end
        if (local_enable) begin
            snc1 = snc0;
            snc0 = capr;
        end
    end
    capr = local_capr_next;
     /*@cexp:code-stop*/
    
    
    //Damit die Verifikation richtig ist
    if (orB(posedge_clk_cog,negedge_ena)) begin
        if (notB(ena)) begin
            vcfg_dummy1 = 0;
            vcfg_dummy2 = 0;
            vcfg_dummy3 = 0;
            
        end else if (setvid) begin
            vcfg_dummy1 = eq32(and32(shr32(data,31),1),1);
            vcfg_dummy2 = and32(shr32(data,11),32'hFFF);
            vcfg_dummy3 = eq32(and32(shr32(data,8),1),1);
        end
    end
    if (posedge_clk_cog) begin
        if (setscl) begin
            vscl_dummy = and32(shr32(data,20),32'hFFF);
        end
    end
    
    //Register Update, nicht mehr teil des C++ Codes
    reg_vid_d = {vcfg_dummy1,vcfg_vmode[1:0],vcfg_cmode,vcfg_chroma1,vcfg_chroma0,vcfg_auralsub[2:0],vcfg_dummy2[11:0],vcfg_vgroup[4:3],vcfg_dummy3,vcfg_vpins[7:0]};
    reg_scl_d = {vscl_dummy[11:0],vscl_pixelclocks[7:0],vscl_frameclocks[11:0]};
    reg_composite_d = composite;
    reg_baseband_d = baseband;
    reg_phase_d = phase;
    reg_discrete_d = discrete;
    reg_pixels_d = saved_pixels;
    reg_colors_d = saved_colors;
    reg_cnts_d = cnts;
    reg_cnt_d = cnt0;
    reg_set_d = setr;
    reg_cap_d = capr;
    reg_snc_d = {snc1,snc0};
    
    /*@cexp:always-block-end*/
end
endmodule
