module verifyequal_cog_vid (
input [31:0] data,
input [7:0] reg_cnt_q,
input clk_vid,
input posedge_vclk,
input [3:0] reg_baseband_q,
input [3:0] reg_phase_q,
input [31:0] reg_scl_q,
input clk_cog,
input [7:0] reg_discrete_q,
input posedge_clk_cog,
input [31:0] color,
input [7:0] reg_cnts_q,
input [2:0] reg_composite_q,
input ena,
input [31:0] pixel,
input [31:0] reg_colors_q,
input [7:0] aural,
input [31:0] reg_vid_q,
input negedge_ena,
input [31:0] reg_pixels_q,
input setvid,
input carrier,
input reg_cap_q,
input posedge_snc1,
input [1:0] reg_snc_q,
input setscl,
input [11:0] reg_set_q
);
wire [31:0] pin_out_expected;
wire [31:0] pin_out_result;
wire [31:0] reg_scl_d_expected;
wire [31:0] reg_scl_d_result;
wire ack_expected;
wire ack_result;
wire snc1_trgout_expected;
wire snc1_trgout_result;
wire [7:0] reg_cnt_d_expected;
wire [31:0] reg_cnt_d_result;
wire vclk_trgout_expected;
wire vclk_trgout_result;
wire [7:0] reg_discrete_d_expected;
wire [31:0] reg_discrete_d_result;
wire [11:0] reg_set_d_expected;
wire [31:0] reg_set_d_result;
wire [2:0] reg_composite_d_expected;
wire [31:0] reg_composite_d_result;
wire [31:0] reg_pixels_d_expected;
wire [31:0] reg_pixels_d_result;
wire [3:0] reg_phase_d_expected;
wire [31:0] reg_phase_d_result;
wire reg_cap_d_expected;
wire reg_cap_d_result;
wire [7:0] reg_cnts_d_expected;
wire [31:0] reg_cnts_d_result;
wire [3:0] reg_baseband_d_expected;
wire [31:0] reg_baseband_d_result;
wire [31:0] reg_colors_d_expected;
wire [31:0] reg_colors_d_result;
wire [1:0] reg_snc_d_expected;
wire [31:0] reg_snc_d_result;
wire [31:0] reg_vid_d_expected;
wire [31:0] reg_vid_d_result;
cog_vid golden(
    .data (data),
    .pin_out (pin_out_expected),
    .reg_cnt_q (reg_cnt_q),
    .reg_scl_d (reg_scl_d_expected),
    .ack (ack_expected),
    .snc1_trgout (snc1_trgout_expected),
    .clk_vid (clk_vid),
    .reg_cnt_d (reg_cnt_d_expected),
    .posedge_vclk (posedge_vclk),
    .reg_baseband_q (reg_baseband_q),
    .vclk_trgout (vclk_trgout_expected),
    .reg_discrete_d (reg_discrete_d_expected),
    .reg_phase_q (reg_phase_q),
    .reg_scl_q (reg_scl_q),
    .clk_cog (clk_cog),
    .reg_discrete_q (reg_discrete_q),
    .posedge_clk_cog (posedge_clk_cog),
    .color (color),
    .reg_set_d (reg_set_d_expected),
    .reg_cnts_q (reg_cnts_q),
    .reg_composite_q (reg_composite_q),
    .reg_composite_d (reg_composite_d_expected),
    .ena (ena),
    .reg_pixels_d (reg_pixels_d_expected),
    .pixel (pixel),
    .reg_phase_d (reg_phase_d_expected),
    .reg_colors_q (reg_colors_q),
    .reg_cap_d (reg_cap_d_expected),
    .aural (aural),
    .reg_vid_q (reg_vid_q),
    .negedge_ena (negedge_ena),
    .reg_cnts_d (reg_cnts_d_expected),
    .reg_pixels_q (reg_pixels_q),
    .setvid (setvid),
    .reg_baseband_d (reg_baseband_d_expected),
    .reg_colors_d (reg_colors_d_expected),
    .carrier (carrier),
    .reg_snc_d (reg_snc_d_expected),
    .reg_vid_d (reg_vid_d_expected),
    .reg_cap_q (reg_cap_q),
    .posedge_snc1 (posedge_snc1),
    .reg_snc_q (reg_snc_q),
    .setscl (setscl),
    .reg_set_q (reg_set_q));
cloned_cog_vid cloned(
    .data (data),
    .pin_out (pin_out_result),
    .reg_cnt_q (reg_cnt_q),
    .reg_scl_d (reg_scl_d_result),
    .ack (ack_result),
    .snc1_trgout (snc1_trgout_result),
    .clk_vid (clk_vid),
    .reg_cnt_d (reg_cnt_d_result),
    .posedge_vclk (posedge_vclk),
    .reg_baseband_q (reg_baseband_q),
    .vclk_trgout (vclk_trgout_result),
    .reg_discrete_d (reg_discrete_d_result),
    .reg_phase_q (reg_phase_q),
    .reg_scl_q (reg_scl_q),
    .clk_cog (clk_cog),
    .reg_discrete_q (reg_discrete_q),
    .posedge_clk_cog (posedge_clk_cog),
    .color (color),
    .reg_set_d (reg_set_d_result),
    .reg_cnts_q (reg_cnts_q),
    .reg_composite_q (reg_composite_q),
    .reg_composite_d (reg_composite_d_result),
    .ena (ena),
    .reg_pixels_d (reg_pixels_d_result),
    .pixel (pixel),
    .reg_phase_d (reg_phase_d_result),
    .reg_colors_q (reg_colors_q),
    .reg_cap_d (reg_cap_d_result),
    .aural (aural),
    .reg_vid_q (reg_vid_q),
    .negedge_ena (negedge_ena),
    .reg_cnts_d (reg_cnts_d_result),
    .reg_pixels_q (reg_pixels_q),
    .setvid (setvid),
    .reg_baseband_d (reg_baseband_d_result),
    .reg_colors_d (reg_colors_d_result),
    .carrier (carrier),
    .reg_snc_d (reg_snc_d_result),
    .reg_vid_d (reg_vid_d_result),
    .reg_cap_q (reg_cap_q),
    .posedge_snc1 (posedge_snc1),
    .reg_snc_q (reg_snc_q),
    .setscl (setscl),
    .reg_set_q (reg_set_q));
assert property(pin_out_result == pin_out_expected);
assert property(reg_scl_d_result == reg_scl_d_expected);
assert property(ack_result == ack_expected);
assert property(snc1_trgout_result == snc1_trgout_expected);
assert property(reg_cnt_d_result[7:0] == reg_cnt_d_expected);
assert property(reg_cnt_d_result[31:8] == 64'h0);
assert property(vclk_trgout_result == vclk_trgout_expected);
assert property(reg_discrete_d_result[7:0] == reg_discrete_d_expected);
assert property(reg_discrete_d_result[31:8] == 64'h0);
assert property(reg_set_d_result[11:0] == reg_set_d_expected);
assert property(reg_set_d_result[31:12] == 64'h0);
assert property(reg_composite_d_result[2:0] == reg_composite_d_expected);
assert property(reg_composite_d_result[31:3] == 64'h0);
assert property(reg_pixels_d_result == reg_pixels_d_expected);
assert property(reg_phase_d_result[3:0] == reg_phase_d_expected);
assert property(reg_phase_d_result[31:4] == 64'h0);
assert property(reg_cap_d_result == reg_cap_d_expected);
assert property(reg_cnts_d_result[7:0] == reg_cnts_d_expected);
assert property(reg_cnts_d_result[31:8] == 64'h0);
assert property(reg_baseband_d_result[3:0] == reg_baseband_d_expected);
assert property(reg_baseband_d_result[31:4] == 64'h0);
assert property(reg_colors_d_result == reg_colors_d_expected);
assert property(reg_snc_d_result[1:0] == reg_snc_d_expected);
assert property(reg_snc_d_result[31:2] == 64'h0);
assert property(reg_vid_d_result == reg_vid_d_expected);
endmodule

//-show pin_out_result -show pin_out_expected -show reg_scl_d_result -show reg_scl_d_expected -show ack_result -show ack_expected -show snc1_trgout_result -show snc1_trgout_expected -show reg_cnt_d_result -show reg_cnt_d_expected -show vclk_trgout_result -show vclk_trgout_expected -show reg_discrete_d_result -show reg_discrete_d_expected -show reg_set_d_result -show reg_set_d_expected -show reg_composite_d_result -show reg_composite_d_expected -show reg_pixels_d_result -show reg_pixels_d_expected -show reg_phase_d_result -show reg_phase_d_expected -show reg_cap_d_result -show reg_cap_d_expected -show reg_cnts_d_result -show reg_cnts_d_expected -show reg_baseband_d_result -show reg_baseband_d_expected -show reg_colors_d_result -show reg_colors_d_expected -show reg_snc_d_result -show reg_snc_d_expected -show reg_vid_d_result -show reg_vid_d_expected 

module cog_vid (
input [31:0] data,
output [31:0] pin_out,
input [7:0] reg_cnt_q,
output reg [31:0] reg_scl_d,
output ack,
output snc1_trgout,
input clk_vid,
output reg [7:0] reg_cnt_d,
input posedge_vclk,
input [3:0] reg_baseband_q,
output vclk_trgout,
output reg [7:0] reg_discrete_d,
input [3:0] reg_phase_q,
input [31:0] reg_scl_q,
input clk_cog,
input [7:0] reg_discrete_q,
input posedge_clk_cog,
input [31:0] color,
output reg [11:0] reg_set_d,
input [7:0] reg_cnts_q,
input [2:0] reg_composite_q,
output reg [2:0] reg_composite_d,
input ena,
output reg [31:0] reg_pixels_d,
input [31:0] pixel,
output reg [3:0] reg_phase_d,
input [31:0] reg_colors_q,
output reg reg_cap_d,
input [7:0] aural,
input [31:0] reg_vid_q,
input negedge_ena,
output reg [7:0] reg_cnts_d,
input [31:0] reg_pixels_q,
input setvid,
output reg [3:0] reg_baseband_d,
output reg [31:0] reg_colors_d,
input carrier,
output reg [1:0] reg_snc_d,
output reg [31:0] reg_vid_d,
input reg_cap_q,
input posedge_snc1,
input [1:0] reg_snc_q,
input setscl,
input [11:0] reg_set_q
);
wire enable;
wire [2:0] level[16];
wire [2:0] colormod;
wire [3:0] colorphs;
wire [3:0] broadcast;
wire new_set;
wire new_cnt;
wire [31:0] colorx;
wire [7:0] outp;
wire vclk;
wire snc1;
assign enable = (|reg_vid_q[30:29]);
assign vclk = (clk_vid && enable);
assign new_set = (reg_set_q == 1'b1);
assign new_cnt = (reg_cnt_q == 1'b1);
assign snc1 = reg_snc_q[1];
assign ack = reg_snc_q[0];
assign colorx = (reg_colors_q >> {(reg_vid_q[28] && reg_pixels_q[1]), reg_pixels_q[0], 3'b0});
assign colorphs = (reg_discrete_q[7:4] + reg_phase_q);
assign colormod = (reg_discrete_q[2:0] + {(reg_discrete_q[3] && colorphs[3]), (reg_discrete_q[3] && colorphs[3]), reg_discrete_q[3]});
assign level[15] = 3'b11;
assign level[14] = 3'b100;
assign level[13] = 3'b100;
assign level[12] = 3'b101;
assign level[11] = 3'b101;
assign level[10] = 3'b110;
assign level[9] = 3'b110;
assign level[8] = 3'b111;
assign level[7] = 3'b11;
assign level[6] = 3'b11;
assign level[5] = 3'b10;
assign level[4] = 3'b10;
assign level[3] = 3'b1;
assign level[2] = 3'b1;
assign level[1] = 3'b0;
assign level[0] = 3'b0;
assign broadcast = {(carrier ^ aural[reg_vid_q[25:23]]), level[{carrier, reg_composite_q}]};
assign outp = ((reg_vid_q[30]) ? (((reg_vid_q[29]) ? ({reg_baseband_q, broadcast}) : ({broadcast, reg_baseband_q}))) : (reg_discrete_q));
assign pin_out = ((enable) ? (({24'h0, (outp & reg_vid_q[7:0])} << {reg_vid_q[10:9], 3'b0})) : (32'h0));
assign vclk_trgout = vclk;
assign snc1_trgout = snc1;
always @(*) begin
    reg_discrete_d <= reg_discrete_q;
    reg_cap_d <= reg_cap_q;
    reg_baseband_d <= reg_baseband_q;
    reg_cnt_d <= reg_cnt_q;
    reg_cnts_d <= reg_cnts_q;
    reg_snc_d <= reg_snc_q;
    reg_scl_d <= reg_scl_q;
    reg_set_d <= reg_set_q;
    reg_composite_d <= reg_composite_q;
    reg_vid_d <= reg_vid_q;
    reg_phase_d <= reg_phase_q;
    reg_pixels_d <= reg_pixels_q;
    reg_colors_d <= reg_colors_q;
    if ((posedge_clk_cog || negedge_ena)) begin
        if ((!ena)) begin
            reg_vid_d <= 32'h0;
        end else begin
            if (setvid) begin
                reg_vid_d <= data;
            end
        end
    end
    if (posedge_clk_cog) begin
        if (setscl) begin
            reg_scl_d <= data;
        end
    end
    if (posedge_vclk) begin
        if (new_set) begin
            reg_cnts_d <= reg_scl_q[19:12];
        end
    end
    if (posedge_vclk) begin
        reg_cnt_d <= ((new_set) ? (reg_scl_q[19:12]) : (((new_cnt) ? (reg_cnts_q) : ((reg_cnt_q - 1'b1)))));
    end
    if (posedge_vclk) begin
        reg_set_d <= ((new_set) ? (reg_scl_q[11:0]) : ((reg_set_q - 1'b1)));
    end
    if (posedge_vclk) begin
        if ((new_set || new_cnt)) begin
            reg_pixels_d <= ((new_set) ? (pixel) : (((reg_vid_q[28]) ? ({reg_pixels_q[31:30], reg_pixels_q[31:2]}) : ({reg_pixels_q[31], reg_pixels_q[31:1]}))));
        end
    end
    if (posedge_vclk) begin
        if (new_set) begin
            reg_colors_d <= color;
        end
    end
    if ((posedge_vclk || posedge_snc1)) begin
        if (reg_snc_q[1]) begin
            reg_cap_d <= 1'b0;
        end else begin
            if (new_set) begin
                reg_cap_d <= 1'b1;
            end
        end
    end
    if (posedge_clk_cog) begin
        if (enable) begin
            reg_snc_d <= {reg_snc_q[0], reg_cap_q};
        end
    end
    if (posedge_vclk) begin
        reg_discrete_d <= colorx[7:0];
    end
    if (posedge_vclk) begin
        reg_phase_d <= (reg_phase_q + 1'b1);
    end
    if (posedge_vclk) begin
        reg_baseband_d <= {(reg_discrete_q[3] && colorphs[3]), ((reg_vid_q[26]) ? (colormod) : (reg_discrete_q[2:0]))};
    end
    if (posedge_vclk) begin
        reg_composite_d <= ((reg_vid_q[27]) ? (colormod) : (reg_discrete_q[2:0]));
    end
end
endmodule

