module verifyequal_hub (
input [1:0] reg_sd_q,
input [7:0] reg_lock_state_q,
input [31:0] reg_bus_q_q,
input reg_ec_q,
input ena_bus,
input [15:0] reg_ac_q,
input [7:0] reg_cog_e_q,
input reg_rd_q,
input reg_sys_c_q,
input [31:0] submod_hub_mem_q_out,
input [31:0] reg_dc_q,
input clk_cog,
input nres,
input posedge_clk_cog,
input [1:0] reg_sc_q,
input [7:0] bus_sel,
input reg_ed_q,
input [7:0] reg_lock_e_q,
input [7:0] reg_cog_ena_q,
input [2:0] reg_sys_q_q,
input reg_wc_q,
input [7:0] reg_cfg_q,
input negedge_nres,
input reg_rc_q,
input bus_w,
input [1:0] reg_ad_q,
input bus_r,
input [1:0] bus_s,
input [15:0] bus_a,
input bus_e,
input [31:0] bus_d
);
wire [7:0] bus_ack_expected;
wire [31:0] bus_ack_result;
wire submod_hub_mem_clk_cog_in_expected;
wire submod_hub_mem_clk_cog_in_result;
wire [7:0] ptr_w_expected;
wire [31:0] ptr_w_result;
wire reg_ec_d_expected;
wire reg_ec_d_result;
wire [1:0] reg_sd_d_expected;
wire [31:0] reg_sd_d_result;
wire [7:0] reg_lock_state_d_expected;
wire [31:0] reg_lock_state_d_result;
wire [15:0] reg_ac_d_expected;
wire [31:0] reg_ac_d_result;
wire [31:0] reg_bus_q_d_expected;
wire [31:0] reg_bus_q_d_result;
wire [31:0] reg_dc_d_expected;
wire [31:0] reg_dc_d_result;
wire [2:0] reg_sys_q_d_expected;
wire [31:0] reg_sys_q_d_result;
wire reg_rd_d_expected;
wire reg_rd_d_result;
wire reg_wc_d_expected;
wire reg_wc_d_result;
wire [7:0] reg_cog_e_d_expected;
wire [31:0] reg_cog_e_d_result;
wire [27:0] ptr_d_expected;
wire [31:0] ptr_d_result;
wire submod_hub_mem_ena_bus_in_expected;
wire submod_hub_mem_ena_bus_in_result;
wire [3:0] submod_hub_mem_wb_in_expected;
wire [31:0] submod_hub_mem_wb_in_result;
wire reg_sys_c_d_expected;
wire reg_sys_c_d_result;
wire [7:0] reg_cog_ena_d_expected;
wire [31:0] reg_cog_ena_d_result;
wire reg_ed_d_expected;
wire reg_ed_d_result;
wire [1:0] reg_sc_d_expected;
wire [31:0] reg_sc_d_result;
wire [1:0] reg_ad_d_expected;
wire [31:0] reg_ad_d_result;
wire [7:0] reg_lock_e_d_expected;
wire [31:0] reg_lock_e_d_result;
wire [13:0] submod_hub_mem_a_in_expected;
wire [31:0] submod_hub_mem_a_in_result;
wire [7:0] cog_ena_expected;
wire [31:0] cog_ena_result;
wire [31:0] submod_hub_mem_d_in_expected;
wire [31:0] submod_hub_mem_d_in_result;
wire [7:0] cfg_expected;
wire [31:0] cfg_result;
wire submod_hub_mem_w_in_expected;
wire submod_hub_mem_w_in_result;
wire [31:0] bus_q_expected;
wire [31:0] bus_q_result;
wire [7:0] reg_cfg_d_expected;
wire [31:0] reg_cfg_d_result;
wire reg_rc_d_expected;
wire reg_rc_d_result;
wire bus_c_expected;
wire bus_c_result;
hub golden(
    .bus_ack (bus_ack_expected),
    .reg_sd_q (reg_sd_q),
    .submod_hub_mem_clk_cog_in (submod_hub_mem_clk_cog_in_expected),
    .reg_lock_state_q (reg_lock_state_q),
    .ptr_w (ptr_w_expected),
    .reg_ec_d (reg_ec_d_expected),
    .reg_bus_q_q (reg_bus_q_q),
    .reg_sd_d (reg_sd_d_expected),
    .reg_ec_q (reg_ec_q),
    .reg_lock_state_d (reg_lock_state_d_expected),
    .reg_ac_d (reg_ac_d_expected),
    .ena_bus (ena_bus),
    .reg_bus_q_d (reg_bus_q_d_expected),
    .reg_ac_q (reg_ac_q),
    .reg_cog_e_q (reg_cog_e_q),
    .reg_rd_q (reg_rd_q),
    .reg_dc_d (reg_dc_d_expected),
    .reg_sys_q_d (reg_sys_q_d_expected),
    .reg_sys_c_q (reg_sys_c_q),
    .reg_rd_d (reg_rd_d_expected),
    .reg_wc_d (reg_wc_d_expected),
    .reg_cog_e_d (reg_cog_e_d_expected),
    .ptr_d (ptr_d_expected),
    .submod_hub_mem_q_out (submod_hub_mem_q_out),
    .reg_dc_q (reg_dc_q),
    .submod_hub_mem_ena_bus_in (submod_hub_mem_ena_bus_in_expected),
    .submod_hub_mem_wb_in (submod_hub_mem_wb_in_expected),
    .clk_cog (clk_cog),
    .reg_sys_c_d (reg_sys_c_d_expected),
    .reg_cog_ena_d (reg_cog_ena_d_expected),
    .nres (nres),
    .posedge_clk_cog (posedge_clk_cog),
    .reg_sc_q (reg_sc_q),
    .reg_ed_d (reg_ed_d_expected),
    .reg_sc_d (reg_sc_d_expected),
    .bus_sel (bus_sel),
    .reg_ed_q (reg_ed_q),
    .reg_lock_e_q (reg_lock_e_q),
    .reg_ad_d (reg_ad_d_expected),
    .reg_cog_ena_q (reg_cog_ena_q),
    .reg_sys_q_q (reg_sys_q_q),
    .reg_wc_q (reg_wc_q),
    .reg_cfg_q (reg_cfg_q),
    .reg_lock_e_d (reg_lock_e_d_expected),
    .submod_hub_mem_a_in (submod_hub_mem_a_in_expected),
    .cog_ena (cog_ena_expected),
    .negedge_nres (negedge_nres),
    .reg_rc_q (reg_rc_q),
    .submod_hub_mem_d_in (submod_hub_mem_d_in_expected),
    .bus_w (bus_w),
    .cfg (cfg_expected),
    .reg_ad_q (reg_ad_q),
    .submod_hub_mem_w_in (submod_hub_mem_w_in_expected),
    .bus_r (bus_r),
    .bus_q (bus_q_expected),
    .reg_cfg_d (reg_cfg_d_expected),
    .reg_rc_d (reg_rc_d_expected),
    .bus_s (bus_s),
    .bus_a (bus_a),
    .bus_e (bus_e),
    .bus_d (bus_d),
    .bus_c (bus_c_expected));
cloned_hub cloned(
    .bus_ack (bus_ack_result),
    .reg_sd_q (reg_sd_q),
    .submod_hub_mem_clk_cog_in (submod_hub_mem_clk_cog_in_result),
    .reg_lock_state_q (reg_lock_state_q),
    .ptr_w (ptr_w_result),
    .reg_ec_d (reg_ec_d_result),
    .reg_bus_q_q (reg_bus_q_q),
    .reg_sd_d (reg_sd_d_result),
    .reg_ec_q (reg_ec_q),
    .reg_lock_state_d (reg_lock_state_d_result),
    .reg_ac_d (reg_ac_d_result),
    .ena_bus (ena_bus),
    .reg_bus_q_d (reg_bus_q_d_result),
    .reg_ac_q (reg_ac_q),
    .reg_cog_e_q (reg_cog_e_q),
    .reg_rd_q (reg_rd_q),
    .reg_dc_d (reg_dc_d_result),
    .reg_sys_q_d (reg_sys_q_d_result),
    .reg_sys_c_q (reg_sys_c_q),
    .reg_rd_d (reg_rd_d_result),
    .reg_wc_d (reg_wc_d_result),
    .reg_cog_e_d (reg_cog_e_d_result),
    .ptr_d (ptr_d_result),
    .submod_hub_mem_q_out (submod_hub_mem_q_out),
    .reg_dc_q (reg_dc_q),
    .submod_hub_mem_ena_bus_in (submod_hub_mem_ena_bus_in_result),
    .submod_hub_mem_wb_in (submod_hub_mem_wb_in_result),
    .clk_cog (clk_cog),
    .reg_sys_c_d (reg_sys_c_d_result),
    .reg_cog_ena_d (reg_cog_ena_d_result),
    .nres (nres),
    .posedge_clk_cog (posedge_clk_cog),
    .reg_sc_q (reg_sc_q),
    .reg_ed_d (reg_ed_d_result),
    .reg_sc_d (reg_sc_d_result),
    .bus_sel (bus_sel),
    .reg_ed_q (reg_ed_q),
    .reg_lock_e_q (reg_lock_e_q),
    .reg_ad_d (reg_ad_d_result),
    .reg_cog_ena_q (reg_cog_ena_q),
    .reg_sys_q_q (reg_sys_q_q),
    .reg_wc_q (reg_wc_q),
    .reg_cfg_q (reg_cfg_q),
    .reg_lock_e_d (reg_lock_e_d_result),
    .submod_hub_mem_a_in (submod_hub_mem_a_in_result),
    .cog_ena (cog_ena_result),
    .negedge_nres (negedge_nres),
    .reg_rc_q (reg_rc_q),
    .submod_hub_mem_d_in (submod_hub_mem_d_in_result),
    .bus_w (bus_w),
    .cfg (cfg_result),
    .reg_ad_q (reg_ad_q),
    .submod_hub_mem_w_in (submod_hub_mem_w_in_result),
    .bus_r (bus_r),
    .bus_q (bus_q_result),
    .reg_cfg_d (reg_cfg_d_result),
    .reg_rc_d (reg_rc_d_result),
    .bus_s (bus_s),
    .bus_a (bus_a),
    .bus_e (bus_e),
    .bus_d (bus_d),
    .bus_c (bus_c_result));
assert property(bus_ack_result[7:0] == bus_ack_expected);
assert property(bus_ack_result[31:8] == 64'h0);
assert property(submod_hub_mem_clk_cog_in_result == submod_hub_mem_clk_cog_in_expected);
assert property(ptr_w_result[7:0] == ptr_w_expected);
assert property(ptr_w_result[31:8] == 64'h0);
assert property(reg_ec_d_result == reg_ec_d_expected);
assert property(reg_sd_d_result[1:0] == reg_sd_d_expected);
assert property(reg_sd_d_result[31:2] == 64'h0);
assert property(reg_lock_state_d_result[7:0] == reg_lock_state_d_expected);
assert property(reg_lock_state_d_result[31:8] == 64'h0);
assert property(reg_ac_d_result[15:0] == reg_ac_d_expected);
assert property(reg_ac_d_result[31:16] == 64'h0);
assert property(reg_bus_q_d_result == reg_bus_q_d_expected);
assert property(reg_dc_d_result == reg_dc_d_expected);
assert property(reg_sys_q_d_result[2:0] == reg_sys_q_d_expected);
assert property(reg_sys_q_d_result[31:3] == 64'h0);
assert property(reg_rd_d_result == reg_rd_d_expected);
assert property(reg_wc_d_result == reg_wc_d_expected);
assert property(reg_cog_e_d_result[7:0] == reg_cog_e_d_expected);
assert property(reg_cog_e_d_result[31:8] == 64'h0);
assert property(ptr_d_result[27:0] == ptr_d_expected);
assert property(ptr_d_result[31:28] == 64'h0);
assert property(submod_hub_mem_ena_bus_in_result == submod_hub_mem_ena_bus_in_expected);
assert property(submod_hub_mem_wb_in_result[3:0] == submod_hub_mem_wb_in_expected);
assert property(submod_hub_mem_wb_in_result[31:4] == 64'h0);
assert property(reg_sys_c_d_result == reg_sys_c_d_expected);
assert property(reg_cog_ena_d_result[7:0] == reg_cog_ena_d_expected);
assert property(reg_cog_ena_d_result[31:8] == 64'h0);
assert property(reg_ed_d_result == reg_ed_d_expected);
assert property(reg_sc_d_result[1:0] == reg_sc_d_expected);
assert property(reg_sc_d_result[31:2] == 64'h0);
assert property(reg_ad_d_result[1:0] == reg_ad_d_expected);
assert property(reg_ad_d_result[31:2] == 64'h0);
assert property(reg_lock_e_d_result[7:0] == reg_lock_e_d_expected);
assert property(reg_lock_e_d_result[31:8] == 64'h0);
assert property(submod_hub_mem_a_in_result[13:0] == submod_hub_mem_a_in_expected);
assert property(submod_hub_mem_a_in_result[31:14] == 64'h0);
assert property(cog_ena_result[7:0] == cog_ena_expected);
assert property(cog_ena_result[31:8] == 64'h0);
assert property(submod_hub_mem_d_in_result == submod_hub_mem_d_in_expected);
assert property(cfg_result[7:0] == cfg_expected);
assert property(cfg_result[31:8] == 64'h0);
assert property(submod_hub_mem_w_in_result == submod_hub_mem_w_in_expected);
assert property(bus_q_result == bus_q_expected);
assert property(reg_cfg_d_result[7:0] == reg_cfg_d_expected);
assert property(reg_cfg_d_result[31:8] == 64'h0);
assert property(reg_rc_d_result == reg_rc_d_expected);
assert property(bus_c_result == bus_c_expected);

endmodule

//-show bus_ack_result -show bus_ack_expected -show submod_hub_mem_clk_cog_in_result -show submod_hub_mem_clk_cog_in_expected -show ptr_w_result -show ptr_w_expected -show reg_ec_d_result -show reg_ec_d_expected -show reg_sd_d_result -show reg_sd_d_expected -show reg_lock_state_d_result -show reg_lock_state_d_expected -show reg_ac_d_result -show reg_ac_d_expected -show reg_bus_q_d_result -show reg_bus_q_d_expected -show reg_dc_d_result -show reg_dc_d_expected -show reg_sys_q_d_result -show reg_sys_q_d_expected -show reg_rd_d_result -show reg_rd_d_expected -show reg_wc_d_result -show reg_wc_d_expected -show reg_cog_e_d_result -show reg_cog_e_d_expected -show ptr_d_result -show ptr_d_expected -show submod_hub_mem_ena_bus_in_result -show submod_hub_mem_ena_bus_in_expected -show submod_hub_mem_wb_in_result -show submod_hub_mem_wb_in_expected -show reg_sys_c_d_result -show reg_sys_c_d_expected -show reg_cog_ena_d_result -show reg_cog_ena_d_expected -show reg_ed_d_result -show reg_ed_d_expected -show reg_sc_d_result -show reg_sc_d_expected -show reg_ad_d_result -show reg_ad_d_expected -show reg_lock_e_d_result -show reg_lock_e_d_expected -show submod_hub_mem_a_in_result -show submod_hub_mem_a_in_expected -show cog_ena_result -show cog_ena_expected -show submod_hub_mem_d_in_result -show submod_hub_mem_d_in_expected -show cfg_result -show cfg_expected -show submod_hub_mem_w_in_result -show submod_hub_mem_w_in_expected -show bus_q_result -show bus_q_expected -show reg_cfg_d_result -show reg_cfg_d_expected -show reg_rc_d_result -show reg_rc_d_expected -show bus_c_result -show bus_c_expected 

module hub (
output [7:0] bus_ack,
input [1:0] reg_sd_q,
output submod_hub_mem_clk_cog_in,
input [7:0] reg_lock_state_q,
output [7:0] ptr_w,
output reg reg_ec_d,
input [31:0] reg_bus_q_q,
output reg [1:0] reg_sd_d,
input reg_ec_q,
output reg [7:0] reg_lock_state_d,
output reg [15:0] reg_ac_d,
input ena_bus,
output reg [31:0] reg_bus_q_d,
input [15:0] reg_ac_q,
input [7:0] reg_cog_e_q,
input reg_rd_q,
output reg [31:0] reg_dc_d,
output reg [2:0] reg_sys_q_d,
input reg_sys_c_q,
output reg reg_rd_d,
output reg reg_wc_d,
output reg [7:0] reg_cog_e_d,
output [27:0] ptr_d,
input [31:0] submod_hub_mem_q_out,
input [31:0] reg_dc_q,
output submod_hub_mem_ena_bus_in,
output [3:0] submod_hub_mem_wb_in,
input clk_cog,
output reg reg_sys_c_d,
output reg [7:0] reg_cog_ena_d,
input nres,
input posedge_clk_cog,
input [1:0] reg_sc_q,
output reg reg_ed_d,
output reg [1:0] reg_sc_d,
input [7:0] bus_sel,
input reg_ed_q,
input [7:0] reg_lock_e_q,
output reg [1:0] reg_ad_d,
input [7:0] reg_cog_ena_q,
input [2:0] reg_sys_q_q,
input reg_wc_q,
input [7:0] reg_cfg_q,
output reg [7:0] reg_lock_e_d,
output [13:0] submod_hub_mem_a_in,
output [7:0] cog_ena,
input negedge_nres,
input reg_rc_q,
output [31:0] submod_hub_mem_d_in,
input bus_w,
output [7:0] cfg,
input [1:0] reg_ad_q,
output submod_hub_mem_w_in,
input bus_r,
output [31:0] bus_q,
output reg [7:0] reg_cfg_d,
output reg reg_rc_d,
input [1:0] bus_s,
input [15:0] bus_a,
input bus_e,
input [31:0] bus_d,
output bus_c
);

///////////////////////////////////
`include "constraints.v"

wire [2:0] num;
wire all;
wire mem_w;
wire [31:0] ramq;
wire [31:0] mem_q;
wire [3:0] mem_wb;
wire sys;
wire [7:0] num_dcd;
wire [31:0] mem_d;
wire [7:0] enc;
wire [2:0] newx;
wire lock_mux;
wire cog_start;
assign mem_w = (reg_ec_q && ((~&reg_sc_q) && reg_wc_q));
assign mem_wb = ((reg_sc_q[1]) ? (4'b1111) : (((reg_sc_q[0]) ? (((reg_ac_q[1]) ? (4'b1100) : (4'b11))) : ((4'b1 << reg_ac_q[1:0])))));
assign mem_d = ((reg_sc_q[1]) ? (reg_dc_q) : (((reg_sc_q[0]) ? ({{2{reg_dc_q[15:0]}}}) : ({{4{reg_dc_q[7:0]}}}))));
assign ramq = (((!reg_rd_q)) ? (mem_q) : ({mem_q[3], mem_q[7], mem_q[21], mem_q[12], mem_q[6], mem_q[19], mem_q[4], mem_q[17], mem_q[20], mem_q[15], mem_q[8], mem_q[11], mem_q[0], mem_q[14], mem_q[30], mem_q[1], mem_q[23], mem_q[31], mem_q[16], mem_q[5], mem_q[9], mem_q[18], mem_q[25], mem_q[2], mem_q[28], mem_q[22], mem_q[13], mem_q[27], mem_q[29], mem_q[24], mem_q[26], mem_q[10]}));
assign bus_c = reg_sys_c_q;
assign bus_ack = ((reg_ed_q) ? ({bus_sel[1:0], bus_sel[7:2]}) : (8'h0));
assign sys = (reg_ec_q && (&reg_sc_q));
assign enc = ((reg_ac_q[2]) ? (reg_lock_e_q) : (reg_cog_e_q));
assign all = (&enc);
assign newx = (((&enc[3:0])) ? ((((&enc[5:4])) ? (((enc[6]) ? (3'b111) : (3'b110))) : (((enc[4]) ? (3'b101) : (3'b100))))) : ((((&enc[1:0])) ? (((enc[2]) ? (3'b11) : (3'b10))) : (((enc[0]) ? (3'b1) : (3'b0))))));
assign num = (((((reg_ac_q[2:0] == 3'b10) && reg_dc_q[3]) || (reg_ac_q[2:0] == 3'b100))) ? (newx) : (reg_dc_q[2:0]));
assign num_dcd = (1'b1 << num);
assign cog_start = (sys && ((reg_ac_q[2:0] == 3'b10) && (!(reg_dc_q[3] && all))));
assign ptr_w = ({{8{cog_start}}} & num_dcd);
assign ptr_d = reg_dc_q[31:4];
assign lock_mux = reg_lock_state_q[reg_dc_q[2:0]];
assign submod_hub_mem_a_in = reg_ac_q[15:2];
assign submod_hub_mem_d_in = mem_d;
assign submod_hub_mem_wb_in = mem_wb;
assign mem_q = submod_hub_mem_q_out;
assign submod_hub_mem_ena_bus_in = ena_bus;
assign submod_hub_mem_w_in = mem_w;
assign submod_hub_mem_clk_cog_in = clk_cog;
assign bus_q = reg_bus_q_q;
assign cog_ena = reg_cog_ena_q;
assign cfg = reg_cfg_q;
always @(*) begin
    reg_ad_d <= reg_ad_q;
    reg_ed_d <= reg_ed_q;
    reg_sys_q_d <= reg_sys_q_q;
    reg_cfg_d <= reg_cfg_q;
    reg_sc_d <= reg_sc_q;
    reg_wc_d <= reg_wc_q;
    reg_sd_d <= reg_sd_q;
    reg_ec_d <= reg_ec_q;
    reg_ac_d <= reg_ac_q;
    reg_lock_e_d <= reg_lock_e_q;
    reg_sys_c_d <= reg_sys_c_q;
    reg_cog_ena_d <= reg_cog_ena_q;
    reg_cog_e_d <= reg_cog_e_q;
    reg_rc_d <= reg_rc_q;
    reg_bus_q_d <= reg_bus_q_q;
    reg_dc_d <= reg_dc_q;
    reg_lock_state_d <= reg_lock_state_q;
    reg_rd_d <= reg_rd_q;
    if (posedge_clk_cog) begin
        if (ena_bus) begin
            reg_rc_d <= bus_r;
        end
    end
    if ((posedge_clk_cog || negedge_nres)) begin
        if ((!nres)) begin
            reg_ec_d <= 1'b0;
        end else begin
            if (ena_bus) begin
                reg_ec_d <= bus_e;
            end
        end
    end
    if (posedge_clk_cog) begin
        if (ena_bus) begin
            reg_wc_d <= bus_w;
        end
    end
    if (posedge_clk_cog) begin
        if (ena_bus) begin
            reg_sc_d <= bus_s;
        end
    end
    if (posedge_clk_cog) begin
        if (ena_bus) begin
            reg_ac_d <= bus_a;
        end
    end
    if (posedge_clk_cog) begin
        if (ena_bus) begin
            reg_dc_d <= bus_d;
        end
    end
    if (posedge_clk_cog) begin
        if (ena_bus) begin
            reg_rd_d <= ((!reg_rc_q) && reg_ac_q[15]);
        end
    end
    if ((posedge_clk_cog || negedge_nres)) begin
        if ((!nres)) begin
            reg_ed_d <= 1'b0;
        end else begin
            if (ena_bus) begin
                reg_ed_d <= reg_ec_q;
            end
        end
    end
    if (posedge_clk_cog) begin
        if (ena_bus) begin
            reg_sd_d <= reg_sc_q;
        end
    end
    if (posedge_clk_cog) begin
        if (ena_bus) begin
            reg_ad_d <= reg_ac_q[1:0];
        end
    end
    if (posedge_clk_cog) begin
        reg_bus_q_d <= ((reg_sd_q[1]) ? (((reg_sd_q[0]) ? ({29'h0, reg_sys_q_q}) : (ramq))) : (((reg_sd_q[0]) ? (((ramq >> {reg_ad_q[1], 4'b0}) & 32'hffff)) : (((ramq >> {reg_ad_q[1:0], 3'b0}) & 32'hff)))));
    end
    if ((posedge_clk_cog || negedge_nres)) begin
        if ((!nres)) begin
            reg_cfg_d <= 8'h0;
        end else begin
            if ((ena_bus && (sys && (reg_ac_q[2:0] == 3'b0)))) begin
                reg_cfg_d <= reg_dc_q[7:0];
            end
        end
    end
    if ((posedge_clk_cog || negedge_nres)) begin
        if ((!nres)) begin
            reg_cog_e_d <= 8'h1;
        end else begin
            if ((ena_bus && (sys && (reg_ac_q[2:1] == 2'b1)))) begin
                reg_cog_e_d <= ((reg_cog_e_q & (~num_dcd)) | ({{8{(!reg_ac_q[0])}}} & num_dcd));
            end
        end
    end
    if ((posedge_clk_cog || negedge_nres)) begin
        if ((!nres)) begin
            reg_cog_ena_d <= 8'h0;
        end else begin
            if (ena_bus) begin
                reg_cog_ena_d <= (reg_cog_e_q & (~({{8{cog_start}}} & num_dcd)));
            end
        end
    end
    if ((posedge_clk_cog || negedge_nres)) begin
        if ((!nres)) begin
            reg_lock_e_d <= 8'h0;
        end else begin
            if ((ena_bus && (sys && (reg_ac_q[2:1] == 2'b10)))) begin
                reg_lock_e_d <= ((reg_lock_e_q & (~num_dcd)) | ({{8{(!reg_ac_q[0])}}} & num_dcd));
            end
        end
    end
    if (posedge_clk_cog) begin
        if ((ena_bus && (sys && (reg_ac_q[2:1] == 2'b11)))) begin
            reg_lock_state_d <= ((reg_lock_state_q & (~num_dcd)) | ({{8{(!reg_ac_q[0])}}} & num_dcd));
        end
    end
    if (posedge_clk_cog) begin
        if ((ena_bus && sys)) begin
            reg_sys_q_d <= (((reg_ac_q[2:0] == 3'b1)) ? ({(bus_sel[7] || (bus_sel[6] || (bus_sel[5] || bus_sel[0]))), (bus_sel[7] || (bus_sel[4] || (bus_sel[3] || bus_sel[0]))), (bus_sel[6] || (bus_sel[4] || (bus_sel[2] || bus_sel[0])))}) : (num));
        end
    end
    if (posedge_clk_cog) begin
        if ((ena_bus && sys)) begin
            reg_sys_c_d <= (((reg_ac_q[2:1] == 2'b11)) ? (lock_mux) : (all));
        end
    end
end
endmodule

