#include "cogramannotationdialog.h"
#include "ui_cogramannotationdialog.h"

CogRamAnnotationDialog::CogRamAnnotationDialog(QWidget *parent, CogRamAnnotation::Annotation annotation) :
    QDialog(parent),
    ui(new Ui::CogRamAnnotationDialog)
{
    ui->setupUi(this);
    ui->edtLabel->setText(annotation.label);
    ui->edtComment->setText(annotation.comment);
    ui->ckbNoInstruction->setChecked(annotation.noInstruction);
    ui->ckbSrcNumber->setChecked(annotation.forceSrcNumber);
    ui->ckbStepOver->setChecked(annotation.stepOver);
}

CogRamAnnotationDialog::~CogRamAnnotationDialog()
{
    delete ui;
}

CogRamAnnotation::Annotation CogRamAnnotationDialog::getResult() {
    CogRamAnnotation::Annotation result;
    result.label = ui->edtLabel->text();
    result.comment = ui->edtComment->text();
    result.noInstruction = ui->ckbNoInstruction->isChecked();
    result.forceSrcNumber = ui->ckbSrcNumber->isChecked();
    result.stepOver = ui->ckbStepOver->isChecked();
    return result;
}
