#ifndef COGVIEWER_H
#define COGVIEWER_H

#include <QWidget>
#include <QListWidgetItem>
#include "abstractpropeller.h"
#include "cogramannotation.h"

namespace Ui {
class CogViewer;
}

class CogViewer : public QWidget
{
    Q_OBJECT

public:
    explicit CogViewer(QWidget *parent = nullptr);
    ~CogViewer();
    void setPropeller(AbstractPropeller *propeller, int cogNo);
    QVector<bool> getStepOverList() const;

    static void displayInnerVars(QList<QPair<QString,QString>> innerVars, QListWidget *lstWdg);
public slots:
    void updateState(bool resetCurrentIndex);
private slots:
    void on_lstCogMemory_itemDoubleClicked(QListWidgetItem *item);
    void on_btnLoadAnnotation_clicked();
private:
    QString getTextForCogRamEntry(int address, int data, bool isAtPc);
    void loadAnnotation();
    Ui::CogViewer *ui;
    QString m_annotationFileName;
    CogRamAnnotation m_annotation;
    AbstractPropeller *m_propeller;
    int m_cogNo;
};

#endif // COGVIEWER_H
