#include "filetools.h"
#include <QtDebug>
#include <QFile>

FileTools::FileTools()
{

}

QList<int> FileTools::readIntelHex32(QString fileName) {
    QFile f(fileName);
    if (!f.open(QIODevice::ReadOnly)) {
        qWarning()<<"unable to open file"<<fileName;
        return QList<int>();
    }
    QList<int> result;
    while (!f.atEnd()) {
        QString line = QString::fromUtf8(f.readLine());
        if (!line.startsWith(":20"))
            continue;
        for (int i=0; i<8; ++i) {
            bool ok=false;
            QString hex = line.mid(9+i*8,8);
            result<<int(hex.toUInt(&ok,16));
            if (!ok) {
                qWarning()<<"illegal number"<<hex;
                return QList<int>();
            }
        }
    }
    return result;
}

QByteArray FileTools::readBinary(QString fileName) {
    QFile f(fileName);
    if (!f.open(QIODevice::ReadOnly)) {
        qWarning()<<"unable to open file"<<fileName;
        return QByteArray();
    }
    return f.readAll();
}

void FileTools::saveBinary(QString fileName, QByteArray data) {
    QFile f(fileName);
    if (!f.open(QIODevice::WriteOnly)) {
        qWarning()<<"unable to open file"<<fileName;
        return;
    }
    f.write(data);
}

void FileTools::saveTextFile(QString fileName, QString text) {
    saveBinary(fileName, text.toUtf8());
}

QString FileTools::readTextFile(QString fileName) {
    return QString::fromUtf8(readBinary(fileName));
}

