#include "hivewidget.h"
#include "ui_hivewidget.h"
#include <QtDebug>

HiveWidget::HiveWidget(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::HiveWidget),
    m_sim(nullptr)
{
    ui->setupUi(this);
}

void HiveWidget::setSimulationMaster(SimulationMaster *sim) {
    m_sim = sim;
    connect(m_sim,SIGNAL(nextFrame(QImage)),this,SLOT(nextFrame(QImage)));
}

HiveWidget::~HiveWidget()
{
    delete ui;
}

void HiveWidget::nextFrame(QImage frame) {
    ui->lblVgaDisplay->setPixmap(QPixmap::fromImage(frame));
}

void HiveWidget::keyPressEvent(QKeyEvent *event) {
    event->accept();
    if (m_sim && m_sim->keyboard())
        m_sim->keyboard()->keyAction(event->key(), true);
}

void HiveWidget::keyReleaseEvent(QKeyEvent *event) {
    event->accept();
    if (m_sim && m_sim->keyboard())
        m_sim->keyboard()->keyAction(event->key(), false);
}
