#ifndef HIVEWIDGET_H
#define HIVEWIDGET_H

#include <QWidget>
#include <QKeyEvent>
#include "simulationmaster.h"

namespace Ui {
class HiveWidget;
}

class HiveWidget : public QWidget
{
    Q_OBJECT

public:
    explicit HiveWidget(QWidget *parent = nullptr);
    ~HiveWidget();
    void setSimulationMaster(SimulationMaster *sim);
protected:
    virtual void keyPressEvent(QKeyEvent *event);
    virtual void keyReleaseEvent(QKeyEvent *event);
private slots:
    void nextFrame(QImage frame);
private:
    Ui::HiveWidget *ui;
    SimulationMaster *m_sim;
};

#endif // HIVEWIDGET_H
