#include "hwtrace.h"
#include <QtDebug>

HWSerializeException::HWSerializeException(QString message):
    message(message)
{
    qWarning()<<"HWSerializeException"<<message;
}

HWTraceable::HWTraceable(QString deviceId, QString deviceName):
    m_deviceId(deviceId),
    m_deviceName(deviceName)
{

}

HWTraceable::~HWTraceable() {
}

TraceInfo HWTraceable::getDeviceTraceInfo() const {
    TraceInfo ti;
    ti.deviceId = m_deviceId;
    ti.deviceName = m_deviceName;
    return ti;
}

void HWTraceable::setDebugTraceFunction(QString, HWTraceMethod) {
}

void HWTraceable::serialize(QDataStream& stream) const {
    stream << SerialMagic;
    stream << deviceId();
}

void HWTraceable::deserialize(QDataStream& stream) {
    quint32 tmpMagic = 0;
    stream >> tmpMagic;
    if (tmpMagic != SerialMagic)
        throw HWSerializeException(QString("invalid serialize magic %1 for device id %2").arg(tmpMagic).arg(deviceId()));
    QString tmpId;
    stream >> tmpId;
    if (tmpId != deviceId())
        throw HWSerializeException(QString("invalid serialize device id '%1' expected '%2'").arg(tmpId).arg(deviceId()));
}
