#ifndef I2CEEPROM_H
#define I2CEEPROM_H

#include "i2cdevice.h"
#include <QByteArray>

class I2CEEPRom : public I2CDevice, public HWTraceable
{
public:
    I2CEEPRom(QString deviceId, QString deviceName, QByteArray initialData, int size);
    //von I2CDevice
    virtual bool start(int address);
    virtual bool writeToDevice(int data);
    virtual int readFromDevice(bool lastByteAck);
    virtual void stop();

    //von HWTraceable
    virtual TraceInfo getDeviceTraceInfo() const;
    virtual void setDebugTraceFunction(QString method, HWTraceMethod func);
    virtual void serialize(QDataStream& stream) const;
    virtual void deserialize(QDataStream& stream);
private:
    enum State {Idle,AddrHigh,AddrLow,Write,Read};
    HWTraceMethod m_trace;
    State m_state;
    int m_dataPointer;
    QByteArray m_storedData;
};

#endif // I2CEEPROM_H
