def readIntelHexFile(filename):
    result = []
    with open(filename,"r") as f:
        for line in f.readlines():
            if line.startswith(":20"):
                for k in range(0,8):
                    off = 9+k*8
                    result.append(line[off:off+8])
    return result
            
romdata=readIntelHexFile("hub_rom_low.hex")
romdata+=readIntelHexFile("hub_rom_high.hex")
if len(romdata) != 8192:
    raise Exception("rom data size mismatch")

verilogFile = '''
//Generated Rom File
module hub_rom (
    input clk_cog,
    input [13:0] a,
    input ena_bus,
    output reg [31:0] q
);
reg [31:0] rom_data [8191:0];

always @(posedge clk_cog)
if (ena_bus && a[13] == 1'b1)
	q <= rom_data[a[12:0]];
initial begin
'''

for i in range(0,len(romdata)):
    verilogFile += "    rom_data["+str(i)+"] = 32'h"+romdata[i]+";\n"
verilogFile += "end\nendmodule\n"

with open("hub_rom.gen.v","w") as f:
    f.write(verilogFile)
#print(verilogFile)
