;Hier wird für den aktuellen Cog die cogClkPeripherals Funktion neu gebaut
;rax.rdx,rcx,r8 werden geändert
updateCogPeripheralsFunction:
    mov rdx,rsi                     ;rsi (cog reg ptr) wird gesichert nach rdx
    mov r8,rdi                        ;rdi (hub reg ptr) sichern
    add rdi,HubRelScratchpadOffset  ;rdi zeigt jetzt auf das scratchpad
    cld
    ;Counter A
    mov eax,dword[rdx+cog_reg_cog_ctra_ctrmode]
    lea rsi,[rel cogPeripheralsCounterAPatch]
    call copyPatchFunctionToScratchpad
    ;Counter B
    mov eax,dword[rdx+cog_reg_cog_ctrb_ctrmode]
    lea rsi,[rel cogPeripheralsCounterBPatch]
    call copyPatchFunctionToScratchpad
    ;Video
    mov eax,dword[rdx+cog_reg_cog_vid_vcfg_vmode]
    lea rsi,[rel cogPeripheralsVideoPatch]
    call copyPatchFunctionToScratchpad

    ;Vom Scratchpad an Ziel kopieren
    lea rax,[rdx+CogRelDynamicAsmOffset+dynamicCogPeripheralsClk]
    call copyScratchPadToDynamicFunction

    mov rdi,r8
    mov rsi,rdx
    ret

macroCogPeripherals:
    lea rax, [rsi+CogRelDynamicAsmOffset+dynamicCogPeripheralsClk]
    jmp rax

