updateCogEvalPinOut:
    mov rdx,rsi                     ;rsi (cog reg ptr) wird gesichert nach rdx
    mov r8,rdi                        ;rdi (hub reg ptr) sichern
    add rdi,HubRelScratchpadOffset  ;rdi zeigt jetzt auf das scratchpad
    cld
    ;Top Code
    xor eax,eax
    lea rsi,[rel cogPinOutTopPatch]
    call copyPatchFunctionToScratchpad
    ;Counter A
    mov eax,dword[rdx+cog_reg_cog_ctra_ctrmode]
    lea rsi,[rel cogPinOutCounterAPatch]
    call copyPatchFunctionToScratchpad
    ;Counter B
    mov eax,dword[rdx+cog_reg_cog_ctrb_ctrmode]
    lea rsi,[rel cogPinOutCounterBPatch]
    call copyPatchFunctionToScratchpad
    ;Video
    mov eax,dword[rdx+cog_reg_cog_vid_vcfg_vmode]
    lea rsi,[rel cogPinOutVideoPatch]
    call copyPatchFunctionToScratchpad
    ;Bot Code
    xor eax,eax
    lea rsi,[rel cogPinOutBotPatch]
    call copyPatchFunctionToScratchpad

    ;Vom Scratchpad an Ziel kopieren
    lea rax,[rdx+CogRelDynamicAsmOffset+dynamicCogPinOut]
    call copyScratchPadToDynamicFunction

    mov rdi,r8
    mov rsi,rdx
    ret

cogEvalPinOut:
    ;TODO tail call innerhalb dynamicCogPreEvalPll einbauen
    push rsi ;TODO weg
    xor r8d,r8d ;global pin out
    xor r9d,r9d ;global pin dir

    ;Cog 0
    lea rsi, [rdi+HubRelFirstCogRegOffset]
    lea rax, [rsi+CogRelDynamicAsmOffset+dynamicCogPinOut]
    call rax
    ;Cog 1
    add rsi, PerCogSize
    lea rax, [rsi+CogRelDynamicAsmOffset+dynamicCogPinOut]
    call rax
    ;Cog 2
    add rsi, PerCogSize
    lea rax, [rsi+CogRelDynamicAsmOffset+dynamicCogPinOut]
    call rax
    ;Cog 3
    add rsi, PerCogSize
    lea rax, [rsi+CogRelDynamicAsmOffset+dynamicCogPinOut]
    call rax
    ;Cog 4
    add rsi, PerCogSize
    lea rax, [rsi+CogRelDynamicAsmOffset+dynamicCogPinOut]
    call rax
    ;Cog 5
    add rsi, PerCogSize
    lea rax, [rsi+CogRelDynamicAsmOffset+dynamicCogPinOut]
    call rax
    ;Cog 6
    add rsi, PerCogSize
    lea rax, [rsi+CogRelDynamicAsmOffset+dynamicCogPinOut]
    call rax
    ;Cog 7
    add rsi, PerCogSize
    lea rax, [rsi+CogRelDynamicAsmOffset+dynamicCogPinOut]
    call rax
    pop rsi
    mov dword [rdi+hub_pinout], r8d
    mov dword [rdi+hub_pindir], r9d
    ret
