
hubClkBusMacroNack:
    ;reghub.bus_ack_idx = 0xf;
    mov dword [rdi+hub_bus_ack_idx],0xf
    ;hub_cog_e mit cog_ena_reg vergleichen
    mov edx,dword [rdi+hub_cog_e]
    mov eax,dword[rdi+hub_cog_ena_reg]
    cmp eax,edx
    je hubClkBusDone
    call hubClkHandleCogsStartStop
    jmp hubClkBusDone
;cog_ena_reg_next: edx
;bus_sel_idx_loc: ecx
;cog_start: r8
;zerstört rax,r8,rdx,rcx
hubClkBusMacroAckStartCog:
    ;//reghub.cogs[cogNo]->progctr = reghub.dc >> 0x4;
    ;kann hier also verwendet werden
    ;eax = reghub.dc >> 4
    mov eax,dword [rdi+hub_dc]
    shr eax,4
    ;Cog Ptr ermitteln
    shl r8,PerCogSizeLog2
    ;progctr = reghub.dc>>4
    mov dword [rdi+r8+HubRelFirstCogRegOffset+cog_progctr],eax
    ;geht weiter mit hubClkBusMacroCustom
    jmp hubClkBusMacroAckCustom

;zerstört rdx,rcx,rax,r8
hubClkBusMacroAck:
    mov edx,dword [rdi+hub_cog_e]
    mov ecx,dword [rdi+hub_bus_sel_idx]
    ;geht weiter mit hubClkBusMacroCustom
;cog_ena_reg_next: edx
;bus_sel_idx_loc: ecx
;zerstört rax,r8,rdx,rcx
hubClkBusMacroAckCustom:
    ;reghub.bus_ack_idx = ((bus_sel_idx_loc + 0x7) & 0x7);
    add ecx,7
    and ecx,7
    mov dword[rdi+hub_bus_ack_idx], ecx

    ;cog_ena_reg_next mit cog_ena_reg vergleichen
    mov eax,dword[rdi+hub_cog_ena_reg]
    cmp eax,edx
    je hubClkBusDone
    call hubClkHandleCogsStartStop
    jmp hubClkBusDone



hubClkBusDone:
    ret

;cog Ena reg wird sich ändern, hier cogs starten/stoppen
;cog_ena_reg:      eax
;cog_ena_reg_next: edx
hubClkHandleCogsStartStop:
        ;cog_ena_reg = cog_ena_reg_next
        mov dword[rdi+hub_cog_ena_reg], edx
        xor eax,edx ;eax enthält jetzt, ein bit pro cog, dessen status sich geändert hat
        ;pointer auf ersten cog registersatz
        lea rsi,[rdi+HubRelFirstCogRegOffset]
        ;alle cogs durchgehen
    .loop:
        test al,1 ;hat sich der cog status geändert?
        jz .nextCog ;nein, dann überspringen
        push rax ;die funktion wird selten aufgerufen, also ist es leichter beide regs zu sichern
        push rdx
        test dl,1 ;gestartet oder gestoppt?
        jz .negedge
        call cogPosedgeEna
        jmp .cogProcessed
    .negedge:
        call cogNegedgeEna
    .cogProcessed:
        pop rdx
        pop rax
    .nextCog:
        shr eax,1 ;für den nächsten cog vorbereiten (bit 0 gibt an, ob sich der cog status geändert hat)
        shr edx,1 ;für den nächsten cog vorbereiten (bit 0 gibt an, ob der cog gestartet oder gestoppt werden soll)
        add rsi,PerCogSize ;pointer auf nächsten cog
        lea rcx,[rdi+HubRelFirstCogRegOffset+8*PerCogSize]
        cmp rsi,rcx ;am ende angelangt?
        jne .loop
    ;if (!ena && lastEna)
        ;PropellerAsmImplGen::cogNegedgeEna(hub,*hub.cogs[i]);
    ;else if (ena && !lastEna)
        ;PropellerAsmImplGen::cogPosedgeEna(hub,*hub.cogs[i]);
        ret
