BITS 64
section .text

startOfCode:
%include "asm-memorymap.asm"
%include "asm-regs.gen.asm"

hub_hub_mem_ext     equ HubRelMemoryOffset
cog_reg_cog_ram_r   equ CogRelMemoryOffset

;Generierter Code
%include "asm-cogclk-stateother.gen.asm"
%include "asm-cogclk-state4.gen.asm"
%include "asm-cogclk-zflagmacros.gen.asm"
%include "asm-hubclk-enabus.gen.asm"
%include "asm-other.gen.asm"
%include "asm-patches.gen.asm"

;Manuell erzeugter Code
%include "asm-hub.asm"
%include "asm-cogpreeval.asm"
%include "asm-cogpinout.asm"
%include "asm-cogclk-peripherals.asm"
%include "asm-debug.asm"


cogUpdateAllDynamicFunctions:
    call updateCogPeripheralsFunction
    call updateCogPreEvalFunction
    call updateCogAsyncVid
    call updateCogEvalPinOut
    ret

;Geänderte Register: rax, rdx, und alle der JumpTBl
hubClkBusEna:
    lea rax,[rel startOfCode]
    mov edx,dword [rdi+hub_hub_state]
    add rax,rdx
    jmp rax

cogBusSel:
    ;bus selektrierten cog ermitteln und pointer zu registern berechnen
    mov edx,dword [rdi+hub_bus_sel_idx]
    shl edx,PerCogSizeLog2
    lea rsi,[rdi+rdx+HubRelFirstCogRegOffset]
    ;hub sel funktion ermitteln
    lea rax,[rel startOfCode]
    mov edx,dword [rsi+cog_bus_sel_state]
    add rax,rdx
    jmp rax

%macro cogClkEnaGetStateDestination 2 ;zielregister; extraoffset
    lea %1,[rel startOfCode]
    mov edx,dword [rsi+cog_compound_statex+%2]
    add %1,rdx
%endmacro

cogClkEna:
    push rsi
    ;Pointer auf Cog Registers von Cog 0
    lea rsi,[rdi+HubRelFirstCogRegOffset]
    ;Sprungtabelle Cog 0 laden
    cogClkEnaGetStateDestination rax, 0
    ;Sprungtabelle Cog 1 vorladenladen
    cogClkEnaGetStateDestination r14, PerCogSize
    call rax ;Cog 0

    add rsi,PerCogSize
    mov rax,r14
    cogClkEnaGetStateDestination r14, PerCogSize
    call rax ;Cog 1

    add rsi,PerCogSize
    mov rax,r14
    cogClkEnaGetStateDestination r14, PerCogSize
    call rax ;Cog 2

    add rsi,PerCogSize
    mov rax,r14
    cogClkEnaGetStateDestination r14, PerCogSize
    call rax ;Cog 3

    add rsi,PerCogSize
    mov rax,r14
    cogClkEnaGetStateDestination r14, PerCogSize
    call rax ;Cog 4

    add rsi,PerCogSize
    mov rax,r14
    cogClkEnaGetStateDestination r14, PerCogSize
    call rax ;Cog 5

    add rsi,PerCogSize
    mov rax,r14
    cogClkEnaGetStateDestination r14, PerCogSize
    call rax ;Cog 6

    add rsi,PerCogSize
    call r14 ;Cog 7

    pop rsi
    ret

;eax Nummer
;rsi Pointer auf die Tabelle
copyPatchFunctionToScratchpad:
    mov ecx, dword[rsi+rax*8+4]
    mov eax, dword[rsi+rax*8]
    sub rsi,rax
    rep movsb
    ret

;rax: Zielfunktion
copyScratchPadToDynamicFunction:
    lea rsi,[r8+HubRelScratchpadOffset]
    sub rdi,rsi  ;Anzahl an bytes
    mov ecx,edi
    mov rdi,rax
    rep movsb
    ret

;instr_dst: rdx
;outp_cog_alu_r rcx
macroCog4SetControlRegisters:
    cmp edx,0x1F0
    jl .end
    ;TODO
    push rax
    push rdx
    push rcx
    push r8
    push r9
    push r10
    push r11
    push r12
    push rsi
    push rdi
    call cppMacroCog4SetControlRegisters
    pop rdi
    pop rsi
    pop r12
    pop r11
    pop r10
    pop r9
    pop r8
    pop rcx
    pop rdx
    pop rax
    .end:
    ret

extern cppMacroCog4SetControlRegisters

%include "asm-callstubs.gen.asm"
times 32 nop
endOfCode:
times 1024*32-(endOfCode-startOfCode) nop
db "START OF DATA",0,0,0
%include "asm-tables.gen.asm"
%include "asm-manual-tables.asm"
times 16 nop
