;Die grobe Memory Map ist hier hinterlegt

PerCogSizeLog2 equ 12
PerCogSize     equ (1<<PerCogSizeLog2)

;Größen der einzelnen Bereiche
HubMemorySize       equ 1024*32*3
CogMemorySize       equ PerCogSize*8
CogRegisterSize     equ PerCogSize*8
HubRegisterSize     equ 1024*4
ScratchPadSize      equ 1024*4
PreEmptyAreaSize    equ 1024*4
DynamicCogAsmOffset equ PerCogSize*8
PostEmptyAreaSize   equ 1024*4


;Globale Offsets der einzelnen Bereiche
GlobalHubMemoryOffset       equ 0                                          
GlobalCogMemoryOffset       equ GlobalHubMemoryOffset+HubMemorySize
GlobalCogRegisterOffset     equ GlobalCogMemoryOffset+CogMemorySize
GlobalHubRegisterOffset     equ GlobalCogRegisterOffset+CogRegisterSize
GlobalScratchpadOffset      equ GlobalHubRegisterOffset+HubRegisterSize
GlobalPreEmptyAreaOffset    equ GlobalScratchpadOffset+ScratchPadSize
GlobalDynamicCogAsmOffset   equ GlobalPreEmptyAreaOffset+PreEmptyAreaSize
GlobalPostEmptyAreaOffset   equ GlobalDynamicCogAsmOffset+DynamicCogAsmOffset

;Gesamtgröße der Map
TotalMemoryMapSize          equ GlobalPostEmptyAreaOffset+PostEmptyAreaSize,

;Relativ zum GlobalHubRegisterOffset, darauf zeigt der hubPtr
HubRelMemoryOffset          equ GlobalHubMemoryOffset-GlobalHubRegisterOffset
HubRelScratchpadOffset      equ GlobalScratchpadOffset-GlobalHubRegisterOffset
HubRelFirstCogRegOffset     equ GlobalCogRegisterOffset-GlobalHubRegisterOffset

;Relativ zum GlobalCogRegisterOffset, darauf (+cogNo*1024*4) zeigt der cogPtr
CogRelMemoryOffset          equ GlobalCogMemoryOffset-GlobalCogRegisterOffset
CogRelDynamicAsmOffset      equ GlobalDynamicCogAsmOffset-GlobalCogRegisterOffset

;Cog Dynamic Funktionen
dynamicCogPeripheralsClk    equ 0           ;256 Bytes
dynamicCogPreEvalPll        equ 256         ;256 Bytes
dynamicCogAsyncVid          equ 512         ;512 Bytes
dynamicCogPreEvalClk        equ 1024        ;256 Bytes
dynamicCogCheckVid          equ 1280        ;256 Bytes
dynamicCogPinOut            equ 1536        ;256 Bytes
