;Inhalt der Datei: 
;Funktion dynFunCogClkPeripherals
;Diese Funktion ist eine dynamisch zusammengebaute Funktion pro cog
;Sie wird über die Funktion funGenerateCogClkPeripherals erzeugt
;Es folgt der Pseudocode der zu erzeugenden Funktion

;function dynFunCogClkPeripherals:
;    macro macroHandleCounter:
;        macro macroSetPhase:
;            let ctrreg_phase (add64 (and64 ctrreg_phase 0Lffffffff) (cast64 ctrreg_frequency))
;            
;        macro macroSetDelayed0Mode8toF:
;            let ctrreg_delayed0 (neq32 (and32 pin_in_wire ctrreg_ctrapinmask) 0I0)
;        
;        macro macroSetDelayed0Mode10to1F:
;            let ctrreg_delayed0 (neq32 (and32 pin_in_wire ctrreg_ctrapinmask) 0I0)
;            let ctrreg_delayed1 (neq32 (and32 pin_in_wire ctrreg_ctrbpinmask) 0I0)
;            
;        ;Im Code Generator wird hier statisch anhand reg_cog_ctrx_ctrmode ein Fall ausgewählt
;        switch reg_cog_ctrx_ctrmode:
;            case 0I0: 
;            case 0I1 0I2 0I3 0I4 0I5 0I6 0I7:
;                macroSetPhase
;            case 0I8 0I9:
;                if ctrreg_delayed0:
;                    macroSetPhase
;                let ctrreg_delayed1 ctrreg_delayed0
;                macroSetDelayed0Mode8toF
;            case 0Ia 0Ib:
;                if (andB ctrreg_delayed0 (notB ctrreg_delayed1)):
;                    macroSetPhase
;                let ctrreg_delayed1 ctrreg_delayed0
;                macroSetDelayed0Mode8toF
;            case 0Ic 0Id:
;                if (notB ctrreg_delayed0):
;                    macroSetPhase
;                let ctrreg_delayed1 ctrreg_delayed0
;                macroSetDelayed0Mode8toF
;            case 0Ie 0If:
;                if (andB (notB ctrreg_delayed0) ctrreg_delayed1):
;                    macroSetPhase
;                let ctrreg_delayed1 ctrreg_delayed0
;                macroSetDelayed0Mode8toF
;            case 0I10:
;                macroSetDelayed0Mode10to1F
;            case 0I11:
;                if (andB (notB ctrreg_delayed1) (notB ctrreg_delayed0)):
;                    macroSetPhase
;                macroSetDelayed0Mode10to1F
;            case 0I12:
;                if (andB (notB ctrreg_delayed1) ctrreg_delayed0):
;                    macroSetPhase
;                macroSetDelayed0Mode10to1F
;            case 0I13:
;                if (notB ctrreg_delayed1):
;                    macroSetPhase
;                macroSetDelayed0Mode10to1F
;            case 0I14:
;                if (andB ctrreg_delayed1 (notB ctrreg_delayed0)):
;                    macroSetPhase
;                macroSetDelayed0Mode10to1F
;            case 0I15:
;                if (notB ctrreg_delayed0):
;                    macroSetPhase
;                macroSetDelayed0Mode10to1F
;            case 0I16:
;                if (neqB ctrreg_delayed1 ctrreg_delayed0):
;                    macroSetPhase
;                macroSetDelayed0Mode10to1F
;            case 0I17:
;                if (notB (andB ctrreg_delayed1 ctrreg_delayed0)):
;                    macroSetPhase
;                macroSetDelayed0Mode10to1F
;            case 0I18:
;                if (andB ctrreg_delayed1 ctrreg_delayed0):
;                    macroSetPhase
;                macroSetDelayed0Mode10to1F
;            case 0I19:
;                if (eqB ctrreg_delayed1 ctrreg_delayed0):
;                    macroSetPhase
;                macroSetDelayed0Mode10to1F
;            case 0I1a:
;                if ctrreg_delayed0:
;                    macroSetPhase
;                macroSetDelayed0Mode10to1F
;            case 0I1b:
;                if (orB ctrreg_delayed0 (notB ctrreg_delayed1)):
;                    macroSetPhase
;                macroSetDelayed0Mode10to1F
;            case 0I1c:
;                if ctrreg_delayed1:
;                    macroSetPhase
;                macroSetDelayed0Mode10to1F
;            case 0I1d:
;                if (orB (notB ctrreg_delayed0) ctrreg_delayed1):
;                    macroSetPhase
;                macroSetDelayed0Mode10to1F
;            case 0I1e:
;                if (orB ctrreg_delayed0 ctrreg_delayed1):
;                    macroSetPhase
;                macroSetDelayed0Mode10to1F
;            case 0I1f:
;                macroSetPhase
;                macroSetDelayed0Mode10to1F
;
;    ;Code der Funktion
;    macroHandleCounter CounterA
;    macroHandleCounter CounterB
;
;    ;Die folgende If Bedingung wird statisch ausgewertet
;    if (neq32 reg_cog_vid_vcfg_vmode 0I0):
;        let reg_cog_vid_snc1 reg_cog_vid_snc0
;        let reg_cog_vid_snc0 reg_cog_vid_capr
;
;    if (andB ena_bus_wire ptr_w_wire):
;        let progctr ptr_d_wire

;Stellt Code Templates für Code bereits, der bei einem cog clk Tick aufgerufen wird
;Der Code wird dabei nicht direkt aufgerufen sondern muss vorher pro Cog zusammengebaut
;werden. Beim ändern wesentlicher Register wird der Code dynamisch neu erzeugt
;Parameter:
;   ctrregset: ctr_regset_a oder ctr_regset_b für Counter A/B
%macro macroHandleCounter 1
    %define CTR COG+%1
    
    %macro macroSetPhase 0
        ;A Register muss erhalten bleiben!
        ;let ctrreg_phase (add64 (and64 ctrreg_phase 0Lffffffff) (cast64 ctrreg_frequency))
        mov B32, dword [CTR+ctrreg_phase]      ;nur unteren 32 bit werden geladen (entspricht and 0xFFFFFFFF)
        mov C32, dword [CTR+ctrreg_frequency]  ;die 32 bit variable wird geladen und auf 64 bit mit 0 erweitert
        add B64, C64
        mov qword [CTR+ctrreg_phase], B64
    %endmacro
    
    %macro macroSetDelayed0Mode8toF 0
        ;Keine TMP Register müssen erhalten bleiben
        ;let ctrreg_delayed0 (neq32 (and32 pin_in_wire ctrreg_ctrapinmask) 0I0)
        ;let A (shr32 pin_in_wire ctrreg_ctrapin)
        mov A32, dword [HUB+hub_pin_in_wire]
        test A32, dword [CTR+ctrreg_ctrapinmask]
        setnz byte [CTR+ctrreg_delayed0] ;wenn pin_in_wire&ctrreg_ctrapinmask !=0 war wird 1 sonst 0 gesetzt
    %endmacro
    
    %macro macroSetDelayed0Mode10to1F 0
        ;Keine TMP Register müssen erhalten bleiben
        mov A32, dword [HUB+hub_pin_in_wire]
        ;let ctrreg_delayed0 (neq32 (and32 pin_in_wire ctrreg_ctrapinmask) 0I0)
        test A32, dword [CTR+ctrreg_ctrapinmask]
        setnz byte [CTR+ctrreg_delayed0] ;wenn pin_in_wire&ctrreg_ctrapinmask !=0 war wird 1 sonst 0 gesetzt
        ;let ctrreg_delayed1 (neq32 (and32 pin_in_wire ctrreg_ctrbpinmask) 0I0)
        test A32, dword [CTR+ctrreg_ctrbpinmask]
        setnz byte [CTR+ctrreg_delayed1] ;wenn pin_in_wire&ctrreg_ctrbpinmask !=0 war wird 1 sonst 0 gesetzt
    %endmacro
    
    
    ;in A64 ist ctrmode, danach wird hier gesprungen
    executeJumpTable .tableStart
    .tableStart:
    ;je nach ctrmode werden verschiedene counter modi ausgewählt (32 stück)
    ;anhand der tabelle wird das passende code fragment ermittelt
    addJumpTableEntry .tableStart, .ctrmode_0              ;0
    addJumpTableEntry .tableStart, .ctrmode_1_2_3_4_5_6_7  ;1
    addJumpTableEntry .tableStart, .ctrmode_1_2_3_4_5_6_7  ;2
    addJumpTableEntry .tableStart, .ctrmode_1_2_3_4_5_6_7  ;3
    addJumpTableEntry .tableStart, .ctrmode_1_2_3_4_5_6_7  ;4
    addJumpTableEntry .tableStart, .ctrmode_1_2_3_4_5_6_7  ;5
    addJumpTableEntry .tableStart, .ctrmode_1_2_3_4_5_6_7  ;6
    addJumpTableEntry .tableStart, .ctrmode_1_2_3_4_5_6_7  ;7
    addJumpTableEntry .tableStart, .ctrmode_8_9            ;8
    addJumpTableEntry .tableStart, .ctrmode_8_9            ;9
    addJumpTableEntry .tableStart, .ctrmode_a_b            ;10
    addJumpTableEntry .tableStart, .ctrmode_a_b            ;11
    addJumpTableEntry .tableStart, .ctrmode_c_d            ;12
    addJumpTableEntry .tableStart, .ctrmode_c_d            ;13
    addJumpTableEntry .tableStart, .ctrmode_e_f            ;14
    addJumpTableEntry .tableStart, .ctrmode_e_f            ;15
    addJumpTableEntry .tableStart, .ctrmode_10             ;16
    addJumpTableEntry .tableStart, .ctrmode_11             ;17
    addJumpTableEntry .tableStart, .ctrmode_12             ;18
    addJumpTableEntry .tableStart, .ctrmode_13             ;19
    addJumpTableEntry .tableStart, .ctrmode_14             ;20
    addJumpTableEntry .tableStart, .ctrmode_15             ;21
    addJumpTableEntry .tableStart, .ctrmode_16             ;22
    addJumpTableEntry .tableStart, .ctrmode_17             ;23
    addJumpTableEntry .tableStart, .ctrmode_18             ;24
    addJumpTableEntry .tableStart, .ctrmode_19             ;25
    addJumpTableEntry .tableStart, .ctrmode_1a             ;26
    addJumpTableEntry .tableStart, .ctrmode_1b             ;27
    addJumpTableEntry .tableStart, .ctrmode_1c             ;28
    addJumpTableEntry .tableStart, .ctrmode_1d             ;29
    addJumpTableEntry .tableStart, .ctrmode_1e             ;30
    addJumpTableEntry .tableStart, .ctrmode_1f             ;31
    times 8 nop                     ;Disassember Resync

    ;Hier sind die einzelnen Fälle für die verschiedenen ctrmode Fälle
    ;Am Anfang ist als Kommentar immer der folgende Pseudocode geschrieben
    
    .ctrmode_0:
        ;Hier gibt es nichts zu tun
        ret
        .ctrmode_0_end:
    
    
    .ctrmode_1_2_3_4_5_6_7:
        ;macroSetPhase
        copyFollowingCodeAndRet .ctrmode_1_2_3_4_5_6_7_end
            macroSetPhase
        .ctrmode_1_2_3_4_5_6_7_end:
        
        
    .ctrmode_8_9:
        ;skipIf !ctrreg_delayed0:
        ;    macroSetPhase
        ;let ctrreg_delayed1 ctrreg_delayed0
        ;macroSetDelayed0Mode8toF
        copyFollowingCodeAndRet .ctrmode_8_9_end
                movzx A32,byte [CTR+ctrreg_delayed0]
                goto_if_false A8, .ctrmode_8_9_skip
                macroSetPhase
            .ctrmode_8_9_skip:
                mov byte [CTR+ctrreg_delayed0],A8
                macroSetDelayed0Mode8toF
        .ctrmode_8_9_end:
        
        
    .ctrmode_a_b:
        ;skipIf !ctrreg_delayed0 || ctrreg_delayed1:
        ;    macroSetPhase
        ;let ctrreg_delayed1 ctrreg_delayed0
        ;macroSetDelayed0Mode8toF
        copyFollowingCodeAndRet .ctrmode_a_b_end
                movzx A32,byte [CTR+ctrreg_delayed0]
                goto_if_false A8, .ctrmode_a_b_skip
                goto_if_true byte [CTR+ctrreg_delayed1], .ctrmode_a_b_skip
                macroSetPhase
            .ctrmode_a_b_skip:
                mov byte [CTR+ctrreg_delayed0],A8
                macroSetDelayed0Mode8toF
        .ctrmode_a_b_end:    
        
    .ctrmode_c_d:
        ;skipIf ctrreg_delayed0:
        ;    macroSetPhase
        ;let ctrreg_delayed1 ctrreg_delayed0
        ;macroSetDelayed0Mode8toF
        copyFollowingCodeAndRet .ctrmode_c_d_end
                movzx A32,byte [CTR+ctrreg_delayed0]
                goto_if_true A8, .ctrmode_c_d_skip
                macroSetPhase
            .ctrmode_c_d_skip:
                mov byte [CTR+ctrreg_delayed0],A8
                macroSetDelayed0Mode8toF
        .ctrmode_c_d_end:
        
    .ctrmode_e_f:
        ;skipIf ctrreg_delayed0 || !ctrreg_delayed1:
        ;    macroSetPhase
        ;let ctrreg_delayed1 ctrreg_delayed0
        ;macroSetDelayed0Mode8toF
        copyFollowingCodeAndRet .ctrmode_e_f_end
                movzx A32,byte [CTR+ctrreg_delayed0]
                goto_if_true A8, .ctrmode_e_f_skip
                goto_if_false byte [CTR+ctrreg_delayed1], .ctrmode_e_f_skip
                je .ctrmode_e_f_skip
            .ctrmode_e_f_skip:
                mov byte [CTR+ctrreg_delayed0],A8
                macroSetDelayed0Mode8toF
            .ctrmode_e_f_end:
        
        
    .ctrmode_10:
        ;macroSetDelayed0Mode10to1F
        copyFollowingCodeAndRet .ctrmode_10_end
                macroSetDelayed0Mode10to1F
        .ctrmode_10_end:
        
        
    .ctrmode_11:
        ;skipIf ctrreg_delayed0 || ctrreg_delayed1:
        ;    macroSetPhase
        ;macroSetDelayed0Mode10to1F
        copyFollowingCodeAndRet .ctrmode_11_end
                goto_if_true byte [CTR+ctrreg_delayed0], .ctrmode_11_skip
                goto_if_true byte [CTR+ctrreg_delayed1], .ctrmode_11_skip
                macroSetPhase
            .ctrmode_11_skip:
                macroSetDelayed0Mode10to1F
        .ctrmode_11_end:
        
        
    .ctrmode_12:
        ;skipIf !ctrreg_delayed0 || ctrreg_delayed1:
        ;    macroSetPhase
        ;macroSetDelayed0Mode10to1F
        copyFollowingCodeAndRet .ctrmode_12_end
                goto_if_false byte [CTR+ctrreg_delayed0], .ctrmode_12_skip
                goto_if_true  byte [CTR+ctrreg_delayed1], .ctrmode_12_skip
                macroSetPhase
            .ctrmode_12_skip:
                macroSetDelayed0Mode10to1F
        .ctrmode_12_end:
        
        
    .ctrmode_13:
        ;skipIf ctrreg_delayed1: //Achtung delayed1
        ;    macroSetPhase
        ;macroSetDelayed0Mode10to1F
        copyFollowingCodeAndRet .ctrmode_13_end
                goto_if_true byte [CTR+ctrreg_delayed1], .ctrmode_13_skip
                macroSetPhase
            .ctrmode_13_skip:
                macroSetDelayed0Mode10to1F
        .ctrmode_13_end:
        
    .ctrmode_14:
        ;skipIf ctrreg_delayed0 || !ctrreg_delayed1:
        ;    macroSetPhase
        ;macroSetDelayed0Mode10to1F
        copyFollowingCodeAndRet .ctrmode_14_end
                goto_if_true  byte [CTR+ctrreg_delayed0], .ctrmode_14_skip
                goto_if_false byte [CTR+ctrreg_delayed1], .ctrmode_14_skip
                macroSetPhase
            .ctrmode_14_skip:
                macroSetDelayed0Mode10to1F
        .ctrmode_14_end:
        
        
    .ctrmode_15:
        ;skipIf ctrreg_delayed0:
        ;    macroSetPhase
        ;macroSetDelayed0Mode10to1F
        copyFollowingCodeAndRet .ctrmode_15_end
                goto_if_true byte [CTR+ctrreg_delayed0], .ctrmode_15_skip
                macroSetPhase
            .ctrmode_15_skip:
                macroSetDelayed0Mode10to1F
        .ctrmode_15_end:
        
        
    .ctrmode_16:
        ;skipIf ctrreg_delayed0 == ctrreg_delayed1:
        ;    macroSetPhase
        ;macroSetDelayed0Mode10to1F
        copyFollowingCodeAndRet .ctrmode_16_end
                movzx A32,byte [CTR+ctrreg_delayed0]
                cmp A8,byte [CTR+ctrreg_delayed1]
                je .ctrmode_16_skip
                macroSetPhase
            .ctrmode_16_skip:
                macroSetDelayed0Mode10to1F
        .ctrmode_16_end:
        
        
    .ctrmode_17:
        ;if (!ctrreg_delayed0 || !ctrreg_delayed1): //ctrreg_delayed0==false -> ausführen, alternativ wenn ctrreg_delayed1 überspringen
        ;    macroSetPhase
        ;macroSetDelayed0Mode10to1F
        copyFollowingCodeAndRet .ctrmode_17_end
                goto_if_false byte [CTR+ctrreg_delayed0], .ctrmode_17_exec
                goto_if_true  byte [CTR+ctrreg_delayed1], .ctrmode_17_skip
            .ctrmode_17_exec:
                macroSetPhase
            .ctrmode_17_skip:
                macroSetDelayed0Mode10to1F
        .ctrmode_17_end:
        
        
    .ctrmode_18:
        ;skipIf (!ctrreg_delayed0 || !ctrreg_delayed1):
        ;    macroSetPhase
        ;macroSetDelayed0Mode10to1F
        copyFollowingCodeAndRet .ctrmode_18_end
                goto_if_false byte [CTR+ctrreg_delayed0], .ctrmode_18_skip
                goto_if_false byte [CTR+ctrreg_delayed1], .ctrmode_18_skip
                macroSetPhase
            .ctrmode_18_skip:
                macroSetDelayed0Mode10to1F
        .ctrmode_18_end:
        
        
    .ctrmode_19:
        ;skipIf ctrreg_delayed0 != ctrreg_delayed1:
        ;    macroSetPhase
        ;macroSetDelayed0Mode10to1F
        copyFollowingCodeAndRet .ctrmode_19_end
                movzx A32,byte [CTR+ctrreg_delayed0]
                cmp A8,byte [CTR+ctrreg_delayed1]
                jne .ctrmode_19_skip
                macroSetPhase
            .ctrmode_19_skip:
                macroSetDelayed0Mode10to1F
        .ctrmode_19_end:
        
        
    .ctrmode_1a:
        ;skipIf !ctrreg_delayed0:
        ;    macroSetPhase
        ;macroSetDelayed0Mode10to1F
        copyFollowingCodeAndRet .ctrmode_1a_end
                goto_if_false byte [CTR+ctrreg_delayed0], .ctrmode_1a_skip
                macroSetPhase
            .ctrmode_1a_skip:
                macroSetDelayed0Mode10to1F
        .ctrmode_1a_end:
        
        
    .ctrmode_1b:
        ;if (ctrreg_delayed0 || !ctrreg_delayed1): //wenn delayed0==true ausführen, alternativ wenn delayed1==true ist, dann überpringen
        ;    macroSetPhase
        ;macroSetDelayed0Mode10to1F
        copyFollowingCodeAndRet .ctrmode_1b_end
                goto_if_true byte [CTR+ctrreg_delayed0], .ctrmode_1b_exec
                goto_if_true byte [CTR+ctrreg_delayed1], .ctrmode_1b_skip
            .ctrmode_1b_exec:
                macroSetPhase
            .ctrmode_1b_skip:
                macroSetDelayed0Mode10to1F
        .ctrmode_1b_end:
        
        
        
    .ctrmode_1c:
        ;skipIf !ctrreg_delayed1: //Achtung delayed1
        ;    macroSetPhase
        ;macroSetDelayed0Mode10to1F
        copyFollowingCodeAndRet .ctrmode_1c_end
                goto_if_false byte [CTR+ctrreg_delayed1], .ctrmode_1c_skip
                macroSetPhase
            .ctrmode_1c_skip:
                macroSetDelayed0Mode10to1F
        .ctrmode_1c_end:
        
        
    .ctrmode_1d:
        ;if (!ctrreg_delayed0 || ctrreg_delayed1): //wenn delayed0==false dann ausführen, ansonsten if delayed1==false überspringen
        ;    macroSetPhase
        ;macroSetDelayed0Mode10to1F
        copyFollowingCodeAndRet .ctrmode_1d_end
                goto_if_false byte [CTR+ctrreg_delayed0], .ctrmode_1d_exec
                goto_if_false byte [CTR+ctrreg_delayed1], .ctrmode_1d_skip
            .ctrmode_1d_exec:
                macroSetPhase
            .ctrmode_1d_skip:
                macroSetDelayed0Mode10to1F
        .ctrmode_1d_end:
        
        
    .ctrmode_1e:
        ;if (ctrreg_delayed0 || ctrreg_delayed1): //Wenn delayed0==true dann ausführen, ansonsten if delayed1==false überspringen
        ;    macroSetPhase
        ;macroSetDelayed0Mode10to1F
        copyFollowingCodeAndRet .ctrmode_1e_end
                goto_if_true  byte [CTR+ctrreg_delayed0], .ctrmode_1e_exec
                goto_if_false byte [CTR+ctrreg_delayed1], .ctrmode_1e_skip
            .ctrmode_1e_exec:
                macroSetPhase
            .ctrmode_1e_skip:
                macroSetDelayed0Mode10to1F
        .ctrmode_1e_end:
        
        
    .ctrmode_1f:
        ;macroSetPhase
        ;macroSetDelayed0Mode10to1F
        copyFollowingCodeAndRet .ctrmode_1f_end
                macroSetPhase
                macroSetDelayed0Mode10to1F
        .ctrmode_1f_end:
        
        
    %unmacro macroSetPhase 0
    %unmacro macroSetDelayed0Mode8toF 0
    %unmacro macroSetDelayed0Mode10to1F 0
    %undef CTR
%endmacro

funGenerateCogClkPeripherals:
        ;Erzeugt für den Cog die dynFunCogClkPeripherals Funktion
        
        ;Der Code wird zuerst in das Scratchpad geschrieben
        lea DST64,[SCRATCHPAD]
        
        ;Nun für Counter A das CLK Template kopieren (je nach ctrmode)
        mov A32,dword[COG+cog_reg_cog_ctra_ctrmode]
    templateCogClkCounterA:
        macroHandleCounter CounterA
        
        ;Nun für Counter B das CLK Template kopieren (je nach ctrmode)
        mov A32,dword[COG+cog_reg_cog_ctrb_ctrmode]
    templateCogClkCounterB:
        macroHandleCounter CounterB
        
        
    templateCogClkVid:
        ;Nun das Video CLK Template kopieren, aber nur wenn vcfg != 0 (kann nur 1,2,3 sonst sein)
        cmp byte[COG+cog_reg_cog_vid_vcfg_vmode],0
        je .skipVidCode
        
        copyFollowingCodeUntil .endOfVidCode
            ;let reg_cog_vid_snc1 reg_cog_vid_snc0
            movzx A32,byte[COG+cog_reg_cog_vid_snc0]
            mov byte [COG+cog_reg_cog_vid_snc1],A8
            ;let reg_cog_vid_snc0 reg_cog_vid_capr
            movzx A32,byte[COG+cog_reg_cog_vid_capr]
            mov byte [COG+cog_reg_cog_vid_snc0],A8
        .endOfVidCode:
        
    .skipVidCode:
        
        ;Als letztes kommen noch ein paar Allgemeine Befehle, die immer eingebaut werden
        copyFollowingCodeUntil .endOfRemainingCode
                ;skipIf !ena_bus_wire || !ptr_w_wire_bit:
                ;   let progctr ptr_d_wire
                goto_if_false byte [HUB+hub_ena_bus_wire], .skipSetProgCtr
                goto_if_false byte [COG+cog_ptr_w_wire_bit], .skipSetProgCtr
                mov A32,dword [HUB+hub_ptr_d_wire]
                mov dword [COG+cog_progctr],A32
            .skipSetProgCtr:
                ret
    .endOfRemainingCode:
        
        ;Funktion aktivieren
        mov SRC64,DST64
        lea DST64, [COGFUN+dynFunCogClkPeripherals]
        call funActivateGeneratedFunction
        ret
funGenerateCogClkPeripherals.endOfFunction:
    
    
    

%unmacro macroHandleCounter 1
