;Inhalt der Datei: 
;Funktion dynFunCogPinOut
;Diese Funktion ist eine dynamisch zusammengebaute Funktion pro cog
;Sie wird über die Funktion funGenerateCogPinOut erzeugt
;Es folgt der Pseudocode der zu erzeugenden Funktion 
;function cogPinOut:
;    macro macroHandleCounter:
;        switch ctrx_ctrmode:
;            case 0I0 0I1 0I8 0Ia 0Ic 0Ie 0I10 0I11 0I12 0I13 0I14 0I15 0I16 0I17 0I18 0I19 0I1a 0I1b 0I1c 0I1d 0I1e 0I1f:
;            case 0I2:
;                if ctrreg_pllsaved:
;                    orlet pin_out_local ctrreg_ctrapinmask
;            case 0I3:
;                orlet pin_out_local (mux32 ctrreg_pllsaved ctrreg_ctrapinmask ctrreg_ctrbpinmask))
;            case 0I4:
;                if (testBit64 ctrreg_phase 0I1f):
;                    orlet pin_out_local ctrreg_ctrapinmask
;            case 0I5:
;                orlet pin_out_local (mux32 (testBit64 ctrreg_phase 0I1f) ctrreg_ctrapinmask ctrreg_ctrbpinmask))
;            case 0I6:
;                if (testBit64 ctrreg_phase 0I20):
;                    orlet pin_out_local ctrreg_ctrapinmask
;            case 0I7:
;                orlet pin_out_local (mux32 (testBit64 ctrreg_phase 0I20) ctrreg_ctrapinmask ctrreg_ctrbpinmask)
;            case 0I9 0Ib 0Id 0If:
;                if !ctrreg_delayed0:
;                    orlet pin_out_local ctrreg_ctrbpinmask
;         
;    macro macroVid:
;        local I vidOut
;        local B vidCond
;        macro calcVidTmp
;            if pllb_saved:
;                true:
;                    let vidTmp (sub32 0I7 (shr32 (add32 reg_cog_vid_composite 0I1) 0I1))
;                false:
;                    let vidTmp (and32 (shr32 reg_cog_vid_composite 0I1) 0I3)

;        macro calcVidCond:
;            let vidCond (neqB pllb_saved (testBit32 pll_in_wire reg_cog_vid_vcfg_auralsub))
;            let vidOut (muxB vidCond 0I1 0I0)
;
;        macro calcVidPinOut:
;            orlet pin_out_local (shl32 (and32 vidOut reg_cog_vid_vcfg_vpins) reg_cog_vid_vcfg_vgroup)
;            
;            
;        switch reg_cog_vid_vcfg_vmode:
;            case 0I0:
;            case 0I1:
;                let vidOut reg_cog_vid_discrete
;                calcVidPinOut
;            case 0I2:
;                calcVidCond
;                let vidOut (shl32 vidOut 7); entspricht (mux32 vidCond 0I80 0I0)
;                add32let vidOut reg_cog_vid_baseband
;                calcVidTmp
;                add32let vidOut (shl32 vidTmp 0I4)
;                calcVidPinOut
;            case 0I3:
;                calcVidCond
;                let vidOut (shl32 vidOut 3); entspricht (mux32 vidCond 0I8 0I0)
;                add32let vidOut (shl32 reg_cog_vid_baseband 0I4)
;                calcVidTmp
;                add32let vidout vidTmp
;                calcVidPinOut
;
;    local I pin_out_local
;    
;    let pin_out_local outa
;    macroHandleCounter CounterA
;    macroHandleCounter CounterB
;    macroVid
;    let pin_out_wire (and32 pin_out_local dira)
;    let pin_dir_wire dira
%define LOCALPINOUT C32
%macro macroHandleCounter 1
    %define CTR COG+%1
    
    executeJumpTable .tableStart
    .tableStart:
    ;je nach ctrmode werden verschiedene counter modi ausgewählt (32 stück)
    ;anhand der tabelle wird das passende code fragment ermittelt
    addJumpTableEntry .tableStart, .ctrmode_0_1_8_a_c_e_10_11_12_13_14_15_16_17_18_19_1a_1b_1c_1d_1e_1f ;0
    addJumpTableEntry .tableStart, .ctrmode_0_1_8_a_c_e_10_11_12_13_14_15_16_17_18_19_1a_1b_1c_1d_1e_1f ;1
    addJumpTableEntry .tableStart, .ctrmode_2                                                           ;2
    addJumpTableEntry .tableStart, .ctrmode_3                                                           ;3
    addJumpTableEntry .tableStart, .ctrmode_4                                                           ;4
    addJumpTableEntry .tableStart, .ctrmode_5                                                           ;5
    addJumpTableEntry .tableStart, .ctrmode_6                                                           ;6
    addJumpTableEntry .tableStart, .ctrmode_7                                                           ;7
    addJumpTableEntry .tableStart, .ctrmode_0_1_8_a_c_e_10_11_12_13_14_15_16_17_18_19_1a_1b_1c_1d_1e_1f ;8
    addJumpTableEntry .tableStart, .ctrmode_9_b_d_f                                                     ;9
    addJumpTableEntry .tableStart, .ctrmode_0_1_8_a_c_e_10_11_12_13_14_15_16_17_18_19_1a_1b_1c_1d_1e_1f ;10
    addJumpTableEntry .tableStart, .ctrmode_9_b_d_f                                                     ;11
    addJumpTableEntry .tableStart, .ctrmode_0_1_8_a_c_e_10_11_12_13_14_15_16_17_18_19_1a_1b_1c_1d_1e_1f ;12
    addJumpTableEntry .tableStart, .ctrmode_9_b_d_f                                                     ;13
    addJumpTableEntry .tableStart, .ctrmode_0_1_8_a_c_e_10_11_12_13_14_15_16_17_18_19_1a_1b_1c_1d_1e_1f ;14
    addJumpTableEntry .tableStart, .ctrmode_9_b_d_f                                                     ;15
    addJumpTableEntry .tableStart, .ctrmode_0_1_8_a_c_e_10_11_12_13_14_15_16_17_18_19_1a_1b_1c_1d_1e_1f ;16
    addJumpTableEntry .tableStart, .ctrmode_0_1_8_a_c_e_10_11_12_13_14_15_16_17_18_19_1a_1b_1c_1d_1e_1f ;17
    addJumpTableEntry .tableStart, .ctrmode_0_1_8_a_c_e_10_11_12_13_14_15_16_17_18_19_1a_1b_1c_1d_1e_1f ;18
    addJumpTableEntry .tableStart, .ctrmode_0_1_8_a_c_e_10_11_12_13_14_15_16_17_18_19_1a_1b_1c_1d_1e_1f ;19
    addJumpTableEntry .tableStart, .ctrmode_0_1_8_a_c_e_10_11_12_13_14_15_16_17_18_19_1a_1b_1c_1d_1e_1f ;20
    addJumpTableEntry .tableStart, .ctrmode_0_1_8_a_c_e_10_11_12_13_14_15_16_17_18_19_1a_1b_1c_1d_1e_1f ;21
    addJumpTableEntry .tableStart, .ctrmode_0_1_8_a_c_e_10_11_12_13_14_15_16_17_18_19_1a_1b_1c_1d_1e_1f ;22
    addJumpTableEntry .tableStart, .ctrmode_0_1_8_a_c_e_10_11_12_13_14_15_16_17_18_19_1a_1b_1c_1d_1e_1f ;23
    addJumpTableEntry .tableStart, .ctrmode_0_1_8_a_c_e_10_11_12_13_14_15_16_17_18_19_1a_1b_1c_1d_1e_1f ;24
    addJumpTableEntry .tableStart, .ctrmode_0_1_8_a_c_e_10_11_12_13_14_15_16_17_18_19_1a_1b_1c_1d_1e_1f ;25
    addJumpTableEntry .tableStart, .ctrmode_0_1_8_a_c_e_10_11_12_13_14_15_16_17_18_19_1a_1b_1c_1d_1e_1f ;26
    addJumpTableEntry .tableStart, .ctrmode_0_1_8_a_c_e_10_11_12_13_14_15_16_17_18_19_1a_1b_1c_1d_1e_1f ;27
    addJumpTableEntry .tableStart, .ctrmode_0_1_8_a_c_e_10_11_12_13_14_15_16_17_18_19_1a_1b_1c_1d_1e_1f ;28
    addJumpTableEntry .tableStart, .ctrmode_0_1_8_a_c_e_10_11_12_13_14_15_16_17_18_19_1a_1b_1c_1d_1e_1f ;29
    addJumpTableEntry .tableStart, .ctrmode_0_1_8_a_c_e_10_11_12_13_14_15_16_17_18_19_1a_1b_1c_1d_1e_1f ;30
    addJumpTableEntry .tableStart, .ctrmode_0_1_8_a_c_e_10_11_12_13_14_15_16_17_18_19_1a_1b_1c_1d_1e_1f ;31
    times 8 nop                     ;Disassember Resync

    ;Hier sind die einzelnen Fälle für die verschiedenen ctrmode Fälle
    ;Am Anfang ist als Kommentar immer der folgende Pseudocode geschrieben
    
    .ctrmode_0_1_8_a_c_e_10_11_12_13_14_15_16_17_18_19_1a_1b_1c_1d_1e_1f:
        ret ;hier ist nichts zu tun
        
    .ctrmode_2:
        copyFollowingCodeAndRet .ctrmode_2_end
        ;skipIf !ctrreg_pllsaved:
        ;   orlet pin_out_local ctrreg_ctrapinmask
            goto_if_false byte [CTR+ctrreg_pllsaved], .ctrmode_2_end
            or LOCALPINOUT, dword [CTR+ctrreg_ctrapinmask]
        .ctrmode_2_end:
        
        
    .ctrmode_3:
        copyFollowingCodeAndRet .ctrmode_3_end
            ;orlet pin_out_local (mux32 ctrreg_pllsaved ctrreg_ctrapinmask ctrreg_ctrbpinmask))
                goto_if_false byte[CTR+ctrreg_pllsaved], .ctrmode3_pinb
                or LOCALPINOUT, dword[CTR+ctrreg_ctrapinmask]
                jmp .ctrmode_3_end
            .ctrmode3_pinb:
                or LOCALPINOUT, dword[CTR+ctrreg_ctrbpinmask]
        .ctrmode_3_end:
        
        
    .ctrmode_4:
        ;if (testBit64 ctrreg_phase 0I1f):
        ;   orlet pin_out_local ctrreg_ctrapinmask
        copyFollowingCodeAndRet .ctrmode_4_end
            test byte[CTR+ctrreg_phase+3],0x80 ;Das 0x1F = 31. Bit ist das 7. Bit von Byte 3
            jz .ctrmode_4_end
            or LOCALPINOUT,dword [CTR+ctrreg_ctrapinmask]
        .ctrmode_4_end:
        
        
    .ctrmode_5:
        ;orlet pin_out_local (mux32 (testBit64 ctrreg_phase 0I1f) ctrreg_ctrapinmask ctrreg_ctrbpinmask))
        copyFollowingCodeAndRet .ctrmode_5_end
                test byte[CTR+ctrreg_phase+3],0x80 ;Das 0x1F = 31. Bit ist das 7. Bit von Byte 3
                jz .ctrmode5_pinb
                or LOCALPINOUT, dword[CTR+ctrreg_ctrapinmask]
                jmp .ctrmode_5_end
            .ctrmode5_pinb:
                or LOCALPINOUT, dword[CTR+ctrreg_ctrbpinmask]
        .ctrmode_5_end:
        
        
    .ctrmode_6:
        ;if (testBit64 ctrreg_phase 0I20):
        ;   orlet pin_out_local ctrreg_ctrapinmask
        copyFollowingCodeAndRet .ctrmode_6_end
                test byte[CTR+ctrreg_phase+4],1 ;Bit 0x20 = 32. Bit ist das 0. Bit von Byte 4
                jz .ctrmode_6_end
                or LOCALPINOUT,dword [CTR+ctrreg_ctrapinmask]
        .ctrmode_6_end:
        
    
    .ctrmode_7:
        ;orlet pin_out_local (mux32 (testBit64 ctrreg_phase 0I20) ctrreg_ctrapinmask ctrreg_ctrbpinmask)
        copyFollowingCodeAndRet .ctrmode_7_end
                test byte[CTR+ctrreg_phase+4],1 ;Bit 0x20 = 32. Bit ist das 0. Bit von Byte 4
                jz .ctrmode_7_pinb
                or LOCALPINOUT, dword[CTR+ctrreg_ctrapinmask]
                jmp .ctrmode_7_end
            .ctrmode_7_pinb:
                or LOCALPINOUT, dword[CTR+ctrreg_ctrbpinmask]
        .ctrmode_7_end:
        
        
    .ctrmode_9_b_d_f:
        ;skipIf ctrreg_delayed0:
        ;    orlet pin_out_local ctrreg_ctrbpinmask
        copyFollowingCodeAndRet .ctrmode_9_b_d_f_end
                goto_if_true byte [CTR+ctrreg_delayed0], .ctrmode_9_b_d_f_end
                or LOCALPINOUT, dword[CTR+ctrreg_ctrbpinmask]
        .ctrmode_9_b_d_f_end:
    
    %undef CTR
%endmacro


funGenerateCogPinOut:
    ;Erzeugt für den Cog die dynFunCogPinOut Funktion
        
    ;Der Code wird zuerst in das Scratchpad geschrieben
    lea DST64,[SCRATCHPAD]
    
    mov A32,dword[COG+cog_reg_cog_ctra_ctrmode]
    templateCogPinOutCounterA:
        macroHandleCounter CounterA
        
    mov A32,dword[COG+cog_reg_cog_ctrb_ctrmode]
    templateCogPinOutCounterB:
        macroHandleCounter CounterB
        
        
    templateCogPinOutVid:
        %define VIDOUT32 A32
        %define VIDOUT8 A8
        %macro calcVidPinOut 0
            ;orlet pin_out_local (shl32 (and32 vidOut reg_cog_vid_vcfg_vpins) reg_cog_vid_vcfg_vgroup)
            mov A32,dword [COG+cog_reg_cog_vid_vcfg_vpins]
            generateAnd32AInstruction
            mov A32,dword [COG+cog_reg_cog_vid_vcfg_vgroup]
            generateShl32AInstruction
            copyFollowingCodeUntil %%end
                or LOCALPINOUT,VIDOUT32
            %%end:
        %endmacro
        
        %macro calcVidCond 0
            ;let vidCond (neqB pllb_saved (testBit32 pll_in_wire reg_cog_vid_vcfg_auralsub))
            ;let vidOut (muxB vidCond 0I1 0I0)
            ;Hier umgebaut zu
            ;let vidOut pll_in_wire
            ;shr32 vidOut, reg_cog_vid_vcfg_auralsub
            ;xor vidOut, pllb_saved
            ;and vidOut, 1
            copyFollowingCodeUntil %%copyEnd1
                mov VIDOUT32,dword[HUB+hub_pll_in_wire]
            %%copyEnd1:
            mov A32,dword[COG+cog_reg_cog_vid_vcfg_auralsub]
            generateShr32AInstruction
            copyFollowingCodeUntil %%copyEnd2
                xor VIDOUT8,byte [COG+cog_pllb_saved]
                and VIDOUT32,1
            %%copyEnd2:
        %endmacro
    
        executeJumpTable .tableStart
        .tableStart:
        ;je nach ctrmode werden verschiedene counter modi ausgewählt (32 stück)
        ;anhand der tabelle wird das passende code fragment ermittelt
        addJumpTableEntry .tableStart, .vidMode0 ;0
        addJumpTableEntry .tableStart, .vidMode1 ;0
        addJumpTableEntry .tableStart, .vidMode2 ;0
        addJumpTableEntry .tableStart, .vidMode3 ;0
        
        .vidMode0:
            jmp .endOfVid ;hier gibt es nichts zu tun
            
        .vidMode1:
            ;let vidOut reg_cog_vid_discrete
            ;calcVidPinOut
            mov VIDOUT32,dword[COG+cog_reg_cog_vid_discrete]
            calcVidPinOut
            jmp .endOfVid
        
        .vidMode2:
            ;calcVidCond
            ;let vidOut (shl32 vidOut 7); entspricht (mux32 vidCond 0I80 0I0)
            ;add32let vidOut reg_cog_vid_baseband
            ;calcVidTmp
            ;add32let vidOut (shl32 vidTmp 0I4)
            ;calcVidPinOut
            calcVidCond
            ;TODO
            
        .vidMode3:
            ;calcVidCond
            ;let vidOut (shl32 vidOut 3); entspricht (mux32 vidCond 0I8 0I0)
            ;add32let vidOut (shl32 reg_cog_vid_baseband 0I4)
            ;calcVidTmp
            ;add32let vidout vidTmp
            ;calcVidPinOut
            calcVidCond
            ;TODO
        
        %unmacro calcVidPinOut 0
        %unmacro calcVidCond 0
        %undef VIDOUT32
    .endOfVid:
        

%undef LOCALPINOUT

%unmacro macroHandleCounter 1
