;Hier werden alle Funktionen aufgelistet, die vom C++ Programm aufgerufen werden

FunctionStatic          equ 0
FunctionDynamicHub      equ 1
FunctionDynamicCog      equ 2
FunctionTemplate        equ 3

;Name, StartLabel, Typ
%macro exportFunction 3
    db %1,0,%3
    dd %2,%2.endOfFunction
%endmacro

;Name, StartLabel, Size
;dynamische Hubfunktionen werden relativ zu GlobalDynamicHubAsmOffset angegeben
%macro exportDynHubFunction 3
    db %1,0,FunctionDynamicHub
    dd %2,%3
%endmacro

;Name, StartLabel, Size
;dynamische Cogfunktionen werden relativ zur jeweiligen GlobalDynamicCogAsmOffset+CogMemoryMultiplicator*cogNo angegeben
%macro exportDynCogFunction 3
    db %1,0,FunctionDynamicCog
    dd %2,%3
%endmacro

funcTableStart:
;Statische Assembler Funktionen
exportFunction "funRunAsmSystemVAbi",                   funRunAsmSystemVAbi,                    FunctionStatic
exportFunction "funActivateGeneratedFunction",          funActivateGeneratedFunction,           FunctionStatic
exportFunction "funCopyFromTemplateToScratchpad",       funCopyFromTemplateToScratchpad,        FunctionStatic
exportFunction "funGenerateCogClkPeripherals",          funGenerateCogClkPeripherals,           FunctionStatic


;Dynamische Cog Funktionen
dynFunCogClkPeripherals     equ 0
dynFunCogClkPeripheralsSize equ 256
exportDynCogFunction "dynFunCogClkPeripherals",               dynFunCogClkPeripherals,                dynFunCogClkPeripheralsSize

db 0



funcTableStop:
times 1024-(funcTableStop-funcTableStart) nop
