;Die grobe Memory Map ist hier hinterlegt

;Größen der einzelnen Bereiche
HubMemorySize       equ 1024*64
CogMemorySize       equ 1024*4*8
CogRegisterSize     equ 1024*4*8
HubRegisterSize     equ 1024*4
ScratchPadSize      equ 1024*4
PreEmptyAreaSize    equ 1024*4
StaticAsmSize       equ 1024*32
DynamicHubAsmOffset equ 1024*4
DynamicCogAsmOffset equ 1024*4*8
PostEmptyAreaSize   equ 1024*4


;Globale Offsets der einzelnen Bereiche
GlobalHubMemoryOffset       equ 0                                          
GlobalCogMemoryOffset       equ GlobalHubMemoryOffset+HubMemorySize
GlobalCogRegisterOffset     equ GlobalCogMemoryOffset+CogMemorySize
GlobalHubRegisterOffset     equ GlobalCogRegisterOffset+CogRegisterSize
GlobalScratchpadOffset      equ GlobalHubRegisterOffset+HubRegisterSize
GlobalPreEmptyAreaOffset    equ GlobalScratchpadOffset+ScratchPadSize
GlobalStaticAsmOffset       equ GlobalPreEmptyAreaOffset+PreEmptyAreaSize
GlobalDynamicHubAsmOffset   equ GlobalStaticAsmOffset+StaticAsmSize
GlobalDynamicCogAsmOffset   equ GlobalDynamicHubAsmOffset+DynamicHubAsmOffset
GlobalPostEmptyAreaOffset   equ GlobalDynamicCogAsmOffset+DynamicCogAsmOffset

;Gesamtgröße der Map
TotalMemoryMapSize          equ GlobalPostEmptyAreaOffset+PostEmptyAreaSize,

;Relativ zum GlobalHubRegisterOffset, darauf zeigt der hubPtr
HubRelMemoryOffset          equ GlobalHubMemoryOffset-GlobalHubRegisterOffset
HubRelDynamicAsmOffset      equ GlobalDynamicHubAsmOffset-GlobalHubRegisterOffset
HubRelScratchpadOffset      equ GlobalScratchpadOffset-GlobalHubRegisterOffset

;Relativ zum GlobalCogRegisterOffset, darauf (+cogNo*1024*4) zeigt der cogPtr
CogRelMemoryOffset          equ GlobalCogMemoryOffset-GlobalCogRegisterOffset
CogRelDynamicAsmOffset      equ GlobalDynamicCogAsmOffset-GlobalCogRegisterOffset
