#include "propellergencpp.h"
#include "propeller-gencpp/generatedpropeller.gen.h"
#include <QtDebug>

//#define FLATTENVERSION

struct module_cloned_dig {
    struct output {
        output():cfg(0U),pin_out(0U),pin_dir(0U) {}

        quint32 cfg;
        quint32 pin_out;
        quint32 pin_dir;
    };

    module_cloned_cog mod_cogs[8];
    module_cloned_hub mod_hub;

    module_cloned_dig():cnt(0U),bus_sel(0U),ena_bus(false) {
        for (int i=0; i<8; ++i) {
            lastclkvid[i] = false;
            lastvidsnc1[i] = false;
            lastena[i] = false;
        }
    }

    quint32 cnt;
    quint32 bus_sel;
    bool ena_bus;
    bool lastclkvid[8];
    bool lastvidsnc1[8];
    bool lastena[8];

    __attribute__((always_inline)) output evaluateInner(const quint32 pin_in, const bool nres, const clocks_dig clkdig, const bool posedge_clk_cog, const bool posedge_clk_pll, const bool negedge_nres) {
        //Evaluate Hub Schritt 0: Werte für Cogs ermitteln
        quint32 out_hub_bus_q=0U;
        bool out_hub_bus_c=false;
        quint32 out_hub_bus_ack=0U;
        quint32 out_hub_cog_ena=0U;
        quint32 out_hub_ptr_w=0U;
        quint32 out_hub_ptr_d=0U;
        //const quint32 bus_sel,quint32& bus_q,bool& bus_c,quint32& bus_ack,quint32& cog_ena,quint32& ptr_w,quint32& ptr_d
        mod_hub.evaluate0(bus_sel,out_hub_bus_q,out_hub_bus_c,out_hub_bus_ack,out_hub_cog_ena,out_hub_ptr_w,out_hub_ptr_d);



        //Cog Evaluate Schritt 0: PLL Out von jedem Cog ermitteln (wird als Eingabewert für alle Cogs benötigt)
        quint32 cogPll=0;
        for (quint32 i=0; i<8; ++i) {
            bool out_cogs_mod_pll=false;
            mod_cogs[i].evaluate0(out_cogs_mod_pll);
            cogPll |= out_cogs_mod_pll ? (1U<<i) : 0;
        }

        //Cog Evaluate Schritt 1: Eigentliche Berechnungen durchführen
        quint32 in_hub_bus_s=0;
        quint32 in_hub_bus_a=0;
        quint32 in_hub_bus_d=0;
        quint32 in_hub_bus_e=0;
        quint32 in_hub_bus_r=0;
        quint32 in_hub_bus_w=0;
        output out;
        for (quint32 i=0; i<8; ++i) {
            bool out_cog_bus_r=false;
            bool out_cog_bus_e=false;
            bool out_cog_bus_w=false;
            quint32 out_cog_bus_s=0;
            quint32 out_cog_bus_a=0;
            quint32 out_cog_bus_d=0;
            quint32 out_cog_pin_out=0;
            quint32 out_cog_pin_dir=0;

            //const bool nres,const bool ena_bus,const bool ptr_w,const quint32 ptr_d,
            //const bool ena,const bool bus_sel,const quint32 bus_q,const bool bus_c,const bool bus_ack,const quint32 cnt,
            //const quint32 pll_in,const quint32 pin_in,const bool posedge_clk_cog,const bool negedge_nres,const bool negedge_ena,
            //const bool posedge_clk_pll,const bool posedge_vclk,const bool posedge_snc1,
            //bool& bus_r,bool& bus_e,bool& bus_w,
            //quint32& bus_s,quint32& bus_a,quint32& bus_d,quint32& pin_out,quint32& pin_dir
            /*if (i==0 && posedge_clk_cog) {
                auto tmpi = (mod_cogs[0].running ? mod_cogs[0].instruction_reg : (0x8840000U | (mod_cogs[0].p_reg << 0x9U)));
                auto instr_opcode = ((tmpi >> 0x1aU) & 0x3fU);
                qDebug()<<"GOLDEN:"<<mod_cogs[0].match<<mod_cogs[0].state
                       <<((mod_cogs[0].instruction_reg & 0x3U) == 0x1U)<<pin_in
                        <<((pin_in & mod_cogs[i].source) == mod_cogs[i].dest);
            }*/
            mod_cogs[i].evaluate1(nres,
                                  ena_bus,
                                  (out_hub_ptr_w & (1U<<i)) != 0U,
                                  out_hub_ptr_d,

                                  (out_hub_cog_ena & (1U<<i)) != 0U,
                                  (bus_sel & (1U<<i)) != 0U,
                                  out_hub_bus_q,
                                  out_hub_bus_c,
                                  (out_hub_bus_ack & (1U<<i)) != 0U,
                                  cnt,

                                  cogPll,
                                  pin_in,
                                  posedge_clk_cog,
                                  negedge_nres,
                                  clkdig.negedge_ena[i],

                                  posedge_clk_pll,
                                  clkdig.posedge_vclk[i],
                                  clkdig.posedge_snc1[i],

                                  out_cog_bus_r,
                                  out_cog_bus_e,
                                  out_cog_bus_w,

                                  out_cog_bus_s,
                                  out_cog_bus_a,
                                  out_cog_bus_d,
                                  out_cog_pin_out,
                                  out_cog_pin_dir);
            in_hub_bus_s |= out_cog_bus_s;
            in_hub_bus_a |= out_cog_bus_a;
            in_hub_bus_d |= out_cog_bus_d;
            in_hub_bus_e |= out_cog_bus_e;
            in_hub_bus_r |= out_cog_bus_r;
            in_hub_bus_w |= out_cog_bus_w;
            out.pin_dir |= out_cog_pin_dir;
            out.pin_out |= out_cog_pin_out;
        }

        //Evaluate Hub Schritt 0: Eigentlichen Transaktionen durchführen
        quint32 out_hub_cfg=0;
        //const bool ena_bus,const bool nres,const bool bus_r,const bool bus_e,const bool bus_w,const quint32 bus_s,const quint32 bus_a,const quint32 bus_d,const bool posedge_clk_cog,const bool negedge_nres,quint32& cfg
        mod_hub.evaluate1(ena_bus,nres,in_hub_bus_r,in_hub_bus_e,in_hub_bus_w,in_hub_bus_s,in_hub_bus_a,in_hub_bus_d,posedge_clk_cog,negedge_nres,out_hub_cfg);

        if (posedge_clk_cog && nres)
            cnt += 1U;
        if (posedge_clk_cog || negedge_nres) {
            if (!nres) {
                ena_bus = false;
                bus_sel = 0;
            }
            else {
                if (ena_bus)
                    bus_sel = ((bus_sel & 0x7FU)!=0) ? ((bus_sel<<1U)&0xFFU) : 1U;
                ena_bus = !ena_bus;
            }
        }

        out.cfg = out_hub_cfg;

        return out;
    }

    __attribute__((always_inline)) output evaluate(const quint32 pin_in, const bool nres, bool posedge_clk_cog, bool posedge_clk_pll, bool negedge_nres) {
        output out = evaluateInner(pin_in, nres, clocks_dig(),posedge_clk_cog, posedge_clk_pll, negedge_nres);
        //abgeleitete clocks untersuchen
        while (true) {
            clocks_dig clkdig;
            bool hasClockChange = false;
            for (int i=0; i<8; ++i) {

#ifdef FLATTENVERSION
                const bool vidActive = (mod_cogs[i].reg_cog_vid_vcfg_vmode != 0);
#else
                const bool vidActive = (mod_cogs[i].mod_cog_vid.vcfg_vmode != 0);
#endif
                if (vidActive) {
                    const bool clkvid = mod_cogs[i].plla_saved;
                    if (clkvid && !lastclkvid[i]) {
                        clkdig.posedge_vclk[i] = true;
                        hasClockChange = true;
                    }
                    lastclkvid[i] = clkvid;
                }
#ifdef FLATTENVERSION
                const bool snc1 = mod_cogs[i].reg_cog_vid_snc1;
#else
                const bool snc1 = mod_cogs[i].mod_cog_vid.snc1;
#endif

                if (snc1 && !lastvidsnc1[i]) {
                    clkdig.posedge_snc1[i] = true;
                    hasClockChange = true;
                }
                lastvidsnc1[i] = snc1;

                bool ena = (mod_hub.cog_ena_reg & (1U<<i)) != 0U;
                if (!ena && lastena[i]) {
                    clkdig.negedge_ena[i] = true;
                    hasClockChange = true;
                }
                lastena[i] = ena;
            }
            if (!hasClockChange)
                return evaluateInner(pin_in, nres, clocks_dig(), false, false, false); //pinout erneuern

            //Version konsistent mit newcpp
            evaluateInner(pin_in, nres, clkdig, false, false, false);
            return evaluateInner(pin_in, nres, clocks_dig(), false, false, false); //pinout erneuern
            //Alternative Version vorher mit Schleife
            //out = evaluateInner(pin_in, nres, clkdig, false, false, false);
        }
    }

    void serialize(QDataStream& stream) const {
        for (int i=0; i<8; ++i)
            mod_cogs[i].serialize(stream);
        mod_hub.serialize(stream);
        stream << cnt;
        stream << bus_sel;
        stream << ena_bus;
        for (int i=0; i<8; ++i) {
            stream << lastclkvid[i];
            stream << lastvidsnc1[i];
            stream << lastena[i];
        }
    }

    void deserialize(QDataStream& stream) {
        for (int i=0; i<8; ++i)
            mod_cogs[i].deserialize(stream);
        mod_hub.deserialize(stream);
        stream >> cnt;
        stream >> bus_sel;
        stream >> ena_bus;
        for (int i=0; i<8; ++i) {
            stream >> lastclkvid[i];
            stream >> lastvidsnc1[i];
            stream >> lastena[i];
        }
    }
};

PropellerGenCpp::PropellerGenCpp(QString deviceId, QString deviceName, QList<int> rom):
    AbstractPropeller(deviceId, deviceName),
    m_dig(new module_cloned_dig()),
    m_pinIn(0),
    m_pinOut(0),
    m_pinDir(0)
{
    quint32* mem = m_dig->mod_hub.mod_hub_mem.memory;
    memset(mem,0,1024*64);
    if (rom.size() == 8192) {
        for (int j=0; j<8192; ++j)
            mem[8192+j] = static_cast<quint32>(rom[j]);
    }
    else
        qWarning()<<"Rom size mismatch"<<rom.size();
    reset();
}

PropellerGenCpp::~PropellerGenCpp() {
    delete m_dig;
}

void PropellerGenCpp::reset() {
    const module_cloned_dig::output out = m_dig->evaluate(m_pinIn,false,false,false,true);
    m_pinOut = out.pin_out;
    m_pinDir = out.pin_dir;
}

void PropellerGenCpp::clockCycle() {
    m_dig->evaluate(m_pinIn,true,false,true,false);
    const module_cloned_dig::output out = m_dig->evaluate(m_pinIn,true,true,true,false);
    m_pinOut = out.pin_out;
    m_pinDir = out.pin_dir;
    AbstractPropeller::clockCycle();
    /*qDebug()<<"PropellerCloned::clockCycle() p4 snc0"<<m_dig->mod_cogs[4].mod_cog_vid.snc0
            <<"capr"<<m_dig->mod_cogs[4].mod_cog_vid.capr
            <<"snc1"<<m_dig->mod_cogs[4].mod_cog_vid.snc1
            <<"setr"<<m_dig->mod_cogs[4].mod_cog_vid.setr
            <<"frmclk"<<m_dig->mod_cogs[4].mod_cog_vid.vscl_frameclocks
            <<"pllafrq"<<m_dig->mod_cogs[4].mod_cog_ctra.frequency
            <<"pllacnt"<<m_dig->mod_cogs[4].mod_cog_ctra.pllcounter
            //<<"ctrmode"<<m_dig->mod_cogs[4].mod_cog_ctra.ctrmode
            <<"plladiv"<<m_dig->mod_cogs[4].mod_cog_ctra.ctrplldiv
            <<"plla"<<m_dig->mod_cogs[4].mod_cog_ctra.pll_saved
              ;*/
}

void PropellerGenCpp::setPinIn(quint32 pins) {
    m_pinIn = pins;
}

quint32 PropellerGenCpp::pinOut() const {
    return m_pinOut;
}

quint32 PropellerGenCpp::pinDir() const {
    return m_pinDir;
}

CogStatus PropellerGenCpp::cogStatus(int cogNo) const {
    const auto& cog = m_dig->mod_cogs[cogNo];
    CogStatus result;
    result.programCounter = int(cog.p_reg-1)&0x1FF;
    result.enabled = (m_dig->mod_hub.cog_ena_reg & (1<<cogNo)) != 0;
    result.running = cog.running;
    result.carryFlag = (cog.flags & 2) != 0;
    result.zeroFlag = (cog.flags & 1) != 0;

    result.state = static_cast<CogStatus::State>(cog.state);
    return result;
}

CogCounterStatus PropellerGenCpp::cogCounterStatus(int cogNo, int counterNo) {
    CogCounterStatus result;
    if (counterNo != 0 && counterNo != 1)
        return result;
    const auto& cog = m_dig->mod_cogs[cogNo];
    const auto& ctr = counterNo == 0 ? cog.mod_cog_ctra : cog.mod_cog_ctrb;

    result.phase = ctr.phase;
    result.pllcounter = ctr.pllcounter;
    result.frequency = ctr.frequency;
    result.ctrmode = ctr.ctrmode;
    result.ctrplldiv = ctr.ctrplldiv;
    result.ctrapin = ctr.ctrapin;
    result.ctrbpin = ctr.ctrbpin;
    result.delayed0 = ctr.delayed0;
    result.delayed1 = ctr.delayed1;
    return result;
}

int PropellerGenCpp::cogMemory(int cogId, int address) const {
#ifdef FLATTENVERSION
    return int(m_dig->mod_cogs[cogId].reg_cog_ram_r[address]);
#else
    return int(m_dig->mod_cogs[cogId].mod_cog_ram.r[address]);
#endif
}

int PropellerGenCpp::hubMemory(int address) const {
    return int(m_dig->mod_hub.mod_hub_mem.memory[address]);
}

quint32 PropellerGenCpp::globalCounter() const {
    return m_dig->cnt;
}

void PropellerGenCpp::serialize(QDataStream& stream) const {
    AbstractPropeller::serialize(stream);
    m_dig->serialize(stream);
    stream << m_pinIn;
    stream << m_pinOut;
    stream << m_pinDir;
}

void PropellerGenCpp::deserialize(QDataStream& stream) {
    AbstractPropeller::deserialize(stream);
    m_dig->deserialize(stream);
    stream >> m_pinIn;
    stream >> m_pinOut;
    stream >> m_pinDir;
}

QList<QPair<QString,QString> > PropellerGenCpp::listInnerCogVariables(int cogNo) const {
    return m_dig->mod_cogs[cogNo].listInnerVars("");
}

QList<QPair<QString,QString> > PropellerGenCpp::listInnerHubVariables() const {
    return m_dig->mod_hub.listInnerVars("");
}

QString PropellerGenCpp::name() const {
    return "PropellerGenCpp";
}
