#ifndef PROPELLERGENCPP_H
#define PROPELLERGENCPP_H

#include "abstractpropeller.h"

struct module_cloned_dig;

class PropellerGenCpp : public AbstractPropeller
{
public:
    PropellerGenCpp(QString deviceId, QString deviceName, QList<int> rom);
    ~PropellerGenCpp();

    virtual void reset();
    virtual void clockCycle();

    virtual void setPinIn(quint32 pins);
    virtual quint32 pinOut() const;
    virtual quint32 pinDir() const;

    virtual CogStatus cogStatus(int cogNo) const;
    virtual CogCounterStatus cogCounterStatus(int cogNo, int counterNo);
    virtual int cogMemory(int cogId, int address) const;
    virtual int hubMemory(int address) const;
    virtual quint32 globalCounter() const;

    virtual void serialize(QDataStream& stream) const;
    virtual void deserialize(QDataStream& stream);

    virtual QList<QPair<QString,QString> > listInnerCogVariables(int cogNo) const;
    virtual QList<QPair<QString,QString> > listInnerHubVariables() const;

    virtual QString name() const;
private:
    module_cloned_dig *m_dig;
    uint32_t m_pinIn;
    uint32_t m_pinOut;
    uint32_t m_pinDir;
};

#endif // PROPELLERGENCPP_H
