#ifndef PROPELLERNEWCPP_H
#define PROPELLERNEWCPP_H

#include "abstractpropeller.h"

struct PropellerNewCppImpl;

class PropellerNewCpp : public AbstractPropeller
{
public:
    PropellerNewCpp(QString deviceId, QString deviceName, QList<int> rom);
    ~PropellerNewCpp();

    virtual void reset();
    virtual void clockCycle();

    virtual void setPinIn(quint32 pins);
    virtual quint32 pinOut() const;
    virtual quint32 pinDir() const;

    virtual CogStatus cogStatus(int cogNo) const;
    virtual CogCounterStatus cogCounterStatus(int cogNo, int counterNo);
    virtual int cogMemory(int cogId, int address) const;
    virtual int hubMemory(int address) const;
    virtual quint32 globalCounter() const;

    virtual void serialize(QDataStream& stream) const;
    virtual void deserialize(QDataStream& stream);

    virtual QList<QPair<QString,QString> > listInnerCogVariables(int cogNo) const;
    virtual QList<QPair<QString,QString> > listInnerHubVariables() const;

    virtual QString name() const;
private:
    static quint32 getPinFromMask(quint32 mask);
    PropellerNewCppImpl *m_dig;
    quint32 m_pinIn;
    quint32 m_pinOut;
    quint32 m_pinDir;
};

#endif // PROPELLERNEWCPP_H
