// hub_mem

/*
-------------------------------------------------------------------------------
Copyright 2014 Parallax Inc.

This file is part of the hardware description for the Propeller 1 Design.

The Propeller 1 Design is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by the
Free Software Foundation, either version 3 of the License, or (at your option)
any later version.

The Propeller 1 Design is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
more details.

You should have received a copy of the GNU General Public License along with
the Propeller 1 Design.  If not, see <http://www.gnu.org/licenses/>.
-------------------------------------------------------------------------------
*/


//Modifiziert von Thilo, nutzt nur noch die C Funktionen statt Verilog Module
import "DPI-C" function void hub_write_mem (input int globalHubId, input int address, input int data, input int mask);
import "DPI-C" function int hub_read_mem(input int globalHubId, input int address);

module hub_mem
(
input clk_cog,
input ena_bus,

input w,
input [3:0] wb,
input [13:0] a,
input [31:0] d,
output reg [31:0] q,
input [4:0] debugGlobalHubId
);

always @(posedge clk_cog) begin
    if (ena_bus) begin
        q <= hub_read_mem(debugGlobalHubId,a);
        if (!a[13] && w)
            hub_write_mem(debugGlobalHubId,a,d,{(wb[3] ? 8'h00 : 8'hFF),(wb[2] ? 8'h00 : 8'hFF),(wb[1] ? 8'h00 : 8'hFF),(wb[0] ? 8'h00 : 8'hFF)});
    end
end

endmodule
