#ifndef PROPELLERWIDGET_H
#define PROPELLERWIDGET_H

#include <QWidget>
#include <QSpinBox>
#include <QSplitter>
#include <QLabel>
#include "cogviewer.h"
#include "hubviewer.h"

class PropellerWidget : public QWidget
{
    Q_OBJECT
public:
    PropellerWidget();
    void setPropeller(AbstractPropeller* propeller);
    void updateViews();
private slots:
    void cogNoChanged(int);
private:
    AbstractPropeller *m_propeller;
    QLabel *m_name;
    QSpinBox *m_spbCog;
    QSplitter *m_splitter;
    CogViewer *m_cogViewer;
    HubViewer *m_hubViewer;
};

#endif // PROPELLERWIDGET_H
