#ifndef VGADECODER_H
#define VGADECODER_H

#include <QString>
#include <QImage>
#include <QVector>
#include "hwtrace.h"

class VGADecoder : public HWTraceable
{
    Q_OBJECT
public:
    VGADecoder(QString deviceId, QString deviceName, quint32 firstPinNumber);
    void clockCycle(quint32 pins);
    void serialize(QDataStream& stream) const;
    void deserialize(QDataStream& stream);
signals:
    void nextFrame(QImage frame);
private:
    void detectFrameFormat();
    QImage m_nextImage;
    QVector<QRgb> m_colorTable;
    quint32 m_timeCode;
    quint32 m_firstPinNumber;
    quint32 m_vSyncPinMask;
    quint32 m_hSyncPinMask;
    quint32 m_lastHsyncTimeStamp;
    quint32 m_lastvVsyncLineCounter;
    quint32 m_sumHsyncLow;
    quint32 m_sumHsyncHigh;
    quint32 m_sumVsyncLow;
    quint32 m_frameCounter;
    quint32 m_hNominator;
    quint32 m_hDenominator;
    quint32 m_hFrac;
    int m_x;
    int m_y;
    int m_vFrontPorch;
    int m_hFrontPorch;
    bool m_lastVsync;
    bool m_lastHsync;
    bool m_frozenVSync;
    bool m_hSyncPolarity;
    bool m_vSyncPolarity;
};

#endif // VGADECODER_H
