module cogEvalMain(
    input nres,
    input ena_bus,
    input ptr_w,
    input [31:0] ptr_d,
    input ena,
    input bus_sel,
    input [31:0] bus_q,
    input bus_c,
    input bus_ack,
    input [31:0] cnt,
    input [31:0] pll_in,
    input [31:0] pin_in,
    input posedge_clk_cog,
    input negedge_nres,
    input negedge_ena,
    input posedge_clk_pll,
    input posedge_vclk,
    input posedge_snc1,
    output reg bus_r,
    output reg bus_e,
    output reg bus_w,
    output reg [31:0] bus_s,
    output reg [31:0] bus_a,
    output reg [31:0] bus_d,
    output reg [31:0] pin_out,
    output reg [31:0] pin_dir,
    input [31:0] flags_$q,
    output reg [31:0] flags_$d,
    input [31:0] dira_$q,
    output reg [31:0] dira_$d,
    input [31:0] outa_$q,
    output reg [31:0] outa_$d,
    input [31:0] instruction_reg_$q,
    output reg [31:0] instruction_reg_$d,
    input [31:0] sy_reg_$q,
    output reg [31:0] sy_reg_$d,
    input [31:0] source_$q,
    output reg [31:0] source_$d,
    input [31:0] dest_$q,
    output reg [31:0] dest_$d,
    input [31:0] p_reg_$q,
    output reg [31:0] p_reg_$d,
    input [31:0] progctr_$q,
    output reg [31:0] progctr_$d,
    input [31:0] state_$q,
    output reg [31:0] state_$d,
    input match_$q,
    output reg match_$d,
    input cancel_$q,
    output reg cancel_$d,
    input running_$q,
    output reg running_$d,
    input plla_saved_$q,
    output reg plla_saved_$d,
    input pllb_saved_$q,
    output reg pllb_saved_$d,
    input [31:0] reg_cog_vid_vcfg_vmode_$q,
    output reg [31:0] reg_cog_vid_vcfg_vmode_$d,
    input [31:0] reg_cog_vid_vcfg_auralsub_$q,
    output reg [31:0] reg_cog_vid_vcfg_auralsub_$d,
    input [31:0] reg_cog_vid_vcfg_vgroup_$q,
    output reg [31:0] reg_cog_vid_vcfg_vgroup_$d,
    input [31:0] reg_cog_vid_vcfg_vpins_$q,
    output reg [31:0] reg_cog_vid_vcfg_vpins_$d,
    input [31:0] reg_cog_vid_vscl_pixelclocks_$q,
    output reg [31:0] reg_cog_vid_vscl_pixelclocks_$d,
    input [31:0] reg_cog_vid_vscl_frameclocks_$q,
    output reg [31:0] reg_cog_vid_vscl_frameclocks_$d,
    input [31:0] reg_cog_vid_composite_$q,
    output reg [31:0] reg_cog_vid_composite_$d,
    input [31:0] reg_cog_vid_baseband_$q,
    output reg [31:0] reg_cog_vid_baseband_$d,
    input [31:0] reg_cog_vid_phase_$q,
    output reg [31:0] reg_cog_vid_phase_$d,
    input [31:0] reg_cog_vid_discrete_$q,
    output reg [31:0] reg_cog_vid_discrete_$d,
    input [31:0] reg_cog_vid_saved_pixels_$q,
    output reg [31:0] reg_cog_vid_saved_pixels_$d,
    input [31:0] reg_cog_vid_saved_colors_$q,
    output reg [31:0] reg_cog_vid_saved_colors_$d,
    input [31:0] reg_cog_vid_cnts_$q,
    output reg [31:0] reg_cog_vid_cnts_$d,
    input [31:0] reg_cog_vid_cnt0_$q,
    output reg [31:0] reg_cog_vid_cnt0_$d,
    input [31:0] reg_cog_vid_setr_$q,
    output reg [31:0] reg_cog_vid_setr_$d,
    input reg_cog_vid_vcfg_cmode_$q,
    output reg reg_cog_vid_vcfg_cmode_$d,
    input reg_cog_vid_vcfg_chroma1_$q,
    output reg reg_cog_vid_vcfg_chroma1_$d,
    input reg_cog_vid_vcfg_chroma0_$q,
    output reg reg_cog_vid_vcfg_chroma0_$d,
    input reg_cog_vid_capr_$q,
    output reg reg_cog_vid_capr_$d,
    input reg_cog_vid_snc0_$q,
    output reg reg_cog_vid_snc0_$d,
    input reg_cog_vid_snc1_$q,
    output reg reg_cog_vid_snc1_$d,
    input [31:0] reg_cog_ctra_frequency_$q,
    output reg [31:0] reg_cog_ctra_frequency_$d,
    input [63:0] reg_cog_ctra_phase_$q,
    output reg [63:0] reg_cog_ctra_phase_$d,
    input [63:0] reg_cog_ctra_pllcounter_$q,
    output reg [63:0] reg_cog_ctra_pllcounter_$d,
    input [31:0] reg_cog_ctra_ctrmode_$q,
    output reg [31:0] reg_cog_ctra_ctrmode_$d,
    input [31:0] reg_cog_ctra_ctrplldiv_$q,
    output reg [31:0] reg_cog_ctra_ctrplldiv_$d,
    input [31:0] reg_cog_ctra_ctrbpin_$q,
    output reg [31:0] reg_cog_ctra_ctrbpin_$d,
    input [31:0] reg_cog_ctra_ctrapin_$q,
    output reg [31:0] reg_cog_ctra_ctrapin_$d,
    input reg_cog_ctra_delayed0_$q,
    output reg reg_cog_ctra_delayed0_$d,
    input reg_cog_ctra_delayed1_$q,
    output reg reg_cog_ctra_delayed1_$d,
    input reg_cog_ctra_pll_saved_$q,
    output reg reg_cog_ctra_pll_saved_$d,
    input [31:0] reg_cog_ctrb_frequency_$q,
    output reg [31:0] reg_cog_ctrb_frequency_$d,
    input [63:0] reg_cog_ctrb_phase_$q,
    output reg [63:0] reg_cog_ctrb_phase_$d,
    input [63:0] reg_cog_ctrb_pllcounter_$q,
    output reg [63:0] reg_cog_ctrb_pllcounter_$d,
    input [31:0] reg_cog_ctrb_ctrmode_$q,
    output reg [31:0] reg_cog_ctrb_ctrmode_$d,
    input [31:0] reg_cog_ctrb_ctrplldiv_$q,
    output reg [31:0] reg_cog_ctrb_ctrplldiv_$d,
    input [31:0] reg_cog_ctrb_ctrbpin_$q,
    output reg [31:0] reg_cog_ctrb_ctrbpin_$d,
    input [31:0] reg_cog_ctrb_ctrapin_$q,
    output reg [31:0] reg_cog_ctrb_ctrapin_$d,
    input reg_cog_ctrb_delayed0_$q,
    output reg reg_cog_ctrb_delayed0_$d,
    input reg_cog_ctrb_delayed1_$q,
    output reg reg_cog_ctrb_delayed1_$d,
    input reg_cog_ctrb_pll_saved_$q,
    output reg reg_cog_ctrb_pll_saved_$d,
    input [31:0] reg_cog_ram_q_reg_$q,
    output reg [31:0] reg_cog_ram_q_reg_$d,
    input [31:0] reg_cog_ram_r_$q,
    output reg [31:0] reg_cog_ram_r_$d,
    output reg [31:0] reg_cog_ram_r_$wi,
    output reg reg_cog_ram_r_$wr
);
    reg [31:0] sx;
    reg [31:0] px;
    reg [31:0] i;
    reg [31:0] instr_src;
    reg [31:0] instr_dst;
    reg [31:0] instr_opcode;
    reg jump;
    reg cond;
    reg jump_cancel;
    reg wio;
    reg match_prev;
    reg [31:0] in_cog_alu_i;
    reg [31:0] in_cog_alu_s;
    reg [31:0] in_cog_alu_d;
    reg [31:0] in_cog_alu_p;
    reg in_cog_alu_run;
    reg in_cog_alu_ci;
    reg in_cog_alu_zi;
    reg [31:0] in_cog_alu_bus_q;
    reg in_cog_alu_bus_c;
    reg [63:0] loc_cog_alu_tmpRes64;
    reg [31:0] loc_cog_alu_tmpRes32;
    reg outp_cog_alu_wr;
    reg [31:0] outp_cog_alu_r;
    reg outp_cog_alu_co;
    reg outp_cog_alu_zo;
    reg in_cog_ctra_ena;
    reg in_cog_ctra_setctr;
    reg in_cog_ctra_setfrq;
    reg in_cog_ctra_setphs;
    reg [31:0] in_cog_ctra_data;
    reg [31:0] in_cog_ctra_pin_in;
    reg in_cog_ctra_posedge_clk_cog;
    reg in_cog_ctra_posedge_clk_pll;
    reg in_cog_ctra_negedge_ena;
    reg [63:0] outp_cog_ctra_phs;
    reg [31:0] outp_cog_ctra_pin_out;
    reg in_cog_ctrb_ena;
    reg in_cog_ctrb_setctr;
    reg in_cog_ctrb_setfrq;
    reg in_cog_ctrb_setphs;
    reg [31:0] in_cog_ctrb_data;
    reg [31:0] in_cog_ctrb_pin_in;
    reg in_cog_ctrb_posedge_clk_cog;
    reg in_cog_ctrb_posedge_clk_pll;
    reg in_cog_ctrb_negedge_ena;
    reg [63:0] outp_cog_ctrb_phs;
    reg [31:0] outp_cog_ctrb_pin_out;
    reg in_cog_vid_ena;
    reg in_cog_vid_setvid;
    reg in_cog_vid_setscl;
    reg [31:0] in_cog_vid_data;
    reg [31:0] in_cog_vid_pixel;
    reg [31:0] in_cog_vid_color;
    reg [31:0] in_cog_vid_aural;
    reg in_cog_vid_carrier;
    reg in_cog_vid_posedge_clk_cog;
    reg in_cog_vid_negedge_ena;
    reg in_cog_vid_posedge_vclk;
    reg in_cog_vid_posedge_snc1;
    reg [31:0] loc_cog_vid_local_colormod;
    reg loc_cog_vid_local_enable;
    reg loc_cog_vid_local_new_set;
    reg loc_cog_vid_local_new_cnt;
    reg loc_cog_vid_local_capr_next;
    reg loc_cog_vid_local_colorphs;
    reg outp_cog_vid_ack;
    reg [31:0] outp_cog_vid_pin_out;
    reg in_cog_ram_posedge_clk_cog;
    reg in_cog_ram_ena;
    reg in_cog_ram_w;
    reg [31:0] in_cog_ram_d;
    reg [31:0] in_cog_ram_a;
    reg [31:0] outp_cog_ram_q;
    reg [31:0] flags;
    reg [31:0] dira;
    reg [31:0] outa;
    reg [31:0] instruction_reg;
    reg [31:0] sy_reg;
    reg [31:0] source;
    reg [31:0] dest;
    reg [31:0] p_reg;
    reg [31:0] progctr;
    reg [31:0] state;
    reg match;
    reg cancel;
    reg running;
    reg plla_saved;
    reg pllb_saved;
    reg [31:0] reg_cog_vid_vcfg_vmode;
    reg [31:0] reg_cog_vid_vcfg_auralsub;
    reg [31:0] reg_cog_vid_vcfg_vgroup;
    reg [31:0] reg_cog_vid_vcfg_vpins;
    reg [31:0] reg_cog_vid_vscl_pixelclocks;
    reg [31:0] reg_cog_vid_vscl_frameclocks;
    reg [31:0] reg_cog_vid_composite;
    reg [31:0] reg_cog_vid_baseband;
    reg [31:0] reg_cog_vid_phase;
    reg [31:0] reg_cog_vid_discrete;
    reg [31:0] reg_cog_vid_saved_pixels;
    reg [31:0] reg_cog_vid_saved_colors;
    reg [31:0] reg_cog_vid_cnts;
    reg [31:0] reg_cog_vid_cnt0;
    reg [31:0] reg_cog_vid_setr;
    reg reg_cog_vid_vcfg_cmode;
    reg reg_cog_vid_vcfg_chroma1;
    reg reg_cog_vid_vcfg_chroma0;
    reg reg_cog_vid_capr;
    reg reg_cog_vid_snc0;
    reg reg_cog_vid_snc1;
    reg [31:0] reg_cog_ctra_frequency;
    reg [63:0] reg_cog_ctra_phase;
    reg [63:0] reg_cog_ctra_pllcounter;
    reg [31:0] reg_cog_ctra_ctrmode;
    reg [31:0] reg_cog_ctra_ctrplldiv;
    reg [31:0] reg_cog_ctra_ctrbpin;
    reg [31:0] reg_cog_ctra_ctrapin;
    reg reg_cog_ctra_delayed0;
    reg reg_cog_ctra_delayed1;
    reg reg_cog_ctra_pll_saved;
    reg [31:0] reg_cog_ctrb_frequency;
    reg [63:0] reg_cog_ctrb_phase;
    reg [63:0] reg_cog_ctrb_pllcounter;
    reg [31:0] reg_cog_ctrb_ctrmode;
    reg [31:0] reg_cog_ctrb_ctrplldiv;
    reg [31:0] reg_cog_ctrb_ctrbpin;
    reg [31:0] reg_cog_ctrb_ctrapin;
    reg reg_cog_ctrb_delayed0;
    reg reg_cog_ctrb_delayed1;
    reg reg_cog_ctrb_pll_saved;
    reg [31:0] reg_cog_ram_q_reg;
    reg [31:0] reg_cog_ram_r;
    always @(*) begin
        //init locals & outputs to 0
        bus_r = 0;
        bus_e = 0;
        bus_w = 0;
        bus_s = 0;
        bus_a = 0;
        bus_d = 0;
        pin_out = 0;
        pin_dir = 0;
        sx = 0;
        px = 0;
        i = 0;
        instr_src = 0;
        instr_dst = 0;
        instr_opcode = 0;
        jump = 0;
        cond = 0;
        jump_cancel = 0;
        wio = 0;
        match_prev = 0;
        in_cog_alu_i = 0;
        in_cog_alu_s = 0;
        in_cog_alu_d = 0;
        in_cog_alu_p = 0;
        in_cog_alu_run = 0;
        in_cog_alu_ci = 0;
        in_cog_alu_zi = 0;
        in_cog_alu_bus_q = 0;
        in_cog_alu_bus_c = 0;
        loc_cog_alu_tmpRes64 = 0;
        loc_cog_alu_tmpRes32 = 0;
        outp_cog_alu_wr = 0;
        outp_cog_alu_r = 0;
        outp_cog_alu_co = 0;
        outp_cog_alu_zo = 0;
        in_cog_ctra_ena = 0;
        in_cog_ctra_setctr = 0;
        in_cog_ctra_setfrq = 0;
        in_cog_ctra_setphs = 0;
        in_cog_ctra_data = 0;
        in_cog_ctra_pin_in = 0;
        in_cog_ctra_posedge_clk_cog = 0;
        in_cog_ctra_posedge_clk_pll = 0;
        in_cog_ctra_negedge_ena = 0;
        outp_cog_ctra_phs = 0;
        outp_cog_ctra_pin_out = 0;
        in_cog_ctrb_ena = 0;
        in_cog_ctrb_setctr = 0;
        in_cog_ctrb_setfrq = 0;
        in_cog_ctrb_setphs = 0;
        in_cog_ctrb_data = 0;
        in_cog_ctrb_pin_in = 0;
        in_cog_ctrb_posedge_clk_cog = 0;
        in_cog_ctrb_posedge_clk_pll = 0;
        in_cog_ctrb_negedge_ena = 0;
        outp_cog_ctrb_phs = 0;
        outp_cog_ctrb_pin_out = 0;
        in_cog_vid_ena = 0;
        in_cog_vid_setvid = 0;
        in_cog_vid_setscl = 0;
        in_cog_vid_data = 0;
        in_cog_vid_pixel = 0;
        in_cog_vid_color = 0;
        in_cog_vid_aural = 0;
        in_cog_vid_carrier = 0;
        in_cog_vid_posedge_clk_cog = 0;
        in_cog_vid_negedge_ena = 0;
        in_cog_vid_posedge_vclk = 0;
        in_cog_vid_posedge_snc1 = 0;
        loc_cog_vid_local_colormod = 0;
        loc_cog_vid_local_enable = 0;
        loc_cog_vid_local_new_set = 0;
        loc_cog_vid_local_new_cnt = 0;
        loc_cog_vid_local_capr_next = 0;
        loc_cog_vid_local_colorphs = 0;
        outp_cog_vid_ack = 0;
        outp_cog_vid_pin_out = 0;
        in_cog_ram_posedge_clk_cog = 0;
        in_cog_ram_ena = 0;
        in_cog_ram_w = 0;
        in_cog_ram_d = 0;
        in_cog_ram_a = 0;
        outp_cog_ram_q = 0;
        //init registers to prev value
        flags = flags_$q;
        dira = dira_$q;
        outa = outa_$q;
        instruction_reg = instruction_reg_$q;
        sy_reg = sy_reg_$q;
        source = source_$q;
        dest = dest_$q;
        p_reg = p_reg_$q;
        progctr = progctr_$q;
        state = state_$q;
        match = match_$q;
        cancel = cancel_$q;
        running = running_$q;
        plla_saved = plla_saved_$q;
        pllb_saved = pllb_saved_$q;
        reg_cog_vid_vcfg_vmode = reg_cog_vid_vcfg_vmode_$q;
        reg_cog_vid_vcfg_auralsub = reg_cog_vid_vcfg_auralsub_$q;
        reg_cog_vid_vcfg_vgroup = reg_cog_vid_vcfg_vgroup_$q;
        reg_cog_vid_vcfg_vpins = reg_cog_vid_vcfg_vpins_$q;
        reg_cog_vid_vscl_pixelclocks = reg_cog_vid_vscl_pixelclocks_$q;
        reg_cog_vid_vscl_frameclocks = reg_cog_vid_vscl_frameclocks_$q;
        reg_cog_vid_composite = reg_cog_vid_composite_$q;
        reg_cog_vid_baseband = reg_cog_vid_baseband_$q;
        reg_cog_vid_phase = reg_cog_vid_phase_$q;
        reg_cog_vid_discrete = reg_cog_vid_discrete_$q;
        reg_cog_vid_saved_pixels = reg_cog_vid_saved_pixels_$q;
        reg_cog_vid_saved_colors = reg_cog_vid_saved_colors_$q;
        reg_cog_vid_cnts = reg_cog_vid_cnts_$q;
        reg_cog_vid_cnt0 = reg_cog_vid_cnt0_$q;
        reg_cog_vid_setr = reg_cog_vid_setr_$q;
        reg_cog_vid_vcfg_cmode = reg_cog_vid_vcfg_cmode_$q;
        reg_cog_vid_vcfg_chroma1 = reg_cog_vid_vcfg_chroma1_$q;
        reg_cog_vid_vcfg_chroma0 = reg_cog_vid_vcfg_chroma0_$q;
        reg_cog_vid_capr = reg_cog_vid_capr_$q;
        reg_cog_vid_snc0 = reg_cog_vid_snc0_$q;
        reg_cog_vid_snc1 = reg_cog_vid_snc1_$q;
        reg_cog_ctra_frequency = reg_cog_ctra_frequency_$q;
        reg_cog_ctra_phase = reg_cog_ctra_phase_$q;
        reg_cog_ctra_pllcounter = reg_cog_ctra_pllcounter_$q;
        reg_cog_ctra_ctrmode = reg_cog_ctra_ctrmode_$q;
        reg_cog_ctra_ctrplldiv = reg_cog_ctra_ctrplldiv_$q;
        reg_cog_ctra_ctrbpin = reg_cog_ctra_ctrbpin_$q;
        reg_cog_ctra_ctrapin = reg_cog_ctra_ctrapin_$q;
        reg_cog_ctra_delayed0 = reg_cog_ctra_delayed0_$q;
        reg_cog_ctra_delayed1 = reg_cog_ctra_delayed1_$q;
        reg_cog_ctra_pll_saved = reg_cog_ctra_pll_saved_$q;
        reg_cog_ctrb_frequency = reg_cog_ctrb_frequency_$q;
        reg_cog_ctrb_phase = reg_cog_ctrb_phase_$q;
        reg_cog_ctrb_pllcounter = reg_cog_ctrb_pllcounter_$q;
        reg_cog_ctrb_ctrmode = reg_cog_ctrb_ctrmode_$q;
        reg_cog_ctrb_ctrplldiv = reg_cog_ctrb_ctrplldiv_$q;
        reg_cog_ctrb_ctrbpin = reg_cog_ctrb_ctrbpin_$q;
        reg_cog_ctrb_ctrapin = reg_cog_ctrb_ctrapin_$q;
        reg_cog_ctrb_delayed0 = reg_cog_ctrb_delayed0_$q;
        reg_cog_ctrb_delayed1 = reg_cog_ctrb_delayed1_$q;
        reg_cog_ctrb_pll_saved = reg_cog_ctrb_pll_saved_$q;
        reg_cog_ram_q_reg = reg_cog_ram_q_reg_$q;
        reg_cog_ram_r = reg_cog_ram_r_$q;
        reg_cog_ram_r_$wi = 0;
        reg_cog_ram_r_$wr = 0;
        //code starts here
        i = (running?instruction_reg:(32'h8840000|((p_reg << 32'h9)&64'hFFFFFFFF)));
        instr_opcode = (((i >> 32'h1a)&64'hFFFFFFFF)&32'h3f);
        bus_r = 1'b0;
        bus_e = 1'b0;
        bus_w = 1'b0;
        bus_s = 32'h0;
        bus_a = 32'h0;
        bus_d = 32'h0;
        if (bus_sel) begin
            bus_r = running;
            bus_e = ((state==32'h5)&((instr_opcode&32'h3c)==32'h0));
            bus_w = (!((i>>32'h17)&1 != 0));
            bus_s = (instr_opcode&32'h3);
            bus_a = (running?(source&32'hffff):(((((((progctr&32'hfffff)+p_reg)&64'hFFFFFFFF) << 32'h2)&64'hFFFFFFFF)&32'hffff)|(source&32'h3)));
            bus_d = dest;
        end
        instr_dst = (((i >> 32'h9)&64'hFFFFFFFF)&32'h1ff);
        instr_src = (i&32'h1ff);
        in_cog_alu_i = instr_opcode;
        in_cog_alu_s = source;
        in_cog_alu_d = dest;
        in_cog_alu_p = p_reg;
        in_cog_alu_run = running;
        in_cog_alu_ci = ((flags>>32'h1)&1 != 0);
        in_cog_alu_zi = ((flags>>32'h0)&1 != 0);
        in_cog_alu_bus_q = bus_q;
        in_cog_alu_bus_c = bus_c;
        outp_cog_alu_wr = 1'b1;
        outp_cog_alu_zo = 1'b0;
        outp_cog_alu_co = 1'b0;
        outp_cog_alu_r = 32'h0;
        loc_cog_alu_tmpRes64 = 64'h0;
        loc_cog_alu_tmpRes32 = 32'h0;
        case (in_cog_alu_i)
            32'h0,32'h1,32'h2,32'h3,32'h4,32'h5,32'h6,32'h7: begin
                outp_cog_alu_r = ((in_cog_alu_run|((in_cog_alu_p&32'h1f0)!=32'h1f0))?in_cog_alu_bus_q:32'h0);
                outp_cog_alu_co = in_cog_alu_bus_c;
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h8: begin
                outp_cog_alu_r = (((in_cog_alu_d >> (in_cog_alu_s&32'h1f))&64'hFFFFFFFF)|((in_cog_alu_d << ((32'h20-(in_cog_alu_s&32'h1f))&64'hFFFFFFFF))&64'hFFFFFFFF));
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
                outp_cog_alu_co = ((in_cog_alu_d&32'h1)==32'h1);
            end
            32'h9: begin
                outp_cog_alu_r = (((in_cog_alu_d << (in_cog_alu_s&32'h1f))&64'hFFFFFFFF)|((in_cog_alu_d >> ((32'h20-(in_cog_alu_s&32'h1f))&64'hFFFFFFFF))&64'hFFFFFFFF));
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
                outp_cog_alu_co = ((in_cog_alu_d&32'h80000000)!=32'h0);
            end
            32'ha: begin
                outp_cog_alu_r = ((in_cog_alu_d >> (in_cog_alu_s&32'h1f))&64'hFFFFFFFF);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
                outp_cog_alu_co = ((in_cog_alu_d&32'h1)==32'h1);
            end
            32'hb: begin
                outp_cog_alu_r = ((in_cog_alu_d << (in_cog_alu_s&32'h1f))&64'hFFFFFFFF);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
                outp_cog_alu_co = ((in_cog_alu_d&32'h80000000)!=32'h0);
            end
            32'hc: begin
                outp_cog_alu_r = ((in_cog_alu_d >> (in_cog_alu_s&32'h1f))&64'hFFFFFFFF);
                if (in_cog_alu_ci) begin
                    outp_cog_alu_r = (outp_cog_alu_r|((32'hffffffff << ((32'h20-(in_cog_alu_s&32'h1f))&64'hFFFFFFFF))&64'hFFFFFFFF));
                end
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
                outp_cog_alu_co = ((in_cog_alu_d&32'h1)==32'h1);
            end
            32'hd: begin
                outp_cog_alu_r = ((in_cog_alu_d << (in_cog_alu_s&32'h1f))&64'hFFFFFFFF);
                if (in_cog_alu_ci) begin
                    outp_cog_alu_r = (outp_cog_alu_r|((32'hffffffff >> ((32'h20-(in_cog_alu_s&32'h1f))&64'hFFFFFFFF))&64'hFFFFFFFF));
                end
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
                outp_cog_alu_co = ((in_cog_alu_d&32'h80000000)!=32'h0);
            end
            32'he: begin
                outp_cog_alu_r = ((in_cog_alu_d >> (in_cog_alu_s&32'h1f))&64'hFFFFFFFF);
                if (((in_cog_alu_d>>32'h1f)&1 != 0)) begin
                    outp_cog_alu_r = (outp_cog_alu_r|((32'hffffffff << ((32'h20-(in_cog_alu_s&32'h1f))&64'hFFFFFFFF))&64'hFFFFFFFF));
                end
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
                outp_cog_alu_co = ((in_cog_alu_d&32'h1)==32'h1);
            end
            32'hf: begin
                outp_cog_alu_r = ((((in_cog_alu_d&32'haaaaaaaa) >> 32'h1)&64'hFFFFFFFF)|(((in_cog_alu_d&32'h55555555) << 32'h1)&64'hFFFFFFFF));
                outp_cog_alu_r = ((((outp_cog_alu_r&32'hcccccccc) >> 32'h2)&64'hFFFFFFFF)|(((outp_cog_alu_r&32'h33333333) << 32'h2)&64'hFFFFFFFF));
                outp_cog_alu_r = ((((outp_cog_alu_r&32'hf0f0f0f0) >> 32'h4)&64'hFFFFFFFF)|(((outp_cog_alu_r&32'hf0f0f0f) << 32'h4)&64'hFFFFFFFF));
                outp_cog_alu_r = ((((outp_cog_alu_r&32'hff00ff00) >> 32'h8)&64'hFFFFFFFF)|(((outp_cog_alu_r&32'hff00ff) << 32'h8)&64'hFFFFFFFF));
                outp_cog_alu_r = (((outp_cog_alu_r >> 32'h10)&64'hFFFFFFFF)|((outp_cog_alu_r << 32'h10)&64'hFFFFFFFF));
                outp_cog_alu_r = ((outp_cog_alu_r >> (in_cog_alu_s&32'h1f))&64'hFFFFFFFF);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
                outp_cog_alu_co = ((in_cog_alu_d&32'h1)==32'h1);
            end
            32'h10: begin
                outp_cog_alu_co = sgnle32(in_cog_alu_d,in_cog_alu_s);
                outp_cog_alu_r = in_cog_alu_s;
                outp_cog_alu_wr = outp_cog_alu_co;
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h11: begin
                outp_cog_alu_co = sgnle32(in_cog_alu_d,in_cog_alu_s);
                outp_cog_alu_r = in_cog_alu_s;
                outp_cog_alu_wr = (!outp_cog_alu_co);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h12: begin
                outp_cog_alu_co = (in_cog_alu_d<in_cog_alu_s);
                outp_cog_alu_r = in_cog_alu_s;
                outp_cog_alu_wr = outp_cog_alu_co;
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h13: begin
                outp_cog_alu_co = (in_cog_alu_d<in_cog_alu_s);
                outp_cog_alu_r = in_cog_alu_s;
                outp_cog_alu_wr = (!outp_cog_alu_co);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h14: begin
                outp_cog_alu_co = (in_cog_alu_d<in_cog_alu_s);
                outp_cog_alu_r = ((in_cog_alu_d&32'hfffffe00)|(in_cog_alu_s&32'h1ff));
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h15: begin
                outp_cog_alu_co = (in_cog_alu_d<in_cog_alu_s);
                outp_cog_alu_r = ((in_cog_alu_d&32'hfffc01ff)|(((in_cog_alu_s&32'h1ff) << 32'h9)&64'hFFFFFFFF));
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h16: begin
                outp_cog_alu_co = (in_cog_alu_d<in_cog_alu_s);
                outp_cog_alu_r = ((in_cog_alu_d&32'h7fffff)|(((in_cog_alu_s&32'h1ff) << 32'h17)&64'hFFFFFFFF));
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h17: begin
                outp_cog_alu_co = (in_cog_alu_d<in_cog_alu_s);
                outp_cog_alu_r = ((in_cog_alu_d&32'hfffffe00)|in_cog_alu_p);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h18: begin
                outp_cog_alu_r = (in_cog_alu_d&in_cog_alu_s);
                loc_cog_alu_tmpRes32 = (outp_cog_alu_r^((outp_cog_alu_r >> 32'h10)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h8)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h4)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h2)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h1)&64'hFFFFFFFF));
                outp_cog_alu_co = ((loc_cog_alu_tmpRes32>>32'h0)&1 != 0);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h19: begin
                outp_cog_alu_r = (in_cog_alu_d&((~in_cog_alu_s)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (outp_cog_alu_r^((outp_cog_alu_r >> 32'h10)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h8)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h4)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h2)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h1)&64'hFFFFFFFF));
                outp_cog_alu_co = ((loc_cog_alu_tmpRes32>>32'h0)&1 != 0);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h1a: begin
                outp_cog_alu_r = (in_cog_alu_d|in_cog_alu_s);
                loc_cog_alu_tmpRes32 = (outp_cog_alu_r^((outp_cog_alu_r >> 32'h10)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h8)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h4)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h2)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h1)&64'hFFFFFFFF));
                outp_cog_alu_co = ((loc_cog_alu_tmpRes32>>32'h0)&1 != 0);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h1b: begin
                outp_cog_alu_r = (in_cog_alu_d^in_cog_alu_s);
                loc_cog_alu_tmpRes32 = (outp_cog_alu_r^((outp_cog_alu_r >> 32'h10)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h8)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h4)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h2)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h1)&64'hFFFFFFFF));
                outp_cog_alu_co = ((loc_cog_alu_tmpRes32>>32'h0)&1 != 0);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h1c: begin
                outp_cog_alu_r = (in_cog_alu_ci?(in_cog_alu_d|in_cog_alu_s):(in_cog_alu_d&((~in_cog_alu_s)&64'hFFFFFFFF)));
                loc_cog_alu_tmpRes32 = (outp_cog_alu_r^((outp_cog_alu_r >> 32'h10)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h8)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h4)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h2)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h1)&64'hFFFFFFFF));
                outp_cog_alu_co = ((loc_cog_alu_tmpRes32>>32'h0)&1 != 0);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h1d: begin
                outp_cog_alu_r = ((!in_cog_alu_ci)?(in_cog_alu_d|in_cog_alu_s):(in_cog_alu_d&((~in_cog_alu_s)&64'hFFFFFFFF)));
                loc_cog_alu_tmpRes32 = (outp_cog_alu_r^((outp_cog_alu_r >> 32'h10)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h8)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h4)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h2)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h1)&64'hFFFFFFFF));
                outp_cog_alu_co = ((loc_cog_alu_tmpRes32>>32'h0)&1 != 0);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h1e: begin
                outp_cog_alu_r = (in_cog_alu_zi?(in_cog_alu_d|in_cog_alu_s):(in_cog_alu_d&((~in_cog_alu_s)&64'hFFFFFFFF)));
                loc_cog_alu_tmpRes32 = (outp_cog_alu_r^((outp_cog_alu_r >> 32'h10)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h8)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h4)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h2)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h1)&64'hFFFFFFFF));
                outp_cog_alu_co = ((loc_cog_alu_tmpRes32>>32'h0)&1 != 0);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h1f: begin
                outp_cog_alu_r = ((!in_cog_alu_zi)?(in_cog_alu_d|in_cog_alu_s):(in_cog_alu_d&((~in_cog_alu_s)&64'hFFFFFFFF)));
                loc_cog_alu_tmpRes32 = (outp_cog_alu_r^((outp_cog_alu_r >> 32'h10)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h8)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h4)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h2)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h1)&64'hFFFFFFFF));
                outp_cog_alu_co = ((loc_cog_alu_tmpRes32>>32'h0)&1 != 0);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h20: begin
                loc_cog_alu_tmpRes64 = ((in_cog_alu_d+in_cog_alu_s)&64'hFFFFFFFFFFFFFFFF);
                outp_cog_alu_r = (loc_cog_alu_tmpRes64 & 64'hFFFFFFFF);
                outp_cog_alu_co = ((loc_cog_alu_tmpRes64>>32'h20)&1 != 0);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h21: begin
                loc_cog_alu_tmpRes64 = ((in_cog_alu_d-in_cog_alu_s)&64'hFFFFFFFFFFFFFFFF);
                outp_cog_alu_r = (loc_cog_alu_tmpRes64 & 64'hFFFFFFFF);
                outp_cog_alu_co = ((loc_cog_alu_tmpRes64>>32'h20)&1 != 0);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h22: begin
                if (((in_cog_alu_s>>32'h1f)&1 != 0)) begin
                    loc_cog_alu_tmpRes64 = ((in_cog_alu_d+((32'h0-in_cog_alu_s)&64'hFFFFFFFF))&64'hFFFFFFFFFFFFFFFF);
                    outp_cog_alu_co = (!((loc_cog_alu_tmpRes64>>32'h20)&1 != 0));
                end
                else begin
                    loc_cog_alu_tmpRes64 = ((in_cog_alu_d+in_cog_alu_s)&64'hFFFFFFFFFFFFFFFF);
                    outp_cog_alu_co = ((loc_cog_alu_tmpRes64>>32'h20)&1 != 0);
                end
                outp_cog_alu_r = (loc_cog_alu_tmpRes64 & 64'hFFFFFFFF);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h23: begin
                if (((in_cog_alu_s>>32'h1f)&1 != 0)) begin
                    loc_cog_alu_tmpRes64 = ((in_cog_alu_d-((32'h0-in_cog_alu_s)&64'hFFFFFFFF))&64'hFFFFFFFFFFFFFFFF);
                    outp_cog_alu_co = (!((loc_cog_alu_tmpRes64>>32'h20)&1 != 0));
                end
                else begin
                    loc_cog_alu_tmpRes64 = ((in_cog_alu_d-in_cog_alu_s)&64'hFFFFFFFFFFFFFFFF);
                    outp_cog_alu_co = ((loc_cog_alu_tmpRes64>>32'h20)&1 != 0);
                end
                outp_cog_alu_r = (loc_cog_alu_tmpRes64 & 64'hFFFFFFFF);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h24: begin
                loc_cog_alu_tmpRes64 = (((((((in_cog_alu_d+64'h80000000)&64'hFFFFFFFFFFFFFFFF)&64'h17fffffff)+((((in_cog_alu_ci?((~in_cog_alu_s)&64'hFFFFFFFF):in_cog_alu_s)+64'h80000000)&64'hFFFFFFFFFFFFFFFF)&64'h17fffffff))&64'hFFFFFFFFFFFFFFFF)+(in_cog_alu_ci?32'h80000001:32'h80000000))&64'hFFFFFFFFFFFFFFFF);
                outp_cog_alu_co = (!((((((loc_cog_alu_tmpRes64 >> 32'h21)&64'hFFFFFFFFFFFFFFFF) & 64'hFFFFFFFF)^(((loc_cog_alu_tmpRes64 & 64'hFFFFFFFF) >> 32'h1f)&64'hFFFFFFFF))>>32'h0)&1 != 0));
                outp_cog_alu_r = (((((loc_cog_alu_tmpRes64 >> 32'h1)&64'hFFFFFFFFFFFFFFFF) & 64'hFFFFFFFF)&32'h80000000)|((loc_cog_alu_tmpRes64 & 64'hFFFFFFFF)&32'h7fffffff));
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h25: begin
                loc_cog_alu_tmpRes64 = (((((((in_cog_alu_d+64'h80000000)&64'hFFFFFFFFFFFFFFFF)&64'h17fffffff)+((((in_cog_alu_ci?in_cog_alu_s:((~in_cog_alu_s)&64'hFFFFFFFF))+64'h80000000)&64'hFFFFFFFFFFFFFFFF)&64'h17fffffff))&64'hFFFFFFFFFFFFFFFF)+(in_cog_alu_ci?32'h80000000:32'h80000001))&64'hFFFFFFFFFFFFFFFF);
                outp_cog_alu_co = (!((((((loc_cog_alu_tmpRes64 >> 32'h21)&64'hFFFFFFFFFFFFFFFF) & 64'hFFFFFFFF)^(((loc_cog_alu_tmpRes64 & 64'hFFFFFFFF) >> 32'h1f)&64'hFFFFFFFF))>>32'h0)&1 != 0));
                outp_cog_alu_r = (((((loc_cog_alu_tmpRes64 >> 32'h1)&64'hFFFFFFFFFFFFFFFF) & 64'hFFFFFFFF)&32'h80000000)|((loc_cog_alu_tmpRes64 & 64'hFFFFFFFF)&32'h7fffffff));
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h26: begin
                loc_cog_alu_tmpRes64 = (((((((in_cog_alu_d+64'h80000000)&64'hFFFFFFFFFFFFFFFF)&64'h17fffffff)+((((in_cog_alu_zi?((~in_cog_alu_s)&64'hFFFFFFFF):in_cog_alu_s)+64'h80000000)&64'hFFFFFFFFFFFFFFFF)&64'h17fffffff))&64'hFFFFFFFFFFFFFFFF)+(in_cog_alu_zi?32'h80000001:32'h80000000))&64'hFFFFFFFFFFFFFFFF);
                outp_cog_alu_co = (!((((((loc_cog_alu_tmpRes64 >> 32'h21)&64'hFFFFFFFFFFFFFFFF) & 64'hFFFFFFFF)^(((loc_cog_alu_tmpRes64 & 64'hFFFFFFFF) >> 32'h1f)&64'hFFFFFFFF))>>32'h0)&1 != 0));
                outp_cog_alu_r = (((((loc_cog_alu_tmpRes64 >> 32'h1)&64'hFFFFFFFFFFFFFFFF) & 64'hFFFFFFFF)&32'h80000000)|((loc_cog_alu_tmpRes64 & 64'hFFFFFFFF)&32'h7fffffff));
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h27: begin
                loc_cog_alu_tmpRes64 = (((((((in_cog_alu_d+64'h80000000)&64'hFFFFFFFFFFFFFFFF)&64'h17fffffff)+((((in_cog_alu_zi?in_cog_alu_s:((~in_cog_alu_s)&64'hFFFFFFFF))+64'h80000000)&64'hFFFFFFFFFFFFFFFF)&64'h17fffffff))&64'hFFFFFFFFFFFFFFFF)+(in_cog_alu_zi?32'h80000000:32'h80000001))&64'hFFFFFFFFFFFFFFFF);
                outp_cog_alu_co = (!((((((loc_cog_alu_tmpRes64 >> 32'h21)&64'hFFFFFFFFFFFFFFFF) & 64'hFFFFFFFF)^(((loc_cog_alu_tmpRes64 & 64'hFFFFFFFF) >> 32'h1f)&64'hFFFFFFFF))>>32'h0)&1 != 0));
                outp_cog_alu_r = (((((loc_cog_alu_tmpRes64 >> 32'h1)&64'hFFFFFFFFFFFFFFFF) & 64'hFFFFFFFF)&32'h80000000)|((loc_cog_alu_tmpRes64 & 64'hFFFFFFFF)&32'h7fffffff));
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h28: begin
                outp_cog_alu_r = in_cog_alu_s;
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
                outp_cog_alu_co = ((in_cog_alu_s>>32'h1f)&1 != 0);
            end
            32'h29: begin
                outp_cog_alu_r = ((32'h0-in_cog_alu_s)&64'hFFFFFFFF);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
                outp_cog_alu_co = ((in_cog_alu_s>>32'h1f)&1 != 0);
            end
            32'h2a: begin
                outp_cog_alu_co = ((in_cog_alu_s>>32'h1f)&1 != 0);
                outp_cog_alu_r = (outp_cog_alu_co?((32'h0-in_cog_alu_s)&64'hFFFFFFFF):in_cog_alu_s);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h2b: begin
                outp_cog_alu_co = ((in_cog_alu_s>>32'h1f)&1 != 0);
                outp_cog_alu_r = (outp_cog_alu_co?in_cog_alu_s:((32'h0-in_cog_alu_s)&64'hFFFFFFFF));
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h2c: begin
                outp_cog_alu_r = (in_cog_alu_ci?((32'h0-in_cog_alu_s)&64'hFFFFFFFF):in_cog_alu_s);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
                outp_cog_alu_co = ((in_cog_alu_s>>32'h1f)&1 != 0);
            end
            32'h2d: begin
                outp_cog_alu_r = (in_cog_alu_ci?in_cog_alu_s:((32'h0-in_cog_alu_s)&64'hFFFFFFFF));
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
                outp_cog_alu_co = ((in_cog_alu_s>>32'h1f)&1 != 0);
            end
            32'h2e: begin
                outp_cog_alu_r = (in_cog_alu_zi?((32'h0-in_cog_alu_s)&64'hFFFFFFFF):in_cog_alu_s);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
                outp_cog_alu_co = ((in_cog_alu_s>>32'h1f)&1 != 0);
            end
            32'h2f: begin
                outp_cog_alu_r = (in_cog_alu_zi?in_cog_alu_s:((32'h0-in_cog_alu_s)&64'hFFFFFFFF));
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
                outp_cog_alu_co = ((in_cog_alu_s>>32'h1f)&1 != 0);
            end
            32'h30: begin
                loc_cog_alu_tmpRes64 = (((((((in_cog_alu_d+64'h80000000)&64'hFFFFFFFFFFFFFFFF)&64'h17fffffff)+(((((~in_cog_alu_s)&64'hFFFFFFFF)+64'h80000000)&64'hFFFFFFFFFFFFFFFF)&64'h17fffffff))&64'hFFFFFFFFFFFFFFFF)+64'h80000001)&64'hFFFFFFFFFFFFFFFF);
                outp_cog_alu_r = (((((loc_cog_alu_tmpRes64 >> 32'h1)&64'hFFFFFFFFFFFFFFFF) & 64'hFFFFFFFF)&32'h80000000)|((loc_cog_alu_tmpRes64 & 64'hFFFFFFFF)&32'h7fffffff));
                outp_cog_alu_co = (((((outp_cog_alu_r >> 32'h1f)&64'hFFFFFFFF)&32'h1)==32'h1)!=(!((((((loc_cog_alu_tmpRes64 >> 32'h21)&64'hFFFFFFFFFFFFFFFF) & 64'hFFFFFFFF)^(((loc_cog_alu_tmpRes64 & 64'hFFFFFFFF) >> 32'h1f)&64'hFFFFFFFF))>>32'h0)&1 != 0)));
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h31: begin
                loc_cog_alu_tmpRes64 = (((((((in_cog_alu_d+64'h80000000)&64'hFFFFFFFFFFFFFFFF)&64'h17fffffff)+(((((~in_cog_alu_s)&64'hFFFFFFFF)+64'h80000000)&64'hFFFFFFFFFFFFFFFF)&64'h17fffffff))&64'hFFFFFFFFFFFFFFFF)+(in_cog_alu_ci?32'h80000000:32'h80000001))&64'hFFFFFFFFFFFFFFFF);
                outp_cog_alu_r = (((((loc_cog_alu_tmpRes64 >> 32'h1)&64'hFFFFFFFFFFFFFFFF) & 64'hFFFFFFFF)&32'h80000000)|((loc_cog_alu_tmpRes64 & 64'hFFFFFFFF)&32'h7fffffff));
                outp_cog_alu_co = (((((outp_cog_alu_r >> 32'h1f)&64'hFFFFFFFF)&32'h1)==32'h1)!=(!((((((loc_cog_alu_tmpRes64 >> 32'h21)&64'hFFFFFFFFFFFFFFFF) & 64'hFFFFFFFF)^(((loc_cog_alu_tmpRes64 & 64'hFFFFFFFF) >> 32'h1f)&64'hFFFFFFFF))>>32'h0)&1 != 0)));
                outp_cog_alu_zo = (in_cog_alu_zi&(outp_cog_alu_r==32'h0));
            end
            32'h32: begin
                loc_cog_alu_tmpRes64 = ((in_cog_alu_d+((in_cog_alu_s+(in_cog_alu_ci?32'h1:32'h0))&64'hFFFFFFFFFFFFFFFF))&64'hFFFFFFFFFFFFFFFF);
                outp_cog_alu_r = (loc_cog_alu_tmpRes64 & 64'hFFFFFFFF);
                outp_cog_alu_co = ((loc_cog_alu_tmpRes64>>32'h20)&1 != 0);
                outp_cog_alu_zo = (in_cog_alu_zi&(outp_cog_alu_r==32'h0));
            end
            32'h33: begin
                loc_cog_alu_tmpRes64 = ((in_cog_alu_d-((in_cog_alu_s+(in_cog_alu_ci?32'h1:32'h0))&64'hFFFFFFFFFFFFFFFF))&64'hFFFFFFFFFFFFFFFF);
                outp_cog_alu_r = (loc_cog_alu_tmpRes64 & 64'hFFFFFFFF);
                outp_cog_alu_co = ((loc_cog_alu_tmpRes64>>32'h20)&1 != 0);
                outp_cog_alu_zo = (in_cog_alu_zi&(outp_cog_alu_r==32'h0));
            end
            32'h34: begin
                loc_cog_alu_tmpRes64 = (((((((in_cog_alu_d+64'h80000000)&64'hFFFFFFFFFFFFFFFF)&64'h17fffffff)+(((in_cog_alu_s+64'h80000000)&64'hFFFFFFFFFFFFFFFF)&64'h17fffffff))&64'hFFFFFFFFFFFFFFFF)+64'h80000000)&64'hFFFFFFFFFFFFFFFF);
                outp_cog_alu_r = (((((loc_cog_alu_tmpRes64 >> 32'h1)&64'hFFFFFFFFFFFFFFFF) & 64'hFFFFFFFF)&32'h80000000)|((loc_cog_alu_tmpRes64 & 64'hFFFFFFFF)&32'h7fffffff));
                outp_cog_alu_co = (!((((((loc_cog_alu_tmpRes64 >> 32'h21)&64'hFFFFFFFFFFFFFFFF) & 64'hFFFFFFFF)^(((loc_cog_alu_tmpRes64 & 64'hFFFFFFFF) >> 32'h1f)&64'hFFFFFFFF))>>32'h0)&1 != 0));
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h35: begin
                loc_cog_alu_tmpRes64 = (((((((in_cog_alu_d+64'h80000000)&64'hFFFFFFFFFFFFFFFF)&64'h17fffffff)+(((((~in_cog_alu_s)&64'hFFFFFFFF)+64'h80000000)&64'hFFFFFFFFFFFFFFFF)&64'h17fffffff))&64'hFFFFFFFFFFFFFFFF)+64'h80000001)&64'hFFFFFFFFFFFFFFFF);
                outp_cog_alu_r = (((((loc_cog_alu_tmpRes64 >> 32'h1)&64'hFFFFFFFFFFFFFFFF) & 64'hFFFFFFFF)&32'h80000000)|((loc_cog_alu_tmpRes64 & 64'hFFFFFFFF)&32'h7fffffff));
                outp_cog_alu_co = (!((((((loc_cog_alu_tmpRes64 >> 32'h21)&64'hFFFFFFFFFFFFFFFF) & 64'hFFFFFFFF)^(((loc_cog_alu_tmpRes64 & 64'hFFFFFFFF) >> 32'h1f)&64'hFFFFFFFF))>>32'h0)&1 != 0));
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h36: begin
                loc_cog_alu_tmpRes64 = (((((((in_cog_alu_d+64'h80000000)&64'hFFFFFFFFFFFFFFFF)&64'h17fffffff)+(((in_cog_alu_s+64'h80000000)&64'hFFFFFFFFFFFFFFFF)&64'h17fffffff))&64'hFFFFFFFFFFFFFFFF)+(in_cog_alu_ci?32'h80000001:32'h80000000))&64'hFFFFFFFFFFFFFFFF);
                outp_cog_alu_r = (((((loc_cog_alu_tmpRes64 >> 32'h1)&64'hFFFFFFFFFFFFFFFF) & 64'hFFFFFFFF)&32'h80000000)|((loc_cog_alu_tmpRes64 & 64'hFFFFFFFF)&32'h7fffffff));
                outp_cog_alu_co = (!((((((loc_cog_alu_tmpRes64 >> 32'h21)&64'hFFFFFFFFFFFFFFFF) & 64'hFFFFFFFF)^(((loc_cog_alu_tmpRes64 & 64'hFFFFFFFF) >> 32'h1f)&64'hFFFFFFFF))>>32'h0)&1 != 0));
                outp_cog_alu_zo = (in_cog_alu_zi&(outp_cog_alu_r==32'h0));
            end
            32'h37: begin
                loc_cog_alu_tmpRes64 = (((((((in_cog_alu_d+64'h80000000)&64'hFFFFFFFFFFFFFFFF)&64'h17fffffff)+(((((~in_cog_alu_s)&64'hFFFFFFFF)+64'h80000000)&64'hFFFFFFFFFFFFFFFF)&64'h17fffffff))&64'hFFFFFFFFFFFFFFFF)+(in_cog_alu_ci?32'h80000000:32'h80000001))&64'hFFFFFFFFFFFFFFFF);
                outp_cog_alu_r = (((((loc_cog_alu_tmpRes64 >> 32'h1)&64'hFFFFFFFFFFFFFFFF) & 64'hFFFFFFFF)&32'h80000000)|((loc_cog_alu_tmpRes64 & 64'hFFFFFFFF)&32'h7fffffff));
                outp_cog_alu_co = (!((((((loc_cog_alu_tmpRes64 >> 32'h21)&64'hFFFFFFFFFFFFFFFF) & 64'hFFFFFFFF)^(((loc_cog_alu_tmpRes64 & 64'hFFFFFFFF) >> 32'h1f)&64'hFFFFFFFF))>>32'h0)&1 != 0));
                outp_cog_alu_zo = (in_cog_alu_zi&(outp_cog_alu_r==32'h0));
            end
            32'h38: begin
                loc_cog_alu_tmpRes64 = ((in_cog_alu_d-in_cog_alu_s)&64'hFFFFFFFFFFFFFFFF);
                outp_cog_alu_r = (loc_cog_alu_tmpRes64 & 64'hFFFFFFFF);
                outp_cog_alu_co = (in_cog_alu_s<=in_cog_alu_d);
                outp_cog_alu_wr = outp_cog_alu_co;
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h39: begin
                outp_cog_alu_r = ((in_cog_alu_d-32'h1)&64'hFFFFFFFF);
                outp_cog_alu_co = (in_cog_alu_d==32'h0);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h3a: begin
                outp_cog_alu_r = in_cog_alu_d;
                outp_cog_alu_co = 1'b0;
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h3b: begin
                outp_cog_alu_r = in_cog_alu_d;
                outp_cog_alu_co = 1'b0;
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h3c: begin
                loc_cog_alu_tmpRes64 = ((in_cog_alu_d+in_cog_alu_s)&64'hFFFFFFFFFFFFFFFF);
                outp_cog_alu_r = (loc_cog_alu_tmpRes64 & 64'hFFFFFFFF);
                outp_cog_alu_co = ((loc_cog_alu_tmpRes64>>32'h20)&1 != 0);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h3d: begin
                loc_cog_alu_tmpRes64 = ((in_cog_alu_d+((in_cog_alu_s+64'h1)&64'hFFFFFFFFFFFFFFFF))&64'hFFFFFFFFFFFFFFFF);
                outp_cog_alu_r = (loc_cog_alu_tmpRes64 & 64'hFFFFFFFF);
                outp_cog_alu_co = ((loc_cog_alu_tmpRes64>>32'h20)&1 != 0);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h3e: begin
                loc_cog_alu_tmpRes64 = ((in_cog_alu_d+in_cog_alu_s)&64'hFFFFFFFFFFFFFFFF);
                outp_cog_alu_r = (loc_cog_alu_tmpRes64 & 64'hFFFFFFFF);
                outp_cog_alu_co = ((loc_cog_alu_tmpRes64>>32'h20)&1 != 0);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h3f: begin
                loc_cog_alu_tmpRes64 = ((in_cog_alu_d+in_cog_alu_s)&64'hFFFFFFFFFFFFFFFF);
                outp_cog_alu_r = (loc_cog_alu_tmpRes64 & 64'hFFFFFFFF);
                outp_cog_alu_co = ((loc_cog_alu_tmpRes64>>32'h20)&1 != 0);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
        endcase
        assume (in_cog_alu_i< 32'h40);
        cond = ((!cancel)&(((((((i >> 32'h12)&64'hFFFFFFFF)&32'hf) >> flags)&64'hFFFFFFFF)&32'h1)==32'h1));
        if (((state==32'h3)|(state==32'h4))) begin
            jump = 1'b1;
            if ((instr_opcode==32'h17)) begin
                jump_cancel = 1'b0;
            end
            else begin
                if ((instr_opcode==32'h39)) begin
                    jump_cancel = (dest==32'h1);
                end
                else begin
                    if ((instr_opcode==32'h3a)) begin
                        jump_cancel = (dest==32'h0);
                    end
                    else begin
                        if ((instr_opcode==32'h3b)) begin
                            jump_cancel = (dest!=32'h0);
                        end
                        else begin
                            jump = 1'b0;
                        end
                    end
                end
            end
            wio = (((state==32'h4)&cond)&((i>>32'h17)&1 != 0));
        end
        in_cog_ctra_ena = ena;
        in_cog_ctra_setctr = (wio&(instr_dst==32'h1f8));
        in_cog_ctra_setfrq = (wio&(instr_dst==32'h1fa));
        in_cog_ctra_setphs = (wio&(instr_dst==32'h1fc));
        in_cog_ctra_data = outp_cog_alu_r;
        in_cog_ctra_pin_in = pin_in;
        in_cog_ctra_posedge_clk_cog = posedge_clk_cog;
        in_cog_ctra_posedge_clk_pll = posedge_clk_pll;
        in_cog_ctra_negedge_ena = negedge_ena;
        outp_cog_ctra_phs = reg_cog_ctra_phase;
        outp_cog_ctra_pin_out = 32'h0;
        case (reg_cog_ctra_ctrmode)
            32'h0: begin
            end
            32'h1: begin
                if (in_cog_ctra_posedge_clk_pll) begin
                    reg_cog_ctra_pllcounter = (((reg_cog_ctra_pllcounter+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if (in_cog_ctra_posedge_clk_cog) begin
                    reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h2: begin
                if (reg_cog_ctra_pll_saved) begin
                    outp_cog_ctra_pin_out = ((32'h1 << reg_cog_ctra_ctrapin)&64'hFFFFFFFF);
                end
                if (in_cog_ctra_posedge_clk_pll) begin
                    reg_cog_ctra_pllcounter = (((reg_cog_ctra_pllcounter+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if (in_cog_ctra_posedge_clk_cog) begin
                    reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h3: begin
                outp_cog_ctra_pin_out = ((32'h1 << (reg_cog_ctra_pll_saved?reg_cog_ctra_ctrapin:reg_cog_ctra_ctrbpin))&64'hFFFFFFFF);
                if (in_cog_ctra_posedge_clk_pll) begin
                    reg_cog_ctra_pllcounter = (((reg_cog_ctra_pllcounter+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if (in_cog_ctra_posedge_clk_cog) begin
                    reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h4: begin
                if (((reg_cog_ctra_phase>>32'h1f)&1 != 0)) begin
                    outp_cog_ctra_pin_out = ((32'h1 << reg_cog_ctra_ctrapin)&64'hFFFFFFFF);
                end
                if (in_cog_ctra_posedge_clk_cog) begin
                    reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h5: begin
                outp_cog_ctra_pin_out = ((32'h1 << (((reg_cog_ctra_phase>>32'h1f)&1 != 0)?reg_cog_ctra_ctrapin:reg_cog_ctra_ctrbpin))&64'hFFFFFFFF);
                if (in_cog_ctra_posedge_clk_pll) begin
                    reg_cog_ctra_pllcounter = (((reg_cog_ctra_pllcounter+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if (in_cog_ctra_posedge_clk_cog) begin
                    reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h6: begin
                if (((reg_cog_ctra_phase>>32'h20)&1 != 0)) begin
                    outp_cog_ctra_pin_out = ((32'h1 << reg_cog_ctra_ctrapin)&64'hFFFFFFFF);
                end
                if (in_cog_ctra_posedge_clk_pll) begin
                    reg_cog_ctra_pllcounter = (((reg_cog_ctra_pllcounter+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if (in_cog_ctra_posedge_clk_cog) begin
                    reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h7: begin
                outp_cog_ctra_pin_out = ((32'h1 << (((reg_cog_ctra_phase>>32'h20)&1 != 0)?reg_cog_ctra_ctrapin:reg_cog_ctra_ctrbpin))&64'hFFFFFFFF);
                if (in_cog_ctra_posedge_clk_pll) begin
                    reg_cog_ctra_pllcounter = (((reg_cog_ctra_pllcounter+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if (in_cog_ctra_posedge_clk_cog) begin
                    reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h8: begin
                if (in_cog_ctra_posedge_clk_cog) begin
                    if (reg_cog_ctra_delayed0) begin
                        reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                    end
                    reg_cog_ctra_delayed1 = reg_cog_ctra_delayed0;
                    reg_cog_ctra_delayed0 = ((((in_cog_ctra_pin_in >> reg_cog_ctra_ctrapin)&64'hFFFFFFFF)&32'h1)==32'h1);
                end
            end
            32'h9: begin
                if (in_cog_ctra_posedge_clk_pll) begin
                    reg_cog_ctra_pllcounter = (((reg_cog_ctra_pllcounter+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if ((!reg_cog_ctra_delayed0)) begin
                    outp_cog_ctra_pin_out = ((32'h1 << reg_cog_ctra_ctrbpin)&64'hFFFFFFFF);
                end
                if (in_cog_ctra_posedge_clk_cog) begin
                    if (reg_cog_ctra_delayed0) begin
                        reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                    end
                    reg_cog_ctra_delayed1 = reg_cog_ctra_delayed0;
                    reg_cog_ctra_delayed0 = ((((in_cog_ctra_pin_in >> reg_cog_ctra_ctrapin)&64'hFFFFFFFF)&32'h1)==32'h1);
                end
            end
            32'ha: begin
                if (in_cog_ctra_posedge_clk_pll) begin
                    reg_cog_ctra_pllcounter = (((reg_cog_ctra_pllcounter+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if (in_cog_ctra_posedge_clk_cog) begin
                    if ((reg_cog_ctra_delayed0&(!reg_cog_ctra_delayed1))) begin
                        reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                    end
                    reg_cog_ctra_delayed1 = reg_cog_ctra_delayed0;
                    reg_cog_ctra_delayed0 = ((((in_cog_ctra_pin_in >> reg_cog_ctra_ctrapin)&64'hFFFFFFFF)&32'h1)==32'h1);
                end
            end
            32'hb: begin
                if (in_cog_ctra_posedge_clk_pll) begin
                    reg_cog_ctra_pllcounter = (((reg_cog_ctra_pllcounter+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if ((!reg_cog_ctra_delayed0)) begin
                    outp_cog_ctra_pin_out = ((32'h1 << reg_cog_ctra_ctrbpin)&64'hFFFFFFFF);
                end
                if (in_cog_ctra_posedge_clk_cog) begin
                    if ((reg_cog_ctra_delayed0&(!reg_cog_ctra_delayed1))) begin
                        reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                    end
                    reg_cog_ctra_delayed1 = reg_cog_ctra_delayed0;
                    reg_cog_ctra_delayed0 = ((((in_cog_ctra_pin_in >> reg_cog_ctra_ctrapin)&64'hFFFFFFFF)&32'h1)==32'h1);
                end
            end
            32'hc: begin
                if (in_cog_ctra_posedge_clk_cog) begin
                    if ((!reg_cog_ctra_delayed0)) begin
                        reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                    end
                    reg_cog_ctra_delayed1 = reg_cog_ctra_delayed0;
                    reg_cog_ctra_delayed0 = ((((in_cog_ctra_pin_in >> reg_cog_ctra_ctrapin)&64'hFFFFFFFF)&32'h1)==32'h1);
                end
            end
            32'hd: begin
                if (in_cog_ctra_posedge_clk_pll) begin
                    reg_cog_ctra_pllcounter = (((reg_cog_ctra_pllcounter+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if ((!reg_cog_ctra_delayed0)) begin
                    outp_cog_ctra_pin_out = ((32'h1 << reg_cog_ctra_ctrbpin)&64'hFFFFFFFF);
                end
                if (in_cog_ctra_posedge_clk_cog) begin
                    if ((!reg_cog_ctra_delayed0)) begin
                        reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                    end
                    reg_cog_ctra_delayed1 = reg_cog_ctra_delayed0;
                    reg_cog_ctra_delayed0 = ((((in_cog_ctra_pin_in >> reg_cog_ctra_ctrapin)&64'hFFFFFFFF)&32'h1)==32'h1);
                end
            end
            32'he: begin
                if (in_cog_ctra_posedge_clk_pll) begin
                    reg_cog_ctra_pllcounter = (((reg_cog_ctra_pllcounter+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if (in_cog_ctra_posedge_clk_cog) begin
                    if (((!reg_cog_ctra_delayed0)&reg_cog_ctra_delayed1)) begin
                        reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                    end
                    reg_cog_ctra_delayed1 = reg_cog_ctra_delayed0;
                    reg_cog_ctra_delayed0 = ((((in_cog_ctra_pin_in >> reg_cog_ctra_ctrapin)&64'hFFFFFFFF)&32'h1)==32'h1);
                end
            end
            32'hf: begin
                if (in_cog_ctra_posedge_clk_pll) begin
                    reg_cog_ctra_pllcounter = (((reg_cog_ctra_pllcounter+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if ((!reg_cog_ctra_delayed0)) begin
                    outp_cog_ctra_pin_out = (outp_cog_ctra_pin_out|((32'h1 << reg_cog_ctra_ctrbpin)&64'hFFFFFFFF));
                end
                if (in_cog_ctra_posedge_clk_cog) begin
                    if (((!reg_cog_ctra_delayed0)&reg_cog_ctra_delayed1)) begin
                        reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                    end
                    reg_cog_ctra_delayed1 = reg_cog_ctra_delayed0;
                    reg_cog_ctra_delayed0 = ((((in_cog_ctra_pin_in >> reg_cog_ctra_ctrapin)&64'hFFFFFFFF)&32'h1)==32'h1);
                end
            end
            32'h10: begin
            end
            32'h11: begin
                if (in_cog_ctra_posedge_clk_pll) begin
                    reg_cog_ctra_pllcounter = (((reg_cog_ctra_pllcounter+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if ((in_cog_ctra_posedge_clk_cog&((!reg_cog_ctra_delayed1)&(!reg_cog_ctra_delayed0)))) begin
                    reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h12: begin
                if (in_cog_ctra_posedge_clk_pll) begin
                    reg_cog_ctra_pllcounter = (((reg_cog_ctra_pllcounter+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if ((in_cog_ctra_posedge_clk_cog&((!reg_cog_ctra_delayed1)&reg_cog_ctra_delayed0))) begin
                    reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h13: begin
                if (in_cog_ctra_posedge_clk_pll) begin
                    reg_cog_ctra_pllcounter = (((reg_cog_ctra_pllcounter+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if ((in_cog_ctra_posedge_clk_cog&(!reg_cog_ctra_delayed1))) begin
                    reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h14: begin
                if ((in_cog_ctra_posedge_clk_cog&(reg_cog_ctra_delayed1&(!reg_cog_ctra_delayed0)))) begin
                    reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h15: begin
                if (in_cog_ctra_posedge_clk_pll) begin
                    reg_cog_ctra_pllcounter = (((reg_cog_ctra_pllcounter+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if ((in_cog_ctra_posedge_clk_cog&(!reg_cog_ctra_delayed0))) begin
                    reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h16: begin
                if (in_cog_ctra_posedge_clk_pll) begin
                    reg_cog_ctra_pllcounter = (((reg_cog_ctra_pllcounter+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if ((in_cog_ctra_posedge_clk_cog&(reg_cog_ctra_delayed1!=reg_cog_ctra_delayed0))) begin
                    reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h17: begin
                if (in_cog_ctra_posedge_clk_pll) begin
                    reg_cog_ctra_pllcounter = (((reg_cog_ctra_pllcounter+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if ((in_cog_ctra_posedge_clk_cog&(!(reg_cog_ctra_delayed1&reg_cog_ctra_delayed0)))) begin
                    reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h18: begin
                if ((in_cog_ctra_posedge_clk_cog&(reg_cog_ctra_delayed1&reg_cog_ctra_delayed0))) begin
                    reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h19: begin
                if (in_cog_ctra_posedge_clk_pll) begin
                    reg_cog_ctra_pllcounter = (((reg_cog_ctra_pllcounter+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if ((in_cog_ctra_posedge_clk_cog&(reg_cog_ctra_delayed1==reg_cog_ctra_delayed0))) begin
                    reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h1a: begin
                if (in_cog_ctra_posedge_clk_pll) begin
                    reg_cog_ctra_pllcounter = (((reg_cog_ctra_pllcounter+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if ((in_cog_ctra_posedge_clk_cog&reg_cog_ctra_delayed0)) begin
                    reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h1b: begin
                if (in_cog_ctra_posedge_clk_pll) begin
                    reg_cog_ctra_pllcounter = (((reg_cog_ctra_pllcounter+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if ((in_cog_ctra_posedge_clk_cog&(reg_cog_ctra_delayed0|(!reg_cog_ctra_delayed1)))) begin
                    reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h1c: begin
                if ((in_cog_ctra_posedge_clk_cog&reg_cog_ctra_delayed1)) begin
                    reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h1d: begin
                if ((in_cog_ctra_posedge_clk_cog&((!reg_cog_ctra_delayed0)|reg_cog_ctra_delayed1))) begin
                    reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h1e: begin
                if ((in_cog_ctra_posedge_clk_cog&(reg_cog_ctra_delayed0|reg_cog_ctra_delayed1))) begin
                    reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h1f: begin
                if (in_cog_ctra_posedge_clk_cog) begin
                    reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
        endcase
        assume (reg_cog_ctra_ctrmode< 32'h20);
        if ((reg_cog_ctra_ctrmode>=32'h10)) begin
            if (in_cog_ctra_posedge_clk_cog) begin
                reg_cog_ctra_delayed0 = ((((in_cog_ctra_pin_in >> reg_cog_ctra_ctrapin)&64'hFFFFFFFF)&32'h1)==32'h1);
                reg_cog_ctra_delayed1 = ((((in_cog_ctra_pin_in >> reg_cog_ctra_ctrbpin)&64'hFFFFFFFF)&32'h1)==32'h1);
            end
        end
        if (in_cog_ctra_posedge_clk_cog) begin
            if (in_cog_ctra_setphs) begin
                reg_cog_ctra_phase = in_cog_ctra_data;
            end
            if (in_cog_ctra_setfrq) begin
                reg_cog_ctra_frequency = in_cog_ctra_data;
            end
        end
        if ((in_cog_ctra_posedge_clk_cog|in_cog_ctra_negedge_ena)) begin
            if ((!in_cog_ctra_ena)) begin
                reg_cog_ctra_ctrmode = 32'h0;
                reg_cog_ctra_ctrplldiv = 32'h0;
                reg_cog_ctra_ctrbpin = 32'h0;
                reg_cog_ctra_ctrapin = 32'h0;
            end
            else begin
                if (in_cog_ctra_setctr) begin
                    reg_cog_ctra_ctrmode = (((in_cog_ctra_data >> 32'h1a)&64'hFFFFFFFF)&32'h3f);
                    reg_cog_ctra_ctrplldiv = (((in_cog_ctra_data >> 32'h17)&64'hFFFFFFFF)&32'h7);
                    reg_cog_ctra_ctrbpin = (((in_cog_ctra_data >> 32'h9)&64'hFFFFFFFF)&32'h1f);
                    reg_cog_ctra_ctrapin = (in_cog_ctra_data&32'h1f);
                end
            end
        end
        in_cog_ctrb_ena = ena;
        in_cog_ctrb_setctr = (wio&(instr_dst==32'h1f9));
        in_cog_ctrb_setfrq = (wio&(instr_dst==32'h1fb));
        in_cog_ctrb_setphs = (wio&(instr_dst==32'h1fd));
        in_cog_ctrb_data = outp_cog_alu_r;
        in_cog_ctrb_pin_in = pin_in;
        in_cog_ctrb_posedge_clk_cog = posedge_clk_cog;
        in_cog_ctrb_posedge_clk_pll = posedge_clk_pll;
        in_cog_ctrb_negedge_ena = negedge_ena;
        outp_cog_ctrb_phs = reg_cog_ctrb_phase;
        outp_cog_ctrb_pin_out = 32'h0;
        case (reg_cog_ctrb_ctrmode)
            32'h0: begin
            end
            32'h1: begin
                if (in_cog_ctrb_posedge_clk_pll) begin
                    reg_cog_ctrb_pllcounter = (((reg_cog_ctrb_pllcounter+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if (in_cog_ctrb_posedge_clk_cog) begin
                    reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h2: begin
                if (reg_cog_ctrb_pll_saved) begin
                    outp_cog_ctrb_pin_out = ((32'h1 << reg_cog_ctrb_ctrapin)&64'hFFFFFFFF);
                end
                if (in_cog_ctrb_posedge_clk_pll) begin
                    reg_cog_ctrb_pllcounter = (((reg_cog_ctrb_pllcounter+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if (in_cog_ctrb_posedge_clk_cog) begin
                    reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h3: begin
                outp_cog_ctrb_pin_out = ((32'h1 << (reg_cog_ctrb_pll_saved?reg_cog_ctrb_ctrapin:reg_cog_ctrb_ctrbpin))&64'hFFFFFFFF);
                if (in_cog_ctrb_posedge_clk_pll) begin
                    reg_cog_ctrb_pllcounter = (((reg_cog_ctrb_pllcounter+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if (in_cog_ctrb_posedge_clk_cog) begin
                    reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h4: begin
                if (((reg_cog_ctrb_phase>>32'h1f)&1 != 0)) begin
                    outp_cog_ctrb_pin_out = ((32'h1 << reg_cog_ctrb_ctrapin)&64'hFFFFFFFF);
                end
                if (in_cog_ctrb_posedge_clk_cog) begin
                    reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h5: begin
                outp_cog_ctrb_pin_out = ((32'h1 << (((reg_cog_ctrb_phase>>32'h1f)&1 != 0)?reg_cog_ctrb_ctrapin:reg_cog_ctrb_ctrbpin))&64'hFFFFFFFF);
                if (in_cog_ctrb_posedge_clk_pll) begin
                    reg_cog_ctrb_pllcounter = (((reg_cog_ctrb_pllcounter+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if (in_cog_ctrb_posedge_clk_cog) begin
                    reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h6: begin
                if (((reg_cog_ctrb_phase>>32'h20)&1 != 0)) begin
                    outp_cog_ctrb_pin_out = ((32'h1 << reg_cog_ctrb_ctrapin)&64'hFFFFFFFF);
                end
                if (in_cog_ctrb_posedge_clk_pll) begin
                    reg_cog_ctrb_pllcounter = (((reg_cog_ctrb_pllcounter+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if (in_cog_ctrb_posedge_clk_cog) begin
                    reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h7: begin
                outp_cog_ctrb_pin_out = ((32'h1 << (((reg_cog_ctrb_phase>>32'h20)&1 != 0)?reg_cog_ctrb_ctrapin:reg_cog_ctrb_ctrbpin))&64'hFFFFFFFF);
                if (in_cog_ctrb_posedge_clk_pll) begin
                    reg_cog_ctrb_pllcounter = (((reg_cog_ctrb_pllcounter+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if (in_cog_ctrb_posedge_clk_cog) begin
                    reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h8: begin
                if (in_cog_ctrb_posedge_clk_cog) begin
                    if (reg_cog_ctrb_delayed0) begin
                        reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                    end
                    reg_cog_ctrb_delayed1 = reg_cog_ctrb_delayed0;
                    reg_cog_ctrb_delayed0 = ((((in_cog_ctrb_pin_in >> reg_cog_ctrb_ctrapin)&64'hFFFFFFFF)&32'h1)==32'h1);
                end
            end
            32'h9: begin
                if (in_cog_ctrb_posedge_clk_pll) begin
                    reg_cog_ctrb_pllcounter = (((reg_cog_ctrb_pllcounter+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if ((!reg_cog_ctrb_delayed0)) begin
                    outp_cog_ctrb_pin_out = ((32'h1 << reg_cog_ctrb_ctrbpin)&64'hFFFFFFFF);
                end
                if (in_cog_ctrb_posedge_clk_cog) begin
                    if (reg_cog_ctrb_delayed0) begin
                        reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                    end
                    reg_cog_ctrb_delayed1 = reg_cog_ctrb_delayed0;
                    reg_cog_ctrb_delayed0 = ((((in_cog_ctrb_pin_in >> reg_cog_ctrb_ctrapin)&64'hFFFFFFFF)&32'h1)==32'h1);
                end
            end
            32'ha: begin
                if (in_cog_ctrb_posedge_clk_pll) begin
                    reg_cog_ctrb_pllcounter = (((reg_cog_ctrb_pllcounter+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if (in_cog_ctrb_posedge_clk_cog) begin
                    if ((reg_cog_ctrb_delayed0&(!reg_cog_ctrb_delayed1))) begin
                        reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                    end
                    reg_cog_ctrb_delayed1 = reg_cog_ctrb_delayed0;
                    reg_cog_ctrb_delayed0 = ((((in_cog_ctrb_pin_in >> reg_cog_ctrb_ctrapin)&64'hFFFFFFFF)&32'h1)==32'h1);
                end
            end
            32'hb: begin
                if (in_cog_ctrb_posedge_clk_pll) begin
                    reg_cog_ctrb_pllcounter = (((reg_cog_ctrb_pllcounter+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if ((!reg_cog_ctrb_delayed0)) begin
                    outp_cog_ctrb_pin_out = ((32'h1 << reg_cog_ctrb_ctrbpin)&64'hFFFFFFFF);
                end
                if (in_cog_ctrb_posedge_clk_cog) begin
                    if ((reg_cog_ctrb_delayed0&(!reg_cog_ctrb_delayed1))) begin
                        reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                    end
                    reg_cog_ctrb_delayed1 = reg_cog_ctrb_delayed0;
                    reg_cog_ctrb_delayed0 = ((((in_cog_ctrb_pin_in >> reg_cog_ctrb_ctrapin)&64'hFFFFFFFF)&32'h1)==32'h1);
                end
            end
            32'hc: begin
                if (in_cog_ctrb_posedge_clk_cog) begin
                    if ((!reg_cog_ctrb_delayed0)) begin
                        reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                    end
                    reg_cog_ctrb_delayed1 = reg_cog_ctrb_delayed0;
                    reg_cog_ctrb_delayed0 = ((((in_cog_ctrb_pin_in >> reg_cog_ctrb_ctrapin)&64'hFFFFFFFF)&32'h1)==32'h1);
                end
            end
            32'hd: begin
                if (in_cog_ctrb_posedge_clk_pll) begin
                    reg_cog_ctrb_pllcounter = (((reg_cog_ctrb_pllcounter+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if ((!reg_cog_ctrb_delayed0)) begin
                    outp_cog_ctrb_pin_out = ((32'h1 << reg_cog_ctrb_ctrbpin)&64'hFFFFFFFF);
                end
                if (in_cog_ctrb_posedge_clk_cog) begin
                    if ((!reg_cog_ctrb_delayed0)) begin
                        reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                    end
                    reg_cog_ctrb_delayed1 = reg_cog_ctrb_delayed0;
                    reg_cog_ctrb_delayed0 = ((((in_cog_ctrb_pin_in >> reg_cog_ctrb_ctrapin)&64'hFFFFFFFF)&32'h1)==32'h1);
                end
            end
            32'he: begin
                if (in_cog_ctrb_posedge_clk_pll) begin
                    reg_cog_ctrb_pllcounter = (((reg_cog_ctrb_pllcounter+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if (in_cog_ctrb_posedge_clk_cog) begin
                    if (((!reg_cog_ctrb_delayed0)&reg_cog_ctrb_delayed1)) begin
                        reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                    end
                    reg_cog_ctrb_delayed1 = reg_cog_ctrb_delayed0;
                    reg_cog_ctrb_delayed0 = ((((in_cog_ctrb_pin_in >> reg_cog_ctrb_ctrapin)&64'hFFFFFFFF)&32'h1)==32'h1);
                end
            end
            32'hf: begin
                if (in_cog_ctrb_posedge_clk_pll) begin
                    reg_cog_ctrb_pllcounter = (((reg_cog_ctrb_pllcounter+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if ((!reg_cog_ctrb_delayed0)) begin
                    outp_cog_ctrb_pin_out = (outp_cog_ctrb_pin_out|((32'h1 << reg_cog_ctrb_ctrbpin)&64'hFFFFFFFF));
                end
                if (in_cog_ctrb_posedge_clk_cog) begin
                    if (((!reg_cog_ctrb_delayed0)&reg_cog_ctrb_delayed1)) begin
                        reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                    end
                    reg_cog_ctrb_delayed1 = reg_cog_ctrb_delayed0;
                    reg_cog_ctrb_delayed0 = ((((in_cog_ctrb_pin_in >> reg_cog_ctrb_ctrapin)&64'hFFFFFFFF)&32'h1)==32'h1);
                end
            end
            32'h10: begin
            end
            32'h11: begin
                if (in_cog_ctrb_posedge_clk_pll) begin
                    reg_cog_ctrb_pllcounter = (((reg_cog_ctrb_pllcounter+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if ((in_cog_ctrb_posedge_clk_cog&((!reg_cog_ctrb_delayed1)&(!reg_cog_ctrb_delayed0)))) begin
                    reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h12: begin
                if (in_cog_ctrb_posedge_clk_pll) begin
                    reg_cog_ctrb_pllcounter = (((reg_cog_ctrb_pllcounter+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if ((in_cog_ctrb_posedge_clk_cog&((!reg_cog_ctrb_delayed1)&reg_cog_ctrb_delayed0))) begin
                    reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h13: begin
                if (in_cog_ctrb_posedge_clk_pll) begin
                    reg_cog_ctrb_pllcounter = (((reg_cog_ctrb_pllcounter+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if ((in_cog_ctrb_posedge_clk_cog&(!reg_cog_ctrb_delayed1))) begin
                    reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h14: begin
                if ((in_cog_ctrb_posedge_clk_cog&(reg_cog_ctrb_delayed1&(!reg_cog_ctrb_delayed0)))) begin
                    reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h15: begin
                if (in_cog_ctrb_posedge_clk_pll) begin
                    reg_cog_ctrb_pllcounter = (((reg_cog_ctrb_pllcounter+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if ((in_cog_ctrb_posedge_clk_cog&(!reg_cog_ctrb_delayed0))) begin
                    reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h16: begin
                if (in_cog_ctrb_posedge_clk_pll) begin
                    reg_cog_ctrb_pllcounter = (((reg_cog_ctrb_pllcounter+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if ((in_cog_ctrb_posedge_clk_cog&(reg_cog_ctrb_delayed1!=reg_cog_ctrb_delayed0))) begin
                    reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h17: begin
                if (in_cog_ctrb_posedge_clk_pll) begin
                    reg_cog_ctrb_pllcounter = (((reg_cog_ctrb_pllcounter+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if ((in_cog_ctrb_posedge_clk_cog&(!(reg_cog_ctrb_delayed1&reg_cog_ctrb_delayed0)))) begin
                    reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h18: begin
                if ((in_cog_ctrb_posedge_clk_cog&(reg_cog_ctrb_delayed1&reg_cog_ctrb_delayed0))) begin
                    reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h19: begin
                if (in_cog_ctrb_posedge_clk_pll) begin
                    reg_cog_ctrb_pllcounter = (((reg_cog_ctrb_pllcounter+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if ((in_cog_ctrb_posedge_clk_cog&(reg_cog_ctrb_delayed1==reg_cog_ctrb_delayed0))) begin
                    reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h1a: begin
                if (in_cog_ctrb_posedge_clk_pll) begin
                    reg_cog_ctrb_pllcounter = (((reg_cog_ctrb_pllcounter+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if ((in_cog_ctrb_posedge_clk_cog&reg_cog_ctrb_delayed0)) begin
                    reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h1b: begin
                if (in_cog_ctrb_posedge_clk_pll) begin
                    reg_cog_ctrb_pllcounter = (((reg_cog_ctrb_pllcounter+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if ((in_cog_ctrb_posedge_clk_cog&(reg_cog_ctrb_delayed0|(!reg_cog_ctrb_delayed1)))) begin
                    reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h1c: begin
                if ((in_cog_ctrb_posedge_clk_cog&reg_cog_ctrb_delayed1)) begin
                    reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h1d: begin
                if ((in_cog_ctrb_posedge_clk_cog&((!reg_cog_ctrb_delayed0)|reg_cog_ctrb_delayed1))) begin
                    reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h1e: begin
                if ((in_cog_ctrb_posedge_clk_cog&(reg_cog_ctrb_delayed0|reg_cog_ctrb_delayed1))) begin
                    reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h1f: begin
                if (in_cog_ctrb_posedge_clk_cog) begin
                    reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
        endcase
        assume (reg_cog_ctrb_ctrmode< 32'h20);
        if ((reg_cog_ctrb_ctrmode>=32'h10)) begin
            if (in_cog_ctrb_posedge_clk_cog) begin
                reg_cog_ctrb_delayed0 = ((((in_cog_ctrb_pin_in >> reg_cog_ctrb_ctrapin)&64'hFFFFFFFF)&32'h1)==32'h1);
                reg_cog_ctrb_delayed1 = ((((in_cog_ctrb_pin_in >> reg_cog_ctrb_ctrbpin)&64'hFFFFFFFF)&32'h1)==32'h1);
            end
        end
        if (in_cog_ctrb_posedge_clk_cog) begin
            if (in_cog_ctrb_setphs) begin
                reg_cog_ctrb_phase = in_cog_ctrb_data;
            end
            if (in_cog_ctrb_setfrq) begin
                reg_cog_ctrb_frequency = in_cog_ctrb_data;
            end
        end
        if ((in_cog_ctrb_posedge_clk_cog|in_cog_ctrb_negedge_ena)) begin
            if ((!in_cog_ctrb_ena)) begin
                reg_cog_ctrb_ctrmode = 32'h0;
                reg_cog_ctrb_ctrplldiv = 32'h0;
                reg_cog_ctrb_ctrbpin = 32'h0;
                reg_cog_ctrb_ctrapin = 32'h0;
            end
            else begin
                if (in_cog_ctrb_setctr) begin
                    reg_cog_ctrb_ctrmode = (((in_cog_ctrb_data >> 32'h1a)&64'hFFFFFFFF)&32'h3f);
                    reg_cog_ctrb_ctrplldiv = (((in_cog_ctrb_data >> 32'h17)&64'hFFFFFFFF)&32'h7);
                    reg_cog_ctrb_ctrbpin = (((in_cog_ctrb_data >> 32'h9)&64'hFFFFFFFF)&32'h1f);
                    reg_cog_ctrb_ctrapin = (in_cog_ctrb_data&32'h1f);
                end
            end
        end
        if (((state==32'h3)|(state==32'h4))) begin
            sx = (((i>>32'h16)&1 != 0)?instr_src:((instr_src==32'h1f0)?(((progctr >> 32'hc)&64'hFFFFFFFF)&32'hfffc):((instr_src==32'h1f1)?cnt:((instr_src==32'h1f2)?pin_in:((instr_src==32'h1fc)?(outp_cog_ctra_phs & 64'hFFFFFFFF):((instr_src==32'h1fd)?(outp_cog_ctrb_phs & 64'hFFFFFFFF):sy_reg))))));
            px = (((cond&jump)?sx:p_reg)&32'h1ff);
        end
        in_cog_vid_ena = ena;
        in_cog_vid_setvid = (wio&(instr_dst==32'h1fe));
        in_cog_vid_setscl = (wio&(instr_dst==32'h1ff));
        in_cog_vid_data = outp_cog_alu_r;
        in_cog_vid_pixel = source;
        in_cog_vid_color = dest;
        in_cog_vid_aural = pll_in;
        in_cog_vid_carrier = pllb_saved;
        in_cog_vid_posedge_clk_cog = posedge_clk_cog;
        in_cog_vid_negedge_ena = negedge_ena;
        in_cog_vid_posedge_vclk = posedge_vclk;
        in_cog_vid_posedge_snc1 = posedge_snc1;
        loc_cog_vid_local_enable = (reg_cog_vid_vcfg_vmode!=32'h0);
        loc_cog_vid_local_capr_next = reg_cog_vid_capr;
        outp_cog_vid_ack = reg_cog_vid_snc0;
        outp_cog_vid_pin_out = 32'h0;
        case (reg_cog_vid_vcfg_vmode)
            32'h3: begin
                outp_cog_vid_pin_out = (((((((((reg_cog_vid_baseband << 32'h4)&64'hFFFFFFFF)+((in_cog_vid_carrier!=((in_cog_vid_aural>>reg_cog_vid_vcfg_auralsub)&1 != 0))?32'h8:32'h0))&64'hFFFFFFFF)+(in_cog_vid_carrier?((32'h7-((((reg_cog_vid_composite+32'h1)&64'hFFFFFFFF) >> 32'h1)&64'hFFFFFFFF))&64'hFFFFFFFF):(((reg_cog_vid_composite >> 32'h1)&64'hFFFFFFFF)&32'h3)))&64'hFFFFFFFF)&reg_cog_vid_vcfg_vpins) << reg_cog_vid_vcfg_vgroup)&64'hFFFFFFFF);
            end
            32'h2: begin
                outp_cog_vid_pin_out = (((((((reg_cog_vid_baseband+((in_cog_vid_carrier!=((in_cog_vid_aural>>reg_cog_vid_vcfg_auralsub)&1 != 0))?32'h80:32'h0))&64'hFFFFFFFF)+(((in_cog_vid_carrier?((32'h7-((((reg_cog_vid_composite+32'h1)&64'hFFFFFFFF) >> 32'h1)&64'hFFFFFFFF))&64'hFFFFFFFF):(((reg_cog_vid_composite >> 32'h1)&64'hFFFFFFFF)&32'h3)) << 32'h4)&64'hFFFFFFFF))&64'hFFFFFFFF)&reg_cog_vid_vcfg_vpins) << reg_cog_vid_vcfg_vgroup)&64'hFFFFFFFF);
            end
            32'h1: begin
                outp_cog_vid_pin_out = (((reg_cog_vid_discrete&reg_cog_vid_vcfg_vpins) << reg_cog_vid_vcfg_vgroup)&64'hFFFFFFFF);
            end
            32'h0: begin
                outp_cog_vid_pin_out = 32'h0;
            end
        endcase
        assume (reg_cog_vid_vcfg_vmode< 32'h4);
        if ((in_cog_vid_posedge_vclk|in_cog_vid_posedge_snc1)) begin
            loc_cog_vid_local_new_set = (reg_cog_vid_setr==32'h1);
            loc_cog_vid_local_new_cnt = (reg_cog_vid_cnt0==32'h1);
            if (reg_cog_vid_snc1) begin
                loc_cog_vid_local_capr_next = 1'b0;
            end
            else begin
                if (loc_cog_vid_local_new_set) begin
                    loc_cog_vid_local_capr_next = 1'b1;
                end
            end
            if (in_cog_vid_posedge_vclk) begin
                loc_cog_vid_local_colorphs = 1'b0;
                loc_cog_vid_local_colormod = reg_cog_vid_discrete;
                if (((reg_cog_vid_discrete&32'h8)!=32'h0)) begin
                    loc_cog_vid_local_colorphs = (((((((reg_cog_vid_discrete >> 32'h4)&64'hFFFFFFFF)&32'hf)+reg_cog_vid_phase)&64'hFFFFFFFF)&32'h8)!=32'h0);
                    loc_cog_vid_local_colormod = ((loc_cog_vid_local_colormod+(loc_cog_vid_local_colorphs?32'h7:32'h1))&64'hFFFFFFFF);
                end
                reg_cog_vid_cnt0 = ((loc_cog_vid_local_new_set?reg_cog_vid_vscl_pixelclocks:(loc_cog_vid_local_new_cnt?reg_cog_vid_cnts:((reg_cog_vid_cnt0-32'h1)&64'hFFFFFFFF)))&32'hff);
                reg_cog_vid_setr = ((loc_cog_vid_local_new_set?reg_cog_vid_vscl_frameclocks:((reg_cog_vid_setr-32'h1)&64'hFFFFFFFF))&32'hfff);
                if (loc_cog_vid_local_new_set) begin
                    reg_cog_vid_cnts = (reg_cog_vid_vscl_pixelclocks&32'hff);
                end
                reg_cog_vid_phase = (((reg_cog_vid_phase+32'h1)&64'hFFFFFFFF)&32'hf);
                reg_cog_vid_baseband = (((loc_cog_vid_local_colorphs?32'h8:32'h0)+((reg_cog_vid_vcfg_chroma0?loc_cog_vid_local_colormod:reg_cog_vid_discrete)&32'h7))&64'hFFFFFFFF);
                reg_cog_vid_composite = ((reg_cog_vid_vcfg_chroma1?loc_cog_vid_local_colormod:reg_cog_vid_discrete)&32'h7);
                if ((reg_cog_vid_vcfg_cmode&((reg_cog_vid_saved_pixels&32'h3)==32'h3))) begin
                    reg_cog_vid_discrete = (((reg_cog_vid_saved_colors >> 32'h18)&64'hFFFFFFFF)&32'hff);
                end
                else begin
                    if ((reg_cog_vid_vcfg_cmode&((reg_cog_vid_saved_pixels&32'h3)==32'h2))) begin
                        reg_cog_vid_discrete = (((reg_cog_vid_saved_colors >> 32'h10)&64'hFFFFFFFF)&32'hff);
                    end
                    else begin
                        if (((reg_cog_vid_saved_pixels&32'h1)==32'h1)) begin
                            reg_cog_vid_discrete = (((reg_cog_vid_saved_colors >> 32'h8)&64'hFFFFFFFF)&32'hff);
                        end
                        else begin
                            reg_cog_vid_discrete = (reg_cog_vid_saved_colors&32'hff);
                        end
                    end
                end
                if (loc_cog_vid_local_new_set) begin
                    reg_cog_vid_saved_pixels = in_cog_vid_pixel;
                    reg_cog_vid_saved_colors = in_cog_vid_color;
                end
                else begin
                    if (loc_cog_vid_local_new_cnt) begin
                        reg_cog_vid_saved_pixels = (reg_cog_vid_vcfg_cmode?((reg_cog_vid_saved_pixels&32'hc0000000)|((reg_cog_vid_saved_pixels >> 32'h2)&64'hFFFFFFFF)):((reg_cog_vid_saved_pixels&32'h80000000)|((reg_cog_vid_saved_pixels >> 32'h1)&64'hFFFFFFFF)));
                    end
                end
            end
        end
        if ((in_cog_vid_posedge_clk_cog|in_cog_vid_negedge_ena)) begin
            if ((!in_cog_vid_ena)) begin
                reg_cog_vid_vcfg_vmode = 32'h0;
                reg_cog_vid_vcfg_cmode = 1'b0;
                reg_cog_vid_vcfg_chroma1 = 1'b0;
                reg_cog_vid_vcfg_chroma0 = 1'b0;
                reg_cog_vid_vcfg_auralsub = 32'h0;
                reg_cog_vid_vcfg_vgroup = 32'h0;
                reg_cog_vid_vcfg_vpins = 32'h0;
            end
            else begin
                if (in_cog_vid_setvid) begin
                    reg_cog_vid_vcfg_vmode = (((in_cog_vid_data >> 32'h1d)&64'hFFFFFFFF)&32'h3);
                    reg_cog_vid_vcfg_cmode = ((((in_cog_vid_data >> 32'h1c)&64'hFFFFFFFF)&32'h1)==32'h1);
                    reg_cog_vid_vcfg_chroma1 = ((((in_cog_vid_data >> 32'h1b)&64'hFFFFFFFF)&32'h1)==32'h1);
                    reg_cog_vid_vcfg_chroma0 = ((((in_cog_vid_data >> 32'h1a)&64'hFFFFFFFF)&32'h1)==32'h1);
                    reg_cog_vid_vcfg_auralsub = (((in_cog_vid_data >> 32'h17)&64'hFFFFFFFF)&32'h7);
                    reg_cog_vid_vcfg_vgroup = (((((in_cog_vid_data >> 32'h9)&64'hFFFFFFFF)&32'h3) << 32'h3)&64'hFFFFFFFF);
                    reg_cog_vid_vcfg_vpins = (in_cog_vid_data&32'hff);
                end
            end
        end
        if (in_cog_vid_posedge_clk_cog) begin
            if (in_cog_vid_setscl) begin
                reg_cog_vid_vscl_pixelclocks = (((in_cog_vid_data >> 32'hc)&64'hFFFFFFFF)&32'hff);
                reg_cog_vid_vscl_frameclocks = (in_cog_vid_data&32'hfff);
            end
            if (loc_cog_vid_local_enable) begin
                reg_cog_vid_snc1 = reg_cog_vid_snc0;
                reg_cog_vid_snc0 = reg_cog_vid_capr;
            end
        end
        reg_cog_vid_capr = loc_cog_vid_local_capr_next;
        pin_out = ((((outa|outp_cog_ctra_pin_out)|outp_cog_ctrb_pin_out)|outp_cog_vid_pin_out)&dira);
        pin_dir = dira;
        in_cog_ram_posedge_clk_cog = posedge_clk_cog;
        in_cog_ram_ena = (inRange32(state,32'h1,32'h3)|(((state==32'h4)&cond)&((i>>32'h17)&1 != 0)));
        in_cog_ram_w = ((state==32'h4)&outp_cog_alu_wr);
        in_cog_ram_d = outp_cog_alu_r;
        in_cog_ram_a = ((state==32'h3)?px:((state==32'h1)?instr_src:instr_dst));
        outp_cog_ram_q = reg_cog_ram_q_reg;
        if ((in_cog_ram_posedge_clk_cog&in_cog_ram_ena)) begin
            reg_cog_ram_q_reg = reg_cog_ram_r;
            if (in_cog_ram_w) begin
                reg_cog_ram_r_$wi = in_cog_ram_a;
                reg_cog_ram_r_$wr = 1'b1;
                reg_cog_ram_r = in_cog_ram_d;
            end
        end
        if ((posedge_clk_cog|negedge_nres)) begin
            if ((!nres)) begin
                progctr = 32'h3e00;
            end
            else begin
                if ((ena_bus&ptr_w)) begin
                    progctr = ptr_d;
                end
            end
        end
        match_prev = match;
        if ((posedge_clk_cog|negedge_ena)) begin
            if ((!ena)) begin
                running = 1'b0;
                p_reg = 32'h0;
                flags = 32'h0;
                dira = 32'h0;
                cancel = 1'b0;
            end
            else begin
                if ((state==32'h4)) begin
                    if ((px==32'h1ff)) begin
                        running = 1'b1;
                    end
                    if ((!(cond&jump_cancel))) begin
                        p_reg = (((px+32'h1)&64'hFFFFFFFF)&32'h1ff);
                    end
                    if ((cond&((i>>32'h18)&1 != 0))) begin
                        flags = (outp_cog_alu_co?(flags|32'h2):(flags&32'h1));
                    end
                    if ((cond&((i>>32'h19)&1 != 0))) begin
                        flags = (outp_cog_alu_zo?(flags|32'h1):(flags&32'h2));
                    end
                    cancel = ((cond&jump_cancel)|(px==32'h1ff));
                end
                if ((wio&(instr_dst==32'h1f6))) begin
                    dira = outp_cog_alu_r;
                end
            end
            if (posedge_clk_cog) begin
                if ((wio&(instr_dst==32'h1f4))) begin
                    outa = outp_cog_alu_r;
                end
                if ((state==32'h4)) begin
                    instruction_reg = outp_cog_ram_q;
                end
                if ((state==32'h2)) begin
                    sy_reg = outp_cog_ram_q;
                end
                match = ((state==32'h5)&(((instr_opcode&32'h3)==32'h1)!=((((i>>32'h1b)&1 != 0)?cnt:(pin_in&source))==dest)));
                if ((state==32'h3)) begin
                    source = sx;
                    dest = outp_cog_ram_q;
                end
            end
            if ((!ena)) begin
                state = 32'h0;
            end
            else begin
                case (state)
                    32'h0: begin
                        state = 32'h1;
                    end
                    32'h1: begin
                        state = 32'h2;
                    end
                    32'h2: begin
                        state = 32'h3;
                    end
                    32'h3,32'h5: begin
                        state = ((cond&(((instr_opcode&32'h3c)==32'h0)?(!bus_ack):((((instr_opcode&32'h3e)==32'h3c)|(instr_opcode==32'h3e))?(!match_prev):((instr_opcode==32'h3f)&(!outp_cog_vid_ack)))))?32'h5:32'h4);
                    end
                    32'h4: begin
                        state = 32'h1;
                    end
                endcase
                assume (state< 32'h6);
            end
        end
        //store registers
        flags_$d = flags;
        dira_$d = dira;
        outa_$d = outa;
        instruction_reg_$d = instruction_reg;
        sy_reg_$d = sy_reg;
        source_$d = source;
        dest_$d = dest;
        p_reg_$d = p_reg;
        progctr_$d = progctr;
        state_$d = state;
        match_$d = match;
        cancel_$d = cancel;
        running_$d = running;
        plla_saved_$d = plla_saved;
        pllb_saved_$d = pllb_saved;
        reg_cog_vid_vcfg_vmode_$d = reg_cog_vid_vcfg_vmode;
        reg_cog_vid_vcfg_auralsub_$d = reg_cog_vid_vcfg_auralsub;
        reg_cog_vid_vcfg_vgroup_$d = reg_cog_vid_vcfg_vgroup;
        reg_cog_vid_vcfg_vpins_$d = reg_cog_vid_vcfg_vpins;
        reg_cog_vid_vscl_pixelclocks_$d = reg_cog_vid_vscl_pixelclocks;
        reg_cog_vid_vscl_frameclocks_$d = reg_cog_vid_vscl_frameclocks;
        reg_cog_vid_composite_$d = reg_cog_vid_composite;
        reg_cog_vid_baseband_$d = reg_cog_vid_baseband;
        reg_cog_vid_phase_$d = reg_cog_vid_phase;
        reg_cog_vid_discrete_$d = reg_cog_vid_discrete;
        reg_cog_vid_saved_pixels_$d = reg_cog_vid_saved_pixels;
        reg_cog_vid_saved_colors_$d = reg_cog_vid_saved_colors;
        reg_cog_vid_cnts_$d = reg_cog_vid_cnts;
        reg_cog_vid_cnt0_$d = reg_cog_vid_cnt0;
        reg_cog_vid_setr_$d = reg_cog_vid_setr;
        reg_cog_vid_vcfg_cmode_$d = reg_cog_vid_vcfg_cmode;
        reg_cog_vid_vcfg_chroma1_$d = reg_cog_vid_vcfg_chroma1;
        reg_cog_vid_vcfg_chroma0_$d = reg_cog_vid_vcfg_chroma0;
        reg_cog_vid_capr_$d = reg_cog_vid_capr;
        reg_cog_vid_snc0_$d = reg_cog_vid_snc0;
        reg_cog_vid_snc1_$d = reg_cog_vid_snc1;
        reg_cog_ctra_frequency_$d = reg_cog_ctra_frequency;
        reg_cog_ctra_phase_$d = reg_cog_ctra_phase;
        reg_cog_ctra_pllcounter_$d = reg_cog_ctra_pllcounter;
        reg_cog_ctra_ctrmode_$d = reg_cog_ctra_ctrmode;
        reg_cog_ctra_ctrplldiv_$d = reg_cog_ctra_ctrplldiv;
        reg_cog_ctra_ctrbpin_$d = reg_cog_ctra_ctrbpin;
        reg_cog_ctra_ctrapin_$d = reg_cog_ctra_ctrapin;
        reg_cog_ctra_delayed0_$d = reg_cog_ctra_delayed0;
        reg_cog_ctra_delayed1_$d = reg_cog_ctra_delayed1;
        reg_cog_ctra_pll_saved_$d = reg_cog_ctra_pll_saved;
        reg_cog_ctrb_frequency_$d = reg_cog_ctrb_frequency;
        reg_cog_ctrb_phase_$d = reg_cog_ctrb_phase;
        reg_cog_ctrb_pllcounter_$d = reg_cog_ctrb_pllcounter;
        reg_cog_ctrb_ctrmode_$d = reg_cog_ctrb_ctrmode;
        reg_cog_ctrb_ctrplldiv_$d = reg_cog_ctrb_ctrplldiv;
        reg_cog_ctrb_ctrbpin_$d = reg_cog_ctrb_ctrbpin;
        reg_cog_ctrb_ctrapin_$d = reg_cog_ctrb_ctrapin;
        reg_cog_ctrb_delayed0_$d = reg_cog_ctrb_delayed0;
        reg_cog_ctrb_delayed1_$d = reg_cog_ctrb_delayed1;
        reg_cog_ctrb_pll_saved_$d = reg_cog_ctrb_pll_saved;
        reg_cog_ram_q_reg_$d = reg_cog_ram_q_reg;
        reg_cog_ram_r_$d = reg_cog_ram_r;
    end
endmodule

module cogEvalMain_simpl(
    input nres,
    input ena_bus,
    input ptr_w,
    input [31:0] ptr_d,
    input ena,
    input bus_sel,
    input [31:0] bus_q,
    input bus_c,
    input bus_ack,
    input [31:0] cnt,
    input [31:0] pll_in,
    input [31:0] pin_in,
    input posedge_clk_cog,
    input negedge_nres,
    input negedge_ena,
    input posedge_clk_pll,
    input posedge_vclk,
    input posedge_snc1,
    output reg bus_r,
    output reg bus_e,
    output reg bus_w,
    output reg [31:0] bus_s,
    output reg [31:0] bus_a,
    output reg [31:0] bus_d,
    output reg [31:0] pin_out,
    output reg [31:0] pin_dir,
    input [31:0] flags_$q,
    output reg [31:0] flags_$d,
    input [31:0] dira_$q,
    output reg [31:0] dira_$d,
    input [31:0] outa_$q,
    output reg [31:0] outa_$d,
    input [31:0] instruction_reg_$q,
    output reg [31:0] instruction_reg_$d,
    input [31:0] sy_reg_$q,
    output reg [31:0] sy_reg_$d,
    input [31:0] source_$q,
    output reg [31:0] source_$d,
    input [31:0] dest_$q,
    output reg [31:0] dest_$d,
    input [31:0] p_reg_$q,
    output reg [31:0] p_reg_$d,
    input [31:0] progctr_$q,
    output reg [31:0] progctr_$d,
    input [31:0] state_$q,
    output reg [31:0] state_$d,
    input match_$q,
    output reg match_$d,
    input cancel_$q,
    output reg cancel_$d,
    input running_$q,
    output reg running_$d,
    input plla_saved_$q,
    output reg plla_saved_$d,
    input pllb_saved_$q,
    output reg pllb_saved_$d,
    input [31:0] reg_cog_vid_vcfg_vmode_$q,
    output reg [31:0] reg_cog_vid_vcfg_vmode_$d,
    input [31:0] reg_cog_vid_vcfg_auralsub_$q,
    output reg [31:0] reg_cog_vid_vcfg_auralsub_$d,
    input [31:0] reg_cog_vid_vcfg_vgroup_$q,
    output reg [31:0] reg_cog_vid_vcfg_vgroup_$d,
    input [31:0] reg_cog_vid_vcfg_vpins_$q,
    output reg [31:0] reg_cog_vid_vcfg_vpins_$d,
    input [31:0] reg_cog_vid_vscl_pixelclocks_$q,
    output reg [31:0] reg_cog_vid_vscl_pixelclocks_$d,
    input [31:0] reg_cog_vid_vscl_frameclocks_$q,
    output reg [31:0] reg_cog_vid_vscl_frameclocks_$d,
    input [31:0] reg_cog_vid_composite_$q,
    output reg [31:0] reg_cog_vid_composite_$d,
    input [31:0] reg_cog_vid_baseband_$q,
    output reg [31:0] reg_cog_vid_baseband_$d,
    input [31:0] reg_cog_vid_phase_$q,
    output reg [31:0] reg_cog_vid_phase_$d,
    input [31:0] reg_cog_vid_discrete_$q,
    output reg [31:0] reg_cog_vid_discrete_$d,
    input [31:0] reg_cog_vid_saved_pixels_$q,
    output reg [31:0] reg_cog_vid_saved_pixels_$d,
    input [31:0] reg_cog_vid_saved_colors_$q,
    output reg [31:0] reg_cog_vid_saved_colors_$d,
    input [31:0] reg_cog_vid_cnts_$q,
    output reg [31:0] reg_cog_vid_cnts_$d,
    input [31:0] reg_cog_vid_cnt0_$q,
    output reg [31:0] reg_cog_vid_cnt0_$d,
    input [31:0] reg_cog_vid_setr_$q,
    output reg [31:0] reg_cog_vid_setr_$d,
    input reg_cog_vid_vcfg_cmode_$q,
    output reg reg_cog_vid_vcfg_cmode_$d,
    input reg_cog_vid_vcfg_chroma1_$q,
    output reg reg_cog_vid_vcfg_chroma1_$d,
    input reg_cog_vid_vcfg_chroma0_$q,
    output reg reg_cog_vid_vcfg_chroma0_$d,
    input reg_cog_vid_capr_$q,
    output reg reg_cog_vid_capr_$d,
    input reg_cog_vid_snc0_$q,
    output reg reg_cog_vid_snc0_$d,
    input reg_cog_vid_snc1_$q,
    output reg reg_cog_vid_snc1_$d,
    input [31:0] reg_cog_ctra_frequency_$q,
    output reg [31:0] reg_cog_ctra_frequency_$d,
    input [63:0] reg_cog_ctra_phase_$q,
    output reg [63:0] reg_cog_ctra_phase_$d,
    input [63:0] reg_cog_ctra_pllcounter_$q,
    output reg [63:0] reg_cog_ctra_pllcounter_$d,
    input [31:0] reg_cog_ctra_ctrmode_$q,
    output reg [31:0] reg_cog_ctra_ctrmode_$d,
    input [31:0] reg_cog_ctra_ctrplldiv_$q,
    output reg [31:0] reg_cog_ctra_ctrplldiv_$d,
    input [31:0] reg_cog_ctra_ctrbpin_$q,
    output reg [31:0] reg_cog_ctra_ctrbpin_$d,
    input [31:0] reg_cog_ctra_ctrapin_$q,
    output reg [31:0] reg_cog_ctra_ctrapin_$d,
    input reg_cog_ctra_delayed0_$q,
    output reg reg_cog_ctra_delayed0_$d,
    input reg_cog_ctra_delayed1_$q,
    output reg reg_cog_ctra_delayed1_$d,
    input reg_cog_ctra_pll_saved_$q,
    output reg reg_cog_ctra_pll_saved_$d,
    input [31:0] reg_cog_ctrb_frequency_$q,
    output reg [31:0] reg_cog_ctrb_frequency_$d,
    input [63:0] reg_cog_ctrb_phase_$q,
    output reg [63:0] reg_cog_ctrb_phase_$d,
    input [63:0] reg_cog_ctrb_pllcounter_$q,
    output reg [63:0] reg_cog_ctrb_pllcounter_$d,
    input [31:0] reg_cog_ctrb_ctrmode_$q,
    output reg [31:0] reg_cog_ctrb_ctrmode_$d,
    input [31:0] reg_cog_ctrb_ctrplldiv_$q,
    output reg [31:0] reg_cog_ctrb_ctrplldiv_$d,
    input [31:0] reg_cog_ctrb_ctrbpin_$q,
    output reg [31:0] reg_cog_ctrb_ctrbpin_$d,
    input [31:0] reg_cog_ctrb_ctrapin_$q,
    output reg [31:0] reg_cog_ctrb_ctrapin_$d,
    input reg_cog_ctrb_delayed0_$q,
    output reg reg_cog_ctrb_delayed0_$d,
    input reg_cog_ctrb_delayed1_$q,
    output reg reg_cog_ctrb_delayed1_$d,
    input reg_cog_ctrb_pll_saved_$q,
    output reg reg_cog_ctrb_pll_saved_$d,
    input [31:0] reg_cog_ram_q_reg_$q,
    output reg [31:0] reg_cog_ram_q_reg_$d,
    input [31:0] reg_cog_ram_r_$q,
    output reg [31:0] reg_cog_ram_r_$d,
    output reg [31:0] reg_cog_ram_r_$wi,
    output reg reg_cog_ram_r_$wr
);
    reg [31:0] sx;
    reg [31:0] px;
    reg [31:0] i;
    reg [31:0] instr_src;
    reg [31:0] instr_dst;
    reg [31:0] instr_opcode;
    reg jump;
    reg cond;
    reg jump_cancel;
    reg wio;
    reg match_prev;
    reg [31:0] in_cog_alu_i;
    reg [31:0] in_cog_alu_s;
    reg [31:0] in_cog_alu_d;
    reg [31:0] in_cog_alu_p;
    reg in_cog_alu_run;
    reg in_cog_alu_ci;
    reg in_cog_alu_zi;
    reg [31:0] in_cog_alu_bus_q;
    reg in_cog_alu_bus_c;
    reg [63:0] loc_cog_alu_tmpRes64;
    reg [31:0] loc_cog_alu_tmpRes32;
    reg outp_cog_alu_wr;
    reg [31:0] outp_cog_alu_r;
    reg outp_cog_alu_co;
    reg outp_cog_alu_zo;
    reg in_cog_ctra_ena;
    reg in_cog_ctra_setctr;
    reg in_cog_ctra_setfrq;
    reg in_cog_ctra_setphs;
    reg [31:0] in_cog_ctra_data;
    reg [31:0] in_cog_ctra_pin_in;
    reg in_cog_ctra_posedge_clk_cog;
    reg in_cog_ctra_posedge_clk_pll;
    reg in_cog_ctra_negedge_ena;
    reg [63:0] outp_cog_ctra_phs;
    reg [31:0] outp_cog_ctra_pin_out;
    reg in_cog_ctrb_ena;
    reg in_cog_ctrb_setctr;
    reg in_cog_ctrb_setfrq;
    reg in_cog_ctrb_setphs;
    reg [31:0] in_cog_ctrb_data;
    reg [31:0] in_cog_ctrb_pin_in;
    reg in_cog_ctrb_posedge_clk_cog;
    reg in_cog_ctrb_posedge_clk_pll;
    reg in_cog_ctrb_negedge_ena;
    reg [63:0] outp_cog_ctrb_phs;
    reg [31:0] outp_cog_ctrb_pin_out;
    reg in_cog_vid_ena;
    reg in_cog_vid_setvid;
    reg in_cog_vid_setscl;
    reg [31:0] in_cog_vid_data;
    reg [31:0] in_cog_vid_pixel;
    reg [31:0] in_cog_vid_color;
    reg [31:0] in_cog_vid_aural;
    reg in_cog_vid_carrier;
    reg in_cog_vid_posedge_clk_cog;
    reg in_cog_vid_negedge_ena;
    reg in_cog_vid_posedge_vclk;
    reg in_cog_vid_posedge_snc1;
    reg [31:0] loc_cog_vid_local_colormod;
    reg loc_cog_vid_local_enable;
    reg loc_cog_vid_local_new_set;
    reg loc_cog_vid_local_new_cnt;
    reg loc_cog_vid_local_capr_next;
    reg loc_cog_vid_local_colorphs;
    reg outp_cog_vid_ack;
    reg [31:0] outp_cog_vid_pin_out;
    reg in_cog_ram_posedge_clk_cog;
    reg in_cog_ram_ena;
    reg in_cog_ram_w;
    reg [31:0] in_cog_ram_d;
    reg [31:0] in_cog_ram_a;
    reg [31:0] outp_cog_ram_q;
    reg [31:0] flags;
    reg [31:0] dira;
    reg [31:0] outa;
    reg [31:0] instruction_reg;
    reg [31:0] sy_reg;
    reg [31:0] source;
    reg [31:0] dest;
    reg [31:0] p_reg;
    reg [31:0] progctr;
    reg [31:0] state;
    reg match;
    reg cancel;
    reg running;
    reg plla_saved;
    reg pllb_saved;
    reg [31:0] reg_cog_vid_vcfg_vmode;
    reg [31:0] reg_cog_vid_vcfg_auralsub;
    reg [31:0] reg_cog_vid_vcfg_vgroup;
    reg [31:0] reg_cog_vid_vcfg_vpins;
    reg [31:0] reg_cog_vid_vscl_pixelclocks;
    reg [31:0] reg_cog_vid_vscl_frameclocks;
    reg [31:0] reg_cog_vid_composite;
    reg [31:0] reg_cog_vid_baseband;
    reg [31:0] reg_cog_vid_phase;
    reg [31:0] reg_cog_vid_discrete;
    reg [31:0] reg_cog_vid_saved_pixels;
    reg [31:0] reg_cog_vid_saved_colors;
    reg [31:0] reg_cog_vid_cnts;
    reg [31:0] reg_cog_vid_cnt0;
    reg [31:0] reg_cog_vid_setr;
    reg reg_cog_vid_vcfg_cmode;
    reg reg_cog_vid_vcfg_chroma1;
    reg reg_cog_vid_vcfg_chroma0;
    reg reg_cog_vid_capr;
    reg reg_cog_vid_snc0;
    reg reg_cog_vid_snc1;
    reg [31:0] reg_cog_ctra_frequency;
    reg [63:0] reg_cog_ctra_phase;
    reg [63:0] reg_cog_ctra_pllcounter;
    reg [31:0] reg_cog_ctra_ctrmode;
    reg [31:0] reg_cog_ctra_ctrplldiv;
    reg [31:0] reg_cog_ctra_ctrbpin;
    reg [31:0] reg_cog_ctra_ctrapin;
    reg reg_cog_ctra_delayed0;
    reg reg_cog_ctra_delayed1;
    reg reg_cog_ctra_pll_saved;
    reg [31:0] reg_cog_ctrb_frequency;
    reg [63:0] reg_cog_ctrb_phase;
    reg [63:0] reg_cog_ctrb_pllcounter;
    reg [31:0] reg_cog_ctrb_ctrmode;
    reg [31:0] reg_cog_ctrb_ctrplldiv;
    reg [31:0] reg_cog_ctrb_ctrbpin;
    reg [31:0] reg_cog_ctrb_ctrapin;
    reg reg_cog_ctrb_delayed0;
    reg reg_cog_ctrb_delayed1;
    reg reg_cog_ctrb_pll_saved;
    reg [31:0] reg_cog_ram_q_reg;
    reg [31:0] reg_cog_ram_r;
    always @(*) begin
        //init locals & outputs to 0
        bus_r = 0;
        bus_e = 0;
        bus_w = 0;
        bus_s = 0;
        bus_a = 0;
        bus_d = 0;
        pin_out = 0;
        pin_dir = 0;
        sx = 0;
        px = 0;
        i = 0;
        instr_src = 0;
        instr_dst = 0;
        instr_opcode = 0;
        jump = 0;
        cond = 0;
        jump_cancel = 0;
        wio = 0;
        match_prev = 0;
        in_cog_alu_i = 0;
        in_cog_alu_s = 0;
        in_cog_alu_d = 0;
        in_cog_alu_p = 0;
        in_cog_alu_run = 0;
        in_cog_alu_ci = 0;
        in_cog_alu_zi = 0;
        in_cog_alu_bus_q = 0;
        in_cog_alu_bus_c = 0;
        loc_cog_alu_tmpRes64 = 0;
        loc_cog_alu_tmpRes32 = 0;
        outp_cog_alu_wr = 0;
        outp_cog_alu_r = 0;
        outp_cog_alu_co = 0;
        outp_cog_alu_zo = 0;
        in_cog_ctra_ena = 0;
        in_cog_ctra_setctr = 0;
        in_cog_ctra_setfrq = 0;
        in_cog_ctra_setphs = 0;
        in_cog_ctra_data = 0;
        in_cog_ctra_pin_in = 0;
        in_cog_ctra_posedge_clk_cog = 0;
        in_cog_ctra_posedge_clk_pll = 0;
        in_cog_ctra_negedge_ena = 0;
        outp_cog_ctra_phs = 0;
        outp_cog_ctra_pin_out = 0;
        in_cog_ctrb_ena = 0;
        in_cog_ctrb_setctr = 0;
        in_cog_ctrb_setfrq = 0;
        in_cog_ctrb_setphs = 0;
        in_cog_ctrb_data = 0;
        in_cog_ctrb_pin_in = 0;
        in_cog_ctrb_posedge_clk_cog = 0;
        in_cog_ctrb_posedge_clk_pll = 0;
        in_cog_ctrb_negedge_ena = 0;
        outp_cog_ctrb_phs = 0;
        outp_cog_ctrb_pin_out = 0;
        in_cog_vid_ena = 0;
        in_cog_vid_setvid = 0;
        in_cog_vid_setscl = 0;
        in_cog_vid_data = 0;
        in_cog_vid_pixel = 0;
        in_cog_vid_color = 0;
        in_cog_vid_aural = 0;
        in_cog_vid_carrier = 0;
        in_cog_vid_posedge_clk_cog = 0;
        in_cog_vid_negedge_ena = 0;
        in_cog_vid_posedge_vclk = 0;
        in_cog_vid_posedge_snc1 = 0;
        loc_cog_vid_local_colormod = 0;
        loc_cog_vid_local_enable = 0;
        loc_cog_vid_local_new_set = 0;
        loc_cog_vid_local_new_cnt = 0;
        loc_cog_vid_local_capr_next = 0;
        loc_cog_vid_local_colorphs = 0;
        outp_cog_vid_ack = 0;
        outp_cog_vid_pin_out = 0;
        in_cog_ram_posedge_clk_cog = 0;
        in_cog_ram_ena = 0;
        in_cog_ram_w = 0;
        in_cog_ram_d = 0;
        in_cog_ram_a = 0;
        outp_cog_ram_q = 0;
        //init registers to prev value
        flags = flags_$q;
        dira = dira_$q;
        outa = outa_$q;
        instruction_reg = instruction_reg_$q;
        sy_reg = sy_reg_$q;
        source = source_$q;
        dest = dest_$q;
        p_reg = p_reg_$q;
        progctr = progctr_$q;
        state = state_$q;
        match = match_$q;
        cancel = cancel_$q;
        running = running_$q;
        plla_saved = plla_saved_$q;
        pllb_saved = pllb_saved_$q;
        reg_cog_vid_vcfg_vmode = reg_cog_vid_vcfg_vmode_$q;
        reg_cog_vid_vcfg_auralsub = reg_cog_vid_vcfg_auralsub_$q;
        reg_cog_vid_vcfg_vgroup = reg_cog_vid_vcfg_vgroup_$q;
        reg_cog_vid_vcfg_vpins = reg_cog_vid_vcfg_vpins_$q;
        reg_cog_vid_vscl_pixelclocks = reg_cog_vid_vscl_pixelclocks_$q;
        reg_cog_vid_vscl_frameclocks = reg_cog_vid_vscl_frameclocks_$q;
        reg_cog_vid_composite = reg_cog_vid_composite_$q;
        reg_cog_vid_baseband = reg_cog_vid_baseband_$q;
        reg_cog_vid_phase = reg_cog_vid_phase_$q;
        reg_cog_vid_discrete = reg_cog_vid_discrete_$q;
        reg_cog_vid_saved_pixels = reg_cog_vid_saved_pixels_$q;
        reg_cog_vid_saved_colors = reg_cog_vid_saved_colors_$q;
        reg_cog_vid_cnts = reg_cog_vid_cnts_$q;
        reg_cog_vid_cnt0 = reg_cog_vid_cnt0_$q;
        reg_cog_vid_setr = reg_cog_vid_setr_$q;
        reg_cog_vid_vcfg_cmode = reg_cog_vid_vcfg_cmode_$q;
        reg_cog_vid_vcfg_chroma1 = reg_cog_vid_vcfg_chroma1_$q;
        reg_cog_vid_vcfg_chroma0 = reg_cog_vid_vcfg_chroma0_$q;
        reg_cog_vid_capr = reg_cog_vid_capr_$q;
        reg_cog_vid_snc0 = reg_cog_vid_snc0_$q;
        reg_cog_vid_snc1 = reg_cog_vid_snc1_$q;
        reg_cog_ctra_frequency = reg_cog_ctra_frequency_$q;
        reg_cog_ctra_phase = reg_cog_ctra_phase_$q;
        reg_cog_ctra_pllcounter = reg_cog_ctra_pllcounter_$q;
        reg_cog_ctra_ctrmode = reg_cog_ctra_ctrmode_$q;
        reg_cog_ctra_ctrplldiv = reg_cog_ctra_ctrplldiv_$q;
        reg_cog_ctra_ctrbpin = reg_cog_ctra_ctrbpin_$q;
        reg_cog_ctra_ctrapin = reg_cog_ctra_ctrapin_$q;
        reg_cog_ctra_delayed0 = reg_cog_ctra_delayed0_$q;
        reg_cog_ctra_delayed1 = reg_cog_ctra_delayed1_$q;
        reg_cog_ctra_pll_saved = reg_cog_ctra_pll_saved_$q;
        reg_cog_ctrb_frequency = reg_cog_ctrb_frequency_$q;
        reg_cog_ctrb_phase = reg_cog_ctrb_phase_$q;
        reg_cog_ctrb_pllcounter = reg_cog_ctrb_pllcounter_$q;
        reg_cog_ctrb_ctrmode = reg_cog_ctrb_ctrmode_$q;
        reg_cog_ctrb_ctrplldiv = reg_cog_ctrb_ctrplldiv_$q;
        reg_cog_ctrb_ctrbpin = reg_cog_ctrb_ctrbpin_$q;
        reg_cog_ctrb_ctrapin = reg_cog_ctrb_ctrapin_$q;
        reg_cog_ctrb_delayed0 = reg_cog_ctrb_delayed0_$q;
        reg_cog_ctrb_delayed1 = reg_cog_ctrb_delayed1_$q;
        reg_cog_ctrb_pll_saved = reg_cog_ctrb_pll_saved_$q;
        reg_cog_ram_q_reg = reg_cog_ram_q_reg_$q;
        reg_cog_ram_r = reg_cog_ram_r_$q;
        reg_cog_ram_r_$wi = 0;
        reg_cog_ram_r_$wr = 0;
        //code starts here
        i = (running?instruction_reg:(32'h8840000|((p_reg << 32'h9)&64'hFFFFFFFF)));
        instr_opcode = (((i >> 32'h1a)&64'hFFFFFFFF)&32'h3f);
        bus_r = 1'b0;
        bus_e = 1'b0;
        bus_w = 1'b0;
        bus_s = 32'h0;
        bus_a = 32'h0;
        bus_d = 32'h0;
        if (bus_sel) begin
            bus_r = running;
            bus_e = ((state==32'h5)&((instr_opcode&32'h3c)==32'h0));
            bus_w = (!((i>>32'h17)&1 != 0));
            bus_s = (instr_opcode&32'h3);
            bus_a = (running?(source&32'hffff):(((((((progctr&32'hfffff)+p_reg)&64'hFFFFFFFF) << 32'h2)&64'hFFFFFFFF)&32'hffff)|(source&32'h3)));
            bus_d = dest;
        end
        instr_dst = (((i >> 32'h9)&64'hFFFFFFFF)&32'h1ff);
        instr_src = (i&32'h1ff);
        in_cog_alu_ci = ((flags>>32'h1)&1 != 0);
        in_cog_alu_zi = ((flags>>32'h0)&1 != 0);
        outp_cog_alu_wr = 1'b1;
        case (instr_opcode)
            32'h0,32'h1,32'h2,32'h3,32'h4,32'h5,32'h6,32'h7: begin
                outp_cog_alu_r = ((running|((p_reg&32'h1f0)!=32'h1f0))?bus_q:32'h0);
                outp_cog_alu_co = bus_c;
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h8: begin
                outp_cog_alu_r = (((dest >> (source&32'h1f))&64'hFFFFFFFF)|((dest << ((32'h20-(source&32'h1f))&64'hFFFFFFFF))&64'hFFFFFFFF));
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
                outp_cog_alu_co = ((dest&32'h1)==32'h1);
            end
            32'h9: begin
                outp_cog_alu_r = (((dest << (source&32'h1f))&64'hFFFFFFFF)|((dest >> ((32'h20-(source&32'h1f))&64'hFFFFFFFF))&64'hFFFFFFFF));
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
                outp_cog_alu_co = ((dest&32'h80000000)!=32'h0);
            end
            32'ha: begin
                outp_cog_alu_r = ((dest >> (source&32'h1f))&64'hFFFFFFFF);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
                outp_cog_alu_co = ((dest&32'h1)==32'h1);
            end
            32'hb: begin
                outp_cog_alu_r = ((dest << (source&32'h1f))&64'hFFFFFFFF);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
                outp_cog_alu_co = ((dest&32'h80000000)!=32'h0);
            end
            32'hc: begin
                outp_cog_alu_r = ((dest >> (source&32'h1f))&64'hFFFFFFFF);
                if (in_cog_alu_ci) begin
                    outp_cog_alu_r = (outp_cog_alu_r|((32'hffffffff << ((32'h20-(source&32'h1f))&64'hFFFFFFFF))&64'hFFFFFFFF));
                end
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
                outp_cog_alu_co = ((dest&32'h1)==32'h1);
            end
            32'hd: begin
                outp_cog_alu_r = ((dest << (source&32'h1f))&64'hFFFFFFFF);
                if (in_cog_alu_ci) begin
                    outp_cog_alu_r = (outp_cog_alu_r|((32'hffffffff >> ((32'h20-(source&32'h1f))&64'hFFFFFFFF))&64'hFFFFFFFF));
                end
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
                outp_cog_alu_co = ((dest&32'h80000000)!=32'h0);
            end
            32'he: begin
                outp_cog_alu_r = ((dest >> (source&32'h1f))&64'hFFFFFFFF);
                if (((dest>>32'h1f)&1 != 0)) begin
                    outp_cog_alu_r = (outp_cog_alu_r|((32'hffffffff << ((32'h20-(source&32'h1f))&64'hFFFFFFFF))&64'hFFFFFFFF));
                end
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
                outp_cog_alu_co = ((dest&32'h1)==32'h1);
            end
            32'hf: begin
                outp_cog_alu_r = ((((dest&32'haaaaaaaa) >> 32'h1)&64'hFFFFFFFF)|(((dest&32'h55555555) << 32'h1)&64'hFFFFFFFF));
                outp_cog_alu_r = ((((outp_cog_alu_r&32'hcccccccc) >> 32'h2)&64'hFFFFFFFF)|(((outp_cog_alu_r&32'h33333333) << 32'h2)&64'hFFFFFFFF));
                outp_cog_alu_r = ((((outp_cog_alu_r&32'hf0f0f0f0) >> 32'h4)&64'hFFFFFFFF)|(((outp_cog_alu_r&32'hf0f0f0f) << 32'h4)&64'hFFFFFFFF));
                outp_cog_alu_r = ((((outp_cog_alu_r&32'hff00ff00) >> 32'h8)&64'hFFFFFFFF)|(((outp_cog_alu_r&32'hff00ff) << 32'h8)&64'hFFFFFFFF));
                outp_cog_alu_r = (((((outp_cog_alu_r >> 32'h10)&64'hFFFFFFFF)|((outp_cog_alu_r << 32'h10)&64'hFFFFFFFF)) >> (source&32'h1f))&64'hFFFFFFFF);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
                outp_cog_alu_co = ((dest&32'h1)==32'h1);
            end
            32'h10: begin
                outp_cog_alu_co = sgnle32(dest,source);
                outp_cog_alu_r = source;
                outp_cog_alu_wr = outp_cog_alu_co;
                outp_cog_alu_zo = (source==32'h0);
            end
            32'h11: begin
                outp_cog_alu_co = sgnle32(dest,source);
                outp_cog_alu_r = source;
                outp_cog_alu_wr = (!outp_cog_alu_co);
                outp_cog_alu_zo = (source==32'h0);
            end
            32'h12: begin
                outp_cog_alu_co = (dest<source);
                outp_cog_alu_r = source;
                outp_cog_alu_wr = outp_cog_alu_co;
                outp_cog_alu_zo = (source==32'h0);
            end
            32'h13: begin
                outp_cog_alu_co = (dest<source);
                outp_cog_alu_r = source;
                outp_cog_alu_wr = (!outp_cog_alu_co);
                outp_cog_alu_zo = (source==32'h0);
            end
            32'h14: begin
                outp_cog_alu_co = (dest<source);
                outp_cog_alu_r = ((dest&32'hfffffe00)|(source&32'h1ff));
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h15: begin
                outp_cog_alu_co = (dest<source);
                outp_cog_alu_r = ((dest&32'hfffc01ff)|(((source&32'h1ff) << 32'h9)&64'hFFFFFFFF));
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h16: begin
                outp_cog_alu_co = (dest<source);
                outp_cog_alu_r = ((dest&32'h7fffff)|(((source&32'h1ff) << 32'h17)&64'hFFFFFFFF));
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h17: begin
                outp_cog_alu_co = (dest<source);
                outp_cog_alu_r = ((dest&32'hfffffe00)|p_reg);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h18: begin
                outp_cog_alu_r = (dest&source);
                loc_cog_alu_tmpRes32 = (outp_cog_alu_r^((outp_cog_alu_r >> 32'h10)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h8)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h4)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h2)&64'hFFFFFFFF));
                outp_cog_alu_co = (((loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h1)&64'hFFFFFFFF))>>32'h0)&1 != 0);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h19: begin
                outp_cog_alu_r = (dest&((~source)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (outp_cog_alu_r^((outp_cog_alu_r >> 32'h10)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h8)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h4)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h2)&64'hFFFFFFFF));
                outp_cog_alu_co = (((loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h1)&64'hFFFFFFFF))>>32'h0)&1 != 0);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h1a: begin
                outp_cog_alu_r = (dest|source);
                loc_cog_alu_tmpRes32 = (outp_cog_alu_r^((outp_cog_alu_r >> 32'h10)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h8)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h4)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h2)&64'hFFFFFFFF));
                outp_cog_alu_co = (((loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h1)&64'hFFFFFFFF))>>32'h0)&1 != 0);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h1b: begin
                outp_cog_alu_r = (dest^source);
                loc_cog_alu_tmpRes32 = (outp_cog_alu_r^((outp_cog_alu_r >> 32'h10)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h8)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h4)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h2)&64'hFFFFFFFF));
                outp_cog_alu_co = (((loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h1)&64'hFFFFFFFF))>>32'h0)&1 != 0);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h1c: begin
                outp_cog_alu_r = (in_cog_alu_ci?(dest|source):(dest&((~source)&64'hFFFFFFFF)));
                loc_cog_alu_tmpRes32 = (outp_cog_alu_r^((outp_cog_alu_r >> 32'h10)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h8)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h4)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h2)&64'hFFFFFFFF));
                outp_cog_alu_co = (((loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h1)&64'hFFFFFFFF))>>32'h0)&1 != 0);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h1d: begin
                outp_cog_alu_r = ((!in_cog_alu_ci)?(dest|source):(dest&((~source)&64'hFFFFFFFF)));
                loc_cog_alu_tmpRes32 = (outp_cog_alu_r^((outp_cog_alu_r >> 32'h10)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h8)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h4)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h2)&64'hFFFFFFFF));
                outp_cog_alu_co = (((loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h1)&64'hFFFFFFFF))>>32'h0)&1 != 0);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h1e: begin
                outp_cog_alu_r = (in_cog_alu_zi?(dest|source):(dest&((~source)&64'hFFFFFFFF)));
                loc_cog_alu_tmpRes32 = (outp_cog_alu_r^((outp_cog_alu_r >> 32'h10)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h8)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h4)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h2)&64'hFFFFFFFF));
                outp_cog_alu_co = (((loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h1)&64'hFFFFFFFF))>>32'h0)&1 != 0);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h1f: begin
                outp_cog_alu_r = ((!in_cog_alu_zi)?(dest|source):(dest&((~source)&64'hFFFFFFFF)));
                loc_cog_alu_tmpRes32 = (outp_cog_alu_r^((outp_cog_alu_r >> 32'h10)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h8)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h4)&64'hFFFFFFFF));
                loc_cog_alu_tmpRes32 = (loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h2)&64'hFFFFFFFF));
                outp_cog_alu_co = (((loc_cog_alu_tmpRes32^((loc_cog_alu_tmpRes32 >> 32'h1)&64'hFFFFFFFF))>>32'h0)&1 != 0);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h20: begin
                loc_cog_alu_tmpRes64 = ((dest+source)&64'hFFFFFFFFFFFFFFFF);
                outp_cog_alu_r = (loc_cog_alu_tmpRes64 & 64'hFFFFFFFF);
                outp_cog_alu_co = ((loc_cog_alu_tmpRes64>>32'h20)&1 != 0);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h21: begin
                loc_cog_alu_tmpRes64 = ((dest-source)&64'hFFFFFFFFFFFFFFFF);
                outp_cog_alu_r = (loc_cog_alu_tmpRes64 & 64'hFFFFFFFF);
                outp_cog_alu_co = ((loc_cog_alu_tmpRes64>>32'h20)&1 != 0);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h22: begin
                if (((source>>32'h1f)&1 != 0)) begin
                    loc_cog_alu_tmpRes64 = ((dest+((32'h0-source)&64'hFFFFFFFF))&64'hFFFFFFFFFFFFFFFF);
                    outp_cog_alu_co = (!((loc_cog_alu_tmpRes64>>32'h20)&1 != 0));
                end
                else begin
                    loc_cog_alu_tmpRes64 = ((dest+source)&64'hFFFFFFFFFFFFFFFF);
                    outp_cog_alu_co = ((loc_cog_alu_tmpRes64>>32'h20)&1 != 0);
                end
                outp_cog_alu_r = (loc_cog_alu_tmpRes64 & 64'hFFFFFFFF);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h23: begin
                if (((source>>32'h1f)&1 != 0)) begin
                    loc_cog_alu_tmpRes64 = ((dest-((32'h0-source)&64'hFFFFFFFF))&64'hFFFFFFFFFFFFFFFF);
                    outp_cog_alu_co = (!((loc_cog_alu_tmpRes64>>32'h20)&1 != 0));
                end
                else begin
                    loc_cog_alu_tmpRes64 = ((dest-source)&64'hFFFFFFFFFFFFFFFF);
                    outp_cog_alu_co = ((loc_cog_alu_tmpRes64>>32'h20)&1 != 0);
                end
                outp_cog_alu_r = (loc_cog_alu_tmpRes64 & 64'hFFFFFFFF);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h24: begin
                loc_cog_alu_tmpRes64 = (((((((dest+64'h80000000)&64'hFFFFFFFFFFFFFFFF)&64'h17fffffff)+((((in_cog_alu_ci?((~source)&64'hFFFFFFFF):source)+64'h80000000)&64'hFFFFFFFFFFFFFFFF)&64'h17fffffff))&64'hFFFFFFFFFFFFFFFF)+(in_cog_alu_ci?32'h80000001:32'h80000000))&64'hFFFFFFFFFFFFFFFF);
                outp_cog_alu_co = (!((((((loc_cog_alu_tmpRes64 >> 32'h21)&64'hFFFFFFFFFFFFFFFF) & 64'hFFFFFFFF)^(((loc_cog_alu_tmpRes64 & 64'hFFFFFFFF) >> 32'h1f)&64'hFFFFFFFF))>>32'h0)&1 != 0));
                outp_cog_alu_r = (((((loc_cog_alu_tmpRes64 >> 32'h1)&64'hFFFFFFFFFFFFFFFF) & 64'hFFFFFFFF)&32'h80000000)|((loc_cog_alu_tmpRes64 & 64'hFFFFFFFF)&32'h7fffffff));
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h25: begin
                loc_cog_alu_tmpRes64 = (((((((dest+64'h80000000)&64'hFFFFFFFFFFFFFFFF)&64'h17fffffff)+((((in_cog_alu_ci?source:((~source)&64'hFFFFFFFF))+64'h80000000)&64'hFFFFFFFFFFFFFFFF)&64'h17fffffff))&64'hFFFFFFFFFFFFFFFF)+(in_cog_alu_ci?32'h80000000:32'h80000001))&64'hFFFFFFFFFFFFFFFF);
                outp_cog_alu_co = (!((((((loc_cog_alu_tmpRes64 >> 32'h21)&64'hFFFFFFFFFFFFFFFF) & 64'hFFFFFFFF)^(((loc_cog_alu_tmpRes64 & 64'hFFFFFFFF) >> 32'h1f)&64'hFFFFFFFF))>>32'h0)&1 != 0));
                outp_cog_alu_r = (((((loc_cog_alu_tmpRes64 >> 32'h1)&64'hFFFFFFFFFFFFFFFF) & 64'hFFFFFFFF)&32'h80000000)|((loc_cog_alu_tmpRes64 & 64'hFFFFFFFF)&32'h7fffffff));
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h26: begin
                loc_cog_alu_tmpRes64 = (((((((dest+64'h80000000)&64'hFFFFFFFFFFFFFFFF)&64'h17fffffff)+((((in_cog_alu_zi?((~source)&64'hFFFFFFFF):source)+64'h80000000)&64'hFFFFFFFFFFFFFFFF)&64'h17fffffff))&64'hFFFFFFFFFFFFFFFF)+(in_cog_alu_zi?32'h80000001:32'h80000000))&64'hFFFFFFFFFFFFFFFF);
                outp_cog_alu_co = (!((((((loc_cog_alu_tmpRes64 >> 32'h21)&64'hFFFFFFFFFFFFFFFF) & 64'hFFFFFFFF)^(((loc_cog_alu_tmpRes64 & 64'hFFFFFFFF) >> 32'h1f)&64'hFFFFFFFF))>>32'h0)&1 != 0));
                outp_cog_alu_r = (((((loc_cog_alu_tmpRes64 >> 32'h1)&64'hFFFFFFFFFFFFFFFF) & 64'hFFFFFFFF)&32'h80000000)|((loc_cog_alu_tmpRes64 & 64'hFFFFFFFF)&32'h7fffffff));
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h27: begin
                loc_cog_alu_tmpRes64 = (((((((dest+64'h80000000)&64'hFFFFFFFFFFFFFFFF)&64'h17fffffff)+((((in_cog_alu_zi?source:((~source)&64'hFFFFFFFF))+64'h80000000)&64'hFFFFFFFFFFFFFFFF)&64'h17fffffff))&64'hFFFFFFFFFFFFFFFF)+(in_cog_alu_zi?32'h80000000:32'h80000001))&64'hFFFFFFFFFFFFFFFF);
                outp_cog_alu_co = (!((((((loc_cog_alu_tmpRes64 >> 32'h21)&64'hFFFFFFFFFFFFFFFF) & 64'hFFFFFFFF)^(((loc_cog_alu_tmpRes64 & 64'hFFFFFFFF) >> 32'h1f)&64'hFFFFFFFF))>>32'h0)&1 != 0));
                outp_cog_alu_r = (((((loc_cog_alu_tmpRes64 >> 32'h1)&64'hFFFFFFFFFFFFFFFF) & 64'hFFFFFFFF)&32'h80000000)|((loc_cog_alu_tmpRes64 & 64'hFFFFFFFF)&32'h7fffffff));
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h28: begin
                outp_cog_alu_r = source;
                outp_cog_alu_zo = (source==32'h0);
                outp_cog_alu_co = ((source>>32'h1f)&1 != 0);
            end
            32'h29: begin
                outp_cog_alu_r = ((32'h0-source)&64'hFFFFFFFF);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
                outp_cog_alu_co = ((source>>32'h1f)&1 != 0);
            end
            32'h2a: begin
                outp_cog_alu_co = ((source>>32'h1f)&1 != 0);
                outp_cog_alu_r = (outp_cog_alu_co?((32'h0-source)&64'hFFFFFFFF):source);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h2b: begin
                outp_cog_alu_co = ((source>>32'h1f)&1 != 0);
                outp_cog_alu_r = (outp_cog_alu_co?source:((32'h0-source)&64'hFFFFFFFF));
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h2c: begin
                outp_cog_alu_r = (in_cog_alu_ci?((32'h0-source)&64'hFFFFFFFF):source);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
                outp_cog_alu_co = ((source>>32'h1f)&1 != 0);
            end
            32'h2d: begin
                outp_cog_alu_r = (in_cog_alu_ci?source:((32'h0-source)&64'hFFFFFFFF));
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
                outp_cog_alu_co = ((source>>32'h1f)&1 != 0);
            end
            32'h2e: begin
                outp_cog_alu_r = (in_cog_alu_zi?((32'h0-source)&64'hFFFFFFFF):source);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
                outp_cog_alu_co = ((source>>32'h1f)&1 != 0);
            end
            32'h2f: begin
                outp_cog_alu_r = (in_cog_alu_zi?source:((32'h0-source)&64'hFFFFFFFF));
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
                outp_cog_alu_co = ((source>>32'h1f)&1 != 0);
            end
            32'h30: begin
                loc_cog_alu_tmpRes64 = (((((((dest+64'h80000000)&64'hFFFFFFFFFFFFFFFF)&64'h17fffffff)+(((((~source)&64'hFFFFFFFF)+64'h80000000)&64'hFFFFFFFFFFFFFFFF)&64'h17fffffff))&64'hFFFFFFFFFFFFFFFF)+64'h80000001)&64'hFFFFFFFFFFFFFFFF);
                outp_cog_alu_r = (((((loc_cog_alu_tmpRes64 >> 32'h1)&64'hFFFFFFFFFFFFFFFF) & 64'hFFFFFFFF)&32'h80000000)|((loc_cog_alu_tmpRes64 & 64'hFFFFFFFF)&32'h7fffffff));
                outp_cog_alu_co = (((((outp_cog_alu_r >> 32'h1f)&64'hFFFFFFFF)&32'h1)==32'h1)!=(!((((((loc_cog_alu_tmpRes64 >> 32'h21)&64'hFFFFFFFFFFFFFFFF) & 64'hFFFFFFFF)^(((loc_cog_alu_tmpRes64 & 64'hFFFFFFFF) >> 32'h1f)&64'hFFFFFFFF))>>32'h0)&1 != 0)));
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h31: begin
                loc_cog_alu_tmpRes64 = (((((((dest+64'h80000000)&64'hFFFFFFFFFFFFFFFF)&64'h17fffffff)+(((((~source)&64'hFFFFFFFF)+64'h80000000)&64'hFFFFFFFFFFFFFFFF)&64'h17fffffff))&64'hFFFFFFFFFFFFFFFF)+(in_cog_alu_ci?32'h80000000:32'h80000001))&64'hFFFFFFFFFFFFFFFF);
                outp_cog_alu_r = (((((loc_cog_alu_tmpRes64 >> 32'h1)&64'hFFFFFFFFFFFFFFFF) & 64'hFFFFFFFF)&32'h80000000)|((loc_cog_alu_tmpRes64 & 64'hFFFFFFFF)&32'h7fffffff));
                outp_cog_alu_co = (((((outp_cog_alu_r >> 32'h1f)&64'hFFFFFFFF)&32'h1)==32'h1)!=(!((((((loc_cog_alu_tmpRes64 >> 32'h21)&64'hFFFFFFFFFFFFFFFF) & 64'hFFFFFFFF)^(((loc_cog_alu_tmpRes64 & 64'hFFFFFFFF) >> 32'h1f)&64'hFFFFFFFF))>>32'h0)&1 != 0)));
                outp_cog_alu_zo = (in_cog_alu_zi&(outp_cog_alu_r==32'h0));
            end
            32'h32: begin
                loc_cog_alu_tmpRes64 = ((dest+((source+(in_cog_alu_ci?32'h1:32'h0))&64'hFFFFFFFFFFFFFFFF))&64'hFFFFFFFFFFFFFFFF);
                outp_cog_alu_r = (loc_cog_alu_tmpRes64 & 64'hFFFFFFFF);
                outp_cog_alu_co = ((loc_cog_alu_tmpRes64>>32'h20)&1 != 0);
                outp_cog_alu_zo = (in_cog_alu_zi&(outp_cog_alu_r==32'h0));
            end
            32'h33: begin
                loc_cog_alu_tmpRes64 = ((dest-((source+(in_cog_alu_ci?32'h1:32'h0))&64'hFFFFFFFFFFFFFFFF))&64'hFFFFFFFFFFFFFFFF);
                outp_cog_alu_r = (loc_cog_alu_tmpRes64 & 64'hFFFFFFFF);
                outp_cog_alu_co = ((loc_cog_alu_tmpRes64>>32'h20)&1 != 0);
                outp_cog_alu_zo = (in_cog_alu_zi&(outp_cog_alu_r==32'h0));
            end
            32'h34: begin
                loc_cog_alu_tmpRes64 = (((((((dest+64'h80000000)&64'hFFFFFFFFFFFFFFFF)&64'h17fffffff)+(((source+64'h80000000)&64'hFFFFFFFFFFFFFFFF)&64'h17fffffff))&64'hFFFFFFFFFFFFFFFF)+64'h80000000)&64'hFFFFFFFFFFFFFFFF);
                outp_cog_alu_r = (((((loc_cog_alu_tmpRes64 >> 32'h1)&64'hFFFFFFFFFFFFFFFF) & 64'hFFFFFFFF)&32'h80000000)|((loc_cog_alu_tmpRes64 & 64'hFFFFFFFF)&32'h7fffffff));
                outp_cog_alu_co = (!((((((loc_cog_alu_tmpRes64 >> 32'h21)&64'hFFFFFFFFFFFFFFFF) & 64'hFFFFFFFF)^(((loc_cog_alu_tmpRes64 & 64'hFFFFFFFF) >> 32'h1f)&64'hFFFFFFFF))>>32'h0)&1 != 0));
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h35: begin
                loc_cog_alu_tmpRes64 = (((((((dest+64'h80000000)&64'hFFFFFFFFFFFFFFFF)&64'h17fffffff)+(((((~source)&64'hFFFFFFFF)+64'h80000000)&64'hFFFFFFFFFFFFFFFF)&64'h17fffffff))&64'hFFFFFFFFFFFFFFFF)+64'h80000001)&64'hFFFFFFFFFFFFFFFF);
                outp_cog_alu_r = (((((loc_cog_alu_tmpRes64 >> 32'h1)&64'hFFFFFFFFFFFFFFFF) & 64'hFFFFFFFF)&32'h80000000)|((loc_cog_alu_tmpRes64 & 64'hFFFFFFFF)&32'h7fffffff));
                outp_cog_alu_co = (!((((((loc_cog_alu_tmpRes64 >> 32'h21)&64'hFFFFFFFFFFFFFFFF) & 64'hFFFFFFFF)^(((loc_cog_alu_tmpRes64 & 64'hFFFFFFFF) >> 32'h1f)&64'hFFFFFFFF))>>32'h0)&1 != 0));
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h36: begin
                loc_cog_alu_tmpRes64 = (((((((dest+64'h80000000)&64'hFFFFFFFFFFFFFFFF)&64'h17fffffff)+(((source+64'h80000000)&64'hFFFFFFFFFFFFFFFF)&64'h17fffffff))&64'hFFFFFFFFFFFFFFFF)+(in_cog_alu_ci?32'h80000001:32'h80000000))&64'hFFFFFFFFFFFFFFFF);
                outp_cog_alu_r = (((((loc_cog_alu_tmpRes64 >> 32'h1)&64'hFFFFFFFFFFFFFFFF) & 64'hFFFFFFFF)&32'h80000000)|((loc_cog_alu_tmpRes64 & 64'hFFFFFFFF)&32'h7fffffff));
                outp_cog_alu_co = (!((((((loc_cog_alu_tmpRes64 >> 32'h21)&64'hFFFFFFFFFFFFFFFF) & 64'hFFFFFFFF)^(((loc_cog_alu_tmpRes64 & 64'hFFFFFFFF) >> 32'h1f)&64'hFFFFFFFF))>>32'h0)&1 != 0));
                outp_cog_alu_zo = (in_cog_alu_zi&(outp_cog_alu_r==32'h0));
            end
            32'h37: begin
                loc_cog_alu_tmpRes64 = (((((((dest+64'h80000000)&64'hFFFFFFFFFFFFFFFF)&64'h17fffffff)+(((((~source)&64'hFFFFFFFF)+64'h80000000)&64'hFFFFFFFFFFFFFFFF)&64'h17fffffff))&64'hFFFFFFFFFFFFFFFF)+(in_cog_alu_ci?32'h80000000:32'h80000001))&64'hFFFFFFFFFFFFFFFF);
                outp_cog_alu_r = (((((loc_cog_alu_tmpRes64 >> 32'h1)&64'hFFFFFFFFFFFFFFFF) & 64'hFFFFFFFF)&32'h80000000)|((loc_cog_alu_tmpRes64 & 64'hFFFFFFFF)&32'h7fffffff));
                outp_cog_alu_co = (!((((((loc_cog_alu_tmpRes64 >> 32'h21)&64'hFFFFFFFFFFFFFFFF) & 64'hFFFFFFFF)^(((loc_cog_alu_tmpRes64 & 64'hFFFFFFFF) >> 32'h1f)&64'hFFFFFFFF))>>32'h0)&1 != 0));
                outp_cog_alu_zo = (in_cog_alu_zi&(outp_cog_alu_r==32'h0));
            end
            32'h38: begin
                outp_cog_alu_r = (((dest-source)&64'hFFFFFFFFFFFFFFFF) & 64'hFFFFFFFF);
                outp_cog_alu_co = (source<=dest);
                outp_cog_alu_wr = outp_cog_alu_co;
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h39: begin
                outp_cog_alu_r = ((dest-32'h1)&64'hFFFFFFFF);
                outp_cog_alu_co = (dest==32'h0);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h3a: begin
                outp_cog_alu_r = dest;
                outp_cog_alu_co = 1'b0;
                outp_cog_alu_zo = (dest==32'h0);
            end
            32'h3b: begin
                outp_cog_alu_r = dest;
                outp_cog_alu_co = 1'b0;
                outp_cog_alu_zo = (dest==32'h0);
            end
            32'h3c: begin
                loc_cog_alu_tmpRes64 = ((dest+source)&64'hFFFFFFFFFFFFFFFF);
                outp_cog_alu_r = (loc_cog_alu_tmpRes64 & 64'hFFFFFFFF);
                outp_cog_alu_co = ((loc_cog_alu_tmpRes64>>32'h20)&1 != 0);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h3d: begin
                loc_cog_alu_tmpRes64 = ((dest+((source+64'h1)&64'hFFFFFFFFFFFFFFFF))&64'hFFFFFFFFFFFFFFFF);
                outp_cog_alu_r = (loc_cog_alu_tmpRes64 & 64'hFFFFFFFF);
                outp_cog_alu_co = ((loc_cog_alu_tmpRes64>>32'h20)&1 != 0);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h3e: begin
                loc_cog_alu_tmpRes64 = ((dest+source)&64'hFFFFFFFFFFFFFFFF);
                outp_cog_alu_r = (loc_cog_alu_tmpRes64 & 64'hFFFFFFFF);
                outp_cog_alu_co = ((loc_cog_alu_tmpRes64>>32'h20)&1 != 0);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
            32'h3f: begin
                loc_cog_alu_tmpRes64 = ((dest+source)&64'hFFFFFFFFFFFFFFFF);
                outp_cog_alu_r = (loc_cog_alu_tmpRes64 & 64'hFFFFFFFF);
                outp_cog_alu_co = ((loc_cog_alu_tmpRes64>>32'h20)&1 != 0);
                outp_cog_alu_zo = (outp_cog_alu_r==32'h0);
            end
        endcase
        assume (instr_opcode< 32'h40);
        cond = ((!cancel)&(((((((i >> 32'h12)&64'hFFFFFFFF)&32'hf) >> flags)&64'hFFFFFFFF)&32'h1)==32'h1));
        if (((state==32'h3)|(state==32'h4))) begin
            jump = 1'b1;
            if ((instr_opcode==32'h17)) begin
                jump_cancel = 1'b0;
            end
            else begin
                if ((instr_opcode==32'h39)) begin
                    jump_cancel = (dest==32'h1);
                end
                else begin
                    if ((instr_opcode==32'h3a)) begin
                        jump_cancel = (dest==32'h0);
                    end
                    else begin
                        if ((instr_opcode==32'h3b)) begin
                            jump_cancel = (dest!=32'h0);
                        end
                        else begin
                            jump = 1'b0;
                        end
                    end
                end
            end
            wio = (((state==32'h4)&cond)&((i>>32'h17)&1 != 0));
        end
        outp_cog_ctra_phs = reg_cog_ctra_phase;
        outp_cog_ctra_pin_out = 32'h0;
        case (reg_cog_ctra_ctrmode)
            32'h0: begin
            end
            32'h1: begin
                if (posedge_clk_pll) begin
                    reg_cog_ctra_pllcounter = (((reg_cog_ctra_pllcounter+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if (posedge_clk_cog) begin
                    reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h2: begin
                if (reg_cog_ctra_pll_saved) begin
                    outp_cog_ctra_pin_out = ((32'h1 << reg_cog_ctra_ctrapin)&64'hFFFFFFFF);
                end
                if (posedge_clk_pll) begin
                    reg_cog_ctra_pllcounter = (((reg_cog_ctra_pllcounter+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if (posedge_clk_cog) begin
                    reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h3: begin
                outp_cog_ctra_pin_out = ((32'h1 << (reg_cog_ctra_pll_saved?reg_cog_ctra_ctrapin:reg_cog_ctra_ctrbpin))&64'hFFFFFFFF);
                if (posedge_clk_pll) begin
                    reg_cog_ctra_pllcounter = (((reg_cog_ctra_pllcounter+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if (posedge_clk_cog) begin
                    reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h4: begin
                if (((reg_cog_ctra_phase>>32'h1f)&1 != 0)) begin
                    outp_cog_ctra_pin_out = ((32'h1 << reg_cog_ctra_ctrapin)&64'hFFFFFFFF);
                end
                if (posedge_clk_cog) begin
                    reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h5: begin
                outp_cog_ctra_pin_out = ((32'h1 << (((reg_cog_ctra_phase>>32'h1f)&1 != 0)?reg_cog_ctra_ctrapin:reg_cog_ctra_ctrbpin))&64'hFFFFFFFF);
                if (posedge_clk_pll) begin
                    reg_cog_ctra_pllcounter = (((reg_cog_ctra_pllcounter+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if (posedge_clk_cog) begin
                    reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h6: begin
                if (((reg_cog_ctra_phase>>32'h20)&1 != 0)) begin
                    outp_cog_ctra_pin_out = ((32'h1 << reg_cog_ctra_ctrapin)&64'hFFFFFFFF);
                end
                if (posedge_clk_pll) begin
                    reg_cog_ctra_pllcounter = (((reg_cog_ctra_pllcounter+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if (posedge_clk_cog) begin
                    reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h7: begin
                outp_cog_ctra_pin_out = ((32'h1 << (((reg_cog_ctra_phase>>32'h20)&1 != 0)?reg_cog_ctra_ctrapin:reg_cog_ctra_ctrbpin))&64'hFFFFFFFF);
                if (posedge_clk_pll) begin
                    reg_cog_ctra_pllcounter = (((reg_cog_ctra_pllcounter+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if (posedge_clk_cog) begin
                    reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h8: begin
                if (posedge_clk_cog) begin
                    if (reg_cog_ctra_delayed0) begin
                        reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                    end
                    reg_cog_ctra_delayed1 = reg_cog_ctra_delayed0;
                    reg_cog_ctra_delayed0 = ((((pin_in >> reg_cog_ctra_ctrapin)&64'hFFFFFFFF)&32'h1)==32'h1);
                end
            end
            32'h9: begin
                if (posedge_clk_pll) begin
                    reg_cog_ctra_pllcounter = (((reg_cog_ctra_pllcounter+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if (reg_cog_ctra_delayed0) begin
                end
                else begin
                    outp_cog_ctra_pin_out = ((32'h1 << reg_cog_ctra_ctrbpin)&64'hFFFFFFFF);
                end
                if (posedge_clk_cog) begin
                    if (reg_cog_ctra_delayed0) begin
                        reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                    end
                    reg_cog_ctra_delayed1 = reg_cog_ctra_delayed0;
                    reg_cog_ctra_delayed0 = ((((pin_in >> reg_cog_ctra_ctrapin)&64'hFFFFFFFF)&32'h1)==32'h1);
                end
            end
            32'ha: begin
                if (posedge_clk_pll) begin
                    reg_cog_ctra_pllcounter = (((reg_cog_ctra_pllcounter+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if (posedge_clk_cog) begin
                    if ((reg_cog_ctra_delayed0&(!reg_cog_ctra_delayed1))) begin
                        reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                    end
                    reg_cog_ctra_delayed1 = reg_cog_ctra_delayed0;
                    reg_cog_ctra_delayed0 = ((((pin_in >> reg_cog_ctra_ctrapin)&64'hFFFFFFFF)&32'h1)==32'h1);
                end
            end
            32'hb: begin
                if (posedge_clk_pll) begin
                    reg_cog_ctra_pllcounter = (((reg_cog_ctra_pllcounter+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if (reg_cog_ctra_delayed0) begin
                end
                else begin
                    outp_cog_ctra_pin_out = ((32'h1 << reg_cog_ctra_ctrbpin)&64'hFFFFFFFF);
                end
                if (posedge_clk_cog) begin
                    if ((reg_cog_ctra_delayed0&(!reg_cog_ctra_delayed1))) begin
                        reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                    end
                    reg_cog_ctra_delayed1 = reg_cog_ctra_delayed0;
                    reg_cog_ctra_delayed0 = ((((pin_in >> reg_cog_ctra_ctrapin)&64'hFFFFFFFF)&32'h1)==32'h1);
                end
            end
            32'hc: begin
                if (posedge_clk_cog) begin
                    if (reg_cog_ctra_delayed0) begin
                    end
                    else begin
                        reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                    end
                    reg_cog_ctra_delayed1 = reg_cog_ctra_delayed0;
                    reg_cog_ctra_delayed0 = ((((pin_in >> reg_cog_ctra_ctrapin)&64'hFFFFFFFF)&32'h1)==32'h1);
                end
            end
            32'hd: begin
                if (posedge_clk_pll) begin
                    reg_cog_ctra_pllcounter = (((reg_cog_ctra_pllcounter+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if (reg_cog_ctra_delayed0) begin
                end
                else begin
                    outp_cog_ctra_pin_out = ((32'h1 << reg_cog_ctra_ctrbpin)&64'hFFFFFFFF);
                end
                if (posedge_clk_cog) begin
                    if (reg_cog_ctra_delayed0) begin
                    end
                    else begin
                        reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                    end
                    reg_cog_ctra_delayed1 = reg_cog_ctra_delayed0;
                    reg_cog_ctra_delayed0 = ((((pin_in >> reg_cog_ctra_ctrapin)&64'hFFFFFFFF)&32'h1)==32'h1);
                end
            end
            32'he: begin
                if (posedge_clk_pll) begin
                    reg_cog_ctra_pllcounter = (((reg_cog_ctra_pllcounter+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if (posedge_clk_cog) begin
                    if (((!reg_cog_ctra_delayed0)&reg_cog_ctra_delayed1)) begin
                        reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                    end
                    reg_cog_ctra_delayed1 = reg_cog_ctra_delayed0;
                    reg_cog_ctra_delayed0 = ((((pin_in >> reg_cog_ctra_ctrapin)&64'hFFFFFFFF)&32'h1)==32'h1);
                end
            end
            32'hf: begin
                if (posedge_clk_pll) begin
                    reg_cog_ctra_pllcounter = (((reg_cog_ctra_pllcounter+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if (reg_cog_ctra_delayed0) begin
                end
                else begin
                    outp_cog_ctra_pin_out = ((32'h1 << reg_cog_ctra_ctrbpin)&64'hFFFFFFFF);
                end
                if (posedge_clk_cog) begin
                    if (((!reg_cog_ctra_delayed0)&reg_cog_ctra_delayed1)) begin
                        reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                    end
                    reg_cog_ctra_delayed1 = reg_cog_ctra_delayed0;
                    reg_cog_ctra_delayed0 = ((((pin_in >> reg_cog_ctra_ctrapin)&64'hFFFFFFFF)&32'h1)==32'h1);
                end
            end
            32'h10: begin
            end
            32'h11: begin
                if (posedge_clk_pll) begin
                    reg_cog_ctra_pllcounter = (((reg_cog_ctra_pllcounter+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if ((posedge_clk_cog&((!reg_cog_ctra_delayed1)&(!reg_cog_ctra_delayed0)))) begin
                    reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h12: begin
                if (posedge_clk_pll) begin
                    reg_cog_ctra_pllcounter = (((reg_cog_ctra_pllcounter+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if ((posedge_clk_cog&((!reg_cog_ctra_delayed1)&reg_cog_ctra_delayed0))) begin
                    reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h13: begin
                if (posedge_clk_pll) begin
                    reg_cog_ctra_pllcounter = (((reg_cog_ctra_pllcounter+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if ((posedge_clk_cog&(!reg_cog_ctra_delayed1))) begin
                    reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h14: begin
                if ((posedge_clk_cog&(reg_cog_ctra_delayed1&(!reg_cog_ctra_delayed0)))) begin
                    reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h15: begin
                if (posedge_clk_pll) begin
                    reg_cog_ctra_pllcounter = (((reg_cog_ctra_pllcounter+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if ((posedge_clk_cog&(!reg_cog_ctra_delayed0))) begin
                    reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h16: begin
                if (posedge_clk_pll) begin
                    reg_cog_ctra_pllcounter = (((reg_cog_ctra_pllcounter+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if ((posedge_clk_cog&(reg_cog_ctra_delayed1!=reg_cog_ctra_delayed0))) begin
                    reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h17: begin
                if (posedge_clk_pll) begin
                    reg_cog_ctra_pllcounter = (((reg_cog_ctra_pllcounter+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if ((posedge_clk_cog&(!(reg_cog_ctra_delayed1&reg_cog_ctra_delayed0)))) begin
                    reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h18: begin
                if ((posedge_clk_cog&(reg_cog_ctra_delayed1&reg_cog_ctra_delayed0))) begin
                    reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h19: begin
                if (posedge_clk_pll) begin
                    reg_cog_ctra_pllcounter = (((reg_cog_ctra_pllcounter+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if ((posedge_clk_cog&(reg_cog_ctra_delayed1==reg_cog_ctra_delayed0))) begin
                    reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h1a: begin
                if (posedge_clk_pll) begin
                    reg_cog_ctra_pllcounter = (((reg_cog_ctra_pllcounter+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if ((posedge_clk_cog&reg_cog_ctra_delayed0)) begin
                    reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h1b: begin
                if (posedge_clk_pll) begin
                    reg_cog_ctra_pllcounter = (((reg_cog_ctra_pllcounter+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if ((posedge_clk_cog&(reg_cog_ctra_delayed0|(!reg_cog_ctra_delayed1)))) begin
                    reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h1c: begin
                if ((posedge_clk_cog&reg_cog_ctra_delayed1)) begin
                    reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h1d: begin
                if ((posedge_clk_cog&((!reg_cog_ctra_delayed0)|reg_cog_ctra_delayed1))) begin
                    reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h1e: begin
                if ((posedge_clk_cog&(reg_cog_ctra_delayed0|reg_cog_ctra_delayed1))) begin
                    reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h1f: begin
                if (posedge_clk_cog) begin
                    reg_cog_ctra_phase = (((reg_cog_ctra_phase&64'hffffffff)+reg_cog_ctra_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
        endcase
        assume (reg_cog_ctra_ctrmode< 32'h20);
        if ((reg_cog_ctra_ctrmode>=32'h10)) begin
            if (posedge_clk_cog) begin
                reg_cog_ctra_delayed0 = ((((pin_in >> reg_cog_ctra_ctrapin)&64'hFFFFFFFF)&32'h1)==32'h1);
                reg_cog_ctra_delayed1 = ((((pin_in >> reg_cog_ctra_ctrbpin)&64'hFFFFFFFF)&32'h1)==32'h1);
            end
        end
        if (posedge_clk_cog) begin
            if ((wio&(instr_dst==32'h1fc))) begin
                reg_cog_ctra_phase = outp_cog_alu_r;
            end
            if ((wio&(instr_dst==32'h1fa))) begin
                reg_cog_ctra_frequency = outp_cog_alu_r;
            end
        end
        if ((posedge_clk_cog|negedge_ena)) begin
            if (ena) begin
                if ((wio&(instr_dst==32'h1f8))) begin
                    reg_cog_ctra_ctrmode = (((outp_cog_alu_r >> 32'h1a)&64'hFFFFFFFF)&32'h3f);
                    reg_cog_ctra_ctrplldiv = (((outp_cog_alu_r >> 32'h17)&64'hFFFFFFFF)&32'h7);
                    reg_cog_ctra_ctrbpin = (((outp_cog_alu_r >> 32'h9)&64'hFFFFFFFF)&32'h1f);
                    reg_cog_ctra_ctrapin = (outp_cog_alu_r&32'h1f);
                end
            end
            else begin
                reg_cog_ctra_ctrmode = 32'h0;
                reg_cog_ctra_ctrplldiv = 32'h0;
                reg_cog_ctra_ctrbpin = 32'h0;
                reg_cog_ctra_ctrapin = 32'h0;
            end
        end
        outp_cog_ctrb_phs = reg_cog_ctrb_phase;
        outp_cog_ctrb_pin_out = 32'h0;
        case (reg_cog_ctrb_ctrmode)
            32'h0: begin
            end
            32'h1: begin
                if (posedge_clk_pll) begin
                    reg_cog_ctrb_pllcounter = (((reg_cog_ctrb_pllcounter+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if (posedge_clk_cog) begin
                    reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h2: begin
                if (reg_cog_ctrb_pll_saved) begin
                    outp_cog_ctrb_pin_out = ((32'h1 << reg_cog_ctrb_ctrapin)&64'hFFFFFFFF);
                end
                if (posedge_clk_pll) begin
                    reg_cog_ctrb_pllcounter = (((reg_cog_ctrb_pllcounter+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if (posedge_clk_cog) begin
                    reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h3: begin
                outp_cog_ctrb_pin_out = ((32'h1 << (reg_cog_ctrb_pll_saved?reg_cog_ctrb_ctrapin:reg_cog_ctrb_ctrbpin))&64'hFFFFFFFF);
                if (posedge_clk_pll) begin
                    reg_cog_ctrb_pllcounter = (((reg_cog_ctrb_pllcounter+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if (posedge_clk_cog) begin
                    reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h4: begin
                if (((reg_cog_ctrb_phase>>32'h1f)&1 != 0)) begin
                    outp_cog_ctrb_pin_out = ((32'h1 << reg_cog_ctrb_ctrapin)&64'hFFFFFFFF);
                end
                if (posedge_clk_cog) begin
                    reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h5: begin
                outp_cog_ctrb_pin_out = ((32'h1 << (((reg_cog_ctrb_phase>>32'h1f)&1 != 0)?reg_cog_ctrb_ctrapin:reg_cog_ctrb_ctrbpin))&64'hFFFFFFFF);
                if (posedge_clk_pll) begin
                    reg_cog_ctrb_pllcounter = (((reg_cog_ctrb_pllcounter+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if (posedge_clk_cog) begin
                    reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h6: begin
                if (((reg_cog_ctrb_phase>>32'h20)&1 != 0)) begin
                    outp_cog_ctrb_pin_out = ((32'h1 << reg_cog_ctrb_ctrapin)&64'hFFFFFFFF);
                end
                if (posedge_clk_pll) begin
                    reg_cog_ctrb_pllcounter = (((reg_cog_ctrb_pllcounter+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if (posedge_clk_cog) begin
                    reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h7: begin
                outp_cog_ctrb_pin_out = ((32'h1 << (((reg_cog_ctrb_phase>>32'h20)&1 != 0)?reg_cog_ctrb_ctrapin:reg_cog_ctrb_ctrbpin))&64'hFFFFFFFF);
                if (posedge_clk_pll) begin
                    reg_cog_ctrb_pllcounter = (((reg_cog_ctrb_pllcounter+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if (posedge_clk_cog) begin
                    reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h8: begin
                if (posedge_clk_cog) begin
                    if (reg_cog_ctrb_delayed0) begin
                        reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                    end
                    reg_cog_ctrb_delayed1 = reg_cog_ctrb_delayed0;
                    reg_cog_ctrb_delayed0 = ((((pin_in >> reg_cog_ctrb_ctrapin)&64'hFFFFFFFF)&32'h1)==32'h1);
                end
            end
            32'h9: begin
                if (posedge_clk_pll) begin
                    reg_cog_ctrb_pllcounter = (((reg_cog_ctrb_pllcounter+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if (reg_cog_ctrb_delayed0) begin
                end
                else begin
                    outp_cog_ctrb_pin_out = ((32'h1 << reg_cog_ctrb_ctrbpin)&64'hFFFFFFFF);
                end
                if (posedge_clk_cog) begin
                    if (reg_cog_ctrb_delayed0) begin
                        reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                    end
                    reg_cog_ctrb_delayed1 = reg_cog_ctrb_delayed0;
                    reg_cog_ctrb_delayed0 = ((((pin_in >> reg_cog_ctrb_ctrapin)&64'hFFFFFFFF)&32'h1)==32'h1);
                end
            end
            32'ha: begin
                if (posedge_clk_pll) begin
                    reg_cog_ctrb_pllcounter = (((reg_cog_ctrb_pllcounter+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if (posedge_clk_cog) begin
                    if ((reg_cog_ctrb_delayed0&(!reg_cog_ctrb_delayed1))) begin
                        reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                    end
                    reg_cog_ctrb_delayed1 = reg_cog_ctrb_delayed0;
                    reg_cog_ctrb_delayed0 = ((((pin_in >> reg_cog_ctrb_ctrapin)&64'hFFFFFFFF)&32'h1)==32'h1);
                end
            end
            32'hb: begin
                if (posedge_clk_pll) begin
                    reg_cog_ctrb_pllcounter = (((reg_cog_ctrb_pllcounter+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if (reg_cog_ctrb_delayed0) begin
                end
                else begin
                    outp_cog_ctrb_pin_out = ((32'h1 << reg_cog_ctrb_ctrbpin)&64'hFFFFFFFF);
                end
                if (posedge_clk_cog) begin
                    if ((reg_cog_ctrb_delayed0&(!reg_cog_ctrb_delayed1))) begin
                        reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                    end
                    reg_cog_ctrb_delayed1 = reg_cog_ctrb_delayed0;
                    reg_cog_ctrb_delayed0 = ((((pin_in >> reg_cog_ctrb_ctrapin)&64'hFFFFFFFF)&32'h1)==32'h1);
                end
            end
            32'hc: begin
                if (posedge_clk_cog) begin
                    if (reg_cog_ctrb_delayed0) begin
                    end
                    else begin
                        reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                    end
                    reg_cog_ctrb_delayed1 = reg_cog_ctrb_delayed0;
                    reg_cog_ctrb_delayed0 = ((((pin_in >> reg_cog_ctrb_ctrapin)&64'hFFFFFFFF)&32'h1)==32'h1);
                end
            end
            32'hd: begin
                if (posedge_clk_pll) begin
                    reg_cog_ctrb_pllcounter = (((reg_cog_ctrb_pllcounter+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if (reg_cog_ctrb_delayed0) begin
                end
                else begin
                    outp_cog_ctrb_pin_out = ((32'h1 << reg_cog_ctrb_ctrbpin)&64'hFFFFFFFF);
                end
                if (posedge_clk_cog) begin
                    if (reg_cog_ctrb_delayed0) begin
                    end
                    else begin
                        reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                    end
                    reg_cog_ctrb_delayed1 = reg_cog_ctrb_delayed0;
                    reg_cog_ctrb_delayed0 = ((((pin_in >> reg_cog_ctrb_ctrapin)&64'hFFFFFFFF)&32'h1)==32'h1);
                end
            end
            32'he: begin
                if (posedge_clk_pll) begin
                    reg_cog_ctrb_pllcounter = (((reg_cog_ctrb_pllcounter+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if (posedge_clk_cog) begin
                    if (((!reg_cog_ctrb_delayed0)&reg_cog_ctrb_delayed1)) begin
                        reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                    end
                    reg_cog_ctrb_delayed1 = reg_cog_ctrb_delayed0;
                    reg_cog_ctrb_delayed0 = ((((pin_in >> reg_cog_ctrb_ctrapin)&64'hFFFFFFFF)&32'h1)==32'h1);
                end
            end
            32'hf: begin
                if (posedge_clk_pll) begin
                    reg_cog_ctrb_pllcounter = (((reg_cog_ctrb_pllcounter+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if (reg_cog_ctrb_delayed0) begin
                end
                else begin
                    outp_cog_ctrb_pin_out = ((32'h1 << reg_cog_ctrb_ctrbpin)&64'hFFFFFFFF);
                end
                if (posedge_clk_cog) begin
                    if (((!reg_cog_ctrb_delayed0)&reg_cog_ctrb_delayed1)) begin
                        reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                    end
                    reg_cog_ctrb_delayed1 = reg_cog_ctrb_delayed0;
                    reg_cog_ctrb_delayed0 = ((((pin_in >> reg_cog_ctrb_ctrapin)&64'hFFFFFFFF)&32'h1)==32'h1);
                end
            end
            32'h10: begin
            end
            32'h11: begin
                if (posedge_clk_pll) begin
                    reg_cog_ctrb_pllcounter = (((reg_cog_ctrb_pllcounter+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if ((posedge_clk_cog&((!reg_cog_ctrb_delayed1)&(!reg_cog_ctrb_delayed0)))) begin
                    reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h12: begin
                if (posedge_clk_pll) begin
                    reg_cog_ctrb_pllcounter = (((reg_cog_ctrb_pllcounter+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if ((posedge_clk_cog&((!reg_cog_ctrb_delayed1)&reg_cog_ctrb_delayed0))) begin
                    reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h13: begin
                if (posedge_clk_pll) begin
                    reg_cog_ctrb_pllcounter = (((reg_cog_ctrb_pllcounter+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if ((posedge_clk_cog&(!reg_cog_ctrb_delayed1))) begin
                    reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h14: begin
                if ((posedge_clk_cog&(reg_cog_ctrb_delayed1&(!reg_cog_ctrb_delayed0)))) begin
                    reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h15: begin
                if (posedge_clk_pll) begin
                    reg_cog_ctrb_pllcounter = (((reg_cog_ctrb_pllcounter+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if ((posedge_clk_cog&(!reg_cog_ctrb_delayed0))) begin
                    reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h16: begin
                if (posedge_clk_pll) begin
                    reg_cog_ctrb_pllcounter = (((reg_cog_ctrb_pllcounter+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if ((posedge_clk_cog&(reg_cog_ctrb_delayed1!=reg_cog_ctrb_delayed0))) begin
                    reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h17: begin
                if (posedge_clk_pll) begin
                    reg_cog_ctrb_pllcounter = (((reg_cog_ctrb_pllcounter+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if ((posedge_clk_cog&(!(reg_cog_ctrb_delayed1&reg_cog_ctrb_delayed0)))) begin
                    reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h18: begin
                if ((posedge_clk_cog&(reg_cog_ctrb_delayed1&reg_cog_ctrb_delayed0))) begin
                    reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h19: begin
                if (posedge_clk_pll) begin
                    reg_cog_ctrb_pllcounter = (((reg_cog_ctrb_pllcounter+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if ((posedge_clk_cog&(reg_cog_ctrb_delayed1==reg_cog_ctrb_delayed0))) begin
                    reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h1a: begin
                if (posedge_clk_pll) begin
                    reg_cog_ctrb_pllcounter = (((reg_cog_ctrb_pllcounter+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if ((posedge_clk_cog&reg_cog_ctrb_delayed0)) begin
                    reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h1b: begin
                if (posedge_clk_pll) begin
                    reg_cog_ctrb_pllcounter = (((reg_cog_ctrb_pllcounter+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF)&64'hfffffffff);
                end
                if ((posedge_clk_cog&(reg_cog_ctrb_delayed0|(!reg_cog_ctrb_delayed1)))) begin
                    reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h1c: begin
                if ((posedge_clk_cog&reg_cog_ctrb_delayed1)) begin
                    reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h1d: begin
                if ((posedge_clk_cog&((!reg_cog_ctrb_delayed0)|reg_cog_ctrb_delayed1))) begin
                    reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h1e: begin
                if ((posedge_clk_cog&(reg_cog_ctrb_delayed0|reg_cog_ctrb_delayed1))) begin
                    reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
            32'h1f: begin
                if (posedge_clk_cog) begin
                    reg_cog_ctrb_phase = (((reg_cog_ctrb_phase&64'hffffffff)+reg_cog_ctrb_frequency)&64'hFFFFFFFFFFFFFFFF);
                end
            end
        endcase
        assume (reg_cog_ctrb_ctrmode< 32'h20);
        if ((reg_cog_ctrb_ctrmode>=32'h10)) begin
            if (posedge_clk_cog) begin
                reg_cog_ctrb_delayed0 = ((((pin_in >> reg_cog_ctrb_ctrapin)&64'hFFFFFFFF)&32'h1)==32'h1);
                reg_cog_ctrb_delayed1 = ((((pin_in >> reg_cog_ctrb_ctrbpin)&64'hFFFFFFFF)&32'h1)==32'h1);
            end
        end
        if (posedge_clk_cog) begin
            if ((wio&(instr_dst==32'h1fd))) begin
                reg_cog_ctrb_phase = outp_cog_alu_r;
            end
            if ((wio&(instr_dst==32'h1fb))) begin
                reg_cog_ctrb_frequency = outp_cog_alu_r;
            end
        end
        if ((posedge_clk_cog|negedge_ena)) begin
            if (ena) begin
                if ((wio&(instr_dst==32'h1f9))) begin
                    reg_cog_ctrb_ctrmode = (((outp_cog_alu_r >> 32'h1a)&64'hFFFFFFFF)&32'h3f);
                    reg_cog_ctrb_ctrplldiv = (((outp_cog_alu_r >> 32'h17)&64'hFFFFFFFF)&32'h7);
                    reg_cog_ctrb_ctrbpin = (((outp_cog_alu_r >> 32'h9)&64'hFFFFFFFF)&32'h1f);
                    reg_cog_ctrb_ctrapin = (outp_cog_alu_r&32'h1f);
                end
            end
            else begin
                reg_cog_ctrb_ctrmode = 32'h0;
                reg_cog_ctrb_ctrplldiv = 32'h0;
                reg_cog_ctrb_ctrbpin = 32'h0;
                reg_cog_ctrb_ctrapin = 32'h0;
            end
        end
        if (((state==32'h3)|(state==32'h4))) begin
            sx = (((i>>32'h16)&1 != 0)?instr_src:((instr_src==32'h1f0)?(((progctr >> 32'hc)&64'hFFFFFFFF)&32'hfffc):((instr_src==32'h1f1)?cnt:((instr_src==32'h1f2)?pin_in:((instr_src==32'h1fc)?(outp_cog_ctra_phs & 64'hFFFFFFFF):((instr_src==32'h1fd)?(outp_cog_ctrb_phs & 64'hFFFFFFFF):sy_reg))))));
            px = (((cond&jump)?sx:p_reg)&32'h1ff);
        end
        loc_cog_vid_local_enable = (reg_cog_vid_vcfg_vmode!=32'h0);
        loc_cog_vid_local_capr_next = reg_cog_vid_capr;
        outp_cog_vid_ack = reg_cog_vid_snc0;
        case (reg_cog_vid_vcfg_vmode)
            32'h3: begin
                outp_cog_vid_pin_out = (((((((((reg_cog_vid_baseband << 32'h4)&64'hFFFFFFFF)+((pllb_saved!=((pll_in>>reg_cog_vid_vcfg_auralsub)&1 != 0))?32'h8:32'h0))&64'hFFFFFFFF)+(pllb_saved?((32'h7-((((reg_cog_vid_composite+32'h1)&64'hFFFFFFFF) >> 32'h1)&64'hFFFFFFFF))&64'hFFFFFFFF):(((reg_cog_vid_composite >> 32'h1)&64'hFFFFFFFF)&32'h3)))&64'hFFFFFFFF)&reg_cog_vid_vcfg_vpins) << reg_cog_vid_vcfg_vgroup)&64'hFFFFFFFF);
            end
            32'h2: begin
                outp_cog_vid_pin_out = (((((((reg_cog_vid_baseband+((pllb_saved!=((pll_in>>reg_cog_vid_vcfg_auralsub)&1 != 0))?32'h80:32'h0))&64'hFFFFFFFF)+(((pllb_saved?((32'h7-((((reg_cog_vid_composite+32'h1)&64'hFFFFFFFF) >> 32'h1)&64'hFFFFFFFF))&64'hFFFFFFFF):(((reg_cog_vid_composite >> 32'h1)&64'hFFFFFFFF)&32'h3)) << 32'h4)&64'hFFFFFFFF))&64'hFFFFFFFF)&reg_cog_vid_vcfg_vpins) << reg_cog_vid_vcfg_vgroup)&64'hFFFFFFFF);
            end
            32'h1: begin
                outp_cog_vid_pin_out = (((reg_cog_vid_discrete&reg_cog_vid_vcfg_vpins) << reg_cog_vid_vcfg_vgroup)&64'hFFFFFFFF);
            end
            32'h0: begin
                outp_cog_vid_pin_out = 32'h0;
            end
        endcase
        assume (reg_cog_vid_vcfg_vmode< 32'h4);
        if ((posedge_vclk|posedge_snc1)) begin
            loc_cog_vid_local_new_set = (reg_cog_vid_setr==32'h1);
            loc_cog_vid_local_new_cnt = (reg_cog_vid_cnt0==32'h1);
            if (reg_cog_vid_snc1) begin
                loc_cog_vid_local_capr_next = 1'b0;
            end
            else begin
                if (loc_cog_vid_local_new_set) begin
                    loc_cog_vid_local_capr_next = 1'b1;
                end
            end
            if (posedge_vclk) begin
                loc_cog_vid_local_colorphs = 1'b0;
                loc_cog_vid_local_colormod = reg_cog_vid_discrete;
                if (((reg_cog_vid_discrete&32'h8)!=32'h0)) begin
                    loc_cog_vid_local_colorphs = (((((((reg_cog_vid_discrete >> 32'h4)&64'hFFFFFFFF)&32'hf)+reg_cog_vid_phase)&64'hFFFFFFFF)&32'h8)!=32'h0);
                    loc_cog_vid_local_colormod = ((reg_cog_vid_discrete+(loc_cog_vid_local_colorphs?32'h7:32'h1))&64'hFFFFFFFF);
                end
                reg_cog_vid_cnt0 = ((loc_cog_vid_local_new_set?reg_cog_vid_vscl_pixelclocks:(loc_cog_vid_local_new_cnt?reg_cog_vid_cnts:((reg_cog_vid_cnt0-32'h1)&64'hFFFFFFFF)))&32'hff);
                reg_cog_vid_setr = ((loc_cog_vid_local_new_set?reg_cog_vid_vscl_frameclocks:((reg_cog_vid_setr-32'h1)&64'hFFFFFFFF))&32'hfff);
                if (loc_cog_vid_local_new_set) begin
                    reg_cog_vid_cnts = (reg_cog_vid_vscl_pixelclocks&32'hff);
                end
                reg_cog_vid_phase = (((reg_cog_vid_phase+32'h1)&64'hFFFFFFFF)&32'hf);
                reg_cog_vid_baseband = (((loc_cog_vid_local_colorphs?32'h8:32'h0)+((reg_cog_vid_vcfg_chroma0?loc_cog_vid_local_colormod:reg_cog_vid_discrete)&32'h7))&64'hFFFFFFFF);
                reg_cog_vid_composite = ((reg_cog_vid_vcfg_chroma1?loc_cog_vid_local_colormod:reg_cog_vid_discrete)&32'h7);
                if ((reg_cog_vid_vcfg_cmode&((reg_cog_vid_saved_pixels&32'h3)==32'h3))) begin
                    reg_cog_vid_discrete = (((reg_cog_vid_saved_colors >> 32'h18)&64'hFFFFFFFF)&32'hff);
                end
                else begin
                    if ((reg_cog_vid_vcfg_cmode&((reg_cog_vid_saved_pixels&32'h3)==32'h2))) begin
                        reg_cog_vid_discrete = (((reg_cog_vid_saved_colors >> 32'h10)&64'hFFFFFFFF)&32'hff);
                    end
                    else begin
                        if (((reg_cog_vid_saved_pixels&32'h1)==32'h1)) begin
                            reg_cog_vid_discrete = (((reg_cog_vid_saved_colors >> 32'h8)&64'hFFFFFFFF)&32'hff);
                        end
                        else begin
                            reg_cog_vid_discrete = (reg_cog_vid_saved_colors&32'hff);
                        end
                    end
                end
                if (loc_cog_vid_local_new_set) begin
                    reg_cog_vid_saved_pixels = source;
                    reg_cog_vid_saved_colors = dest;
                end
                else begin
                    if (loc_cog_vid_local_new_cnt) begin
                        reg_cog_vid_saved_pixels = (reg_cog_vid_vcfg_cmode?((reg_cog_vid_saved_pixels&32'hc0000000)|((reg_cog_vid_saved_pixels >> 32'h2)&64'hFFFFFFFF)):((reg_cog_vid_saved_pixels&32'h80000000)|((reg_cog_vid_saved_pixels >> 32'h1)&64'hFFFFFFFF)));
                    end
                end
            end
        end
        if ((posedge_clk_cog|negedge_ena)) begin
            if (ena) begin
                if ((wio&(instr_dst==32'h1fe))) begin
                    reg_cog_vid_vcfg_vmode = (((outp_cog_alu_r >> 32'h1d)&64'hFFFFFFFF)&32'h3);
                    reg_cog_vid_vcfg_cmode = ((((outp_cog_alu_r >> 32'h1c)&64'hFFFFFFFF)&32'h1)==32'h1);
                    reg_cog_vid_vcfg_chroma1 = ((((outp_cog_alu_r >> 32'h1b)&64'hFFFFFFFF)&32'h1)==32'h1);
                    reg_cog_vid_vcfg_chroma0 = ((((outp_cog_alu_r >> 32'h1a)&64'hFFFFFFFF)&32'h1)==32'h1);
                    reg_cog_vid_vcfg_auralsub = (((outp_cog_alu_r >> 32'h17)&64'hFFFFFFFF)&32'h7);
                    reg_cog_vid_vcfg_vgroup = (((((outp_cog_alu_r >> 32'h9)&64'hFFFFFFFF)&32'h3) << 32'h3)&64'hFFFFFFFF);
                    reg_cog_vid_vcfg_vpins = (outp_cog_alu_r&32'hff);
                end
            end
            else begin
                reg_cog_vid_vcfg_vmode = 32'h0;
                reg_cog_vid_vcfg_cmode = 1'b0;
                reg_cog_vid_vcfg_chroma1 = 1'b0;
                reg_cog_vid_vcfg_chroma0 = 1'b0;
                reg_cog_vid_vcfg_auralsub = 32'h0;
                reg_cog_vid_vcfg_vgroup = 32'h0;
                reg_cog_vid_vcfg_vpins = 32'h0;
            end
        end
        if (posedge_clk_cog) begin
            if ((wio&(instr_dst==32'h1ff))) begin
                reg_cog_vid_vscl_pixelclocks = (((outp_cog_alu_r >> 32'hc)&64'hFFFFFFFF)&32'hff);
                reg_cog_vid_vscl_frameclocks = (outp_cog_alu_r&32'hfff);
            end
            if (loc_cog_vid_local_enable) begin
                reg_cog_vid_snc1 = reg_cog_vid_snc0;
                reg_cog_vid_snc0 = reg_cog_vid_capr;
            end
        end
        reg_cog_vid_capr = loc_cog_vid_local_capr_next;
        pin_out = ((((outa|outp_cog_ctra_pin_out)|outp_cog_ctrb_pin_out)|outp_cog_vid_pin_out)&dira);
        pin_dir = dira;
        in_cog_ram_a = ((state==32'h3)?px:((state==32'h1)?instr_src:instr_dst));
        outp_cog_ram_q = reg_cog_ram_q_reg;
        if ((posedge_clk_cog&(inRange32(state,32'h1,32'h3)|(((state==32'h4)&cond)&((i>>32'h17)&1 != 0))))) begin
            reg_cog_ram_q_reg = reg_cog_ram_r;
            if (((state==32'h4)&outp_cog_alu_wr)) begin
                reg_cog_ram_r_$wi = in_cog_ram_a;
                reg_cog_ram_r_$wr = 1'b1;
                reg_cog_ram_r = outp_cog_alu_r;
            end
        end
        if ((posedge_clk_cog|negedge_nres)) begin
            if (nres) begin
                if ((ena_bus&ptr_w)) begin
                    progctr = ptr_d;
                end
            end
            else begin
                progctr = 32'h3e00;
            end
        end
        match_prev = match;
        if ((posedge_clk_cog|negedge_ena)) begin
            if (ena) begin
                if ((state==32'h4)) begin
                    if ((px==32'h1ff)) begin
                        running = 1'b1;
                    end
                    if ((cond&jump_cancel)) begin
                    end
                    else begin
                        p_reg = (((px+32'h1)&64'hFFFFFFFF)&32'h1ff);
                    end
                    if ((cond&((i>>32'h18)&1 != 0))) begin
                        flags = (outp_cog_alu_co?(flags|32'h2):(flags&32'h1));
                    end
                    if ((cond&((i>>32'h19)&1 != 0))) begin
                        flags = (outp_cog_alu_zo?(flags|32'h1):(flags&32'h2));
                    end
                    cancel = ((cond&jump_cancel)|(px==32'h1ff));
                end
                if ((wio&(instr_dst==32'h1f6))) begin
                    dira = outp_cog_alu_r;
                end
            end
            else begin
                running = 1'b0;
                p_reg = 32'h0;
                flags = 32'h0;
                dira = 32'h0;
                cancel = 1'b0;
            end
            if (posedge_clk_cog) begin
                if ((wio&(instr_dst==32'h1f4))) begin
                    outa = outp_cog_alu_r;
                end
                if ((state==32'h4)) begin
                    instruction_reg = outp_cog_ram_q;
                end
                if ((state==32'h2)) begin
                    sy_reg = outp_cog_ram_q;
                end
                match = ((state==32'h5)&(((instr_opcode&32'h3)==32'h1)!=((((i>>32'h1b)&1 != 0)?cnt:(pin_in&source))==dest)));
                if ((state==32'h3)) begin
                    source = sx;
                    dest = outp_cog_ram_q;
                end
            end
            if (ena) begin
                case (state)
                    32'h0: begin
                        state = 32'h1;
                    end
                    32'h1: begin
                        state = 32'h2;
                    end
                    32'h2: begin
                        state = 32'h3;
                    end
                    32'h3,32'h5: begin
                        state = ((cond&(((instr_opcode&32'h3c)==32'h0)?(!bus_ack):((((instr_opcode&32'h3e)==32'h3c)|(instr_opcode==32'h3e))?(!match_prev):((instr_opcode==32'h3f)&(!outp_cog_vid_ack)))))?32'h5:32'h4);
                    end
                    32'h4: begin
                        state = 32'h1;
                    end
                endcase
                assume (state< 32'h6);
            end
            else begin
                state = 32'h0;
            end
        end
        //store registers
        flags_$d = flags;
        dira_$d = dira;
        outa_$d = outa;
        instruction_reg_$d = instruction_reg;
        sy_reg_$d = sy_reg;
        source_$d = source;
        dest_$d = dest;
        p_reg_$d = p_reg;
        progctr_$d = progctr;
        state_$d = state;
        match_$d = match;
        cancel_$d = cancel;
        running_$d = running;
        plla_saved_$d = plla_saved;
        pllb_saved_$d = pllb_saved;
        reg_cog_vid_vcfg_vmode_$d = reg_cog_vid_vcfg_vmode;
        reg_cog_vid_vcfg_auralsub_$d = reg_cog_vid_vcfg_auralsub;
        reg_cog_vid_vcfg_vgroup_$d = reg_cog_vid_vcfg_vgroup;
        reg_cog_vid_vcfg_vpins_$d = reg_cog_vid_vcfg_vpins;
        reg_cog_vid_vscl_pixelclocks_$d = reg_cog_vid_vscl_pixelclocks;
        reg_cog_vid_vscl_frameclocks_$d = reg_cog_vid_vscl_frameclocks;
        reg_cog_vid_composite_$d = reg_cog_vid_composite;
        reg_cog_vid_baseband_$d = reg_cog_vid_baseband;
        reg_cog_vid_phase_$d = reg_cog_vid_phase;
        reg_cog_vid_discrete_$d = reg_cog_vid_discrete;
        reg_cog_vid_saved_pixels_$d = reg_cog_vid_saved_pixels;
        reg_cog_vid_saved_colors_$d = reg_cog_vid_saved_colors;
        reg_cog_vid_cnts_$d = reg_cog_vid_cnts;
        reg_cog_vid_cnt0_$d = reg_cog_vid_cnt0;
        reg_cog_vid_setr_$d = reg_cog_vid_setr;
        reg_cog_vid_vcfg_cmode_$d = reg_cog_vid_vcfg_cmode;
        reg_cog_vid_vcfg_chroma1_$d = reg_cog_vid_vcfg_chroma1;
        reg_cog_vid_vcfg_chroma0_$d = reg_cog_vid_vcfg_chroma0;
        reg_cog_vid_capr_$d = reg_cog_vid_capr;
        reg_cog_vid_snc0_$d = reg_cog_vid_snc0;
        reg_cog_vid_snc1_$d = reg_cog_vid_snc1;
        reg_cog_ctra_frequency_$d = reg_cog_ctra_frequency;
        reg_cog_ctra_phase_$d = reg_cog_ctra_phase;
        reg_cog_ctra_pllcounter_$d = reg_cog_ctra_pllcounter;
        reg_cog_ctra_ctrmode_$d = reg_cog_ctra_ctrmode;
        reg_cog_ctra_ctrplldiv_$d = reg_cog_ctra_ctrplldiv;
        reg_cog_ctra_ctrbpin_$d = reg_cog_ctra_ctrbpin;
        reg_cog_ctra_ctrapin_$d = reg_cog_ctra_ctrapin;
        reg_cog_ctra_delayed0_$d = reg_cog_ctra_delayed0;
        reg_cog_ctra_delayed1_$d = reg_cog_ctra_delayed1;
        reg_cog_ctra_pll_saved_$d = reg_cog_ctra_pll_saved;
        reg_cog_ctrb_frequency_$d = reg_cog_ctrb_frequency;
        reg_cog_ctrb_phase_$d = reg_cog_ctrb_phase;
        reg_cog_ctrb_pllcounter_$d = reg_cog_ctrb_pllcounter;
        reg_cog_ctrb_ctrmode_$d = reg_cog_ctrb_ctrmode;
        reg_cog_ctrb_ctrplldiv_$d = reg_cog_ctrb_ctrplldiv;
        reg_cog_ctrb_ctrbpin_$d = reg_cog_ctrb_ctrbpin;
        reg_cog_ctrb_ctrapin_$d = reg_cog_ctrb_ctrapin;
        reg_cog_ctrb_delayed0_$d = reg_cog_ctrb_delayed0;
        reg_cog_ctrb_delayed1_$d = reg_cog_ctrb_delayed1;
        reg_cog_ctrb_pll_saved_$d = reg_cog_ctrb_pll_saved;
        reg_cog_ram_q_reg_$d = reg_cog_ram_q_reg;
        reg_cog_ram_r_$d = reg_cog_ram_r;
    end
endmodule

module verify(
    input nres,
    input ena_bus,
    input ptr_w,
    input [31:0] ptr_d,
    input ena,
    input bus_sel,
    input [31:0] bus_q,
    input bus_c,
    input bus_ack,
    input [31:0] cnt,
    input [31:0] pll_in,
    input [31:0] pin_in,
    input posedge_clk_cog,
    input negedge_nres,
    input negedge_ena,
    input posedge_clk_pll,
    input posedge_vclk,
    input posedge_snc1,
    input [31:0] flags_$q,
    input [31:0] dira_$q,
    input [31:0] outa_$q,
    input [31:0] instruction_reg_$q,
    input [31:0] sy_reg_$q,
    input [31:0] source_$q,
    input [31:0] dest_$q,
    input [31:0] p_reg_$q,
    input [31:0] progctr_$q,
    input [31:0] state_$q,
    input match_$q,
    input cancel_$q,
    input running_$q,
    input plla_saved_$q,
    input pllb_saved_$q,
    input [31:0] reg_cog_vid_vcfg_vmode_$q,
    input [31:0] reg_cog_vid_vcfg_auralsub_$q,
    input [31:0] reg_cog_vid_vcfg_vgroup_$q,
    input [31:0] reg_cog_vid_vcfg_vpins_$q,
    input [31:0] reg_cog_vid_vscl_pixelclocks_$q,
    input [31:0] reg_cog_vid_vscl_frameclocks_$q,
    input [31:0] reg_cog_vid_composite_$q,
    input [31:0] reg_cog_vid_baseband_$q,
    input [31:0] reg_cog_vid_phase_$q,
    input [31:0] reg_cog_vid_discrete_$q,
    input [31:0] reg_cog_vid_saved_pixels_$q,
    input [31:0] reg_cog_vid_saved_colors_$q,
    input [31:0] reg_cog_vid_cnts_$q,
    input [31:0] reg_cog_vid_cnt0_$q,
    input [31:0] reg_cog_vid_setr_$q,
    input reg_cog_vid_vcfg_cmode_$q,
    input reg_cog_vid_vcfg_chroma1_$q,
    input reg_cog_vid_vcfg_chroma0_$q,
    input reg_cog_vid_capr_$q,
    input reg_cog_vid_snc0_$q,
    input reg_cog_vid_snc1_$q,
    input [31:0] reg_cog_ctra_frequency_$q,
    input [63:0] reg_cog_ctra_phase_$q,
    input [63:0] reg_cog_ctra_pllcounter_$q,
    input [31:0] reg_cog_ctra_ctrmode_$q,
    input [31:0] reg_cog_ctra_ctrplldiv_$q,
    input [31:0] reg_cog_ctra_ctrbpin_$q,
    input [31:0] reg_cog_ctra_ctrapin_$q,
    input reg_cog_ctra_delayed0_$q,
    input reg_cog_ctra_delayed1_$q,
    input reg_cog_ctra_pll_saved_$q,
    input [31:0] reg_cog_ctrb_frequency_$q,
    input [63:0] reg_cog_ctrb_phase_$q,
    input [63:0] reg_cog_ctrb_pllcounter_$q,
    input [31:0] reg_cog_ctrb_ctrmode_$q,
    input [31:0] reg_cog_ctrb_ctrplldiv_$q,
    input [31:0] reg_cog_ctrb_ctrbpin_$q,
    input [31:0] reg_cog_ctrb_ctrapin_$q,
    input reg_cog_ctrb_delayed0_$q,
    input reg_cog_ctrb_delayed1_$q,
    input reg_cog_ctrb_pll_saved_$q,
    input [31:0] reg_cog_ram_q_reg_$q,
    input [31:0] reg_cog_ram_r_$q
);
    wire bus_r_$gld;
    wire bus_r_$ver;
    wire bus_e_$gld;
    wire bus_e_$ver;
    wire bus_w_$gld;
    wire bus_w_$ver;
    wire [31:0] bus_s_$gld;
    wire [31:0] bus_s_$ver;
    wire [31:0] bus_a_$gld;
    wire [31:0] bus_a_$ver;
    wire [31:0] bus_d_$gld;
    wire [31:0] bus_d_$ver;
    wire [31:0] pin_out_$gld;
    wire [31:0] pin_out_$ver;
    wire [31:0] pin_dir_$gld;
    wire [31:0] pin_dir_$ver;
    wire [31:0] flags_$d_$gld;
    wire [31:0] flags_$d_$ver;
    wire [31:0] dira_$d_$gld;
    wire [31:0] dira_$d_$ver;
    wire [31:0] outa_$d_$gld;
    wire [31:0] outa_$d_$ver;
    wire [31:0] instruction_reg_$d_$gld;
    wire [31:0] instruction_reg_$d_$ver;
    wire [31:0] sy_reg_$d_$gld;
    wire [31:0] sy_reg_$d_$ver;
    wire [31:0] source_$d_$gld;
    wire [31:0] source_$d_$ver;
    wire [31:0] dest_$d_$gld;
    wire [31:0] dest_$d_$ver;
    wire [31:0] p_reg_$d_$gld;
    wire [31:0] p_reg_$d_$ver;
    wire [31:0] progctr_$d_$gld;
    wire [31:0] progctr_$d_$ver;
    wire [31:0] state_$d_$gld;
    wire [31:0] state_$d_$ver;
    wire match_$d_$gld;
    wire match_$d_$ver;
    wire cancel_$d_$gld;
    wire cancel_$d_$ver;
    wire running_$d_$gld;
    wire running_$d_$ver;
    wire plla_saved_$d_$gld;
    wire plla_saved_$d_$ver;
    wire pllb_saved_$d_$gld;
    wire pllb_saved_$d_$ver;
    wire [31:0] reg_cog_vid_vcfg_vmode_$d_$gld;
    wire [31:0] reg_cog_vid_vcfg_vmode_$d_$ver;
    wire [31:0] reg_cog_vid_vcfg_auralsub_$d_$gld;
    wire [31:0] reg_cog_vid_vcfg_auralsub_$d_$ver;
    wire [31:0] reg_cog_vid_vcfg_vgroup_$d_$gld;
    wire [31:0] reg_cog_vid_vcfg_vgroup_$d_$ver;
    wire [31:0] reg_cog_vid_vcfg_vpins_$d_$gld;
    wire [31:0] reg_cog_vid_vcfg_vpins_$d_$ver;
    wire [31:0] reg_cog_vid_vscl_pixelclocks_$d_$gld;
    wire [31:0] reg_cog_vid_vscl_pixelclocks_$d_$ver;
    wire [31:0] reg_cog_vid_vscl_frameclocks_$d_$gld;
    wire [31:0] reg_cog_vid_vscl_frameclocks_$d_$ver;
    wire [31:0] reg_cog_vid_composite_$d_$gld;
    wire [31:0] reg_cog_vid_composite_$d_$ver;
    wire [31:0] reg_cog_vid_baseband_$d_$gld;
    wire [31:0] reg_cog_vid_baseband_$d_$ver;
    wire [31:0] reg_cog_vid_phase_$d_$gld;
    wire [31:0] reg_cog_vid_phase_$d_$ver;
    wire [31:0] reg_cog_vid_discrete_$d_$gld;
    wire [31:0] reg_cog_vid_discrete_$d_$ver;
    wire [31:0] reg_cog_vid_saved_pixels_$d_$gld;
    wire [31:0] reg_cog_vid_saved_pixels_$d_$ver;
    wire [31:0] reg_cog_vid_saved_colors_$d_$gld;
    wire [31:0] reg_cog_vid_saved_colors_$d_$ver;
    wire [31:0] reg_cog_vid_cnts_$d_$gld;
    wire [31:0] reg_cog_vid_cnts_$d_$ver;
    wire [31:0] reg_cog_vid_cnt0_$d_$gld;
    wire [31:0] reg_cog_vid_cnt0_$d_$ver;
    wire [31:0] reg_cog_vid_setr_$d_$gld;
    wire [31:0] reg_cog_vid_setr_$d_$ver;
    wire reg_cog_vid_vcfg_cmode_$d_$gld;
    wire reg_cog_vid_vcfg_cmode_$d_$ver;
    wire reg_cog_vid_vcfg_chroma1_$d_$gld;
    wire reg_cog_vid_vcfg_chroma1_$d_$ver;
    wire reg_cog_vid_vcfg_chroma0_$d_$gld;
    wire reg_cog_vid_vcfg_chroma0_$d_$ver;
    wire reg_cog_vid_capr_$d_$gld;
    wire reg_cog_vid_capr_$d_$ver;
    wire reg_cog_vid_snc0_$d_$gld;
    wire reg_cog_vid_snc0_$d_$ver;
    wire reg_cog_vid_snc1_$d_$gld;
    wire reg_cog_vid_snc1_$d_$ver;
    wire [31:0] reg_cog_ctra_frequency_$d_$gld;
    wire [31:0] reg_cog_ctra_frequency_$d_$ver;
    wire [63:0] reg_cog_ctra_phase_$d_$gld;
    wire [63:0] reg_cog_ctra_phase_$d_$ver;
    wire [63:0] reg_cog_ctra_pllcounter_$d_$gld;
    wire [63:0] reg_cog_ctra_pllcounter_$d_$ver;
    wire [31:0] reg_cog_ctra_ctrmode_$d_$gld;
    wire [31:0] reg_cog_ctra_ctrmode_$d_$ver;
    wire [31:0] reg_cog_ctra_ctrplldiv_$d_$gld;
    wire [31:0] reg_cog_ctra_ctrplldiv_$d_$ver;
    wire [31:0] reg_cog_ctra_ctrbpin_$d_$gld;
    wire [31:0] reg_cog_ctra_ctrbpin_$d_$ver;
    wire [31:0] reg_cog_ctra_ctrapin_$d_$gld;
    wire [31:0] reg_cog_ctra_ctrapin_$d_$ver;
    wire reg_cog_ctra_delayed0_$d_$gld;
    wire reg_cog_ctra_delayed0_$d_$ver;
    wire reg_cog_ctra_delayed1_$d_$gld;
    wire reg_cog_ctra_delayed1_$d_$ver;
    wire reg_cog_ctra_pll_saved_$d_$gld;
    wire reg_cog_ctra_pll_saved_$d_$ver;
    wire [31:0] reg_cog_ctrb_frequency_$d_$gld;
    wire [31:0] reg_cog_ctrb_frequency_$d_$ver;
    wire [63:0] reg_cog_ctrb_phase_$d_$gld;
    wire [63:0] reg_cog_ctrb_phase_$d_$ver;
    wire [63:0] reg_cog_ctrb_pllcounter_$d_$gld;
    wire [63:0] reg_cog_ctrb_pllcounter_$d_$ver;
    wire [31:0] reg_cog_ctrb_ctrmode_$d_$gld;
    wire [31:0] reg_cog_ctrb_ctrmode_$d_$ver;
    wire [31:0] reg_cog_ctrb_ctrplldiv_$d_$gld;
    wire [31:0] reg_cog_ctrb_ctrplldiv_$d_$ver;
    wire [31:0] reg_cog_ctrb_ctrbpin_$d_$gld;
    wire [31:0] reg_cog_ctrb_ctrbpin_$d_$ver;
    wire [31:0] reg_cog_ctrb_ctrapin_$d_$gld;
    wire [31:0] reg_cog_ctrb_ctrapin_$d_$ver;
    wire reg_cog_ctrb_delayed0_$d_$gld;
    wire reg_cog_ctrb_delayed0_$d_$ver;
    wire reg_cog_ctrb_delayed1_$d_$gld;
    wire reg_cog_ctrb_delayed1_$d_$ver;
    wire reg_cog_ctrb_pll_saved_$d_$gld;
    wire reg_cog_ctrb_pll_saved_$d_$ver;
    wire [31:0] reg_cog_ram_q_reg_$d_$gld;
    wire [31:0] reg_cog_ram_q_reg_$d_$ver;
    wire [31:0] reg_cog_ram_r_$d_$gld;
    wire [31:0] reg_cog_ram_r_$d_$ver;
    wire [31:0] reg_cog_ram_r_$wi_$gld;
    wire [31:0] reg_cog_ram_r_$wi_$ver;
    wire reg_cog_ram_r_$wr_$gld;
    wire reg_cog_ram_r_$wr_$ver;cogEvalMain golden(
        .nres(nres),
        .ena_bus(ena_bus),
        .ptr_w(ptr_w),
        .ptr_d(ptr_d),
        .ena(ena),
        .bus_sel(bus_sel),
        .bus_q(bus_q),
        .bus_c(bus_c),
        .bus_ack(bus_ack),
        .cnt(cnt),
        .pll_in(pll_in),
        .pin_in(pin_in),
        .posedge_clk_cog(posedge_clk_cog),
        .negedge_nres(negedge_nres),
        .negedge_ena(negedge_ena),
        .posedge_clk_pll(posedge_clk_pll),
        .posedge_vclk(posedge_vclk),
        .posedge_snc1(posedge_snc1),
        .bus_r(bus_r_$gld),
        .bus_e(bus_e_$gld),
        .bus_w(bus_w_$gld),
        .bus_s(bus_s_$gld),
        .bus_a(bus_a_$gld),
        .bus_d(bus_d_$gld),
        .pin_out(pin_out_$gld),
        .pin_dir(pin_dir_$gld),
        .flags_$q(flags_$q),
        .flags_$d(flags_$d_$gld),
        .dira_$q(dira_$q),
        .dira_$d(dira_$d_$gld),
        .outa_$q(outa_$q),
        .outa_$d(outa_$d_$gld),
        .instruction_reg_$q(instruction_reg_$q),
        .instruction_reg_$d(instruction_reg_$d_$gld),
        .sy_reg_$q(sy_reg_$q),
        .sy_reg_$d(sy_reg_$d_$gld),
        .source_$q(source_$q),
        .source_$d(source_$d_$gld),
        .dest_$q(dest_$q),
        .dest_$d(dest_$d_$gld),
        .p_reg_$q(p_reg_$q),
        .p_reg_$d(p_reg_$d_$gld),
        .progctr_$q(progctr_$q),
        .progctr_$d(progctr_$d_$gld),
        .state_$q(state_$q),
        .state_$d(state_$d_$gld),
        .match_$q(match_$q),
        .match_$d(match_$d_$gld),
        .cancel_$q(cancel_$q),
        .cancel_$d(cancel_$d_$gld),
        .running_$q(running_$q),
        .running_$d(running_$d_$gld),
        .plla_saved_$q(plla_saved_$q),
        .plla_saved_$d(plla_saved_$d_$gld),
        .pllb_saved_$q(pllb_saved_$q),
        .pllb_saved_$d(pllb_saved_$d_$gld),
        .reg_cog_vid_vcfg_vmode_$q(reg_cog_vid_vcfg_vmode_$q),
        .reg_cog_vid_vcfg_vmode_$d(reg_cog_vid_vcfg_vmode_$d_$gld),
        .reg_cog_vid_vcfg_auralsub_$q(reg_cog_vid_vcfg_auralsub_$q),
        .reg_cog_vid_vcfg_auralsub_$d(reg_cog_vid_vcfg_auralsub_$d_$gld),
        .reg_cog_vid_vcfg_vgroup_$q(reg_cog_vid_vcfg_vgroup_$q),
        .reg_cog_vid_vcfg_vgroup_$d(reg_cog_vid_vcfg_vgroup_$d_$gld),
        .reg_cog_vid_vcfg_vpins_$q(reg_cog_vid_vcfg_vpins_$q),
        .reg_cog_vid_vcfg_vpins_$d(reg_cog_vid_vcfg_vpins_$d_$gld),
        .reg_cog_vid_vscl_pixelclocks_$q(reg_cog_vid_vscl_pixelclocks_$q),
        .reg_cog_vid_vscl_pixelclocks_$d(reg_cog_vid_vscl_pixelclocks_$d_$gld),
        .reg_cog_vid_vscl_frameclocks_$q(reg_cog_vid_vscl_frameclocks_$q),
        .reg_cog_vid_vscl_frameclocks_$d(reg_cog_vid_vscl_frameclocks_$d_$gld),
        .reg_cog_vid_composite_$q(reg_cog_vid_composite_$q),
        .reg_cog_vid_composite_$d(reg_cog_vid_composite_$d_$gld),
        .reg_cog_vid_baseband_$q(reg_cog_vid_baseband_$q),
        .reg_cog_vid_baseband_$d(reg_cog_vid_baseband_$d_$gld),
        .reg_cog_vid_phase_$q(reg_cog_vid_phase_$q),
        .reg_cog_vid_phase_$d(reg_cog_vid_phase_$d_$gld),
        .reg_cog_vid_discrete_$q(reg_cog_vid_discrete_$q),
        .reg_cog_vid_discrete_$d(reg_cog_vid_discrete_$d_$gld),
        .reg_cog_vid_saved_pixels_$q(reg_cog_vid_saved_pixels_$q),
        .reg_cog_vid_saved_pixels_$d(reg_cog_vid_saved_pixels_$d_$gld),
        .reg_cog_vid_saved_colors_$q(reg_cog_vid_saved_colors_$q),
        .reg_cog_vid_saved_colors_$d(reg_cog_vid_saved_colors_$d_$gld),
        .reg_cog_vid_cnts_$q(reg_cog_vid_cnts_$q),
        .reg_cog_vid_cnts_$d(reg_cog_vid_cnts_$d_$gld),
        .reg_cog_vid_cnt0_$q(reg_cog_vid_cnt0_$q),
        .reg_cog_vid_cnt0_$d(reg_cog_vid_cnt0_$d_$gld),
        .reg_cog_vid_setr_$q(reg_cog_vid_setr_$q),
        .reg_cog_vid_setr_$d(reg_cog_vid_setr_$d_$gld),
        .reg_cog_vid_vcfg_cmode_$q(reg_cog_vid_vcfg_cmode_$q),
        .reg_cog_vid_vcfg_cmode_$d(reg_cog_vid_vcfg_cmode_$d_$gld),
        .reg_cog_vid_vcfg_chroma1_$q(reg_cog_vid_vcfg_chroma1_$q),
        .reg_cog_vid_vcfg_chroma1_$d(reg_cog_vid_vcfg_chroma1_$d_$gld),
        .reg_cog_vid_vcfg_chroma0_$q(reg_cog_vid_vcfg_chroma0_$q),
        .reg_cog_vid_vcfg_chroma0_$d(reg_cog_vid_vcfg_chroma0_$d_$gld),
        .reg_cog_vid_capr_$q(reg_cog_vid_capr_$q),
        .reg_cog_vid_capr_$d(reg_cog_vid_capr_$d_$gld),
        .reg_cog_vid_snc0_$q(reg_cog_vid_snc0_$q),
        .reg_cog_vid_snc0_$d(reg_cog_vid_snc0_$d_$gld),
        .reg_cog_vid_snc1_$q(reg_cog_vid_snc1_$q),
        .reg_cog_vid_snc1_$d(reg_cog_vid_snc1_$d_$gld),
        .reg_cog_ctra_frequency_$q(reg_cog_ctra_frequency_$q),
        .reg_cog_ctra_frequency_$d(reg_cog_ctra_frequency_$d_$gld),
        .reg_cog_ctra_phase_$q(reg_cog_ctra_phase_$q),
        .reg_cog_ctra_phase_$d(reg_cog_ctra_phase_$d_$gld),
        .reg_cog_ctra_pllcounter_$q(reg_cog_ctra_pllcounter_$q),
        .reg_cog_ctra_pllcounter_$d(reg_cog_ctra_pllcounter_$d_$gld),
        .reg_cog_ctra_ctrmode_$q(reg_cog_ctra_ctrmode_$q),
        .reg_cog_ctra_ctrmode_$d(reg_cog_ctra_ctrmode_$d_$gld),
        .reg_cog_ctra_ctrplldiv_$q(reg_cog_ctra_ctrplldiv_$q),
        .reg_cog_ctra_ctrplldiv_$d(reg_cog_ctra_ctrplldiv_$d_$gld),
        .reg_cog_ctra_ctrbpin_$q(reg_cog_ctra_ctrbpin_$q),
        .reg_cog_ctra_ctrbpin_$d(reg_cog_ctra_ctrbpin_$d_$gld),
        .reg_cog_ctra_ctrapin_$q(reg_cog_ctra_ctrapin_$q),
        .reg_cog_ctra_ctrapin_$d(reg_cog_ctra_ctrapin_$d_$gld),
        .reg_cog_ctra_delayed0_$q(reg_cog_ctra_delayed0_$q),
        .reg_cog_ctra_delayed0_$d(reg_cog_ctra_delayed0_$d_$gld),
        .reg_cog_ctra_delayed1_$q(reg_cog_ctra_delayed1_$q),
        .reg_cog_ctra_delayed1_$d(reg_cog_ctra_delayed1_$d_$gld),
        .reg_cog_ctra_pll_saved_$q(reg_cog_ctra_pll_saved_$q),
        .reg_cog_ctra_pll_saved_$d(reg_cog_ctra_pll_saved_$d_$gld),
        .reg_cog_ctrb_frequency_$q(reg_cog_ctrb_frequency_$q),
        .reg_cog_ctrb_frequency_$d(reg_cog_ctrb_frequency_$d_$gld),
        .reg_cog_ctrb_phase_$q(reg_cog_ctrb_phase_$q),
        .reg_cog_ctrb_phase_$d(reg_cog_ctrb_phase_$d_$gld),
        .reg_cog_ctrb_pllcounter_$q(reg_cog_ctrb_pllcounter_$q),
        .reg_cog_ctrb_pllcounter_$d(reg_cog_ctrb_pllcounter_$d_$gld),
        .reg_cog_ctrb_ctrmode_$q(reg_cog_ctrb_ctrmode_$q),
        .reg_cog_ctrb_ctrmode_$d(reg_cog_ctrb_ctrmode_$d_$gld),
        .reg_cog_ctrb_ctrplldiv_$q(reg_cog_ctrb_ctrplldiv_$q),
        .reg_cog_ctrb_ctrplldiv_$d(reg_cog_ctrb_ctrplldiv_$d_$gld),
        .reg_cog_ctrb_ctrbpin_$q(reg_cog_ctrb_ctrbpin_$q),
        .reg_cog_ctrb_ctrbpin_$d(reg_cog_ctrb_ctrbpin_$d_$gld),
        .reg_cog_ctrb_ctrapin_$q(reg_cog_ctrb_ctrapin_$q),
        .reg_cog_ctrb_ctrapin_$d(reg_cog_ctrb_ctrapin_$d_$gld),
        .reg_cog_ctrb_delayed0_$q(reg_cog_ctrb_delayed0_$q),
        .reg_cog_ctrb_delayed0_$d(reg_cog_ctrb_delayed0_$d_$gld),
        .reg_cog_ctrb_delayed1_$q(reg_cog_ctrb_delayed1_$q),
        .reg_cog_ctrb_delayed1_$d(reg_cog_ctrb_delayed1_$d_$gld),
        .reg_cog_ctrb_pll_saved_$q(reg_cog_ctrb_pll_saved_$q),
        .reg_cog_ctrb_pll_saved_$d(reg_cog_ctrb_pll_saved_$d_$gld),
        .reg_cog_ram_q_reg_$q(reg_cog_ram_q_reg_$q),
        .reg_cog_ram_q_reg_$d(reg_cog_ram_q_reg_$d_$gld),
        .reg_cog_ram_r_$q(reg_cog_ram_r_$q),
        .reg_cog_ram_r_$d(reg_cog_ram_r_$d_$gld),
        .reg_cog_ram_r_$wi(reg_cog_ram_r_$wi_$gld),
        .reg_cog_ram_r_$wr(reg_cog_ram_r_$wr_$gld));
cogEvalMain_simpl verify(
        .nres(nres),
        .ena_bus(ena_bus),
        .ptr_w(ptr_w),
        .ptr_d(ptr_d),
        .ena(ena),
        .bus_sel(bus_sel),
        .bus_q(bus_q),
        .bus_c(bus_c),
        .bus_ack(bus_ack),
        .cnt(cnt),
        .pll_in(pll_in),
        .pin_in(pin_in),
        .posedge_clk_cog(posedge_clk_cog),
        .negedge_nres(negedge_nres),
        .negedge_ena(negedge_ena),
        .posedge_clk_pll(posedge_clk_pll),
        .posedge_vclk(posedge_vclk),
        .posedge_snc1(posedge_snc1),
        .bus_r(bus_r_$ver),
        .bus_e(bus_e_$ver),
        .bus_w(bus_w_$ver),
        .bus_s(bus_s_$ver),
        .bus_a(bus_a_$ver),
        .bus_d(bus_d_$ver),
        .pin_out(pin_out_$ver),
        .pin_dir(pin_dir_$ver),
        .flags_$q(flags_$q),
        .flags_$d(flags_$d_$ver),
        .dira_$q(dira_$q),
        .dira_$d(dira_$d_$ver),
        .outa_$q(outa_$q),
        .outa_$d(outa_$d_$ver),
        .instruction_reg_$q(instruction_reg_$q),
        .instruction_reg_$d(instruction_reg_$d_$ver),
        .sy_reg_$q(sy_reg_$q),
        .sy_reg_$d(sy_reg_$d_$ver),
        .source_$q(source_$q),
        .source_$d(source_$d_$ver),
        .dest_$q(dest_$q),
        .dest_$d(dest_$d_$ver),
        .p_reg_$q(p_reg_$q),
        .p_reg_$d(p_reg_$d_$ver),
        .progctr_$q(progctr_$q),
        .progctr_$d(progctr_$d_$ver),
        .state_$q(state_$q),
        .state_$d(state_$d_$ver),
        .match_$q(match_$q),
        .match_$d(match_$d_$ver),
        .cancel_$q(cancel_$q),
        .cancel_$d(cancel_$d_$ver),
        .running_$q(running_$q),
        .running_$d(running_$d_$ver),
        .plla_saved_$q(plla_saved_$q),
        .plla_saved_$d(plla_saved_$d_$ver),
        .pllb_saved_$q(pllb_saved_$q),
        .pllb_saved_$d(pllb_saved_$d_$ver),
        .reg_cog_vid_vcfg_vmode_$q(reg_cog_vid_vcfg_vmode_$q),
        .reg_cog_vid_vcfg_vmode_$d(reg_cog_vid_vcfg_vmode_$d_$ver),
        .reg_cog_vid_vcfg_auralsub_$q(reg_cog_vid_vcfg_auralsub_$q),
        .reg_cog_vid_vcfg_auralsub_$d(reg_cog_vid_vcfg_auralsub_$d_$ver),
        .reg_cog_vid_vcfg_vgroup_$q(reg_cog_vid_vcfg_vgroup_$q),
        .reg_cog_vid_vcfg_vgroup_$d(reg_cog_vid_vcfg_vgroup_$d_$ver),
        .reg_cog_vid_vcfg_vpins_$q(reg_cog_vid_vcfg_vpins_$q),
        .reg_cog_vid_vcfg_vpins_$d(reg_cog_vid_vcfg_vpins_$d_$ver),
        .reg_cog_vid_vscl_pixelclocks_$q(reg_cog_vid_vscl_pixelclocks_$q),
        .reg_cog_vid_vscl_pixelclocks_$d(reg_cog_vid_vscl_pixelclocks_$d_$ver),
        .reg_cog_vid_vscl_frameclocks_$q(reg_cog_vid_vscl_frameclocks_$q),
        .reg_cog_vid_vscl_frameclocks_$d(reg_cog_vid_vscl_frameclocks_$d_$ver),
        .reg_cog_vid_composite_$q(reg_cog_vid_composite_$q),
        .reg_cog_vid_composite_$d(reg_cog_vid_composite_$d_$ver),
        .reg_cog_vid_baseband_$q(reg_cog_vid_baseband_$q),
        .reg_cog_vid_baseband_$d(reg_cog_vid_baseband_$d_$ver),
        .reg_cog_vid_phase_$q(reg_cog_vid_phase_$q),
        .reg_cog_vid_phase_$d(reg_cog_vid_phase_$d_$ver),
        .reg_cog_vid_discrete_$q(reg_cog_vid_discrete_$q),
        .reg_cog_vid_discrete_$d(reg_cog_vid_discrete_$d_$ver),
        .reg_cog_vid_saved_pixels_$q(reg_cog_vid_saved_pixels_$q),
        .reg_cog_vid_saved_pixels_$d(reg_cog_vid_saved_pixels_$d_$ver),
        .reg_cog_vid_saved_colors_$q(reg_cog_vid_saved_colors_$q),
        .reg_cog_vid_saved_colors_$d(reg_cog_vid_saved_colors_$d_$ver),
        .reg_cog_vid_cnts_$q(reg_cog_vid_cnts_$q),
        .reg_cog_vid_cnts_$d(reg_cog_vid_cnts_$d_$ver),
        .reg_cog_vid_cnt0_$q(reg_cog_vid_cnt0_$q),
        .reg_cog_vid_cnt0_$d(reg_cog_vid_cnt0_$d_$ver),
        .reg_cog_vid_setr_$q(reg_cog_vid_setr_$q),
        .reg_cog_vid_setr_$d(reg_cog_vid_setr_$d_$ver),
        .reg_cog_vid_vcfg_cmode_$q(reg_cog_vid_vcfg_cmode_$q),
        .reg_cog_vid_vcfg_cmode_$d(reg_cog_vid_vcfg_cmode_$d_$ver),
        .reg_cog_vid_vcfg_chroma1_$q(reg_cog_vid_vcfg_chroma1_$q),
        .reg_cog_vid_vcfg_chroma1_$d(reg_cog_vid_vcfg_chroma1_$d_$ver),
        .reg_cog_vid_vcfg_chroma0_$q(reg_cog_vid_vcfg_chroma0_$q),
        .reg_cog_vid_vcfg_chroma0_$d(reg_cog_vid_vcfg_chroma0_$d_$ver),
        .reg_cog_vid_capr_$q(reg_cog_vid_capr_$q),
        .reg_cog_vid_capr_$d(reg_cog_vid_capr_$d_$ver),
        .reg_cog_vid_snc0_$q(reg_cog_vid_snc0_$q),
        .reg_cog_vid_snc0_$d(reg_cog_vid_snc0_$d_$ver),
        .reg_cog_vid_snc1_$q(reg_cog_vid_snc1_$q),
        .reg_cog_vid_snc1_$d(reg_cog_vid_snc1_$d_$ver),
        .reg_cog_ctra_frequency_$q(reg_cog_ctra_frequency_$q),
        .reg_cog_ctra_frequency_$d(reg_cog_ctra_frequency_$d_$ver),
        .reg_cog_ctra_phase_$q(reg_cog_ctra_phase_$q),
        .reg_cog_ctra_phase_$d(reg_cog_ctra_phase_$d_$ver),
        .reg_cog_ctra_pllcounter_$q(reg_cog_ctra_pllcounter_$q),
        .reg_cog_ctra_pllcounter_$d(reg_cog_ctra_pllcounter_$d_$ver),
        .reg_cog_ctra_ctrmode_$q(reg_cog_ctra_ctrmode_$q),
        .reg_cog_ctra_ctrmode_$d(reg_cog_ctra_ctrmode_$d_$ver),
        .reg_cog_ctra_ctrplldiv_$q(reg_cog_ctra_ctrplldiv_$q),
        .reg_cog_ctra_ctrplldiv_$d(reg_cog_ctra_ctrplldiv_$d_$ver),
        .reg_cog_ctra_ctrbpin_$q(reg_cog_ctra_ctrbpin_$q),
        .reg_cog_ctra_ctrbpin_$d(reg_cog_ctra_ctrbpin_$d_$ver),
        .reg_cog_ctra_ctrapin_$q(reg_cog_ctra_ctrapin_$q),
        .reg_cog_ctra_ctrapin_$d(reg_cog_ctra_ctrapin_$d_$ver),
        .reg_cog_ctra_delayed0_$q(reg_cog_ctra_delayed0_$q),
        .reg_cog_ctra_delayed0_$d(reg_cog_ctra_delayed0_$d_$ver),
        .reg_cog_ctra_delayed1_$q(reg_cog_ctra_delayed1_$q),
        .reg_cog_ctra_delayed1_$d(reg_cog_ctra_delayed1_$d_$ver),
        .reg_cog_ctra_pll_saved_$q(reg_cog_ctra_pll_saved_$q),
        .reg_cog_ctra_pll_saved_$d(reg_cog_ctra_pll_saved_$d_$ver),
        .reg_cog_ctrb_frequency_$q(reg_cog_ctrb_frequency_$q),
        .reg_cog_ctrb_frequency_$d(reg_cog_ctrb_frequency_$d_$ver),
        .reg_cog_ctrb_phase_$q(reg_cog_ctrb_phase_$q),
        .reg_cog_ctrb_phase_$d(reg_cog_ctrb_phase_$d_$ver),
        .reg_cog_ctrb_pllcounter_$q(reg_cog_ctrb_pllcounter_$q),
        .reg_cog_ctrb_pllcounter_$d(reg_cog_ctrb_pllcounter_$d_$ver),
        .reg_cog_ctrb_ctrmode_$q(reg_cog_ctrb_ctrmode_$q),
        .reg_cog_ctrb_ctrmode_$d(reg_cog_ctrb_ctrmode_$d_$ver),
        .reg_cog_ctrb_ctrplldiv_$q(reg_cog_ctrb_ctrplldiv_$q),
        .reg_cog_ctrb_ctrplldiv_$d(reg_cog_ctrb_ctrplldiv_$d_$ver),
        .reg_cog_ctrb_ctrbpin_$q(reg_cog_ctrb_ctrbpin_$q),
        .reg_cog_ctrb_ctrbpin_$d(reg_cog_ctrb_ctrbpin_$d_$ver),
        .reg_cog_ctrb_ctrapin_$q(reg_cog_ctrb_ctrapin_$q),
        .reg_cog_ctrb_ctrapin_$d(reg_cog_ctrb_ctrapin_$d_$ver),
        .reg_cog_ctrb_delayed0_$q(reg_cog_ctrb_delayed0_$q),
        .reg_cog_ctrb_delayed0_$d(reg_cog_ctrb_delayed0_$d_$ver),
        .reg_cog_ctrb_delayed1_$q(reg_cog_ctrb_delayed1_$q),
        .reg_cog_ctrb_delayed1_$d(reg_cog_ctrb_delayed1_$d_$ver),
        .reg_cog_ctrb_pll_saved_$q(reg_cog_ctrb_pll_saved_$q),
        .reg_cog_ctrb_pll_saved_$d(reg_cog_ctrb_pll_saved_$d_$ver),
        .reg_cog_ram_q_reg_$q(reg_cog_ram_q_reg_$q),
        .reg_cog_ram_q_reg_$d(reg_cog_ram_q_reg_$d_$ver),
        .reg_cog_ram_r_$q(reg_cog_ram_r_$q),
        .reg_cog_ram_r_$d(reg_cog_ram_r_$d_$ver),
        .reg_cog_ram_r_$wi(reg_cog_ram_r_$wi_$ver),
        .reg_cog_ram_r_$wr(reg_cog_ram_r_$wr_$ver));
    assert property(bus_r_$gld == bus_r_$ver);
    assert property(bus_e_$gld == bus_e_$ver);
    assert property(bus_w_$gld == bus_w_$ver);
    assert property(bus_s_$gld == bus_s_$ver);
    assert property(bus_a_$gld == bus_a_$ver);
    assert property(bus_d_$gld == bus_d_$ver);
    assert property(pin_out_$gld == pin_out_$ver);
    assert property(pin_dir_$gld == pin_dir_$ver);
    assert property(flags_$d_$gld == flags_$d_$ver);
    assert property(dira_$d_$gld == dira_$d_$ver);
    assert property(outa_$d_$gld == outa_$d_$ver);
    assert property(instruction_reg_$d_$gld == instruction_reg_$d_$ver);
    assert property(sy_reg_$d_$gld == sy_reg_$d_$ver);
    assert property(source_$d_$gld == source_$d_$ver);
    assert property(dest_$d_$gld == dest_$d_$ver);
    assert property(p_reg_$d_$gld == p_reg_$d_$ver);
    assert property(progctr_$d_$gld == progctr_$d_$ver);
    assert property(state_$d_$gld == state_$d_$ver);
    assert property(match_$d_$gld == match_$d_$ver);
    assert property(cancel_$d_$gld == cancel_$d_$ver);
    assert property(running_$d_$gld == running_$d_$ver);
    assert property(plla_saved_$d_$gld == plla_saved_$d_$ver);
    assert property(pllb_saved_$d_$gld == pllb_saved_$d_$ver);
    assert property(reg_cog_vid_vcfg_vmode_$d_$gld == reg_cog_vid_vcfg_vmode_$d_$ver);
    assert property(reg_cog_vid_vcfg_auralsub_$d_$gld == reg_cog_vid_vcfg_auralsub_$d_$ver);
    assert property(reg_cog_vid_vcfg_vgroup_$d_$gld == reg_cog_vid_vcfg_vgroup_$d_$ver);
    assert property(reg_cog_vid_vcfg_vpins_$d_$gld == reg_cog_vid_vcfg_vpins_$d_$ver);
    assert property(reg_cog_vid_vscl_pixelclocks_$d_$gld == reg_cog_vid_vscl_pixelclocks_$d_$ver);
    assert property(reg_cog_vid_vscl_frameclocks_$d_$gld == reg_cog_vid_vscl_frameclocks_$d_$ver);
    assert property(reg_cog_vid_composite_$d_$gld == reg_cog_vid_composite_$d_$ver);
    assert property(reg_cog_vid_baseband_$d_$gld == reg_cog_vid_baseband_$d_$ver);
    assert property(reg_cog_vid_phase_$d_$gld == reg_cog_vid_phase_$d_$ver);
    assert property(reg_cog_vid_discrete_$d_$gld == reg_cog_vid_discrete_$d_$ver);
    assert property(reg_cog_vid_saved_pixels_$d_$gld == reg_cog_vid_saved_pixels_$d_$ver);
    assert property(reg_cog_vid_saved_colors_$d_$gld == reg_cog_vid_saved_colors_$d_$ver);
    assert property(reg_cog_vid_cnts_$d_$gld == reg_cog_vid_cnts_$d_$ver);
    assert property(reg_cog_vid_cnt0_$d_$gld == reg_cog_vid_cnt0_$d_$ver);
    assert property(reg_cog_vid_setr_$d_$gld == reg_cog_vid_setr_$d_$ver);
    assert property(reg_cog_vid_vcfg_cmode_$d_$gld == reg_cog_vid_vcfg_cmode_$d_$ver);
    assert property(reg_cog_vid_vcfg_chroma1_$d_$gld == reg_cog_vid_vcfg_chroma1_$d_$ver);
    assert property(reg_cog_vid_vcfg_chroma0_$d_$gld == reg_cog_vid_vcfg_chroma0_$d_$ver);
    assert property(reg_cog_vid_capr_$d_$gld == reg_cog_vid_capr_$d_$ver);
    assert property(reg_cog_vid_snc0_$d_$gld == reg_cog_vid_snc0_$d_$ver);
    assert property(reg_cog_vid_snc1_$d_$gld == reg_cog_vid_snc1_$d_$ver);
    assert property(reg_cog_ctra_frequency_$d_$gld == reg_cog_ctra_frequency_$d_$ver);
    assert property(reg_cog_ctra_phase_$d_$gld == reg_cog_ctra_phase_$d_$ver);
    assert property(reg_cog_ctra_pllcounter_$d_$gld == reg_cog_ctra_pllcounter_$d_$ver);
    assert property(reg_cog_ctra_ctrmode_$d_$gld == reg_cog_ctra_ctrmode_$d_$ver);
    assert property(reg_cog_ctra_ctrplldiv_$d_$gld == reg_cog_ctra_ctrplldiv_$d_$ver);
    assert property(reg_cog_ctra_ctrbpin_$d_$gld == reg_cog_ctra_ctrbpin_$d_$ver);
    assert property(reg_cog_ctra_ctrapin_$d_$gld == reg_cog_ctra_ctrapin_$d_$ver);
    assert property(reg_cog_ctra_delayed0_$d_$gld == reg_cog_ctra_delayed0_$d_$ver);
    assert property(reg_cog_ctra_delayed1_$d_$gld == reg_cog_ctra_delayed1_$d_$ver);
    assert property(reg_cog_ctra_pll_saved_$d_$gld == reg_cog_ctra_pll_saved_$d_$ver);
    assert property(reg_cog_ctrb_frequency_$d_$gld == reg_cog_ctrb_frequency_$d_$ver);
    assert property(reg_cog_ctrb_phase_$d_$gld == reg_cog_ctrb_phase_$d_$ver);
    assert property(reg_cog_ctrb_pllcounter_$d_$gld == reg_cog_ctrb_pllcounter_$d_$ver);
    assert property(reg_cog_ctrb_ctrmode_$d_$gld == reg_cog_ctrb_ctrmode_$d_$ver);
    assert property(reg_cog_ctrb_ctrplldiv_$d_$gld == reg_cog_ctrb_ctrplldiv_$d_$ver);
    assert property(reg_cog_ctrb_ctrbpin_$d_$gld == reg_cog_ctrb_ctrbpin_$d_$ver);
    assert property(reg_cog_ctrb_ctrapin_$d_$gld == reg_cog_ctrb_ctrapin_$d_$ver);
    assert property(reg_cog_ctrb_delayed0_$d_$gld == reg_cog_ctrb_delayed0_$d_$ver);
    assert property(reg_cog_ctrb_delayed1_$d_$gld == reg_cog_ctrb_delayed1_$d_$ver);
    assert property(reg_cog_ctrb_pll_saved_$d_$gld == reg_cog_ctrb_pll_saved_$d_$ver);
    assert property(reg_cog_ram_q_reg_$d_$gld == reg_cog_ram_q_reg_$d_$ver);
    assert property(reg_cog_ram_r_$d_$gld == reg_cog_ram_r_$d_$ver);
    assert property(reg_cog_ram_r_$wi_$gld == reg_cog_ram_r_$wi_$ver);
    assert property(reg_cog_ram_r_$wr_$gld == reg_cog_ram_r_$wr_$ver);
endmodule
